=== modified file 'Makefile.am'
--- Makefile.am	2009-08-11 16:45:00 +0000
+++ Makefile.am	2009-08-26 12:15:00 +0000
@@ -38,7 +38,10 @@
 pyfiles = $(shell SRCDIR="$(top_srcdir)/ubuntuone"; for i in `find $$SRCDIR -type f -name "*.py"`; do if [ ! -f $$i.in ]; then printf "$$i "; fi; done)
 
 $(clientdefs_DATA): $(clientdefs_in_files) ubuntuone
-	sed -e 's|\@localedir\@|$(localedir)|g' -e 's|\@GETTEXT_PACKAGE\@|$(GETTEXT_PACKAGE)|g' -e 's|\@VERSION\@|$(VERSION)|g' < $< > $@
+	sed -e 's|\@localedir\@|$(localedir)|g' \
+	-e 's|\@libexecdir\@|$(libexecdir)|g' \
+	-e 's|\@GETTEXT_PACKAGE\@|$(GETTEXT_PACKAGE)|g' \
+	-e 's|\@VERSION\@|$(VERSION)|g' < $< > $@
 
 pylintrc: Makefile
 	if test "x$(builddir)" != "x$(srcdir)"; then \

=== modified file 'Makefile.in'
--- Makefile.in	2009-08-11 16:45:00 +0000
+++ Makefile.in	2009-08-26 12:15:00 +0000
@@ -1,8 +1,9 @@
-# Makefile.in generated by automake 1.10.2 from Makefile.am.
+# Makefile.in generated by automake 1.11 from Makefile.am.
 # @configure_input@
 
 # Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2000, 2001, 2002,
-# 2003, 2004, 2005, 2006, 2007, 2008  Free Software Foundation, Inc.
+# 2003, 2004, 2005, 2006, 2007, 2008, 2009  Free Software Foundation,
+# Inc.
 # This Makefile.in is free software; the Free Software Foundation
 # gives unlimited permission to copy and/or distribute it,
 # with or without modifications, as long as this notice is preserved.
@@ -17,8 +18,9 @@
 
 VPATH = @srcdir@
 pkgdatadir = $(datadir)/@PACKAGE@
+pkgincludedir = $(includedir)/@PACKAGE@
 pkglibdir = $(libdir)/@PACKAGE@
-pkgincludedir = $(includedir)/@PACKAGE@
+pkglibexecdir = $(libexecdir)/@PACKAGE@
 am__cd = CDPATH="$${ZSH_VERSION+.}$(PATH_SEPARATOR)" && cd
 install_sh_DATA = $(install_sh) -c -m 644
 install_sh_PROGRAM = $(install_sh) -c
@@ -50,10 +52,30 @@
 mkinstalldirs = $(install_sh) -d
 CONFIG_HEADER = config.h
 CONFIG_CLEAN_FILES =
+CONFIG_CLEAN_VPATH_FILES =
+am__vpath_adj_setup = srcdirstrip=`echo "$(srcdir)" | sed 's|.|.|g'`;
+am__vpath_adj = case $$p in \
+    $(srcdir)/*) f=`echo "$$p" | sed "s|^$$srcdirstrip/||"`;; \
+    *) f=$$p;; \
+  esac;
+am__strip_dir = f=`echo $$p | sed -e 's|^.*/||'`;
+am__install_max = 40
+am__nobase_strip_setup = \
+  srcdirstrip=`echo "$(srcdir)" | sed 's/[].[^$$\\*|]/\\\\&/g'`
+am__nobase_strip = \
+  for p in $$list; do echo "$$p"; done | sed -e "s|$$srcdirstrip/||"
+am__nobase_list = $(am__nobase_strip_setup); \
+  for p in $$list; do echo "$$p $$p"; done | \
+  sed "s| $$srcdirstrip/| |;"' / .*\//!s/ .*/ ./; s,\( .*\)/[^/]*$$,\1,' | \
+  $(AWK) 'BEGIN { files["."] = "" } { files[$$2] = files[$$2] " " $$1; \
+    if (++n[$$2] == $(am__install_max)) \
+      { print $$2, files[$$2]; n[$$2] = 0; files[$$2] = "" } } \
+    END { for (dir in files) print dir, files[dir] }'
+am__base_list = \
+  sed '$$!N;$$!N;$$!N;$$!N;$$!N;$$!N;$$!N;s/\n/ /g' | \
+  sed '$$!N;$$!N;$$!N;$$!N;s/\n/ /g'
 am__installdirs = "$(DESTDIR)$(bindir)" "$(DESTDIR)$(libexecdir)" \
 	"$(DESTDIR)$(clientdefsdir)" "$(DESTDIR)$(manfilesdir)"
-binSCRIPT_INSTALL = $(INSTALL_SCRIPT)
-libexecSCRIPT_INSTALL = $(INSTALL_SCRIPT)
 SCRIPTS = $(bin_SCRIPTS) $(libexec_SCRIPTS)
 SOURCES =
 DIST_SOURCES =
@@ -64,17 +86,12 @@
 	install-pdf-recursive install-ps-recursive install-recursive \
 	installcheck-recursive installdirs-recursive pdf-recursive \
 	ps-recursive uninstall-recursive
-am__vpath_adj_setup = srcdirstrip=`echo "$(srcdir)" | sed 's|.|.|g'`;
-am__vpath_adj = case $$p in \
-    $(srcdir)/*) f=`echo "$$p" | sed "s|^$$srcdirstrip/||"`;; \
-    *) f=$$p;; \
-  esac;
-am__strip_dir = `echo $$p | sed -e 's|^.*/||'`;
-clientdefsDATA_INSTALL = $(INSTALL_DATA)
-manfilesDATA_INSTALL = $(INSTALL_DATA)
 DATA = $(clientdefs_DATA) $(manfiles_DATA)
 RECURSIVE_CLEAN_TARGETS = mostlyclean-recursive clean-recursive	\
   distclean-recursive maintainer-clean-recursive
+AM_RECURSIVE_TARGETS = $(RECURSIVE_TARGETS:-recursive=) \
+	$(RECURSIVE_CLEAN_TARGETS:-recursive=) tags TAGS ctags CTAGS \
+	distdir dist dist-all distcheck
 ETAGS = etags
 CTAGS = ctags
 DIST_SUBDIRS = $(SUBDIRS)
@@ -82,9 +99,34 @@
 distdir = $(PACKAGE)-$(VERSION)
 top_distdir = $(distdir)
 am__remove_distdir = \
-  { test ! -d $(distdir) \
-    || { find $(distdir) -type d ! -perm -200 -exec chmod u+w {} ';' \
-         && rm -fr $(distdir); }; }
+  { test ! -d "$(distdir)" \
+    || { find "$(distdir)" -type d ! -perm -200 -exec chmod u+w {} ';' \
+         && rm -fr "$(distdir)"; }; }
+am__relativize = \
+  dir0=`pwd`; \
+  sed_first='s,^\([^/]*\)/.*$$,\1,'; \
+  sed_rest='s,^[^/]*/*,,'; \
+  sed_last='s,^.*/\([^/]*\)$$,\1,'; \
+  sed_butlast='s,/*[^/]*$$,,'; \
+  while test -n "$$dir1"; do \
+    first=`echo "$$dir1" | sed -e "$$sed_first"`; \
+    if test "$$first" != "."; then \
+      if test "$$first" = ".."; then \
+        dir2=`echo "$$dir0" | sed -e "$$sed_last"`/"$$dir2"; \
+        dir0=`echo "$$dir0" | sed -e "$$sed_butlast"`; \
+      else \
+        first2=`echo "$$dir2" | sed -e "$$sed_first"`; \
+        if test "$$first2" = "$$first"; then \
+          dir2=`echo "$$dir2" | sed -e "$$sed_rest"`; \
+        else \
+          dir2="../$$dir2"; \
+        fi; \
+        dir0="$$dir0"/"$$first"; \
+      fi; \
+    fi; \
+    dir1=`echo "$$dir1" | sed -e "$$sed_rest"`; \
+  done; \
+  reldir="$$dir2"
 DIST_ARCHIVES = $(distdir).tar.gz
 GZIP_ENV = --best
 distuninstallcheck_listfiles = find . -type f -print
@@ -308,15 +350,15 @@
 	@for dep in $?; do \
 	  case '$(am__configure_deps)' in \
 	    *$$dep*) \
-	      echo ' cd $(srcdir) && $(AUTOMAKE) --foreign '; \
-	      cd $(srcdir) && $(AUTOMAKE) --foreign  \
+	      echo ' cd $(srcdir) && $(AUTOMAKE) --foreign'; \
+	      $(am__cd) $(srcdir) && $(AUTOMAKE) --foreign \
 		&& exit 0; \
 	      exit 1;; \
 	  esac; \
 	done; \
-	echo ' cd $(top_srcdir) && $(AUTOMAKE) --foreign  Makefile'; \
-	cd $(top_srcdir) && \
-	  $(AUTOMAKE) --foreign  Makefile
+	echo ' cd $(top_srcdir) && $(AUTOMAKE) --foreign Makefile'; \
+	$(am__cd) $(top_srcdir) && \
+	  $(AUTOMAKE) --foreign Makefile
 .PRECIOUS: Makefile
 Makefile: $(srcdir)/Makefile.in $(top_builddir)/config.status
 	@case '$?' in \
@@ -332,9 +374,10 @@
 	$(SHELL) ./config.status --recheck
 
 $(top_srcdir)/configure:  $(am__configure_deps)
-	cd $(srcdir) && $(AUTOCONF)
+	$(am__cd) $(srcdir) && $(AUTOCONF)
 $(ACLOCAL_M4):  $(am__aclocal_m4_deps)
-	cd $(srcdir) && $(ACLOCAL) $(ACLOCAL_AMFLAGS)
+	$(am__cd) $(srcdir) && $(ACLOCAL) $(ACLOCAL_AMFLAGS)
+$(am__aclocal_m4_deps):
 
 config.h: stamp-h1
 	@if test ! -f $@; then \
@@ -346,7 +389,7 @@
 	@rm -f stamp-h1
 	cd $(top_builddir) && $(SHELL) ./config.status config.h
 $(srcdir)/config.h.in:  $(am__configure_deps) 
-	cd $(top_srcdir) && $(AUTOHEADER)
+	($(am__cd) $(top_srcdir) && $(AUTOHEADER))
 	rm -f stamp-h1
 	touch $@
 
@@ -355,41 +398,71 @@
 install-binSCRIPTS: $(bin_SCRIPTS)
 	@$(NORMAL_INSTALL)
 	test -z "$(bindir)" || $(MKDIR_P) "$(DESTDIR)$(bindir)"
-	@list='$(bin_SCRIPTS)'; for p in $$list; do \
+	@list='$(bin_SCRIPTS)'; test -n "$(bindir)" || list=; \
+	for p in $$list; do \
 	  if test -f "$$p"; then d=; else d="$(srcdir)/"; fi; \
-	  if test -f $$d$$p; then \
-	    f=`echo "$$p" | sed 's|^.*/||;$(transform)'`; \
-	    echo " $(binSCRIPT_INSTALL) '$$d$$p' '$(DESTDIR)$(bindir)/$$f'"; \
-	    $(binSCRIPT_INSTALL) "$$d$$p" "$(DESTDIR)$(bindir)/$$f"; \
-	  else :; fi; \
-	done
+	  if test -f "$$d$$p"; then echo "$$d$$p"; echo "$$p"; else :; fi; \
+	done | \
+	sed -e 'p;s,.*/,,;n' \
+	    -e 'h;s|.*|.|' \
+	    -e 'p;x;s,.*/,,;$(transform)' | sed 'N;N;N;s,\n, ,g' | \
+	$(AWK) 'BEGIN { files["."] = ""; dirs["."] = 1; } \
+	  { d=$$3; if (dirs[d] != 1) { print "d", d; dirs[d] = 1 } \
+	    if ($$2 == $$4) { files[d] = files[d] " " $$1; \
+	      if (++n[d] == $(am__install_max)) { \
+		print "f", d, files[d]; n[d] = 0; files[d] = "" } } \
+	    else { print "f", d "/" $$4, $$1 } } \
+	  END { for (d in files) print "f", d, files[d] }' | \
+	while read type dir files; do \
+	     if test "$$dir" = .; then dir=; else dir=/$$dir; fi; \
+	     test -z "$$files" || { \
+	       echo " $(INSTALL_SCRIPT) $$files '$(DESTDIR)$(bindir)$$dir'"; \
+	       $(INSTALL_SCRIPT) $$files "$(DESTDIR)$(bindir)$$dir" || exit $$?; \
+	     } \
+	; done
 
 uninstall-binSCRIPTS:
 	@$(NORMAL_UNINSTALL)
-	@list='$(bin_SCRIPTS)'; for p in $$list; do \
-	  f=`echo "$$p" | sed 's|^.*/||;$(transform)'`; \
-	  echo " rm -f '$(DESTDIR)$(bindir)/$$f'"; \
-	  rm -f "$(DESTDIR)$(bindir)/$$f"; \
-	done
+	@list='$(bin_SCRIPTS)'; test -n "$(bindir)" || exit 0; \
+	files=`for p in $$list; do echo "$$p"; done | \
+	       sed -e 's,.*/,,;$(transform)'`; \
+	test -n "$$list" || exit 0; \
+	echo " ( cd '$(DESTDIR)$(bindir)' && rm -f" $$files ")"; \
+	cd "$(DESTDIR)$(bindir)" && rm -f $$files
 install-libexecSCRIPTS: $(libexec_SCRIPTS)
 	@$(NORMAL_INSTALL)
 	test -z "$(libexecdir)" || $(MKDIR_P) "$(DESTDIR)$(libexecdir)"
-	@list='$(libexec_SCRIPTS)'; for p in $$list; do \
+	@list='$(libexec_SCRIPTS)'; test -n "$(libexecdir)" || list=; \
+	for p in $$list; do \
 	  if test -f "$$p"; then d=; else d="$(srcdir)/"; fi; \
-	  if test -f $$d$$p; then \
-	    f=`echo "$$p" | sed 's|^.*/||;$(transform)'`; \
-	    echo " $(libexecSCRIPT_INSTALL) '$$d$$p' '$(DESTDIR)$(libexecdir)/$$f'"; \
-	    $(libexecSCRIPT_INSTALL) "$$d$$p" "$(DESTDIR)$(libexecdir)/$$f"; \
-	  else :; fi; \
-	done
+	  if test -f "$$d$$p"; then echo "$$d$$p"; echo "$$p"; else :; fi; \
+	done | \
+	sed -e 'p;s,.*/,,;n' \
+	    -e 'h;s|.*|.|' \
+	    -e 'p;x;s,.*/,,;$(transform)' | sed 'N;N;N;s,\n, ,g' | \
+	$(AWK) 'BEGIN { files["."] = ""; dirs["."] = 1; } \
+	  { d=$$3; if (dirs[d] != 1) { print "d", d; dirs[d] = 1 } \
+	    if ($$2 == $$4) { files[d] = files[d] " " $$1; \
+	      if (++n[d] == $(am__install_max)) { \
+		print "f", d, files[d]; n[d] = 0; files[d] = "" } } \
+	    else { print "f", d "/" $$4, $$1 } } \
+	  END { for (d in files) print "f", d, files[d] }' | \
+	while read type dir files; do \
+	     if test "$$dir" = .; then dir=; else dir=/$$dir; fi; \
+	     test -z "$$files" || { \
+	       echo " $(INSTALL_SCRIPT) $$files '$(DESTDIR)$(libexecdir)$$dir'"; \
+	       $(INSTALL_SCRIPT) $$files "$(DESTDIR)$(libexecdir)$$dir" || exit $$?; \
+	     } \
+	; done
 
 uninstall-libexecSCRIPTS:
 	@$(NORMAL_UNINSTALL)
-	@list='$(libexec_SCRIPTS)'; for p in $$list; do \
-	  f=`echo "$$p" | sed 's|^.*/||;$(transform)'`; \
-	  echo " rm -f '$(DESTDIR)$(libexecdir)/$$f'"; \
-	  rm -f "$(DESTDIR)$(libexecdir)/$$f"; \
-	done
+	@list='$(libexec_SCRIPTS)'; test -n "$(libexecdir)" || exit 0; \
+	files=`for p in $$list; do echo "$$p"; done | \
+	       sed -e 's,.*/,,;$(transform)'`; \
+	test -n "$$list" || exit 0; \
+	echo " ( cd '$(DESTDIR)$(libexecdir)' && rm -f" $$files ")"; \
+	cd "$(DESTDIR)$(libexecdir)" && rm -f $$files
 
 mostlyclean-libtool:
 	-rm -f *.lo
@@ -402,37 +475,43 @@
 install-clientdefsDATA: $(clientdefs_DATA)
 	@$(NORMAL_INSTALL)
 	test -z "$(clientdefsdir)" || $(MKDIR_P) "$(DESTDIR)$(clientdefsdir)"
-	@list='$(clientdefs_DATA)'; for p in $$list; do \
+	@list='$(clientdefs_DATA)'; test -n "$(clientdefsdir)" || list=; \
+	for p in $$list; do \
 	  if test -f "$$p"; then d=; else d="$(srcdir)/"; fi; \
-	  f=$(am__strip_dir) \
-	  echo " $(clientdefsDATA_INSTALL) '$$d$$p' '$(DESTDIR)$(clientdefsdir)/$$f'"; \
-	  $(clientdefsDATA_INSTALL) "$$d$$p" "$(DESTDIR)$(clientdefsdir)/$$f"; \
+	  echo "$$d$$p"; \
+	done | $(am__base_list) | \
+	while read files; do \
+	  echo " $(INSTALL_DATA) $$files '$(DESTDIR)$(clientdefsdir)'"; \
+	  $(INSTALL_DATA) $$files "$(DESTDIR)$(clientdefsdir)" || exit $$?; \
 	done
 
 uninstall-clientdefsDATA:
 	@$(NORMAL_UNINSTALL)
-	@list='$(clientdefs_DATA)'; for p in $$list; do \
-	  f=$(am__strip_dir) \
-	  echo " rm -f '$(DESTDIR)$(clientdefsdir)/$$f'"; \
-	  rm -f "$(DESTDIR)$(clientdefsdir)/$$f"; \
-	done
+	@list='$(clientdefs_DATA)'; test -n "$(clientdefsdir)" || list=; \
+	files=`for p in $$list; do echo $$p; done | sed -e 's|^.*/||'`; \
+	test -n "$$files" || exit 0; \
+	echo " ( cd '$(DESTDIR)$(clientdefsdir)' && rm -f" $$files ")"; \
+	cd "$(DESTDIR)$(clientdefsdir)" && rm -f $$files
 install-manfilesDATA: $(manfiles_DATA)
 	@$(NORMAL_INSTALL)
 	test -z "$(manfilesdir)" || $(MKDIR_P) "$(DESTDIR)$(manfilesdir)"
-	@list='$(manfiles_DATA)'; for p in $$list; do \
+	@list='$(manfiles_DATA)'; test -n "$(manfilesdir)" || list=; \
+	for p in $$list; do \
 	  if test -f "$$p"; then d=; else d="$(srcdir)/"; fi; \
-	  f=$(am__strip_dir) \
-	  echo " $(manfilesDATA_INSTALL) '$$d$$p' '$(DESTDIR)$(manfilesdir)/$$f'"; \
-	  $(manfilesDATA_INSTALL) "$$d$$p" "$(DESTDIR)$(manfilesdir)/$$f"; \
+	  echo "$$d$$p"; \
+	done | $(am__base_list) | \
+	while read files; do \
+	  echo " $(INSTALL_DATA) $$files '$(DESTDIR)$(manfilesdir)'"; \
+	  $(INSTALL_DATA) $$files "$(DESTDIR)$(manfilesdir)" || exit $$?; \
 	done
 
 uninstall-manfilesDATA:
 	@$(NORMAL_UNINSTALL)
-	@list='$(manfiles_DATA)'; for p in $$list; do \
-	  f=$(am__strip_dir) \
-	  echo " rm -f '$(DESTDIR)$(manfilesdir)/$$f'"; \
-	  rm -f "$(DESTDIR)$(manfilesdir)/$$f"; \
-	done
+	@list='$(manfiles_DATA)'; test -n "$(manfilesdir)" || list=; \
+	files=`for p in $$list; do echo $$p; done | sed -e 's|^.*/||'`; \
+	test -n "$$files" || exit 0; \
+	echo " ( cd '$(DESTDIR)$(manfilesdir)' && rm -f" $$files ")"; \
+	cd "$(DESTDIR)$(manfilesdir)" && rm -f $$files
 
 # This directory's subdirectories are mostly independent; you can cd
 # into them and run `make' without going through this Makefile.
@@ -458,7 +537,7 @@
 	  else \
 	    local_target="$$target"; \
 	  fi; \
-	  (cd $$subdir && $(MAKE) $(AM_MAKEFLAGS) $$local_target) \
+	  ($(am__cd) $$subdir && $(MAKE) $(AM_MAKEFLAGS) $$local_target) \
 	  || eval $$failcom; \
 	done; \
 	if test "$$dot_seen" = "no"; then \
@@ -492,16 +571,16 @@
 	  else \
 	    local_target="$$target"; \
 	  fi; \
-	  (cd $$subdir && $(MAKE) $(AM_MAKEFLAGS) $$local_target) \
+	  ($(am__cd) $$subdir && $(MAKE) $(AM_MAKEFLAGS) $$local_target) \
 	  || eval $$failcom; \
 	done && test -z "$$fail"
 tags-recursive:
 	list='$(SUBDIRS)'; for subdir in $$list; do \
-	  test "$$subdir" = . || (cd $$subdir && $(MAKE) $(AM_MAKEFLAGS) tags); \
+	  test "$$subdir" = . || ($(am__cd) $$subdir && $(MAKE) $(AM_MAKEFLAGS) tags); \
 	done
 ctags-recursive:
 	list='$(SUBDIRS)'; for subdir in $$list; do \
-	  test "$$subdir" = . || (cd $$subdir && $(MAKE) $(AM_MAKEFLAGS) ctags); \
+	  test "$$subdir" = . || ($(am__cd) $$subdir && $(MAKE) $(AM_MAKEFLAGS) ctags); \
 	done
 
 ID: $(HEADERS) $(SOURCES) $(LISP) $(TAGS_FILES)
@@ -516,7 +595,7 @@
 
 TAGS: tags-recursive $(HEADERS) $(SOURCES) config.h.in $(TAGS_DEPENDENCIES) \
 		$(TAGS_FILES) $(LISP)
-	tags=; \
+	set x; \
 	here=`pwd`; \
 	if ($(ETAGS) --etags-include --version) >/dev/null 2>&1; then \
 	  include_option=--etags-include; \
@@ -528,7 +607,7 @@
 	list='$(SUBDIRS)'; for subdir in $$list; do \
 	  if test "$$subdir" = .; then :; else \
 	    test ! -f $$subdir/TAGS || \
-	      tags="$$tags $$include_option=$$here/$$subdir/TAGS"; \
+	      set "$$@" "$$include_option=$$here/$$subdir/TAGS"; \
 	  fi; \
 	done; \
 	list='$(SOURCES) $(HEADERS) config.h.in $(LISP) $(TAGS_FILES)'; \
@@ -537,36 +616,41 @@
 	  done | \
 	  $(AWK) '{ files[$$0] = 1; nonempty = 1; } \
 	      END { if (nonempty) { for (i in files) print i; }; }'`; \
-	if test -z "$(ETAGS_ARGS)$$tags$$unique"; then :; else \
+	shift; \
+	if test -z "$(ETAGS_ARGS)$$*$$unique"; then :; else \
 	  test -n "$$unique" || unique=$$empty_fix; \
-	  $(ETAGS) $(ETAGSFLAGS) $(AM_ETAGSFLAGS) $(ETAGS_ARGS) \
-	    $$tags $$unique; \
+	  if test $$# -gt 0; then \
+	    $(ETAGS) $(ETAGSFLAGS) $(AM_ETAGSFLAGS) $(ETAGS_ARGS) \
+	      "$$@" $$unique; \
+	  else \
+	    $(ETAGS) $(ETAGSFLAGS) $(AM_ETAGSFLAGS) $(ETAGS_ARGS) \
+	      $$unique; \
+	  fi; \
 	fi
 ctags: CTAGS
 CTAGS: ctags-recursive $(HEADERS) $(SOURCES) config.h.in $(TAGS_DEPENDENCIES) \
 		$(TAGS_FILES) $(LISP)
-	tags=; \
 	list='$(SOURCES) $(HEADERS) config.h.in $(LISP) $(TAGS_FILES)'; \
 	unique=`for i in $$list; do \
 	    if test -f "$$i"; then echo $$i; else echo $(srcdir)/$$i; fi; \
 	  done | \
 	  $(AWK) '{ files[$$0] = 1; nonempty = 1; } \
 	      END { if (nonempty) { for (i in files) print i; }; }'`; \
-	test -z "$(CTAGS_ARGS)$$tags$$unique" \
+	test -z "$(CTAGS_ARGS)$$unique" \
 	  || $(CTAGS) $(CTAGSFLAGS) $(AM_CTAGSFLAGS) $(CTAGS_ARGS) \
-	     $$tags $$unique
+	     $$unique
 
 GTAGS:
 	here=`$(am__cd) $(top_builddir) && pwd` \
-	  && cd $(top_srcdir) \
-	  && gtags -i $(GTAGS_ARGS) $$here
+	  && $(am__cd) $(top_srcdir) \
+	  && gtags -i $(GTAGS_ARGS) "$$here"
 
 distclean-tags:
 	-rm -f TAGS ID GTAGS GRTAGS GSYMS GPATH tags
 
 distdir: $(DISTFILES)
 	$(am__remove_distdir)
-	test -d $(distdir) || mkdir $(distdir)
+	test -d "$(distdir)" || mkdir "$(distdir)"
 	@srcdirstrip=`echo "$(srcdir)" | sed 's/[].[^$$\\*]/\\\\&/g'`; \
 	topsrcdirstrip=`echo "$(top_srcdir)" | sed 's/[].[^$$\\*]/\\\\&/g'`; \
 	list='$(DISTFILES)'; \
@@ -582,38 +666,54 @@
 	  if test -f $$file || test -d $$file; then d=.; else d=$(srcdir); fi; \
 	  if test -d $$d/$$file; then \
 	    dir=`echo "/$$file" | sed -e 's,/[^/]*$$,,'`; \
+	    if test -d "$(distdir)/$$file"; then \
+	      find "$(distdir)/$$file" -type d ! -perm -700 -exec chmod u+rwx {} \;; \
+	    fi; \
 	    if test -d $(srcdir)/$$file && test $$d != $(srcdir); then \
-	      cp -pR $(srcdir)/$$file $(distdir)$$dir || exit 1; \
+	      cp -fpR $(srcdir)/$$file "$(distdir)$$dir" || exit 1; \
+	      find "$(distdir)/$$file" -type d ! -perm -700 -exec chmod u+rwx {} \;; \
 	    fi; \
-	    cp -pR $$d/$$file $(distdir)$$dir || exit 1; \
+	    cp -fpR $$d/$$file "$(distdir)$$dir" || exit 1; \
 	  else \
-	    test -f $(distdir)/$$file \
-	    || cp -p $$d/$$file $(distdir)/$$file \
+	    test -f "$(distdir)/$$file" \
+	    || cp -p $$d/$$file "$(distdir)/$$file" \
 	    || exit 1; \
 	  fi; \
 	done
-	list='$(DIST_SUBDIRS)'; for subdir in $$list; do \
+	@list='$(DIST_SUBDIRS)'; for subdir in $$list; do \
 	  if test "$$subdir" = .; then :; else \
 	    test -d "$(distdir)/$$subdir" \
 	    || $(MKDIR_P) "$(distdir)/$$subdir" \
 	    || exit 1; \
-	    distdir=`$(am__cd) $(distdir) && pwd`; \
-	    top_distdir=`$(am__cd) $(top_distdir) && pwd`; \
-	    (cd $$subdir && \
+	  fi; \
+	done
+	@list='$(DIST_SUBDIRS)'; for subdir in $$list; do \
+	  if test "$$subdir" = .; then :; else \
+	    dir1=$$subdir; dir2="$(distdir)/$$subdir"; \
+	    $(am__relativize); \
+	    new_distdir=$$reldir; \
+	    dir1=$$subdir; dir2="$(top_distdir)"; \
+	    $(am__relativize); \
+	    new_top_distdir=$$reldir; \
+	    echo " (cd $$subdir && $(MAKE) $(AM_MAKEFLAGS) top_distdir="$$new_top_distdir" distdir="$$new_distdir" \\"; \
+	    echo "     am__remove_distdir=: am__skip_length_check=: am__skip_mode_fix=: distdir)"; \
+	    ($(am__cd) $$subdir && \
 	      $(MAKE) $(AM_MAKEFLAGS) \
-	        top_distdir="$$top_distdir" \
-	        distdir="$$distdir/$$subdir" \
+	        top_distdir="$$new_top_distdir" \
+	        distdir="$$new_distdir" \
 		am__remove_distdir=: \
 		am__skip_length_check=: \
+		am__skip_mode_fix=: \
 	        distdir) \
 	      || exit 1; \
 	  fi; \
 	done
-	-find $(distdir) -type d ! -perm -777 -exec chmod a+rwx {} \; -o \
+	-test -n "$(am__skip_mode_fix)" \
+	|| find "$(distdir)" -type d ! -perm -777 -exec chmod a+rwx {} \; -o \
 	  ! -type d ! -perm -444 -links 1 -exec chmod a+r {} \; -o \
 	  ! -type d ! -perm -400 -exec chmod a+r {} \; -o \
 	  ! -type d ! -perm -444 -exec $(install_sh) -c -m a+r {} {} \; \
-	|| chmod -R a+r $(distdir)
+	|| chmod -R a+r "$(distdir)"
 dist-gzip: distdir
 	tardir=$(distdir) && $(am__tar) | GZIP=$(GZIP_ENV) gzip -c >$(distdir).tar.gz
 	$(am__remove_distdir)
@@ -626,6 +726,10 @@
 	tardir=$(distdir) && $(am__tar) | lzma -9 -c >$(distdir).tar.lzma
 	$(am__remove_distdir)
 
+dist-xz: distdir
+	tardir=$(distdir) && $(am__tar) | xz -c >$(distdir).tar.xz
+	$(am__remove_distdir)
+
 dist-tarZ: distdir
 	tardir=$(distdir) && $(am__tar) | compress -c >$(distdir).tar.Z
 	$(am__remove_distdir)
@@ -654,6 +758,8 @@
 	  bunzip2 -c $(distdir).tar.bz2 | $(am__untar) ;;\
 	*.tar.lzma*) \
 	  unlzma -c $(distdir).tar.lzma | $(am__untar) ;;\
+	*.tar.xz*) \
+	  xz -dc $(distdir).tar.xz | $(am__untar) ;;\
 	*.tar.Z*) \
 	  uncompress -c $(distdir).tar.Z | $(am__untar) ;;\
 	*.shar.gz*) \
@@ -665,9 +771,11 @@
 	mkdir $(distdir)/_build
 	mkdir $(distdir)/_inst
 	chmod a-w $(distdir)
+	test -d $(distdir)/_build || exit 0; \
 	dc_install_base=`$(am__cd) $(distdir)/_inst && pwd | sed -e 's,^[^:\\/]:[\\/],/,'` \
 	  && dc_destdir="$${TMPDIR-/tmp}/am-dc-$$$$/" \
-	  && cd $(distdir)/_build \
+	  && am__cwd=`pwd` \
+	  && $(am__cd) $(distdir)/_build \
 	  && ../configure --srcdir=.. --prefix="$$dc_install_base" \
 	    $(DISTCHECK_CONFIGURE_FLAGS) \
 	  && $(MAKE) $(AM_MAKEFLAGS) \
@@ -689,13 +797,15 @@
 	  && rm -rf "$$dc_destdir" \
 	  && $(MAKE) $(AM_MAKEFLAGS) dist \
 	  && rm -rf $(DIST_ARCHIVES) \
-	  && $(MAKE) $(AM_MAKEFLAGS) distcleancheck
+	  && $(MAKE) $(AM_MAKEFLAGS) distcleancheck \
+	  && cd "$$am__cwd" \
+	  || exit 1
 	$(am__remove_distdir)
 	@(echo "$(distdir) archives ready for distribution: "; \
 	  list='$(DIST_ARCHIVES)'; for i in $$list; do echo $$i; done) | \
 	  sed -e 1h -e 1s/./=/g -e 1p -e 1x -e '$$p' -e '$$x'
 distuninstallcheck:
-	@cd $(distuninstallcheck_dir) \
+	@$(am__cd) '$(distuninstallcheck_dir)' \
 	&& test `$(distuninstallcheck_listfiles) | wc -l` -le 1 \
 	   || { echo "ERROR: files left after uninstall:" ; \
 	        if test -n "$(DESTDIR)"; then \
@@ -741,6 +851,7 @@
 
 distclean-generic:
 	-test -z "$(CONFIG_CLEAN_FILES)" || rm -f $(CONFIG_CLEAN_FILES)
+	-test . = "$(srcdir)" || test -z "$(CONFIG_CLEAN_VPATH_FILES)" || rm -f $(CONFIG_CLEAN_VPATH_FILES)
 
 maintainer-clean-generic:
 	@echo "This command is intended for maintainers to use"
@@ -762,6 +873,8 @@
 
 html: html-recursive
 
+html-am:
+
 info: info-recursive
 
 info-am:
@@ -771,18 +884,28 @@
 
 install-dvi: install-dvi-recursive
 
+install-dvi-am:
+
 install-exec-am: install-binSCRIPTS install-libexecSCRIPTS
 
 install-html: install-html-recursive
 
+install-html-am:
+
 install-info: install-info-recursive
 
+install-info-am:
+
 install-man:
 
 install-pdf: install-pdf-recursive
 
+install-pdf-am:
+
 install-ps: install-ps-recursive
 
+install-ps-am:
+
 installcheck-am:
 
 maintainer-clean: maintainer-clean-recursive
@@ -807,24 +930,24 @@
 	uninstall-libexecSCRIPTS uninstall-local \
 	uninstall-manfilesDATA
 
-.MAKE: $(RECURSIVE_CLEAN_TARGETS) $(RECURSIVE_TARGETS) install-am \
-	install-strip
+.MAKE: $(RECURSIVE_CLEAN_TARGETS) $(RECURSIVE_TARGETS) all \
+	ctags-recursive install-am install-strip tags-recursive
 
 .PHONY: $(RECURSIVE_CLEAN_TARGETS) $(RECURSIVE_TARGETS) CTAGS GTAGS \
 	all all-am all-local am--refresh check check-am clean \
 	clean-generic clean-libtool clean-local ctags ctags-recursive \
 	dist dist-all dist-bzip2 dist-gzip dist-lzma dist-shar \
-	dist-tarZ dist-zip distcheck distclean distclean-generic \
-	distclean-hdr distclean-libtool distclean-tags distcleancheck \
-	distdir distuninstallcheck dvi dvi-am html html-am info \
-	info-am install install-am install-binSCRIPTS \
-	install-clientdefsDATA install-data install-data-am \
-	install-data-local install-dvi install-dvi-am install-exec \
-	install-exec-am install-html install-html-am install-info \
-	install-info-am install-libexecSCRIPTS install-man \
-	install-manfilesDATA install-pdf install-pdf-am install-ps \
-	install-ps-am install-strip installcheck installcheck-am \
-	installdirs installdirs-am maintainer-clean \
+	dist-tarZ dist-xz dist-zip distcheck distclean \
+	distclean-generic distclean-hdr distclean-libtool \
+	distclean-tags distcleancheck distdir distuninstallcheck dvi \
+	dvi-am html html-am info info-am install install-am \
+	install-binSCRIPTS install-clientdefsDATA install-data \
+	install-data-am install-data-local install-dvi install-dvi-am \
+	install-exec install-exec-am install-html install-html-am \
+	install-info install-info-am install-libexecSCRIPTS \
+	install-man install-manfilesDATA install-pdf install-pdf-am \
+	install-ps install-ps-am install-strip installcheck \
+	installcheck-am installdirs installdirs-am maintainer-clean \
 	maintainer-clean-generic mostlyclean mostlyclean-generic \
 	mostlyclean-libtool pdf pdf-am ps ps-am tags tags-recursive \
 	uninstall uninstall-am uninstall-binSCRIPTS \
@@ -833,7 +956,10 @@
 
 
 $(clientdefs_DATA): $(clientdefs_in_files) ubuntuone
-	sed -e 's|\@localedir\@|$(localedir)|g' -e 's|\@GETTEXT_PACKAGE\@|$(GETTEXT_PACKAGE)|g' -e 's|\@VERSION\@|$(VERSION)|g' < $< > $@
+	sed -e 's|\@localedir\@|$(localedir)|g' \
+	-e 's|\@libexecdir\@|$(libexecdir)|g' \
+	-e 's|\@GETTEXT_PACKAGE\@|$(GETTEXT_PACKAGE)|g' \
+	-e 's|\@VERSION\@|$(VERSION)|g' < $< > $@
 
 pylintrc: Makefile
 	if test "x$(builddir)" != "x$(srcdir)"; then \
@@ -910,6 +1036,7 @@
 	done
 	rm -f ubuntuone/storageprotocol
 	rm -rf build dist _trial_temp
+
 # Tell versions [3.59,3.63) of GNU make to not export all variables.
 # Otherwise a system limit (for SysV at least) may be exceeded.
 .NOEXPORT:

=== modified file 'aclocal.m4'
--- aclocal.m4	2009-08-11 16:45:00 +0000
+++ aclocal.m4	2009-08-26 12:15:00 +0000
@@ -1,7 +1,7 @@
-# generated automatically by aclocal 1.10.2 -*- Autoconf -*-
+# generated automatically by aclocal 1.11 -*- Autoconf -*-
 
 # Copyright (C) 1996, 1997, 1998, 1999, 2000, 2001, 2002, 2003, 2004,
-# 2005, 2006, 2007, 2008  Free Software Foundation, Inc.
+# 2005, 2006, 2007, 2008, 2009  Free Software Foundation, Inc.
 # This file is free software; the Free Software Foundation
 # gives unlimited permission to copy and/or distribute it,
 # with or without modifications, as long as this notice is preserved.
@@ -221,10 +221,10 @@
 # generated from the m4 files accompanying Automake X.Y.
 # (This private macro should not be called outside this file.)
 AC_DEFUN([AM_AUTOMAKE_VERSION],
-[am__api_version='1.10'
+[am__api_version='1.11'
 dnl Some users find AM_AUTOMAKE_VERSION and mistake it for a way to
 dnl require some minimum version.  Point them to the right macro.
-m4_if([$1], [1.10.2], [],
+m4_if([$1], [1.11], [],
       [AC_FATAL([Do not call $0, use AM_INIT_AUTOMAKE([$1]).])])dnl
 ])
 
@@ -240,7 +240,7 @@
 # Call AM_AUTOMAKE_VERSION and AM_AUTOMAKE_VERSION so they can be traced.
 # This function is AC_REQUIREd by AM_INIT_AUTOMAKE.
 AC_DEFUN([AM_SET_CURRENT_AUTOMAKE_VERSION],
-[AM_AUTOMAKE_VERSION([1.10.2])dnl
+[AM_AUTOMAKE_VERSION([1.11])dnl
 m4_ifndef([AC_AUTOCONF_VERSION],
   [m4_copy([m4_PACKAGE_VERSION], [AC_AUTOCONF_VERSION])])dnl
 _AM_AUTOCONF_VERSION(m4_defn([AC_AUTOCONF_VERSION]))])
@@ -300,14 +300,14 @@
 
 # AM_CONDITIONAL                                            -*- Autoconf -*-
 
-# Copyright (C) 1997, 2000, 2001, 2003, 2004, 2005, 2006
+# Copyright (C) 1997, 2000, 2001, 2003, 2004, 2005, 2006, 2008
 # Free Software Foundation, Inc.
 #
 # This file is free software; the Free Software Foundation
 # gives unlimited permission to copy and/or distribute it,
 # with or without modifications, as long as this notice is preserved.
 
-# serial 8
+# serial 9
 
 # AM_CONDITIONAL(NAME, SHELL-CONDITION)
 # -------------------------------------
@@ -320,6 +320,7 @@
 AC_SUBST([$1_FALSE])dnl
 _AM_SUBST_NOTMAKE([$1_TRUE])dnl
 _AM_SUBST_NOTMAKE([$1_FALSE])dnl
+m4_define([_AM_COND_VALUE_$1], [$2])dnl
 if $2; then
   $1_TRUE=
   $1_FALSE='#'
@@ -333,14 +334,14 @@
 Usually this means the macro was only invoked conditionally.]])
 fi])])
 
-# Copyright (C) 1999, 2000, 2001, 2002, 2003, 2004, 2005, 2006
+# Copyright (C) 1999, 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2009
 # Free Software Foundation, Inc.
 #
 # This file is free software; the Free Software Foundation
 # gives unlimited permission to copy and/or distribute it,
 # with or without modifications, as long as this notice is preserved.
 
-# serial 9
+# serial 10
 
 # There are a few dirty hacks below to avoid letting `AC_PROG_CC' be
 # written in clear, in which case automake, when reading aclocal.m4,
@@ -397,6 +398,16 @@
   if test "$am_compiler_list" = ""; then
      am_compiler_list=`sed -n ['s/^#*\([a-zA-Z0-9]*\))$/\1/p'] < ./depcomp`
   fi
+  am__universal=false
+  m4_case([$1], [CC],
+    [case " $depcc " in #(
+     *\ -arch\ *\ -arch\ *) am__universal=true ;;
+     esac],
+    [CXX],
+    [case " $depcc " in #(
+     *\ -arch\ *\ -arch\ *) am__universal=true ;;
+     esac])
+
   for depmode in $am_compiler_list; do
     # Setup a source with many dependencies, because some compilers
     # like to wrap large dependency lists on column 80 (with \), and
@@ -414,7 +425,17 @@
     done
     echo "${am__include} ${am__quote}sub/conftest.Po${am__quote}" > confmf
 
+    # We check with `-c' and `-o' for the sake of the "dashmstdout"
+    # mode.  It turns out that the SunPro C++ compiler does not properly
+    # handle `-M -o', and we need to detect this.  Also, some Intel
+    # versions had trouble with output in subdirs
+    am__obj=sub/conftest.${OBJEXT-o}
+    am__minus_obj="-o $am__obj"
     case $depmode in
+    gcc)
+      # This depmode causes a compiler race in universal mode.
+      test "$am__universal" = false || continue
+      ;;
     nosideeffect)
       # after this tag, mechanisms are not by side-effect, so they'll
       # only be used when explicitly requested
@@ -424,19 +445,23 @@
 	break
       fi
       ;;
+    msvisualcpp | msvcmsys)
+      # This compiler won't grok `-c -o', but also, the minuso test has
+      # not run yet.  These depmodes are late enough in the game, and
+      # so weak that their functioning should not be impacted.
+      am__obj=conftest.${OBJEXT-o}
+      am__minus_obj=
+      ;;
     none) break ;;
     esac
-    # We check with `-c' and `-o' for the sake of the "dashmstdout"
-    # mode.  It turns out that the SunPro C++ compiler does not properly
-    # handle `-M -o', and we need to detect this.
     if depmode=$depmode \
-       source=sub/conftest.c object=sub/conftest.${OBJEXT-o} \
+       source=sub/conftest.c object=$am__obj \
        depfile=sub/conftest.Po tmpdepfile=sub/conftest.TPo \
-       $SHELL ./depcomp $depcc -c -o sub/conftest.${OBJEXT-o} sub/conftest.c \
+       $SHELL ./depcomp $depcc -c $am__minus_obj sub/conftest.c \
          >/dev/null 2>conftest.err &&
        grep sub/conftst1.h sub/conftest.Po > /dev/null 2>&1 &&
        grep sub/conftst6.h sub/conftest.Po > /dev/null 2>&1 &&
-       grep sub/conftest.${OBJEXT-o} sub/conftest.Po > /dev/null 2>&1 &&
+       grep $am__obj sub/conftest.Po > /dev/null 2>&1 &&
        ${MAKE-make} -s -f confmf > /dev/null 2>&1; then
       # icc doesn't choke on unknown options, it will just issue warnings
       # or remarks (even with -Werror).  So we grep stderr for any message
@@ -586,13 +611,13 @@
 # Do all the work for Automake.                             -*- Autoconf -*-
 
 # Copyright (C) 1996, 1997, 1998, 1999, 2000, 2001, 2002, 2003, 2004,
-# 2005, 2006, 2008 Free Software Foundation, Inc.
+# 2005, 2006, 2008, 2009 Free Software Foundation, Inc.
 #
 # This file is free software; the Free Software Foundation
 # gives unlimited permission to copy and/or distribute it,
 # with or without modifications, as long as this notice is preserved.
 
-# serial 13
+# serial 16
 
 # This macro actually does too much.  Some checks are only needed if
 # your package does certain things.  But this isn't really a big deal.
@@ -609,7 +634,7 @@
 # arguments mandatory, and then we can depend on a new Autoconf
 # release and drop the old call support.
 AC_DEFUN([AM_INIT_AUTOMAKE],
-[AC_PREREQ([2.60])dnl
+[AC_PREREQ([2.62])dnl
 dnl Autoconf wants to disallow AM_ names.  We explicitly allow
 dnl the ones we care about.
 m4_pattern_allow([^AM_[A-Z]+FLAGS$])dnl
@@ -660,8 +685,8 @@
 AM_MISSING_PROG(AUTOMAKE, automake-${am__api_version})
 AM_MISSING_PROG(AUTOHEADER, autoheader)
 AM_MISSING_PROG(MAKEINFO, makeinfo)
-AM_PROG_INSTALL_SH
-AM_PROG_INSTALL_STRIP
+AC_REQUIRE([AM_PROG_INSTALL_SH])dnl
+AC_REQUIRE([AM_PROG_INSTALL_STRIP])dnl
 AC_REQUIRE([AM_PROG_MKDIR_P])dnl
 # We need awk for the "check" target.  The system "awk" is bad on
 # some platforms.
@@ -669,23 +694,36 @@
 AC_REQUIRE([AC_PROG_MAKE_SET])dnl
 AC_REQUIRE([AM_SET_LEADING_DOT])dnl
 _AM_IF_OPTION([tar-ustar], [_AM_PROG_TAR([ustar])],
-              [_AM_IF_OPTION([tar-pax], [_AM_PROG_TAR([pax])],
-	      		     [_AM_PROG_TAR([v7])])])
+	      [_AM_IF_OPTION([tar-pax], [_AM_PROG_TAR([pax])],
+			     [_AM_PROG_TAR([v7])])])
 _AM_IF_OPTION([no-dependencies],,
 [AC_PROVIDE_IFELSE([AC_PROG_CC],
-                  [_AM_DEPENDENCIES(CC)],
-                  [define([AC_PROG_CC],
-                          defn([AC_PROG_CC])[_AM_DEPENDENCIES(CC)])])dnl
+		  [_AM_DEPENDENCIES(CC)],
+		  [define([AC_PROG_CC],
+			  defn([AC_PROG_CC])[_AM_DEPENDENCIES(CC)])])dnl
 AC_PROVIDE_IFELSE([AC_PROG_CXX],
-                  [_AM_DEPENDENCIES(CXX)],
-                  [define([AC_PROG_CXX],
-                          defn([AC_PROG_CXX])[_AM_DEPENDENCIES(CXX)])])dnl
+		  [_AM_DEPENDENCIES(CXX)],
+		  [define([AC_PROG_CXX],
+			  defn([AC_PROG_CXX])[_AM_DEPENDENCIES(CXX)])])dnl
 AC_PROVIDE_IFELSE([AC_PROG_OBJC],
-                  [_AM_DEPENDENCIES(OBJC)],
-                  [define([AC_PROG_OBJC],
-                          defn([AC_PROG_OBJC])[_AM_DEPENDENCIES(OBJC)])])dnl
-])
-])
+		  [_AM_DEPENDENCIES(OBJC)],
+		  [define([AC_PROG_OBJC],
+			  defn([AC_PROG_OBJC])[_AM_DEPENDENCIES(OBJC)])])dnl
+])
+_AM_IF_OPTION([silent-rules], [AC_REQUIRE([AM_SILENT_RULES])])dnl
+dnl The `parallel-tests' driver may need to know about EXEEXT, so add the
+dnl `am__EXEEXT' conditional if _AM_COMPILER_EXEEXT was seen.  This macro
+dnl is hooked onto _AC_COMPILER_EXEEXT early, see below.
+AC_CONFIG_COMMANDS_PRE(dnl
+[m4_provide_if([_AM_COMPILER_EXEEXT],
+  [AM_CONDITIONAL([am__EXEEXT], [test -n "$EXEEXT"])])])dnl
+])
+
+dnl Hook into `_AC_COMPILER_EXEEXT' early to learn its expansion.  Do not
+dnl add the conditional right here, as _AC_COMPILER_EXEEXT may be further
+dnl mangled by Autoconf and run in a shell conditional statement.
+m4_define([_AC_COMPILER_EXEEXT],
+m4_defn([_AC_COMPILER_EXEEXT])[m4_provide([_AM_COMPILER_EXEEXT])])
 
 
 # When config.status generates a header, we must update the stamp-h file.
@@ -709,7 +747,7 @@
 done
 echo "timestamp for $_am_arg" >`AS_DIRNAME(["$_am_arg"])`/stamp-h[]$_am_stamp_count])
 
-# Copyright (C) 2001, 2003, 2005  Free Software Foundation, Inc.
+# Copyright (C) 2001, 2003, 2005, 2008  Free Software Foundation, Inc.
 #
 # This file is free software; the Free Software Foundation
 # gives unlimited permission to copy and/or distribute it,
@@ -720,7 +758,14 @@
 # Define $install_sh.
 AC_DEFUN([AM_PROG_INSTALL_SH],
 [AC_REQUIRE([AM_AUX_DIR_EXPAND])dnl
-install_sh=${install_sh-"\$(SHELL) $am_aux_dir/install-sh"}
+if test x"${install_sh}" != xset; then
+  case $am_aux_dir in
+  *\ * | *\	*)
+    install_sh="\${SHELL} '$am_aux_dir/install-sh'" ;;
+  *)
+    install_sh="\${SHELL} $am_aux_dir/install-sh"
+  esac
+fi
 AC_SUBST(install_sh)])
 
 # Copyright (C) 2003, 2005  Free Software Foundation, Inc.
@@ -746,13 +791,13 @@
 
 # Check to see how 'make' treats includes.	            -*- Autoconf -*-
 
-# Copyright (C) 2001, 2002, 2003, 2005  Free Software Foundation, Inc.
+# Copyright (C) 2001, 2002, 2003, 2005, 2009  Free Software Foundation, Inc.
 #
 # This file is free software; the Free Software Foundation
 # gives unlimited permission to copy and/or distribute it,
 # with or without modifications, as long as this notice is preserved.
 
-# serial 3
+# serial 4
 
 # AM_MAKE_INCLUDE()
 # -----------------
@@ -761,7 +806,7 @@
 [am_make=${MAKE-make}
 cat > confinc << 'END'
 am__doit:
-	@echo done
+	@echo this is the am__doit target
 .PHONY: am__doit
 END
 # If we don't find an include directive, just comment out the code.
@@ -771,24 +816,24 @@
 _am_result=none
 # First try GNU make style include.
 echo "include confinc" > confmf
-# We grep out `Entering directory' and `Leaving directory'
-# messages which can occur if `w' ends up in MAKEFLAGS.
-# In particular we don't look at `^make:' because GNU make might
-# be invoked under some other name (usually "gmake"), in which
-# case it prints its new name instead of `make'.
-if test "`$am_make -s -f confmf 2> /dev/null | grep -v 'ing directory'`" = "done"; then
-   am__include=include
-   am__quote=
-   _am_result=GNU
-fi
+# Ignore all kinds of additional output from `make'.
+case `$am_make -s -f confmf 2> /dev/null` in #(
+*the\ am__doit\ target*)
+  am__include=include
+  am__quote=
+  _am_result=GNU
+  ;;
+esac
 # Now try BSD make style include.
 if test "$am__include" = "#"; then
    echo '.include "confinc"' > confmf
-   if test "`$am_make -s -f confmf 2> /dev/null`" = "done"; then
-      am__include=.include
-      am__quote="\""
-      _am_result=BSD
-   fi
+   case `$am_make -s -f confmf 2> /dev/null` in #(
+   *the\ am__doit\ target*)
+     am__include=.include
+     am__quote="\""
+     _am_result=BSD
+     ;;
+   esac
 fi
 AC_SUBST([am__include])
 AC_SUBST([am__quote])
@@ -798,14 +843,14 @@
 
 # Fake the existence of programs that GNU maintainers use.  -*- Autoconf -*-
 
-# Copyright (C) 1997, 1999, 2000, 2001, 2003, 2004, 2005
+# Copyright (C) 1997, 1999, 2000, 2001, 2003, 2004, 2005, 2008
 # Free Software Foundation, Inc.
 #
 # This file is free software; the Free Software Foundation
 # gives unlimited permission to copy and/or distribute it,
 # with or without modifications, as long as this notice is preserved.
 
-# serial 5
+# serial 6
 
 # AM_MISSING_PROG(NAME, PROGRAM)
 # ------------------------------
@@ -822,7 +867,14 @@
 AC_DEFUN([AM_MISSING_HAS_RUN],
 [AC_REQUIRE([AM_AUX_DIR_EXPAND])dnl
 AC_REQUIRE_AUX_FILE([missing])dnl
-test x"${MISSING+set}" = xset || MISSING="\${SHELL} $am_aux_dir/missing"
+if test x"${MISSING+set}" != xset; then
+  case $am_aux_dir in
+  *\ * | *\	*)
+    MISSING="\${SHELL} \"$am_aux_dir/missing\"" ;;
+  *)
+    MISSING="\${SHELL} $am_aux_dir/missing" ;;
+  esac
+fi
 # Use eval to expand $SHELL
 if eval "$MISSING --run true"; then
   am_missing_run="$MISSING --run "
@@ -891,7 +943,7 @@
 AC_DEFUN([_AM_IF_OPTION],
 [m4_ifset(_AM_MANGLE_OPTION([$1]), [$2], [$3])])
 
-# Copyright (C) 1999, 2000, 2001, 2002, 2003, 2004, 2005
+# Copyright (C) 1999, 2000, 2001, 2002, 2003, 2004, 2005, 2008, 2009
 # Free Software Foundation, Inc.
 #
 # This file is free software; the Free Software Foundation
@@ -922,13 +974,11 @@
 # numbers and dots only.
 AC_DEFUN([AM_PATH_PYTHON],
  [
-  dnl Find a Python interpreter.  Python versions prior to 1.5 are not
-  dnl supported because the default installation locations changed from
-  dnl $prefix/lib/site-python in 1.4 to $prefix/lib/python1.5/site-packages
-  dnl in 1.5.
+  dnl Find a Python interpreter.  Python versions prior to 2.0 are not
+  dnl supported. (2.0 was released on October 16, 2000).
   m4_define_default([_AM_PYTHON_INTERPRETER_LIST],
-                    [python python2 python2.5 python2.4 python2.3 python2.2 dnl
-python2.1 python2.0 python1.6 python1.5])
+                    [python python2 python3 python3.0 python2.5 python2.4 python2.3 python2.2 dnl
+python2.1 python2.0])
 
   m4_if([$1],[],[
     dnl No version check is needed.
@@ -975,7 +1025,7 @@
   dnl library.
 
   AC_CACHE_CHECK([for $am_display_PYTHON version], [am_cv_python_version],
-    [am_cv_python_version=`$PYTHON -c "import sys; print sys.version[[:3]]"`])
+    [am_cv_python_version=`$PYTHON -c "import sys; sys.stdout.write(sys.version[[:3]])"`])
   AC_SUBST([PYTHON_VERSION], [$am_cv_python_version])
 
   dnl Use the values of $prefix and $exec_prefix for the corresponding
@@ -990,7 +1040,7 @@
   dnl to know which OS platform Python thinks this is.
 
   AC_CACHE_CHECK([for $am_display_PYTHON platform], [am_cv_python_platform],
-    [am_cv_python_platform=`$PYTHON -c "import sys; print sys.platform"`])
+    [am_cv_python_platform=`$PYTHON -c "import sys; sys.stdout.write(sys.platform)"`])
   AC_SUBST([PYTHON_PLATFORM], [$am_cv_python_platform])
 
 
@@ -1069,15 +1119,16 @@
 # Run ACTION-IF-FALSE otherwise.
 # This test uses sys.hexversion instead of the string equivalent (first
 # word of sys.version), in order to cope with versions such as 2.2c1.
-# hexversion has been introduced in Python 1.5.2; it's probably not
-# worth to support older versions (1.5.1 was released on October 31, 1998).
+# This supports Python 2.0 or higher. (2.0 was released on October 16, 2000).
 AC_DEFUN([AM_PYTHON_CHECK_VERSION],
- [prog="import sys, string
+ [prog="import sys
 # split strings by '.' and convert to numeric.  Append some zeros
 # because we need at least 4 digits for the hex conversion.
-minver = map(int, string.split('$2', '.')) + [[0, 0, 0]]
+# map returns an iterator in Python 3.0 and a list in 2.x
+minver = list(map(int, '$2'.split('.'))) + [[0, 0, 0]]
 minverhex = 0
-for i in xrange(0, 4): minverhex = (minverhex << 8) + minver[[i]]
+# xrange is not present in Python 3.0 and range returns an iterator
+for i in list(range(0, 4)): minverhex = (minverhex << 8) + minver[[i]]
 sys.exit(sys.hexversion < minverhex)"
   AS_IF([AM_RUN_LOG([$1 -c "$prog"])], [$3], [$4])])
 
@@ -1100,14 +1151,14 @@
 
 # Check to make sure that the build environment is sane.    -*- Autoconf -*-
 
-# Copyright (C) 1996, 1997, 2000, 2001, 2003, 2005
+# Copyright (C) 1996, 1997, 2000, 2001, 2003, 2005, 2008
 # Free Software Foundation, Inc.
 #
 # This file is free software; the Free Software Foundation
 # gives unlimited permission to copy and/or distribute it,
 # with or without modifications, as long as this notice is preserved.
 
-# serial 4
+# serial 5
 
 # AM_SANITY_CHECK
 # ---------------
@@ -1116,16 +1167,29 @@
 # Just in case
 sleep 1
 echo timestamp > conftest.file
+# Reject unsafe characters in $srcdir or the absolute working directory
+# name.  Accept space and tab only in the latter.
+am_lf='
+'
+case `pwd` in
+  *[[\\\"\#\$\&\'\`$am_lf]]*)
+    AC_MSG_ERROR([unsafe absolute working directory name]);;
+esac
+case $srcdir in
+  *[[\\\"\#\$\&\'\`$am_lf\ \	]]*)
+    AC_MSG_ERROR([unsafe srcdir value: `$srcdir']);;
+esac
+
 # Do `set' in a subshell so we don't clobber the current shell's
 # arguments.  Must try -L first in case configure is actually a
 # symlink; some systems play weird games with the mod time of symlinks
 # (eg FreeBSD returns the mod time of the symlink's containing
 # directory).
 if (
-   set X `ls -Lt $srcdir/configure conftest.file 2> /dev/null`
+   set X `ls -Lt "$srcdir/configure" conftest.file 2> /dev/null`
    if test "$[*]" = "X"; then
       # -L didn't work.
-      set X `ls -t $srcdir/configure conftest.file`
+      set X `ls -t "$srcdir/configure" conftest.file`
    fi
    rm -f conftest.file
    if test "$[*]" != "X $srcdir/configure conftest.file" \
@@ -1178,18 +1242,25 @@
 INSTALL_STRIP_PROGRAM="\$(install_sh) -c -s"
 AC_SUBST([INSTALL_STRIP_PROGRAM])])
 
-# Copyright (C) 2006  Free Software Foundation, Inc.
+# Copyright (C) 2006, 2008  Free Software Foundation, Inc.
 #
 # This file is free software; the Free Software Foundation
 # gives unlimited permission to copy and/or distribute it,
 # with or without modifications, as long as this notice is preserved.
 
+# serial 2
+
 # _AM_SUBST_NOTMAKE(VARIABLE)
 # ---------------------------
 # Prevent Automake from outputting VARIABLE = @VARIABLE@ in Makefile.in.
 # This macro is traced by Automake.
 AC_DEFUN([_AM_SUBST_NOTMAKE])
 
+# AM_SUBST_NOTMAKE(VARIABLE)
+# ---------------------------
+# Public sister of _AM_SUBST_NOTMAKE.
+AC_DEFUN([AM_SUBST_NOTMAKE], [_AM_SUBST_NOTMAKE($@)])
+
 # Check how to create a tarball.                            -*- Autoconf -*-
 
 # Copyright (C) 2004, 2005  Free Software Foundation, Inc.

=== modified file 'bin/ubuntuone-client-applet'
--- bin/ubuntuone-client-applet	2009-08-11 16:45:00 +0000
+++ bin/ubuntuone-client-applet	2009-08-26 12:15:00 +0000
@@ -36,10 +36,12 @@
 # pylint: disable-msg=F0401
 import pynotify
 
+from ConfigParser import ConfigParser
 from dbus.exceptions import DBusException
 from dbus.mainloop.glib import DBusGMainLoop
 from ubuntuone.oauthdesktop.main import Login
 from xdg.BaseDirectory import xdg_config_home
+from threading import Lock
 from urllib import quote
 
 from ubuntuone.oauthdesktop.logger import setupLogging
@@ -51,18 +53,30 @@
 
 _ = gettext.gettext
 
-# Wait for 30 seconds to get a proper login request
-LOGIN_TIMEOUT = 30
-
-# Prepend tooltip labels with this label
-TOOLTIP_TITLE = "Ubuntu One: "
-
 DBUS_IFACE_NAME = "com.ubuntuone.SyncDaemon"
 DBUS_IFACE_SYNC_NAME = "com.ubuntuone.SyncDaemon.SyncDaemon"
 DBUS_IFACE_STATUS_NAME = "com.ubuntuone.SyncDaemon.Status"
+DBUS_IFACE_CONFIG_NAME = "com.ubuntuone.SyncDaemon.Config"
 
 DBUS_IFACE_AUTH_NAME = "com.ubuntuone.Authentication"
 
+OAUTH_REALM = "https://ubuntuone.com"
+OAUTH_CONSUMER = "ubuntuone"
+BOOKMARK_NAME = "Ubuntu One"
+
+# Why thank you GTK+ for enforcing style-set and breaking API
+RCSTYLE = """
+style 'dialogs' {
+  GtkDialog::action-area-border = 12
+  GtkDialog::button-spacing = 6
+  GtkDialog::content-area-border = 0
+}
+widget_class '*Dialog*' style 'dialogs'
+"""
+
+CONF_FILE = os.path.join(xdg_config_home, "ubuntuone", "ubuntuone-client.conf")
+
+
 def dbus_async(*args):
       """Simple handler to make dbus do stuff async."""
       pass
@@ -77,9 +91,40 @@
             login = Login(dbus.service.BusName(DBUS_IFACE_AUTH_NAME,
                                                bus=dbus.SessionBus()))
 
+            logger.debug(_("Starting Ubuntu One client version %s") %
+                         clientdefs.VERSION)
+
             # Whether or not we are authorized
             self.is_authorized = False
 
+            # Load the config, with some defaults if it doesn't exist yet
+            if not os.path.isdir(os.path.dirname(CONF_FILE)):
+                  os.makedirs(os.path.dirname(CONF_FILE))
+
+            self.config = ConfigParser()
+            self.config.read(CONF_FILE)
+
+            if not self.config.has_section("ubuntuone"):
+                  self.config.add_section("ubuntuone")
+
+            if not self.config.has_option("ubuntuone", "show_applet"):
+                  self.config.set("ubuntuone", "show_applet", "1")
+
+            if not self.config.has_option("ubuntuone", "connect"):
+                  self.config.set("ubuntuone", "connect", "0")
+
+            if not self.config.has_option("ubuntuone", "connected"):
+                  self.config.set("ubuntuone", "connected", "False")
+
+            self.show_applet = self.config.getint("ubuntuone", "show_applet")
+            self.connect = self.config.getint("ubuntuone", "connect")
+            self.connected = self.config.getboolean("ubuntuone", "connected")
+
+            if not os.path.exists(CONF_FILE):
+                  with open(CONF_FILE, "w+b") as f:
+                        self.config.write(f)
+
+            # Handle some DBus signals
             self.__bus = dbus.SessionBus()
             self.__bus.add_signal_receiver(
                   handler_function=self.__new_credentials,
@@ -98,7 +143,7 @@
                   signal_name="OAuthError",
                   dbus_interface=DBUS_IFACE_AUTH_NAME)
 
-            self.__icon = AppletIcon(main=self)
+            self.__icon = AppletIcon(main=self, config=self.config)
 
       def __new_credentials(self, realm=None, consumer_key=None, sender=None):
             """Signal callback for when we get new credentials."""
@@ -107,26 +152,36 @@
             self.__start_storage_daemon()
             self.add_to_autostart()
 
+            if self.connect == 2:
+                  return
+
+            if self.connect == 1 and not self.connected:
+                  return
+
             try:
                   client = self.__bus.get_object(DBUS_IFACE_NAME, "/")
                   iface = dbus.Interface(client, DBUS_IFACE_SYNC_NAME)
                   iface.connect(reply_handler=dbus_async,
-                                error_handler=self.dbus_error)
+                                error_handler=self.sd_dbus_error)
             except DBusException, e:
-                  self.dbus_error(e)
+                  self.sd_dbus_error(e)
 
       def __auth_denied(self):
             """Signal callback for when auth was denied by user."""
             self.is_authorized = False
             self.remove_from_autostart()
 
+            def quit_error(e):
+                  """Only log when quit fails."""
+                  logger.error(_("Quit Error: %s") % e.get_dbus_message())
+
             try:
                   client = self.__bus.get_object(DBUS_IFACE_NAME, "/")
                   iface = dbus.Interface(client, DBUS_IFACE_SYNC_NAME)
                   iface.quit(reply_handler=dbus_async,
-                             error_handler=self.dbus_error)
+                             error_handler=quit_error)
             except DBusException, e:
-                  self.dbus_error(e)
+                  quit_error(e)
 
             from twisted.internet import reactor
             reactor.stop()
@@ -153,6 +208,7 @@
                   area = dialog.get_content_area()
 
                   hbox = gtk.HBox(spacing=12)
+                  hbox.set_border_width(12)
                   area.pack_start(hbox)
                   hbox.show()
 
@@ -185,19 +241,23 @@
 
                   dialog.show()
             else:
-                  logger.error("Got an error with no message!")
+                  logger.error(_("Got an OAuth error with no message."))
 
       def check_for_token(self, do_login=False):
             """Method to check for an existing token."""
+            def local_dbus_error(e):
+                  """Can't talk to ourself?"""
+                  logger.error(_("Internal Error: %s") % e.get_dbus_message())
+
             try:
                   client = self.__bus.get_object(DBUS_IFACE_AUTH_NAME, "/")
                   iface = dbus.Interface(client, DBUS_IFACE_AUTH_NAME)
-                  iface.maybe_login("https://ubuntuone.com", "ubuntuone",
+                  iface.maybe_login(OAUTH_REALM, OAUTH_CONSUMER,
                                     do_login,
                                     reply_handler=dbus_async,
-                                    error_handler=self.dbus_error)
+                                    error_handler=local_dbus_error)
             except DBusException, e:
-                  self.dbus_error(e)
+                  local_dbus_error(e)
                   return False
 
             return False
@@ -208,9 +268,9 @@
                   client = self.__bus.get_object(DBUS_IFACE_NAME, "/")
                   iface = dbus.Interface(client, DBUS_IFACE_SYNC_NAME)
                   iface.get_rootdir(reply_handler=dbus_async,
-                                    error_handler=self.dbus_error)
+                                    error_handler=self.sd_dbus_error)
             except DBusException, e:
-                  self.dbus_error(e)
+                  self.sd_dbus_error(e)
                   return False
 
             return False
@@ -261,9 +321,9 @@
             """Are we authorized?"""
             return self.is_authorized
 
-      def dbus_error(self, error):
+      def sd_dbus_error(self, error):
             """Got an error from DBus."""
-            self.__icon.dbus_error(error)
+            self.__icon.sd_dbus_error(error)
 
 
 
@@ -271,7 +331,7 @@
       """Utility method to run xdg-open with path_or_url."""
       ret = subprocess.call(["xdg-open", path_or_url])
       if ret != 0:
-            logger.debug("Failed to run 'xdg-open %s'" % path_or_url)
+            logger.error(_("Failed to run 'xdg-open %s'") % path_or_url)
 
 class AppletIcon(gtk.StatusIcon):
       """
@@ -279,13 +339,19 @@
       animated icons and a few other nice things.
       """
 
-      def __init__(self, main=None, *args, **kw):
+      def __init__(self, main=None, config=None, *args, **kw):
             """Initializes our custom StatusIcon based widget."""
             super(AppletIcon, self).__init__(*args, **kw)
+            # Hide until we get status, to avoid flickering
+            self.set_visible(False)
 
             # The AppletMain object
             self.__main = main
 
+            # A ConfigParser object that we can poke at
+            self.__config = config
+            self.__show_when = self.__config.getint("ubuntuone", "show_applet")
+
             self.__managed_dir = None
 
             self.__theme = gtk.icon_theme_get_default()
@@ -300,25 +366,16 @@
                         "usr", "local", "share", "ubuntuone-client", "icons"))
 
             self.set_from_icon_name('ubuntuone-client-offline')
-            self.set_tooltip(TOOLTIP_TITLE + _("Disconnected"))
+            self.set_tooltip(_("Disconnected"))
             self.connect("popup-menu", self.__popup_menu)
             self.connect("activate", self.__do_action)
 
-            self.__busy = False
-            self.__busy_id = 0
-
             self.__size = 24
-            self.__pixbuf = None
-
-            self.__vframes = 0
-            self.__hframes = 0
-            self.__vpos = 0
-            self.__hpos = 0
-
             self.__size_changed(self, self.__size)
 
-            self.__items = {}
-            self.__menu = self.__build_menus()
+            self.__litems = {}
+            self.__ritems = {}
+            self.__status_menu, self.__config_menu = self.__build_menus()
 
             self.__connected = False
             self.__need_update = False
@@ -326,6 +383,19 @@
 
             pynotify.init("Ubuntu One")
 
+            # Managing applet visibility
+            self.__visible = True
+            self.__visible_id = 0
+
+            # Up/Dn status
+            self.__lock = Lock()
+            self.__updating = 0
+            self.__total = 0
+            self.__last_id = 0
+
+            # Config dialog!
+            self.__conf_dialog = AppletConfigDialog(self, self.__config)
+
             self.__bus = dbus.SessionBus()
 
             self.__bus.add_signal_receiver(
@@ -333,70 +403,239 @@
                   signal_name="StatusChanged",
                   dbus_interface=DBUS_IFACE_STATUS_NAME)
 
+            self.__bus.add_signal_receiver(
+                  handler_function=self.__queue_changed,
+                  signal_name="ContentQueueChanged",
+                  dbus_interface=DBUS_IFACE_STATUS_NAME)
+            self.__bus.add_signal_receiver(
+                  handler_function=self.__transfer_started,
+                  signal_name="UploadStarted",
+                  dbus_interface=DBUS_IFACE_STATUS_NAME)
+            self.__bus.add_signal_receiver(
+                  handler_function=self.__transfer_started,
+                  signal_name="DownloadStarted",
+                  dbus_interface=DBUS_IFACE_STATUS_NAME)
+
             gobject.idle_add(self.__get_root)
 
+      def update_config(self):
+            """Update internal reference to the config when it changes."""
+            self.__show_when = self.__config.getint("ubuntuone", "show_applet")
+
+      def __update_transfer_status(self, done=False):
+            """Update the status display."""
+            with self.__lock:
+                  text = "Updating %(transfers)d of %(total)d files..." % (
+                        { 'transfers' : self.__updating,
+                          'total' : self.__total})
+            label = self.__litems["status"].get_child()
+            if done:
+                  self.set_tooltip(_("Files updated."))
+                  label.set_text(_("Your files are up to date."))
+            else:
+                  label.set_markup("<i>%s</i>" % text)
+
+      def __queue_changed(self, queue):
+            """Handle ContentQueueChanged."""
+            total = 0
+            d = queue.get('Download', None)
+            if d is not None:
+                  total += int(d.get('count', 0))
+            d = queue.get('Upload', None)
+            if d is not None:
+                  total += int(d.get('count', 0))
+            first = False
+            last = False
+            self.__visible = True
+            self.set_tooltip(_("Updating files..."))
+            self.update_visibility()
+            with self.__lock:
+                  if self.__total == 0:
+                        first = True
+                        last = False
+                  if self.__total != 0 and total == 0:
+                        first = False
+                        last = True
+                  self.__total = total + self.__updating
+            if first:
+                  n = pynotify.Notification(
+                        "Updating Files...",
+                        _("Ubuntu One is now updating your files."))
+                  pixbuf = self.__theme.load_icon(
+                        "ubuntuone-client", 24,
+                        gtk.ICON_LOOKUP_GENERIC_FALLBACK)
+                  n.set_icon_from_pixbuf(pixbuf)
+                  n.show()
+            if last:
+                  if self.__last_id != 0:
+                        gobject.source_remove(self.__last_id)
+                        self.__last_id = 0
+                  self.__last_id = gobject.timeout_add_seconds(
+                        15, self.__updating_completed)
+
+      def __updating_completed(self):
+            """Timeout to avoid multiple started/finished notifications."""
+            really_last = False
+            n = None
+            with self.__lock:
+                  done = self.__total - self.__updating
+                  if done == 0:
+                        really_last = True
+            if not really_last:
+                  return False
+
+            with self.__lock:
+                  n = pynotify.Notification(
+                        "Updating Finished",
+                        _("Ubuntu One finished updating %(total)d files.") %
+                        { 'total' : self.__total })
+                  self.__total = 0
+                  self.__updating = 0
+            pixbuf = self.__theme.load_icon(
+                  "ubuntuone-client", 24,
+                  gtk.ICON_LOOKUP_GENERIC_FALLBACK)
+            n.set_icon_from_pixbuf(pixbuf)
+            n.show()
+            self.__update_transfer_status(True)
+            return False
+
+      def __transfer_started(self, path):
+            """Handle the started signals."""
+            with self.__lock:
+                  self.__updating += 1
+            self.__update_transfer_status()
+
+      def update_visibility(self):
+            """Update the icon's visibility."""
+            if self.__visible_id != 0:
+                  gobject.source_remove(self.__visible_id)
+                  self.__visible_id = 0
+
+            if (self.__visible and self.__show_when != 2) or self.__fatal_error:
+                  self.set_visible(True)
+                  return
+
+            if self.__show_when == 2 and not self.__fatal_error:
+                  self.set_visible(False)
+                  return
+
+            # If the icon is shown, set up a timeout to hide it
+            if self.get_visible():
+                  self.__visible_id = gobject.timeout_add_seconds(
+                        30, self.__hide_icon)
+
       def __status_changed(self, status):
             """The sync daemon status changed."""
             if self.__managed_dir is None:
                 gobject.idle_add(self.__get_root)
-            if status['name'] == "OFFLINE" or \
-                      status['name'].startswith("INIT") or \
-                      status['name'].startswith("READY"):
-                  self.set_busy(False)
+
+            if self.__show_when != 0:
+                  self.__visible = False
+
+            state = status['name']
+
+            if self.__fatal_error and state != "UNKNOWN_ERROR":
+                  # Just blow your nose, and it's fixed, isn't it.
+                  self.__fatal_error = False
+                  self.__litems["connect"].set_sensitive(True)
+                  self.__litems["disconnect"].set_sensitive(True)
+                  
+            if state == "OFFLINE" or state.startswith("INIT") or \
+                      state.startswith("READY"):
                   self.set_from_icon_name("ubuntuone-client-offline")
-                  self.set_tooltip(TOOLTIP_TITLE + _("Disconnected"))
                   self.__connected = False
-            elif status['name'].startswith("IDLE"):
-                  self.set_busy(False)
-                  self.set_from_icon_name("ubuntuone-client")
-                  self.set_tooltip(TOOLTIP_TITLE + _("Idle"))
+                  self.__visible = True
+
+            elif state == "IDLE" or state.startswith("READING") or \
+                      state.startswith("SCANNING"):
                   self.__connected = True
-            elif status['name'] == "BAD_VERSION":
-                  self.set_busy(False)
-                  self.set_from_icon_name("ubuntuone-client-offline")
-                  self.set_tooltip(TOOLTIP_TITLE + _("Update Required"))
+                  if self.__show_when != 0:
+                        self.__visible = False
+
+            elif state == "AUTH_FAILED":
+                  self.set_from_icon_name("ubuntuone-client-error")
+                  self.set_tooltip(_("Authentication failed"))
                   self.__connected = False
-                  self.__need_update = True
-                  self.__items["connect"].set_sensitive(False)
+                  self.__visible = True
+
+                  def reauthorize_error(e):
+                        """Simple dbus error handler."""
+                        logger.error(_("Error clearing token: %s") % str(e))
+
+                  try:
+                        def token_cleared():
+                              """Do the next step."""
+                              if self.__main:
+                                    self.__main.check_for_token(True)
+
+                        client = self.__bus.get_object(DBUS_IFACE_AUTH_NAME,
+                                                       "/")
+                        iface = dbus.Interface(client, DBUS_IFACE_AUTH_NAME)
+                        iface.clear_token(OAUTH_REALM, OAUTH_CONSUMER,
+                                          reply_handler=token_cleared,
+                                          error_handler=reauthorize_error)
+                  except DBusException, e:
+                        reauthorize_error(e)
+
+            elif state == "UNKNOWN_ERROR":
+                  # Disable some menu items
+                  self.__litems["connect"].set_sensitive(False)
+                  self.__litems["disconnect"].set_sensitive(False)
+                  # Change the behavior to file a bug
+                  if self.__fatal_error:
+                        return
+
+                  self.__fatal_error = True
+                  self.__visible = True
+
+                  # Pop up a notification
                   n = pynotify.Notification(
                         "Ubuntu One",
-                        _("A new client version is required to continue " +
-                        "using the service. Please click the Ubuntu One" +
-                        "applet icon to upgrade."),
-                        "ubuntuone-client-offline")
+                        _("There was a fatal error in Ubuntu One. " +
+                          "This may be a bug in the software. "
+                          "Please click on the Ubuntu One icon " +
+                          "in your panel to report a bug."))
+                  pixbuf = self.__theme.load_icon(
+                        "ubuntuone-client-error", 24,
+                        gtk.ICON_LOOKUP_GENERIC_FALLBACK)
+                  n.set_icon_from_pixbuf(pixbuf)
                   n.set_urgency(pynotify.URGENCY_CRITICAL)
                   n.show()
-                  logger.debug("Invalid protocol version. Update needed.")
-            elif status['name'] == "AUTH_FAILED":
-                  self.set_busy(False)
-                  self.set_from_icon_name("ubuntuone-client-offline")
-                  self.set_tooltip(TOOLTIP_TITLE + _("Authentication failed"))
-                  self.__connected = False
-                  if self.__main:
-                        self.__main.check_for_token(True)
+                  # Set the tooltip and icon on the applet
+                  self.set_tooltip(_("Fatal Error"))
+                  self.set_from_icon_name("ubuntuone-client-error")
+
             else:
-                  self.set_busy()
                   self.__connected = True
-                  if status['name'].startswith("CONNECTING") or \
-                            status['name'].startswith("AUTHENTICATING") or \
-                            status['name'].startswith("CONNECTED"):
-                        self.set_tooltip(TOOLTIP_TITLE + _("Connecting"))
-                  elif status['name'].startswith("SCANNING") or \
-                            status['name'].startswith("READING"):
-                        self.set_tooltip(TOOLTIP_TITLE + _("Scanning"))
-                  elif status['name'].startswith("WORKING"):
-                        self.set_tooltip(TOOLTIP_TITLE + _("Synchronizing"))
-                  elif status['name'].startswith("UNKNOWN_ERROR"):
-                        pass
-                  else:
-                        self.set_tooltip(TOOLTIP_TITLE + _("Working"))
+                  self.set_from_icon_name("ubuntuone-client")
+                  if state.startswith("CONNECTING") or \
+                            state.startswith("START_CONNECTING") or \
+                            state.startswith("AUTHENTICATING") or \
+                            state.startswith("CONNECTED") or \
+                            state.startswith("START_CONNECTED"):
+                        self.set_from_icon_name("ubuntuone-client")
+                        self.set_tooltip(_("Connecting"))
+                        self.__visible = True
+
+            self.update_visibility()
 
             if self.__connected:
-                  self.__items["connect"].hide()
-                  self.__items["disconnect"].show()
+                  self.__litems["connect"].hide()
+                  self.__litems["disconnect"].show()
             else:
-                  self.__items["connect"].show()
-                  self.__items["disconnect"].hide()
+                  self.__litems["connect"].show()
+                  self.__litems["disconnect"].hide()
+            self.__config.set("ubuntuone", "connected", self.__connected)
+
+      def __hide_icon(self):
+            """Timeout to hide tray icon after a period of inactivity."""
+            if self.__show_visible == 0:
+                  return False
+
+            self.__visible = False
+            self.__visible_id = 0
+            self.set_visible(False)
+            return False
 
       def __get_root(self):
             """Method to get the rootdir from the sync daemon."""
@@ -415,16 +654,16 @@
                   if os.path.isdir(self.__managed_dir) and \
                             os.access(self.__managed_dir,
                                       os.F_OK | os.R_OK):
-                        self.__items["open"].set_sensitive(True)
+                        self.__ritems["open"].set_sensitive(True)
                         self.__add_to_places()
                   else:
-                        self.__items["open"].set_sensitive(False)
+                        self.__ritems["open"].set_sensitive(False)
 
             def got_err(error):
                   """Handle error from the dbus callback."""
-                  self.dbus_error(error)
+                  self.sd_dbus_error(error)
                   self.__managed_dir = None
-                  self.__items["open"].set_sensitive(False)
+                  self.__ritems["open"].set_sensitive(False)
 
             iface.get_rootdir(reply_handler=got_root, error_handler=got_err)
 
@@ -433,58 +672,78 @@
                   client = self.__bus.get_object(DBUS_IFACE_NAME, "/status")
                   iface = dbus.Interface(client, DBUS_IFACE_STATUS_NAME)
                   iface.current_status(reply_handler=self.__status_changed,
-                                       error_handler=self.dbus_error)
+                                       error_handler=self.sd_dbus_error)
             except DBusException, e:
-                  self.dbus_error(e)
+                  self.sd_dbus_error(e)
                   return False
 
             return False
 
       def __build_menus(self):
             """Create the pop-up menu items."""
-            menu = gtk.Menu()
-
-            self.__items["connect"] = gtk.ImageMenuItem(stock_id=gtk.STOCK_CONNECT)
-            menu.append(self.__items["connect"])
-            self.__items["connect"].connect("activate", self.__toggle_state)
-            self.__items["connect"].show()
-
-            self.__items["disconnect"] = gtk.ImageMenuItem(stock_id=gtk.STOCK_DISCONNECT)
-            menu.append(self.__items["disconnect"])
-            self.__items["disconnect"].connect("activate", self.__toggle_state)
-
-            sep = gtk.SeparatorMenuItem()
-            menu.append(sep)
-            sep.show()
-
-            self.__items["bug"] = gtk.MenuItem(label=_("_Report a Problem"))
-            menu.append(self.__items["bug"])
-            self.__items["bug"].connect("activate", self.__report_problem)
-            self.__items["bug"].show()
-
-            self.__items["open"] = gtk.MenuItem(label=_("_Open Folder"))
-            menu.append(self.__items["open"])
-            self.__items["open"].connect("activate", self.__open_folder)
-            self.__items["open"].set_sensitive(False)
-            self.__items["open"].show()
-
-            self.__items["web"] = gtk.MenuItem(label=_("_Go to Web"))
-            menu.append(self.__items["web"])
-            self.__items["web"].connect("activate", self.__open_website)
-            self.__items["web"].show()
-
-            sep = gtk.SeparatorMenuItem()
-            menu.append(sep)
-            sep.show()
-
-            self.__items["quit"] = gtk.ImageMenuItem(stock_id=gtk.STOCK_QUIT)
-            menu.append(self.__items["quit"])
-            self.__items["quit"].connect("activate", self.__quit_applet)
-            self.__items["quit"].show()
-
-            menu.show()
-
-            return menu
+            # Create the left-click menu
+            lmenu = gtk.Menu()
+
+            self.__litems["status"] = gtk.MenuItem(
+                  label=_("Your files are up to date."))
+            lmenu.append(self.__litems["status"])
+            self.__litems["status"].set_sensitive(False)
+            self.__litems["status"].show()
+
+            sep = gtk.SeparatorMenuItem()
+            lmenu.append(sep)
+            sep.show()
+
+            self.__litems["connect"] = gtk.ImageMenuItem(
+                  stock_id=gtk.STOCK_CONNECT)
+            lmenu.append(self.__litems["connect"])
+            self.__litems["connect"].connect("activate", self.__toggle_state)
+            self.__litems["connect"].show()
+
+            self.__litems["disconnect"] = gtk.ImageMenuItem(
+                  stock_id=gtk.STOCK_DISCONNECT)
+            lmenu.append(self.__litems["disconnect"])
+            self.__litems["disconnect"].connect("activate", self.__toggle_state)
+
+            lmenu.show()
+
+            # Create the right-click menu
+            rmenu = gtk.Menu()
+
+            self.__ritems["bug"] = gtk.MenuItem(label=_("_Report a Problem"))
+            rmenu.append(self.__ritems["bug"])
+            self.__ritems["bug"].connect("activate", self.__report_problem)
+            self.__ritems["bug"].show()
+
+            self.__ritems["open"] = gtk.MenuItem(label=_("_Open Folder"))
+            rmenu.append(self.__ritems["open"])
+            self.__ritems["open"].connect("activate", self.__open_folder)
+            self.__ritems["open"].set_sensitive(False)
+            self.__ritems["open"].show()
+
+            self.__ritems["web"] = gtk.MenuItem(label=_("_Go to Web"))
+            rmenu.append(self.__ritems["web"])
+            self.__ritems["web"].connect("activate", self.__open_website)
+            self.__ritems["web"].show()
+
+            self.__ritems["config"] = gtk.ImageMenuItem(
+                  stock_id=gtk.STOCK_PREFERENCES)
+            rmenu.append(self.__ritems["config"])
+            self.__ritems["config"].connect("activate", self.__open_config)
+            self.__ritems["config"].show()
+
+            sep = gtk.SeparatorMenuItem()
+            rmenu.append(sep)
+            sep.show()
+
+            self.__ritems["quit"] = gtk.ImageMenuItem(stock_id=gtk.STOCK_QUIT)
+            rmenu.append(self.__ritems["quit"])
+            self.__ritems["quit"].connect("activate", self.__quit_applet)
+            self.__ritems["quit"].show()
+
+            rmenu.show()
+
+            return lmenu, rmenu
 
       def __size_changed(self, icon, size, data=None):
             """Callback for when the size changes."""
@@ -499,67 +758,33 @@
             else:
                   self.__size = size
 
-            self.__pixbuf = self.__theme.load_icon(
-                  'ubuntuone-client-working',
-                  self.__size,
-                  gtk.ICON_LOOKUP_GENERIC_FALLBACK)
-
-            self.__hframes = self.__pixbuf.get_width() / self.__size
-            self.__vframes = self.__pixbuf.get_height() / self.__size
-
-            return True
-
-
-      def __spinner_timeout(self):
-            """Timeout callback that spins the spinner."""
-            # This is wrong
-            if not self.__busy:
-                  return False
-
-            # Skip the first (resting) frame to avoid flicker
-            if self.__hpos == 0 and self.__vpos == 0:
-                  self.__hpos = 1
-
-            x = self.__size * self.__hpos
-            y = self.__size * self.__vpos
-            pixbuf = self.__pixbuf.subpixbuf(x, y, self.__size, self.__size)
-            self.set_from_pixbuf(pixbuf)
-
-            self.__hpos += 1
-            if self.__hpos == self.__hframes:
-                  self.__hpos = 0
-                  self.__vpos += 1
-            if self.__vpos >= self.__vframes:
-                  self.__vpos = 0
-
-            return True
-
-      def set_busy(self, busy=True):
-            if self.__busy and busy:
-                  return
-
-            if self.__busy_id:
-                  gobject.source_remove(self.__busy_id)
-
-            self.__busy = busy
-            self.__busy_id = gobject.timeout_add(100,
-                                                 self.__spinner_timeout)
-
       def __popup_menu(self, icon, button, timestamp, data=None):
             """Pops up the context menu for the tray icon."""
-            self.__menu.popup(None, None, gtk.status_icon_position_menu,
-                              button, timestamp, icon)
+            if button == 0:
+                  self.__status_menu.popup(None, None,
+                                           gtk.status_icon_position_menu,
+                                           button, timestamp, icon)
+            else:
+                  self.__config_menu.popup(None, None,
+                                           gtk.status_icon_position_menu,
+                                           button, timestamp, icon)
 
       def __quit_applet(self, menuitem, data=None):
             """Quit the daemon and closes the applet."""
+            with open(CONF_FILE, "w+b") as f:
+                  self.__config.write(f)
+
+            def quit_error(e):
+                  """Just log and ignore."""
+                  logger.error(_("Quit Error: %s") % e.get_dbus_message())
 
             try:
                   client = self.__bus.get_object(DBUS_IFACE_NAME, "/")
                   iface = dbus.Interface(client, DBUS_IFACE_SYNC_NAME)
                   iface.quit(reply_handler=dbus_async,
-                             error_handler=self.dbus_error)
+                             error_handler=quit_error)
             except DBusException, e:
-                  self.dbus_error(e)
+                  quit_error(e)
 
             from twisted.internet import reactor
             reactor.stop()
@@ -571,14 +796,18 @@
                   iface = dbus.Interface(client, DBUS_IFACE_SYNC_NAME)
                   if self.__connected:
                         iface.disconnect(reply_handler=dbus_async,
-                                         error_handler=self.dbus_error)
+                                         error_handler=self.sd_dbus_error)
                   else:
                         if self.__main and self.__main.authorized is False:
                               self.__main.check_for_token(do_login=True)
                         iface.connect(reply_handler=dbus_async,
-                                      error_handler=self.dbus_error)
+                                      error_handler=self.sd_dbus_error)
             except DBusException, e:
-                  self.dbus_error(e)
+                  self.sd_dbus_error(e)
+
+            self.__config.set("ubuntuone", "connected", not self.__connected)
+            with open(CONF_FILE, "w+b") as f:
+                  self.__config.write(f)
 
       def __open_folder(self, data=None):
             """Opens the storage folder in the file manager."""
@@ -598,14 +827,15 @@
                   do_xdg_open("apt:ubuntuone-storage-protocol?refresh=yes")
                   return
 
-            self.__open_folder()
+            # Popup the status menu
+            self.emit("popup-menu", 0, gtk.get_current_event_time())
 
       def __report_problem(self, data=None):
             """Runs apport to report a problem against our code."""
             args = ["ubuntu-bug", "ubuntuone-client"]
             ret = subprocess.call(args)
             if ret != 0:
-                  logger.error("Failed to run 'ubuntu-bug'")
+                  logger.error(_("Failed to run 'ubuntu-bug'"))
 
       def __open_website(self, data=None, url=None):
             """Opens the ubuntuone.com web site."""
@@ -614,13 +844,20 @@
             else:
                   do_xdg_open("https://ubuntuone.com/")
 
+
+      def __open_config(self, data=None):
+            """Opens the preferences dialog."""
+            self.__conf_dialog.show()
+
       def __add_to_places(self):
             """Add the managed directory to the .gtk-bookmarks file."""
+            # migrate from the old places bookmark
+            if os.path.basename(self.__managed_dir) != BOOKMARK_NAME:
+                self.__remove_from_places(os.path.dirname(self.__managed_dir))
             path = os.path.join(os.path.expanduser("~"), ".gtk-bookmarks")
             with open(path, "a+") as f:
                   bookmarks_entry = "file://%s %s\n" % (
-                        quote(self.__managed_dir),
-                        os.path.basename(self.__managed_dir))
+                        quote(self.__managed_dir), BOOKMARK_NAME)
                   in_file = False
                   for line in f:
                         if line == bookmarks_entry:
@@ -642,33 +879,265 @@
                   output = "".join(lines)
                   f.write(output)
 
-      def dbus_error(self, error):
-            """Handle DBus errors and change the applet behavior slightly."""
-            logger.debug("DBusError: %s" % error.get_dbus_message())
-            # Disable some menu items
-            self.__items["connect"].set_sensitive(False)
-            self.__items["disconnect"].set_sensitive(False)
-            # Change the behavior to file a bug
-            if self.__fatal_error:
-                  return
-
-            self.__fatal_error = True
-            # Pop up a notification
-            n = pynotify.Notification(
-                  "Ubuntu One",
-                  _("There was a problem starting the ubuntuone-syncdaemon. " +
-                    "This may be a bug in the software. Please click on the " +
-                    "Ubuntu One icon in your panel to report a bug."))
-            pixbuf = self.__theme.load_icon("ubuntuone-client-error", 24,
-                                            gtk.ICON_LOOKUP_GENERIC_FALLBACK)
-            n.set_icon_from_pixbuf(pixbuf)
-            #n.set_urgency(pynotify.URGENCY_CRITICAL)
-            n.show()
-            # Set the tooltip and icon on the applet
-            self.set_tooltip(TOOLTIP_TITLE + _("Fatal Error"))
-            self.set_from_icon_name("ubuntuone-client-error")
-
-
+      def sd_dbus_error(self, error):
+            """
+            Handle DBus errors for crucial syncdaemon calls,
+            and change the applet behavior slightly.
+            """
+            logger.error(_("DBus Error: %s") % error.get_dbus_message())
+            sd_path = os.path.join(clientdefs.LIBEXECDIR,
+                                   "ubuntuone-syncdaemon")
+            try:
+                  p = subprocess.Popen([sd_path],
+                                       bufsize=4096,
+                                       stderr=subprocess.PIPE)
+                  if p.returncode:
+                        errors = "".join(p.stderr.readlines())
+                        if errors != "":
+                              print "Failure to launch:\n%s" % errors
+                              self.__status_changed({'name' : 'UNKNOWN_ERROR'})
+                  else:
+                        self.__status_changed({'name' : 'OFFLINE'})
+            except (OSError, IOError), e:
+                  logger.error(_("Failed to launch syncdaemon: %s") %
+                               str(e))
+                  self.__status_changed({'name' : 'UNKNOWN_ERROR'})
+
+
+class AppletConfigDialog(gtk.Dialog):
+      """Preferences dialog."""
+
+      def __init__(self, icon=None, config=None, *args, **kw):
+            """Initializes our custom StatusIcon based widget."""
+            super(AppletConfigDialog, self).__init__(*args, **kw)
+            self.set_title(_("Ubuntu One Preferences"))
+            self.set_has_separator(False)
+            self.add_button(gtk.STOCK_CLOSE, gtk.RESPONSE_CLOSE)
+            self.set_default_response(gtk.RESPONSE_CLOSE)
+            self.set_icon_name("ubuntuone-client")
+
+            self.connect("close", self.__handle_response, gtk.RESPONSE_CLOSE)
+            self.connect("response", self.__handle_response)
+
+            self.__icon = icon
+            self.config = config
+
+            self.bw_enabled = False
+            self.up_limit = 2097152
+            self.dn_limit = 2097152
+
+            self.__bus = dbus.SessionBus()
+
+            try:
+                  client = self.__bus.get_object(DBUS_IFACE_NAME, "/config")
+                  iface = dbus.Interface(client, DBUS_IFACE_CONFIG_NAME)
+                  iface.get_throttling_limits(
+                        reply_handler=self.__got_limits,
+                        error_handler=self.__throttle_error)
+                  iface.bandwidth_throttling_enabled(
+                        reply_handler=self.__got_enabled,
+                        error_handler=self.__throttle_error)
+            except DBusException, e:
+                  self.__throttle_error(e)
+
+            # Timeout ID to avoid spamming DBus from spinbutton changes
+            self.__update_id = 0
+
+            self.__construct()
+
+
+      def __throttle_error(self, error):
+            """Error getting throttling config."""
+            logger.error(_("Error getting throttle config: %s") %
+                         error.get_dbus_message())
+
+      def __got_limits(self, limits):
+            """Got the throttling limits."""
+            self.up_limit = int(limits['upload'])
+            self.dn_limit = int(limits['download'])
+
+      def __got_enabled(self, enabled):
+            """Got the throttling enabled config."""
+            self.bw_enabled = bool(enabled)
+
+      def __update_bw_settings(self):
+            """Update the bandwidth throttling config in syncdaemon."""
+            self.bw_enabled = self.limit_check.get_active()
+            self.up_limit = self.up_spin.get_value_as_int() * 1024
+            self.dn_limit = self.dn_spin.get_value_as_int() * 1024
+
+            try:
+                  client = self.__bus.get_object(DBUS_IFACE_NAME, "/config")
+                  iface = dbus.Interface(client, DBUS_IFACE_CONFIG_NAME)
+                  iface.set_throttling_limits(self.dn_limit, self.up_limit,
+                        reply_handler=dbus_async,
+                        error_handler=self.__throttle_error)
+                  if self.bw_enabled:
+                        iface.enable_bandwidth_throttling(
+                              reply_handler=dbus_async,
+                              error_handler=self.__throttle_error)
+                  else:
+                        iface.disable_bandwidth_throttling(
+                              reply_handler=dbus_async,
+                              error_handler=self.__throttle_error)
+            except DBusException, e:
+                  self.__throttle_error(e)
+
+      def __handle_response(self, dialog, response):
+            """Handle the dialog's response."""
+            self.hide()
+            self.config.set("ubuntuone", "show_applet",
+                            self.show_menu.get_active())
+            self.config.set("ubuntuone", "connect",
+                            self.conn_menu.get_active())
+
+            self.__update_bw_settings()
+
+            with open(CONF_FILE, "w+b") as f:
+                  self.config.write(f)
+
+      def __show_menu_changed(self, menu, data=None):
+            """Update the config for showing the applet."""
+            value = menu.get_active()
+            self.config.set("ubuntuone", "show_applet", str(value))
+            self.__icon.update_config()
+            self.__icon.update_visibility()
+
+      def __conn_menu_changed(self, menu, data=None):
+            """Update the config for showing the applet."""
+            self.config.set("ubuntuone", "connect", str(menu.get_active()))
+
+      def __bw_limit_toggled(self, button, data=None):
+            """Toggle the bw limit panel."""
+            self.bw_enabled = self.limit_check.get_active()
+            self.bw_table.set_sensitive(self.bw_enabled)
+            try:
+                  client = self.__bus.get_object(DBUS_IFACE_NAME, "/config")
+                  iface = dbus.Interface(client, DBUS_IFACE_CONFIG_NAME)
+                  iface.set_throttling_limits(self.dn_limit, self.up_limit,
+                        reply_handler=dbus_async,
+                        error_handler=self.__throttle_error)
+                  if self.bw_enabled:
+                        iface.enable_bandwidth_throttling(
+                              reply_handler=dbus_async,
+                              error_handler=self.__throttle_error)
+                  else:
+                        iface.disable_bandwidth_throttling(
+                              reply_handler=dbus_async,
+                              error_handler=self.__throttle_error)
+            except DBusException, e:
+                  self.__throttle_error(e)
+
+      def __spinner_changed(self, button, data=None):
+            """Remove timeout and add anew."""
+            if self.__update_id != 0:
+                  gobject.source_remove(self.__update_id)
+
+            self.__update_id = gobject.timeout_add_seconds(
+                  1, self.__update_bw_settings)
+
+      def __construct(self):
+            """Construct the dialog's layout."""
+            area = self.get_content_area()
+
+            vbox = gtk.VBox(spacing=12)
+            vbox.set_border_width(12)
+            area.add(vbox)
+            vbox.show()
+
+            # Put the first set of options in a table.
+            table = gtk.Table(rows=2, columns=2)
+            table.set_row_spacings(12)
+            table.set_col_spacings(6)
+            vbox.add(table)
+            table.show()
+
+            label = gtk.Label(_("_Show icon:"))
+            label.set_use_underline(True)
+            label.set_alignment(0, 0.5)
+            table.attach(label, 0, 1, 0, 1)
+            label.show()
+
+            self.show_menu = gtk.combo_box_new_text()
+            self.show_menu.connect("changed", self.__show_menu_changed)
+            label.set_mnemonic_widget(self.show_menu)
+            self.show_menu.append_text(_("Always"))
+            self.show_menu.append_text(_("When updating"))
+            self.show_menu.append_text(_("Never"))
+            self.show_menu.set_active(self.config.getint("ubuntuone",
+                                                         "show_applet"))
+            table.attach(self.show_menu, 1, 2, 0, 1)
+            self.show_menu.show()
+
+            label = gtk.Label(_("Connect on start:"))
+            label.set_use_underline(True)
+            label.set_alignment(0, 0.5)
+            table.attach(label, 0, 1, 1, 2)
+            label.show()
+
+            self.conn_menu = gtk.combo_box_new_text()
+            self.conn_menu.connect("changed", self.__conn_menu_changed)
+            label.set_mnemonic_widget(self.conn_menu)
+            self.conn_menu.append_text(_("Automatically"))
+            self.conn_menu.append_text(_("Remember last"))
+            self.conn_menu.append_text(_("Never"))
+            self.conn_menu.set_active(self.config.getint("ubuntuone",
+                                                         "connect"))
+            table.attach(self.conn_menu, 1, 2, 1, 2)
+            self.conn_menu.show()
+
+            # Bandwidth limiting
+            self.limit_check = gtk.CheckButton(_("_Limit Bandwidth Usage"))
+            self.limit_check.connect("toggled", self.__bw_limit_toggled)
+            vbox.add(self.limit_check)
+            self.limit_check.show()
+
+            hbox = gtk.HBox(spacing=12)
+            vbox.add(hbox)
+            hbox.show()
+
+            label = gtk.Label()
+            hbox.add(label)
+            label.show()
+
+            # Now put the bw limit bits in a table too
+            self.bw_table = gtk.Table(rows=2, columns=2)
+            self.bw_table.set_row_spacings(6)
+            self.bw_table.set_col_spacings(6)
+            self.bw_table.set_sensitive(False)
+            hbox.add(self.bw_table)
+            self.bw_table.show()
+
+            # Upload speed
+            label = gtk.Label(_("Maximum _upload speed (KB/s):"))
+            label.set_use_underline(True)
+            label.set_alignment(0, 0.5)
+            self.bw_table.attach(label, 0, 1, 0, 1)
+            label.show()
+
+            adjustment = gtk.Adjustment(value=2048.0, lower=0.0, upper=4096.0,
+                                        step_incr=64.0, page_incr=128.0)
+            self.up_spin = gtk.SpinButton(adjustment)
+            self.up_spin.connect("value-changed", self.__spinner_changed)
+            label.set_mnemonic_widget(self.up_spin)
+            self.bw_table.attach(self.up_spin, 1, 2, 0, 1)
+            self.up_spin.show()
+
+            # Download speed
+            label = gtk.Label(_("Maximum _download speed (KB/s):"))
+            label.set_use_underline(True)
+            label.set_alignment(0, 0.5)
+            self.bw_table.attach(label, 0, 1, 1, 2)
+            label.show()
+            adjustment = gtk.Adjustment(value=2048.0, lower=0.0, upper=4096.0,
+                                        step_incr=64.0, page_incr=128.0)
+            self.dn_spin = gtk.SpinButton(adjustment)
+            self.dn_spin.connect("value-changed", self.__spinner_changed)
+            label.set_mnemonic_widget(self.dn_spin)
+            self.bw_table.attach(self.dn_spin, 1, 2, 1, 2)
+            self.dn_spin.show()
+
+            
 if __name__ == "__main__":
       gettext.bindtextdomain(clientdefs.GETTEXT_PACKAGE, clientdefs.LOCALEDIR)
       gettext.textdomain(clientdefs.GETTEXT_PACKAGE)
@@ -679,5 +1148,7 @@
             print _("Ubuntu One client applet already running, quitting")
             sys.exit(-1)
 
+      gtk.rc_parse_string(RCSTYLE)
+
       icon = AppletMain()
       icon.main()

=== modified file 'bin/ubuntuone-syncdaemon'
--- bin/ubuntuone-syncdaemon	2009-08-11 16:45:00 +0000
+++ bin/ubuntuone-syncdaemon	2009-08-26 12:15:00 +0000
@@ -36,7 +36,7 @@
 
 from configglue import configglue
 from twisted.internet import reactor
-from xdg.BaseDirectory import xdg_config_dirs, xdg_cache_home
+from xdg.BaseDirectory import xdg_config_dirs, xdg_cache_home, xdg_data_home
 
 dbus.mainloop.glib.DBusGMainLoop(set_as_default=True)
 
@@ -48,13 +48,20 @@
     return os.path.expanduser(value)
 
 
-def cache_dir_parser(value):
+def xdg_cache_dir_parser(value):
     """ Parser for the data_dir option.
     returns the path using xdg_cache_home + value.
     """
     return os.path.join(xdg_cache_home, value)
 
 
+def xdg_data_dir_parser(value):
+    """ Parser for the data_dir option.
+    returns the path using xdg_data_home + value.
+    """
+    return os.path.join(xdg_data_home, value)
+
+
 def log_level_parser(value):
     level = getattr(logging, value, None)
     if level is None:
@@ -105,8 +112,9 @@
     (parser, options, argv) = configglue(file(configs[0]), *configs[1:], 
                                args=args, usage=usage,
                                extra_parsers=[('home_dir', home_dir_parser),
-                                              ('cache_dir', cache_dir_parser),
-                                              ('log_level', log_level_parser)])
+                                          ('xdg_cache', xdg_cache_dir_parser),
+                                          ('xdg_data', xdg_data_dir_parser),
+                                          ('log_level', log_level_parser)])
 
     if options.debug:
         logger.set_debug('stdout file')
@@ -126,23 +134,15 @@
     if not os.path.exists(options.data_dir):
         os.makedirs(options.data_dir)
 
-    if not os.path.exists(options.root_dir):
-        os.makedirs(options.root_dir)
-
-    user_root_dir = os.path.join(options.root_dir, 'My Files')
-    shares_root_dir = os.path.join(options.root_dir, 'Shared With Me')
-    if not os.path.exists(options.root_dir):
-        os.makedirs(options.root_dir)
-    # make the root read only
-    os.chmod(options.root_dir, 0555)
-
-    main = Main(user_root_dir, shares_root_dir, options.data_dir,
+    main = Main(options.root_dir, options.shares_dir, options.data_dir,
                 host=options.host, port=int(options.port), 
                 dns_srv=options.dns_srv, ssl=True,
                 disable_ssl_verify=options.disable_ssl_verify,
                 realm=options.realm, mark_interval=options.mark_interval,
-                fsync_md=not options.disable_fsync_md, 
-                dbus_events=options.send_events_over_dbus)
+                dbus_events=options.send_events_over_dbus,
+                handshake_timeout=options.handshake_timeout,
+                max_handshake_timeouts=options.max_handshake_timeouts,
+                shares_symlink_name='Shared With Me')
     if options.oauth:
         try:
             (key, secret) = options.oauth.split(':', 2)

=== modified file 'configure'
--- configure	2009-08-11 16:45:00 +0000
+++ configure	2009-08-26 12:15:00 +0000
@@ -1,6 +1,6 @@
 #! /bin/sh
 # Guess values for system-dependent variables and create Makefiles.
-# Generated by GNU Autoconf 2.64 for ubuntuone-client 0.92.0.
+# Generated by GNU Autoconf 2.64 for ubuntuone-client 0.93.0.
 #
 # Copyright (C) 1992, 1993, 1994, 1995, 1996, 1998, 1999, 2000, 2001,
 # 2002, 2003, 2004, 2005, 2006, 2007, 2008, 2009 Free Software
@@ -695,8 +695,8 @@
 # Identity of this package.
 PACKAGE_NAME='ubuntuone-client'
 PACKAGE_TARNAME='ubuntuone-client'
-PACKAGE_VERSION='0.92.0'
-PACKAGE_STRING='ubuntuone-client 0.92.0'
+PACKAGE_VERSION='0.93.0'
+PACKAGE_STRING='ubuntuone-client 0.93.0'
 PACKAGE_BUGREPORT=''
 PACKAGE_URL=''
 
@@ -737,7 +737,9 @@
 # include <unistd.h>
 #endif"
 
-ac_subst_vars='LTLIBOBJS
+ac_subst_vars='am__EXEEXT_FALSE
+am__EXEEXT_TRUE
+LTLIBOBJS
 LIBOBJS
 DBUS_SERVICES_DIR
 DBUS_LIBS
@@ -1468,7 +1470,7 @@
   # Omit some internal or obsolete options to make the list less imposing.
   # This message is too long to be a string in the A/UX 3.1 sh.
   cat <<_ACEOF
-\`configure' configures ubuntuone-client 0.92.0 to adapt to many kinds of systems.
+\`configure' configures ubuntuone-client 0.93.0 to adapt to many kinds of systems.
 
 Usage: $0 [OPTION]... [VAR=VALUE]...
 
@@ -1539,7 +1541,7 @@
 
 if test -n "$ac_init_help"; then
   case $ac_init_help in
-     short | recursive ) echo "Configuration of ubuntuone-client 0.92.0:";;
+     short | recursive ) echo "Configuration of ubuntuone-client 0.93.0:";;
    esac
   cat <<\_ACEOF
 
@@ -1651,7 +1653,7 @@
 test -n "$ac_init_help" && exit $ac_status
 if $ac_init_version; then
   cat <<\_ACEOF
-ubuntuone-client configure 0.92.0
+ubuntuone-client configure 0.93.0
 generated by GNU Autoconf 2.64
 
 Copyright (C) 2009 Free Software Foundation, Inc.
@@ -1929,7 +1931,7 @@
 This file contains any messages produced by compilers while
 running configure, to aid debugging if configure makes a mistake.
 
-It was created by ubuntuone-client $as_me 0.92.0, which was
+It was created by ubuntuone-client $as_me 0.93.0, which was
 generated by GNU Autoconf 2.64.  Invocation command line was
 
   $ $0 $@
@@ -2278,7 +2280,7 @@
 
 
 
-am__api_version='1.10'
+am__api_version='1.11'
 
 ac_aux_dir=
 for ac_dir in "$srcdir" "$srcdir/.." "$srcdir/../.."; do
@@ -2401,16 +2403,29 @@
 # Just in case
 sleep 1
 echo timestamp > conftest.file
+# Reject unsafe characters in $srcdir or the absolute working directory
+# name.  Accept space and tab only in the latter.
+am_lf='
+'
+case `pwd` in
+  *[\\\"\#\$\&\'\`$am_lf]*)
+    as_fn_error "unsafe absolute working directory name" "$LINENO" 5;;
+esac
+case $srcdir in
+  *[\\\"\#\$\&\'\`$am_lf\ \	]*)
+    as_fn_error "unsafe srcdir value: \`$srcdir'" "$LINENO" 5;;
+esac
+
 # Do `set' in a subshell so we don't clobber the current shell's
 # arguments.  Must try -L first in case configure is actually a
 # symlink; some systems play weird games with the mod time of symlinks
 # (eg FreeBSD returns the mod time of the symlink's containing
 # directory).
 if (
-   set X `ls -Lt $srcdir/configure conftest.file 2> /dev/null`
+   set X `ls -Lt "$srcdir/configure" conftest.file 2> /dev/null`
    if test "$*" = "X"; then
       # -L didn't work.
-      set X `ls -t $srcdir/configure conftest.file`
+      set X `ls -t "$srcdir/configure" conftest.file`
    fi
    rm -f conftest.file
    if test "$*" != "X $srcdir/configure conftest.file" \
@@ -2448,7 +2463,14 @@
 # expand $ac_aux_dir to an absolute path
 am_aux_dir=`cd $ac_aux_dir && pwd`
 
-test x"${MISSING+set}" = xset || MISSING="\${SHELL} $am_aux_dir/missing"
+if test x"${MISSING+set}" != xset; then
+  case $am_aux_dir in
+  *\ * | *\	*)
+    MISSING="\${SHELL} \"$am_aux_dir/missing\"" ;;
+  *)
+    MISSING="\${SHELL} $am_aux_dir/missing" ;;
+  esac
+fi
 # Use eval to expand $SHELL
 if eval "$MISSING --run true"; then
   am_missing_run="$MISSING --run "
@@ -2458,6 +2480,115 @@
 $as_echo "$as_me: WARNING: \`missing' script is too old or missing" >&2;}
 fi
 
+if test x"${install_sh}" != xset; then
+  case $am_aux_dir in
+  *\ * | *\	*)
+    install_sh="\${SHELL} '$am_aux_dir/install-sh'" ;;
+  *)
+    install_sh="\${SHELL} $am_aux_dir/install-sh"
+  esac
+fi
+
+# Installed binaries are usually stripped using `strip' when the user
+# run `make install-strip'.  However `strip' might not be the right
+# tool to use in cross-compilation environments, therefore Automake
+# will honor the `STRIP' environment variable to overrule this program.
+if test "$cross_compiling" != no; then
+  if test -n "$ac_tool_prefix"; then
+  # Extract the first word of "${ac_tool_prefix}strip", so it can be a program name with args.
+set dummy ${ac_tool_prefix}strip; ac_word=$2
+{ $as_echo "$as_me:${as_lineno-$LINENO}: checking for $ac_word" >&5
+$as_echo_n "checking for $ac_word... " >&6; }
+if test "${ac_cv_prog_STRIP+set}" = set; then :
+  $as_echo_n "(cached) " >&6
+else
+  if test -n "$STRIP"; then
+  ac_cv_prog_STRIP="$STRIP" # Let the user override the test.
+else
+as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
+for as_dir in $PATH
+do
+  IFS=$as_save_IFS
+  test -z "$as_dir" && as_dir=.
+    for ac_exec_ext in '' $ac_executable_extensions; do
+  if { test -f "$as_dir/$ac_word$ac_exec_ext" && $as_test_x "$as_dir/$ac_word$ac_exec_ext"; }; then
+    ac_cv_prog_STRIP="${ac_tool_prefix}strip"
+    $as_echo "$as_me:${as_lineno-$LINENO}: found $as_dir/$ac_word$ac_exec_ext" >&5
+    break 2
+  fi
+done
+  done
+IFS=$as_save_IFS
+
+fi
+fi
+STRIP=$ac_cv_prog_STRIP
+if test -n "$STRIP"; then
+  { $as_echo "$as_me:${as_lineno-$LINENO}: result: $STRIP" >&5
+$as_echo "$STRIP" >&6; }
+else
+  { $as_echo "$as_me:${as_lineno-$LINENO}: result: no" >&5
+$as_echo "no" >&6; }
+fi
+
+
+fi
+if test -z "$ac_cv_prog_STRIP"; then
+  ac_ct_STRIP=$STRIP
+  # Extract the first word of "strip", so it can be a program name with args.
+set dummy strip; ac_word=$2
+{ $as_echo "$as_me:${as_lineno-$LINENO}: checking for $ac_word" >&5
+$as_echo_n "checking for $ac_word... " >&6; }
+if test "${ac_cv_prog_ac_ct_STRIP+set}" = set; then :
+  $as_echo_n "(cached) " >&6
+else
+  if test -n "$ac_ct_STRIP"; then
+  ac_cv_prog_ac_ct_STRIP="$ac_ct_STRIP" # Let the user override the test.
+else
+as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
+for as_dir in $PATH
+do
+  IFS=$as_save_IFS
+  test -z "$as_dir" && as_dir=.
+    for ac_exec_ext in '' $ac_executable_extensions; do
+  if { test -f "$as_dir/$ac_word$ac_exec_ext" && $as_test_x "$as_dir/$ac_word$ac_exec_ext"; }; then
+    ac_cv_prog_ac_ct_STRIP="strip"
+    $as_echo "$as_me:${as_lineno-$LINENO}: found $as_dir/$ac_word$ac_exec_ext" >&5
+    break 2
+  fi
+done
+  done
+IFS=$as_save_IFS
+
+fi
+fi
+ac_ct_STRIP=$ac_cv_prog_ac_ct_STRIP
+if test -n "$ac_ct_STRIP"; then
+  { $as_echo "$as_me:${as_lineno-$LINENO}: result: $ac_ct_STRIP" >&5
+$as_echo "$ac_ct_STRIP" >&6; }
+else
+  { $as_echo "$as_me:${as_lineno-$LINENO}: result: no" >&5
+$as_echo "no" >&6; }
+fi
+
+  if test "x$ac_ct_STRIP" = x; then
+    STRIP=":"
+  else
+    case $cross_compiling:$ac_tool_warned in
+yes:)
+{ $as_echo "$as_me:${as_lineno-$LINENO}: WARNING: using cross tools not prefixed with host triplet" >&5
+$as_echo "$as_me: WARNING: using cross tools not prefixed with host triplet" >&2;}
+ac_tool_warned=yes ;;
+esac
+    STRIP=$ac_ct_STRIP
+  fi
+else
+  STRIP="$ac_cv_prog_STRIP"
+fi
+
+fi
+INSTALL_STRIP_PROGRAM="\$(install_sh) -c -s"
+
 { $as_echo "$as_me:${as_lineno-$LINENO}: checking for a thread-safe mkdir -p" >&5
 $as_echo_n "checking for a thread-safe mkdir -p... " >&6; }
 if test -z "$MKDIR_P"; then
@@ -2610,7 +2741,7 @@
 
 # Define the identity of the package.
  PACKAGE='ubuntuone-client'
- VERSION='0.92.0'
+ VERSION='0.93.0'
 
 
 cat >>confdefs.h <<_ACEOF
@@ -2638,108 +2769,6 @@
 
 MAKEINFO=${MAKEINFO-"${am_missing_run}makeinfo"}
 
-install_sh=${install_sh-"\$(SHELL) $am_aux_dir/install-sh"}
-
-# Installed binaries are usually stripped using `strip' when the user
-# run `make install-strip'.  However `strip' might not be the right
-# tool to use in cross-compilation environments, therefore Automake
-# will honor the `STRIP' environment variable to overrule this program.
-if test "$cross_compiling" != no; then
-  if test -n "$ac_tool_prefix"; then
-  # Extract the first word of "${ac_tool_prefix}strip", so it can be a program name with args.
-set dummy ${ac_tool_prefix}strip; ac_word=$2
-{ $as_echo "$as_me:${as_lineno-$LINENO}: checking for $ac_word" >&5
-$as_echo_n "checking for $ac_word... " >&6; }
-if test "${ac_cv_prog_STRIP+set}" = set; then :
-  $as_echo_n "(cached) " >&6
-else
-  if test -n "$STRIP"; then
-  ac_cv_prog_STRIP="$STRIP" # Let the user override the test.
-else
-as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
-for as_dir in $PATH
-do
-  IFS=$as_save_IFS
-  test -z "$as_dir" && as_dir=.
-    for ac_exec_ext in '' $ac_executable_extensions; do
-  if { test -f "$as_dir/$ac_word$ac_exec_ext" && $as_test_x "$as_dir/$ac_word$ac_exec_ext"; }; then
-    ac_cv_prog_STRIP="${ac_tool_prefix}strip"
-    $as_echo "$as_me:${as_lineno-$LINENO}: found $as_dir/$ac_word$ac_exec_ext" >&5
-    break 2
-  fi
-done
-  done
-IFS=$as_save_IFS
-
-fi
-fi
-STRIP=$ac_cv_prog_STRIP
-if test -n "$STRIP"; then
-  { $as_echo "$as_me:${as_lineno-$LINENO}: result: $STRIP" >&5
-$as_echo "$STRIP" >&6; }
-else
-  { $as_echo "$as_me:${as_lineno-$LINENO}: result: no" >&5
-$as_echo "no" >&6; }
-fi
-
-
-fi
-if test -z "$ac_cv_prog_STRIP"; then
-  ac_ct_STRIP=$STRIP
-  # Extract the first word of "strip", so it can be a program name with args.
-set dummy strip; ac_word=$2
-{ $as_echo "$as_me:${as_lineno-$LINENO}: checking for $ac_word" >&5
-$as_echo_n "checking for $ac_word... " >&6; }
-if test "${ac_cv_prog_ac_ct_STRIP+set}" = set; then :
-  $as_echo_n "(cached) " >&6
-else
-  if test -n "$ac_ct_STRIP"; then
-  ac_cv_prog_ac_ct_STRIP="$ac_ct_STRIP" # Let the user override the test.
-else
-as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
-for as_dir in $PATH
-do
-  IFS=$as_save_IFS
-  test -z "$as_dir" && as_dir=.
-    for ac_exec_ext in '' $ac_executable_extensions; do
-  if { test -f "$as_dir/$ac_word$ac_exec_ext" && $as_test_x "$as_dir/$ac_word$ac_exec_ext"; }; then
-    ac_cv_prog_ac_ct_STRIP="strip"
-    $as_echo "$as_me:${as_lineno-$LINENO}: found $as_dir/$ac_word$ac_exec_ext" >&5
-    break 2
-  fi
-done
-  done
-IFS=$as_save_IFS
-
-fi
-fi
-ac_ct_STRIP=$ac_cv_prog_ac_ct_STRIP
-if test -n "$ac_ct_STRIP"; then
-  { $as_echo "$as_me:${as_lineno-$LINENO}: result: $ac_ct_STRIP" >&5
-$as_echo "$ac_ct_STRIP" >&6; }
-else
-  { $as_echo "$as_me:${as_lineno-$LINENO}: result: no" >&5
-$as_echo "no" >&6; }
-fi
-
-  if test "x$ac_ct_STRIP" = x; then
-    STRIP=":"
-  else
-    case $cross_compiling:$ac_tool_warned in
-yes:)
-{ $as_echo "$as_me:${as_lineno-$LINENO}: WARNING: using cross tools not prefixed with host triplet" >&5
-$as_echo "$as_me: WARNING: using cross tools not prefixed with host triplet" >&2;}
-ac_tool_warned=yes ;;
-esac
-    STRIP=$ac_ct_STRIP
-  fi
-else
-  STRIP="$ac_cv_prog_STRIP"
-fi
-
-fi
-INSTALL_STRIP_PROGRAM="\$(install_sh) -c -s"
-
 # We need awk for the "check" target.  The system "awk" is bad on
 # some platforms.
 # Always define AMTAR for backward compatibility.
@@ -2763,7 +2792,7 @@
 am_make=${MAKE-make}
 cat > confinc << 'END'
 am__doit:
-	@echo done
+	@echo this is the am__doit target
 .PHONY: am__doit
 END
 # If we don't find an include directive, just comment out the code.
@@ -2774,24 +2803,24 @@
 _am_result=none
 # First try GNU make style include.
 echo "include confinc" > confmf
-# We grep out `Entering directory' and `Leaving directory'
-# messages which can occur if `w' ends up in MAKEFLAGS.
-# In particular we don't look at `^make:' because GNU make might
-# be invoked under some other name (usually "gmake"), in which
-# case it prints its new name instead of `make'.
-if test "`$am_make -s -f confmf 2> /dev/null | grep -v 'ing directory'`" = "done"; then
-   am__include=include
-   am__quote=
-   _am_result=GNU
-fi
+# Ignore all kinds of additional output from `make'.
+case `$am_make -s -f confmf 2> /dev/null` in #(
+*the\ am__doit\ target*)
+  am__include=include
+  am__quote=
+  _am_result=GNU
+  ;;
+esac
 # Now try BSD make style include.
 if test "$am__include" = "#"; then
    echo '.include "confinc"' > confmf
-   if test "`$am_make -s -f confmf 2> /dev/null`" = "done"; then
-      am__include=.include
-      am__quote="\""
-      _am_result=BSD
-   fi
+   case `$am_make -s -f confmf 2> /dev/null` in #(
+   *the\ am__doit\ target*)
+     am__include=.include
+     am__quote="\""
+     _am_result=BSD
+     ;;
+   esac
 fi
 
 
@@ -3614,6 +3643,11 @@
   if test "$am_compiler_list" = ""; then
      am_compiler_list=`sed -n 's/^#*\([a-zA-Z0-9]*\))$/\1/p' < ./depcomp`
   fi
+  am__universal=false
+  case " $depcc " in #(
+     *\ -arch\ *\ -arch\ *) am__universal=true ;;
+     esac
+
   for depmode in $am_compiler_list; do
     # Setup a source with many dependencies, because some compilers
     # like to wrap large dependency lists on column 80 (with \), and
@@ -3631,7 +3665,17 @@
     done
     echo "${am__include} ${am__quote}sub/conftest.Po${am__quote}" > confmf
 
+    # We check with `-c' and `-o' for the sake of the "dashmstdout"
+    # mode.  It turns out that the SunPro C++ compiler does not properly
+    # handle `-M -o', and we need to detect this.  Also, some Intel
+    # versions had trouble with output in subdirs
+    am__obj=sub/conftest.${OBJEXT-o}
+    am__minus_obj="-o $am__obj"
     case $depmode in
+    gcc)
+      # This depmode causes a compiler race in universal mode.
+      test "$am__universal" = false || continue
+      ;;
     nosideeffect)
       # after this tag, mechanisms are not by side-effect, so they'll
       # only be used when explicitly requested
@@ -3641,19 +3685,23 @@
 	break
       fi
       ;;
+    msvisualcpp | msvcmsys)
+      # This compiler won't grok `-c -o', but also, the minuso test has
+      # not run yet.  These depmodes are late enough in the game, and
+      # so weak that their functioning should not be impacted.
+      am__obj=conftest.${OBJEXT-o}
+      am__minus_obj=
+      ;;
     none) break ;;
     esac
-    # We check with `-c' and `-o' for the sake of the "dashmstdout"
-    # mode.  It turns out that the SunPro C++ compiler does not properly
-    # handle `-M -o', and we need to detect this.
     if depmode=$depmode \
-       source=sub/conftest.c object=sub/conftest.${OBJEXT-o} \
+       source=sub/conftest.c object=$am__obj \
        depfile=sub/conftest.Po tmpdepfile=sub/conftest.TPo \
-       $SHELL ./depcomp $depcc -c -o sub/conftest.${OBJEXT-o} sub/conftest.c \
+       $SHELL ./depcomp $depcc -c $am__minus_obj sub/conftest.c \
          >/dev/null 2>conftest.err &&
        grep sub/conftst1.h sub/conftest.Po > /dev/null 2>&1 &&
        grep sub/conftst6.h sub/conftest.Po > /dev/null 2>&1 &&
-       grep sub/conftest.${OBJEXT-o} sub/conftest.Po > /dev/null 2>&1 &&
+       grep $am__obj sub/conftest.Po > /dev/null 2>&1 &&
        ${MAKE-make} -s -f confmf > /dev/null 2>&1; then
       # icc doesn't choke on unknown options, it will just issue warnings
       # or remarks (even with -Werror).  So we grep stderr for any message
@@ -4319,6 +4367,11 @@
   if test "$am_compiler_list" = ""; then
      am_compiler_list=`sed -n 's/^#*\([a-zA-Z0-9]*\))$/\1/p' < ./depcomp`
   fi
+  am__universal=false
+  case " $depcc " in #(
+     *\ -arch\ *\ -arch\ *) am__universal=true ;;
+     esac
+
   for depmode in $am_compiler_list; do
     # Setup a source with many dependencies, because some compilers
     # like to wrap large dependency lists on column 80 (with \), and
@@ -4336,7 +4389,17 @@
     done
     echo "${am__include} ${am__quote}sub/conftest.Po${am__quote}" > confmf
 
+    # We check with `-c' and `-o' for the sake of the "dashmstdout"
+    # mode.  It turns out that the SunPro C++ compiler does not properly
+    # handle `-M -o', and we need to detect this.  Also, some Intel
+    # versions had trouble with output in subdirs
+    am__obj=sub/conftest.${OBJEXT-o}
+    am__minus_obj="-o $am__obj"
     case $depmode in
+    gcc)
+      # This depmode causes a compiler race in universal mode.
+      test "$am__universal" = false || continue
+      ;;
     nosideeffect)
       # after this tag, mechanisms are not by side-effect, so they'll
       # only be used when explicitly requested
@@ -4346,19 +4409,23 @@
 	break
       fi
       ;;
+    msvisualcpp | msvcmsys)
+      # This compiler won't grok `-c -o', but also, the minuso test has
+      # not run yet.  These depmodes are late enough in the game, and
+      # so weak that their functioning should not be impacted.
+      am__obj=conftest.${OBJEXT-o}
+      am__minus_obj=
+      ;;
     none) break ;;
     esac
-    # We check with `-c' and `-o' for the sake of the "dashmstdout"
-    # mode.  It turns out that the SunPro C++ compiler does not properly
-    # handle `-M -o', and we need to detect this.
     if depmode=$depmode \
-       source=sub/conftest.c object=sub/conftest.${OBJEXT-o} \
+       source=sub/conftest.c object=$am__obj \
        depfile=sub/conftest.Po tmpdepfile=sub/conftest.TPo \
-       $SHELL ./depcomp $depcc -c -o sub/conftest.${OBJEXT-o} sub/conftest.c \
+       $SHELL ./depcomp $depcc -c $am__minus_obj sub/conftest.c \
          >/dev/null 2>conftest.err &&
        grep sub/conftst1.h sub/conftest.Po > /dev/null 2>&1 &&
        grep sub/conftst6.h sub/conftest.Po > /dev/null 2>&1 &&
-       grep sub/conftest.${OBJEXT-o} sub/conftest.Po > /dev/null 2>&1 &&
+       grep $am__obj sub/conftest.Po > /dev/null 2>&1 &&
        ${MAKE-make} -s -f confmf > /dev/null 2>&1; then
       # icc doesn't choke on unknown options, it will just issue warnings
       # or remarks (even with -Werror).  So we grep stderr for any message
@@ -5077,13 +5144,13 @@
 else
   lt_cv_nm_interface="BSD nm"
   echo "int some_variable = 0;" > conftest.$ac_ext
-  (eval echo "\"\$as_me:5080: $ac_compile\"" >&5)
+  (eval echo "\"\$as_me:5147: $ac_compile\"" >&5)
   (eval "$ac_compile" 2>conftest.err)
   cat conftest.err >&5
-  (eval echo "\"\$as_me:5083: $NM \\\"conftest.$ac_objext\\\"\"" >&5)
+  (eval echo "\"\$as_me:5150: $NM \\\"conftest.$ac_objext\\\"\"" >&5)
   (eval "$NM \"conftest.$ac_objext\"" 2>conftest.err > conftest.out)
   cat conftest.err >&5
-  (eval echo "\"\$as_me:5086: output\"" >&5)
+  (eval echo "\"\$as_me:5153: output\"" >&5)
   cat conftest.out >&5
   if $GREP 'External.*some_variable' conftest.out > /dev/null; then
     lt_cv_nm_interface="MS dumpbin"
@@ -6288,7 +6355,7 @@
   ;;
 *-*-irix6*)
   # Find out which ABI we are using.
-  echo '#line 6291 "configure"' > conftest.$ac_ext
+  echo '#line 6358 "configure"' > conftest.$ac_ext
   if { { eval echo "\"\$as_me\":${as_lineno-$LINENO}: \"$ac_compile\""; } >&5
   (eval $ac_compile) 2>&5
   ac_status=$?
@@ -7818,11 +7885,11 @@
    -e 's:.*FLAGS}\{0,1\} :&$lt_compiler_flag :; t' \
    -e 's: [^ ]*conftest\.: $lt_compiler_flag&:; t' \
    -e 's:$: $lt_compiler_flag:'`
-   (eval echo "\"\$as_me:7821: $lt_compile\"" >&5)
+   (eval echo "\"\$as_me:7888: $lt_compile\"" >&5)
    (eval "$lt_compile" 2>conftest.err)
    ac_status=$?
    cat conftest.err >&5
-   echo "$as_me:7825: \$? = $ac_status" >&5
+   echo "$as_me:7892: \$? = $ac_status" >&5
    if (exit $ac_status) && test -s "$ac_outfile"; then
      # The compiler can only warn and ignore the option if not recognized
      # So say no if there are warnings other than the usual output.
@@ -8157,11 +8224,11 @@
    -e 's:.*FLAGS}\{0,1\} :&$lt_compiler_flag :; t' \
    -e 's: [^ ]*conftest\.: $lt_compiler_flag&:; t' \
    -e 's:$: $lt_compiler_flag:'`
-   (eval echo "\"\$as_me:8160: $lt_compile\"" >&5)
+   (eval echo "\"\$as_me:8227: $lt_compile\"" >&5)
    (eval "$lt_compile" 2>conftest.err)
    ac_status=$?
    cat conftest.err >&5
-   echo "$as_me:8164: \$? = $ac_status" >&5
+   echo "$as_me:8231: \$? = $ac_status" >&5
    if (exit $ac_status) && test -s "$ac_outfile"; then
      # The compiler can only warn and ignore the option if not recognized
      # So say no if there are warnings other than the usual output.
@@ -8262,11 +8329,11 @@
    -e 's:.*FLAGS}\{0,1\} :&$lt_compiler_flag :; t' \
    -e 's: [^ ]*conftest\.: $lt_compiler_flag&:; t' \
    -e 's:$: $lt_compiler_flag:'`
-   (eval echo "\"\$as_me:8265: $lt_compile\"" >&5)
+   (eval echo "\"\$as_me:8332: $lt_compile\"" >&5)
    (eval "$lt_compile" 2>out/conftest.err)
    ac_status=$?
    cat out/conftest.err >&5
-   echo "$as_me:8269: \$? = $ac_status" >&5
+   echo "$as_me:8336: \$? = $ac_status" >&5
    if (exit $ac_status) && test -s out/conftest2.$ac_objext
    then
      # The compiler can only warn and ignore the option if not recognized
@@ -8317,11 +8384,11 @@
    -e 's:.*FLAGS}\{0,1\} :&$lt_compiler_flag :; t' \
    -e 's: [^ ]*conftest\.: $lt_compiler_flag&:; t' \
    -e 's:$: $lt_compiler_flag:'`
-   (eval echo "\"\$as_me:8320: $lt_compile\"" >&5)
+   (eval echo "\"\$as_me:8387: $lt_compile\"" >&5)
    (eval "$lt_compile" 2>out/conftest.err)
    ac_status=$?
    cat out/conftest.err >&5
-   echo "$as_me:8324: \$? = $ac_status" >&5
+   echo "$as_me:8391: \$? = $ac_status" >&5
    if (exit $ac_status) && test -s out/conftest2.$ac_objext
    then
      # The compiler can only warn and ignore the option if not recognized
@@ -10700,7 +10767,7 @@
   lt_dlunknown=0; lt_dlno_uscore=1; lt_dlneed_uscore=2
   lt_status=$lt_dlunknown
   cat > conftest.$ac_ext <<_LT_EOF
-#line 10703 "configure"
+#line 10770 "configure"
 #include "confdefs.h"
 
 #if HAVE_DLFCN_H
@@ -10796,7 +10863,7 @@
   lt_dlunknown=0; lt_dlno_uscore=1; lt_dlneed_uscore=2
   lt_status=$lt_dlunknown
   cat > conftest.$ac_ext <<_LT_EOF
-#line 10799 "configure"
+#line 10866 "configure"
 #include "confdefs.h"
 
 #if HAVE_DLFCN_H
@@ -11835,12 +11902,14 @@
       # If the user set $PYTHON, use it and don't search something else.
       { $as_echo "$as_me:${as_lineno-$LINENO}: checking whether $PYTHON version >= 2.5" >&5
 $as_echo_n "checking whether $PYTHON version >= 2.5... " >&6; }
-      prog="import sys, string
+      prog="import sys
 # split strings by '.' and convert to numeric.  Append some zeros
 # because we need at least 4 digits for the hex conversion.
-minver = map(int, string.split('2.5', '.')) + [0, 0, 0]
+# map returns an iterator in Python 3.0 and a list in 2.x
+minver = list(map(int, '2.5'.split('.'))) + [0, 0, 0]
 minverhex = 0
-for i in xrange(0, 4): minverhex = (minverhex << 8) + minver[i]
+# xrange is not present in Python 3.0 and range returns an iterator
+for i in list(range(0, 4)): minverhex = (minverhex << 8) + minver[i]
 sys.exit(sys.hexversion < minverhex)"
   if { echo "$as_me:$LINENO: $PYTHON -c "$prog"" >&5
    ($PYTHON -c "$prog") >&5 2>&5
@@ -11862,14 +11931,16 @@
   $as_echo_n "(cached) " >&6
 else
 
-	for am_cv_pathless_PYTHON in python python2 python2.5 python2.4 python2.3 python2.2 python2.1 python2.0 python1.6 python1.5 none; do
+	for am_cv_pathless_PYTHON in python python2 python3 python3.0 python2.5 python2.4 python2.3 python2.2 python2.1 python2.0 none; do
 	  test "$am_cv_pathless_PYTHON" = none && break
-	  prog="import sys, string
+	  prog="import sys
 # split strings by '.' and convert to numeric.  Append some zeros
 # because we need at least 4 digits for the hex conversion.
-minver = map(int, string.split('2.5', '.')) + [0, 0, 0]
+# map returns an iterator in Python 3.0 and a list in 2.x
+minver = list(map(int, '2.5'.split('.'))) + [0, 0, 0]
 minverhex = 0
-for i in xrange(0, 4): minverhex = (minverhex << 8) + minver[i]
+# xrange is not present in Python 3.0 and range returns an iterator
+for i in list(range(0, 4)): minverhex = (minverhex << 8) + minver[i]
 sys.exit(sys.hexversion < minverhex)"
   if { echo "$as_me:$LINENO: $am_cv_pathless_PYTHON -c "$prog"" >&5
    ($am_cv_pathless_PYTHON -c "$prog") >&5 2>&5
@@ -11941,7 +12012,7 @@
 if test "${am_cv_python_version+set}" = set; then :
   $as_echo_n "(cached) " >&6
 else
-  am_cv_python_version=`$PYTHON -c "import sys; print sys.version[:3]"`
+  am_cv_python_version=`$PYTHON -c "import sys; sys.stdout.write(sys.version[:3])"`
 fi
 { $as_echo "$as_me:${as_lineno-$LINENO}: result: $am_cv_python_version" >&5
 $as_echo "$am_cv_python_version" >&6; }
@@ -11960,7 +12031,7 @@
 if test "${am_cv_python_platform+set}" = set; then :
   $as_echo_n "(cached) " >&6
 else
-  am_cv_python_platform=`$PYTHON -c "import sys; print sys.platform"`
+  am_cv_python_platform=`$PYTHON -c "import sys; sys.stdout.write(sys.platform)"`
 fi
 { $as_echo "$as_me:${as_lineno-$LINENO}: result: $am_cv_python_platform" >&5
 $as_echo "$am_cv_python_platform" >&6; }
@@ -12386,6 +12457,14 @@
 LTLIBOBJS=$ac_ltlibobjs
 
 
+ if test -n "$EXEEXT"; then
+  am__EXEEXT_TRUE=
+  am__EXEEXT_FALSE='#'
+else
+  am__EXEEXT_TRUE='#'
+  am__EXEEXT_FALSE=
+fi
+
 if test -z "${AMDEP_TRUE}" && test -z "${AMDEP_FALSE}"; then
   as_fn_error "conditional \"AMDEP\" was never defined.
 Usually this means the macro was only invoked conditionally." "$LINENO" 5
@@ -12814,7 +12893,7 @@
 # report actual input values of CONFIG_FILES etc. instead of their
 # values after options handling.
 ac_log="
-This file was extended by ubuntuone-client $as_me 0.92.0, which was
+This file was extended by ubuntuone-client $as_me 0.93.0, which was
 generated by GNU Autoconf 2.64.  Invocation command line was
 
   CONFIG_FILES    = $CONFIG_FILES
@@ -12878,7 +12957,7 @@
 _ACEOF
 cat >>$CONFIG_STATUS <<_ACEOF || ac_write_fail=1
 ac_cs_version="\\
-ubuntuone-client config.status 0.92.0
+ubuntuone-client config.status 0.93.0
 configured by $0, generated by GNU Autoconf 2.64,
   with options \\"`$as_echo "$ac_configure_args" | sed 's/^ //; s/[\\""\`\$]/\\\\&/g'`\\"
 

=== modified file 'configure.ac'
--- configure.ac	2009-08-11 16:45:00 +0000
+++ configure.ac	2009-08-26 12:15:00 +0000
@@ -1,7 +1,7 @@
 dnl Process this file with autoconf to produce a configure script.
 AC_PREREQ(2.53)
 
-AC_INIT([ubuntuone-client], [0.92.0])
+AC_INIT([ubuntuone-client], [0.93.0])
 AC_CONFIG_SRCDIR([config.h.in])
 
 AM_INIT_AUTOMAKE([1.10 foreign])

=== added file 'contrib/__init__.pyc'
Binary files contrib/__init__.pyc and contrib/__init__.pyc differ
=== modified file 'contrib/ck_states.py'
--- contrib/ck_states.py	2009-07-16 17:00:00 +0000
+++ contrib/ck_states.py	2009-08-26 12:15:00 +0000
@@ -12,7 +12,7 @@
                   if isinstance(v, states.SyncDaemonState))
 
 is_start = re.compile(r'(?:^START_|_START(?:_WITH_[^_]+Q)?$)').search
-has_q = re.compile(r'_WITH_[^_]+Q$').search
+has_q = re.compile(r'_WITH_([^_]+)Q$|^(?:START_)?WORKING_ON_(....)').search
 
 all_trns = set(sum((state.transitions.values()
                     for state in all_states.values()), []))
@@ -105,6 +105,31 @@
                     if only_in_other:
                         print 'missing from %s: %s' % \
                             (name, ", ".join(sorted(only_in_other)))
+    # the tuple is SYS_META_QUEUE_WAITING, _DONE, and then _CONTENT_
+    ok_trns = {'meta': ('meta', '', 'both', 'meta'),
+               'cont': ('both', 'cont', 'cont', ''),
+               'both': ('both', 'cont', 'both', 'meta'),
+               '': ('meta', '', 'cont', ''),
+               }
+    if has_q(state.name):
+        this_q = filter(None, has_q(state.name).groups())[0].lower()
+    else:
+        this_q = ''
+    for i, evt in enumerate(['SYS_META_QUEUE_WAITING',
+                             'SYS_META_QUEUE_DONE',
+                             'SYS_CONTENT_QUEUE_WAITING',
+                             'SYS_CONTENT_QUEUE_DONE']):
+        trn = state.transitions.get(evt, None)
+        if trn is None:
+            continue
+        if has_q(trn):
+            that_q = filter(None, has_q(trn).groups())[0].lower()
+        else:
+            that_q = ''
+        if ok_trns[this_q][i] != that_q:
+            print '%s goes to %r on %r instead of %r' % (state.name,
+                                                         trn, evt,
+                                                         ok_trns[this_q][i])
 
     # most states should handle the queue events
     if not (isinstance(state, states.AQErrorState)

=== added file 'contrib/mocker.pyc'
Binary files contrib/mocker.pyc and contrib/mocker.pyc differ
=== added file 'contrib/testing/__init__.pyc'
Binary files contrib/testing/__init__.pyc and contrib/testing/__init__.pyc differ
=== modified file 'contrib/testing/testcase.py'
--- contrib/testing/testcase.py	2009-08-11 16:45:00 +0000
+++ contrib/testing/testcase.py	2009-08-26 12:15:00 +0000
@@ -91,13 +91,14 @@
         self.root_dir = root_dir
         self.data_dir = data_dir
         self.shares_dir = shares_dir
+        self.shares_dir_link = os.path.join(self.root_dir, 'Shared With Me')
         self.realm = 'http://test.ubuntuone.com'
         self.oauth_client = FakeOAuthClient(self.realm)
         self.vm = volume_manager.VolumeManager(self)
         self.fs = fs_manager.FileSystemManager(self.data_dir, self.vm)
         self.event_q = event_queue.EventQueue(self.fs)
         self.action_q = FakeActionQueue(self.event_q)
-        self.state = main.SyncDaemonStateManager(self)
+        self.state = main.SyncDaemonStateManager(self, 2, 0)
         self.event_q.subscribe(self.vm)
         self.vm.init_root()
         self.hash_q = FakeHashQueue()
@@ -223,6 +224,8 @@
         self.event_q.push('SYS_WAIT_FOR_LOCAL_RESCAN')
         self.event_q.push('SYS_LOCAL_RESCAN_DONE')
         self.signal_receivers = set()
+        self.action_q.content_queue.set_change_notification_cb(
+            self.dbus_iface.status.emit_content_queue_changed)
 
     def tearDown(self):
         """ Cleanup the test. """
@@ -275,7 +278,7 @@
 
     def __init__(self, eq, *args, **kwargs):
         """ Creates the instance """
-        self.eq = eq
+        self.eq = self.event_queue = eq
         self.client = action_queue.ActionQueueProtocol()
         self.uploading = {}
         self.downloading = {}
@@ -287,8 +290,13 @@
                 pass
 
         self.uuid_map = UUID_Map()
-        self.content_queue = action_queue.RequestQueue('CONTENT', self)
-        self.meta_queue = action_queue.RequestQueue('META', self)
+        self.content_queue = action_queue.ContentQueue('CONTENT_QUEUE', self)
+        self.meta_queue = action_queue.RequestQueue('META_QUEUE', self)
+
+        # throttling attributes
+        self.readLimit = None
+        self.writeLimit = None
+        self.throttling = False
 
     def connect(self, host=None, port=None, user_ssl=False):
         """ stub implementation """
@@ -298,6 +306,9 @@
         """ stub implementation """
         pass
 
+    def enable_throttling(self, value):
+        self.throttling = value
+
     def cancel_download(self, share_id, node_id):
         """ stub implementation """
         pass
@@ -351,6 +362,14 @@
         """ sutb implementation """
         pass
 
+    def inquire_free_space(self, share_id):
+        """ stub implementation """
+        pass
+
+    def inquire_account_info(self):
+        """ stub implementation """
+        pass
+
 
 class MementoHandler(logging.Handler):
     """ A handler class which store logging records in a list """

=== added file 'contrib/testing/testcase.pyc'
Binary files contrib/testing/testcase.pyc and contrib/testing/testcase.pyc differ
=== modified file 'data/Makefile.am'
--- data/Makefile.am	2009-08-11 16:45:00 +0000
+++ data/Makefile.am	2009-08-26 12:15:00 +0000
@@ -37,7 +37,7 @@
 	@sed -e "s|\@libexecdir\@|$(libexecdir)|" \
 		-e "s|\@bindir\@|$(bindir)|" $< > $@
 
-icon_in_files = ubuntuone-icons.svg ubuntuone-animations.svg
+icon_in_files = ubuntuone-icons.svg
 icon_cache = $(icon_in_files:.svg=.rendercache)
 icon_files = $(shell BUILDDIR="$(builddir)"; for i in `find $$BUILDDIR -name "*.rendercache"`; do cat $$i|sort|uniq; done)
 

=== modified file 'data/Makefile.in'
--- data/Makefile.in	2009-08-11 16:45:00 +0000
+++ data/Makefile.in	2009-08-26 12:15:00 +0000
@@ -1,8 +1,9 @@
-# Makefile.in generated by automake 1.10.2 from Makefile.am.
+# Makefile.in generated by automake 1.11 from Makefile.am.
 # @configure_input@
 
 # Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2000, 2001, 2002,
-# 2003, 2004, 2005, 2006, 2007, 2008  Free Software Foundation, Inc.
+# 2003, 2004, 2005, 2006, 2007, 2008, 2009  Free Software Foundation,
+# Inc.
 # This Makefile.in is free software; the Free Software Foundation
 # gives unlimited permission to copy and/or distribute it,
 # with or without modifications, as long as this notice is preserved.
@@ -16,8 +17,9 @@
 
 VPATH = @srcdir@
 pkgdatadir = $(datadir)/@PACKAGE@
+pkgincludedir = $(includedir)/@PACKAGE@
 pkglibdir = $(libdir)/@PACKAGE@
-pkgincludedir = $(includedir)/@PACKAGE@
+pkglibexecdir = $(libexecdir)/@PACKAGE@
 am__cd = CDPATH="$${ZSH_VERSION+.}$(PATH_SEPARATOR)" && cd
 install_sh_DATA = $(install_sh) -c -m 644
 install_sh_PROGRAM = $(install_sh) -c
@@ -44,6 +46,7 @@
 mkinstalldirs = $(install_sh) -d
 CONFIG_HEADER = $(top_builddir)/config.h
 CONFIG_CLEAN_FILES =
+CONFIG_CLEAN_VPATH_FILES =
 SOURCES =
 DIST_SOURCES =
 am__vpath_adj_setup = srcdirstrip=`echo "$(srcdir)" | sed 's|.|.|g'`;
@@ -51,16 +54,25 @@
     $(srcdir)/*) f=`echo "$$p" | sed "s|^$$srcdirstrip/||"`;; \
     *) f=$$p;; \
   esac;
-am__strip_dir = `echo $$p | sed -e 's|^.*/||'`;
+am__strip_dir = f=`echo $$p | sed -e 's|^.*/||'`;
+am__install_max = 40
+am__nobase_strip_setup = \
+  srcdirstrip=`echo "$(srcdir)" | sed 's/[].[^$$\\*|]/\\\\&/g'`
+am__nobase_strip = \
+  for p in $$list; do echo "$$p"; done | sed -e "s|$$srcdirstrip/||"
+am__nobase_list = $(am__nobase_strip_setup); \
+  for p in $$list; do echo "$$p $$p"; done | \
+  sed "s| $$srcdirstrip/| |;"' / .*\//!s/ .*/ ./; s,\( .*\)/[^/]*$$,\1,' | \
+  $(AWK) 'BEGIN { files["."] = "" } { files[$$2] = files[$$2] " " $$1; \
+    if (++n[$$2] == $(am__install_max)) \
+      { print $$2, files[$$2]; n[$$2] = 0; files[$$2] = "" } } \
+    END { for (dir in files) print dir, files[dir] }'
+am__base_list = \
+  sed '$$!N;$$!N;$$!N;$$!N;$$!N;$$!N;$$!N;s/\n/ /g' | \
+  sed '$$!N;$$!N;$$!N;$$!N;s/\n/ /g'
 am__installdirs = "$(DESTDIR)$(apportdir)" "$(DESTDIR)$(configdir)" \
 	"$(DESTDIR)$(crashdbdir)" "$(DESTDIR)$(desktopdir)" \
 	"$(DESTDIR)$(oauthdir)" "$(DESTDIR)$(servicedir)"
-apportDATA_INSTALL = $(INSTALL_DATA)
-configDATA_INSTALL = $(INSTALL_DATA)
-crashdbDATA_INSTALL = $(INSTALL_DATA)
-desktopDATA_INSTALL = $(INSTALL_DATA)
-oauthDATA_INSTALL = $(INSTALL_DATA)
-serviceDATA_INSTALL = $(INSTALL_DATA)
 DATA = $(apport_DATA) $(config_DATA) $(crashdb_DATA) $(desktop_DATA) \
 	$(oauth_DATA) $(service_DATA)
 DISTFILES = $(DIST_COMMON) $(DIST_SOURCES) $(TEXINFOS) $(EXTRA_DIST)
@@ -232,7 +244,7 @@
 	com.ubuntuone.SyncDaemon.service.in
 
 service_DATA = $(service_in_files:.service.in=.service)
-icon_in_files = ubuntuone-icons.svg ubuntuone-animations.svg
+icon_in_files = ubuntuone-icons.svg
 icon_cache = $(icon_in_files:.svg=.rendercache)
 icon_files = $(shell BUILDDIR="$(builddir)"; for i in `find $$BUILDDIR -name "*.rendercache"`; do cat $$i|sort|uniq; done)
 EXTRA_DIST = \
@@ -268,9 +280,9 @@
 	      exit 1;; \
 	  esac; \
 	done; \
-	echo ' cd $(top_srcdir) && $(AUTOMAKE) --foreign  data/Makefile'; \
-	cd $(top_srcdir) && \
-	  $(AUTOMAKE) --foreign  data/Makefile
+	echo ' cd $(top_srcdir) && $(AUTOMAKE) --foreign data/Makefile'; \
+	$(am__cd) $(top_srcdir) && \
+	  $(AUTOMAKE) --foreign data/Makefile
 .PRECIOUS: Makefile
 Makefile: $(srcdir)/Makefile.in $(top_builddir)/config.status
 	@case '$?' in \
@@ -288,6 +300,7 @@
 	cd $(top_builddir) && $(MAKE) $(AM_MAKEFLAGS) am--refresh
 $(ACLOCAL_M4):  $(am__aclocal_m4_deps)
 	cd $(top_builddir) && $(MAKE) $(AM_MAKEFLAGS) am--refresh
+$(am__aclocal_m4_deps):
 
 mostlyclean-libtool:
 	-rm -f *.lo
@@ -297,105 +310,123 @@
 install-apportDATA: $(apport_DATA)
 	@$(NORMAL_INSTALL)
 	test -z "$(apportdir)" || $(MKDIR_P) "$(DESTDIR)$(apportdir)"
-	@list='$(apport_DATA)'; for p in $$list; do \
+	@list='$(apport_DATA)'; test -n "$(apportdir)" || list=; \
+	for p in $$list; do \
 	  if test -f "$$p"; then d=; else d="$(srcdir)/"; fi; \
-	  f=$(am__strip_dir) \
-	  echo " $(apportDATA_INSTALL) '$$d$$p' '$(DESTDIR)$(apportdir)/$$f'"; \
-	  $(apportDATA_INSTALL) "$$d$$p" "$(DESTDIR)$(apportdir)/$$f"; \
+	  echo "$$d$$p"; \
+	done | $(am__base_list) | \
+	while read files; do \
+	  echo " $(INSTALL_DATA) $$files '$(DESTDIR)$(apportdir)'"; \
+	  $(INSTALL_DATA) $$files "$(DESTDIR)$(apportdir)" || exit $$?; \
 	done
 
 uninstall-apportDATA:
 	@$(NORMAL_UNINSTALL)
-	@list='$(apport_DATA)'; for p in $$list; do \
-	  f=$(am__strip_dir) \
-	  echo " rm -f '$(DESTDIR)$(apportdir)/$$f'"; \
-	  rm -f "$(DESTDIR)$(apportdir)/$$f"; \
-	done
+	@list='$(apport_DATA)'; test -n "$(apportdir)" || list=; \
+	files=`for p in $$list; do echo $$p; done | sed -e 's|^.*/||'`; \
+	test -n "$$files" || exit 0; \
+	echo " ( cd '$(DESTDIR)$(apportdir)' && rm -f" $$files ")"; \
+	cd "$(DESTDIR)$(apportdir)" && rm -f $$files
 install-configDATA: $(config_DATA)
 	@$(NORMAL_INSTALL)
 	test -z "$(configdir)" || $(MKDIR_P) "$(DESTDIR)$(configdir)"
-	@list='$(config_DATA)'; for p in $$list; do \
+	@list='$(config_DATA)'; test -n "$(configdir)" || list=; \
+	for p in $$list; do \
 	  if test -f "$$p"; then d=; else d="$(srcdir)/"; fi; \
-	  f=$(am__strip_dir) \
-	  echo " $(configDATA_INSTALL) '$$d$$p' '$(DESTDIR)$(configdir)/$$f'"; \
-	  $(configDATA_INSTALL) "$$d$$p" "$(DESTDIR)$(configdir)/$$f"; \
+	  echo "$$d$$p"; \
+	done | $(am__base_list) | \
+	while read files; do \
+	  echo " $(INSTALL_DATA) $$files '$(DESTDIR)$(configdir)'"; \
+	  $(INSTALL_DATA) $$files "$(DESTDIR)$(configdir)" || exit $$?; \
 	done
 
 uninstall-configDATA:
 	@$(NORMAL_UNINSTALL)
-	@list='$(config_DATA)'; for p in $$list; do \
-	  f=$(am__strip_dir) \
-	  echo " rm -f '$(DESTDIR)$(configdir)/$$f'"; \
-	  rm -f "$(DESTDIR)$(configdir)/$$f"; \
-	done
+	@list='$(config_DATA)'; test -n "$(configdir)" || list=; \
+	files=`for p in $$list; do echo $$p; done | sed -e 's|^.*/||'`; \
+	test -n "$$files" || exit 0; \
+	echo " ( cd '$(DESTDIR)$(configdir)' && rm -f" $$files ")"; \
+	cd "$(DESTDIR)$(configdir)" && rm -f $$files
 install-crashdbDATA: $(crashdb_DATA)
 	@$(NORMAL_INSTALL)
 	test -z "$(crashdbdir)" || $(MKDIR_P) "$(DESTDIR)$(crashdbdir)"
-	@list='$(crashdb_DATA)'; for p in $$list; do \
+	@list='$(crashdb_DATA)'; test -n "$(crashdbdir)" || list=; \
+	for p in $$list; do \
 	  if test -f "$$p"; then d=; else d="$(srcdir)/"; fi; \
-	  f=$(am__strip_dir) \
-	  echo " $(crashdbDATA_INSTALL) '$$d$$p' '$(DESTDIR)$(crashdbdir)/$$f'"; \
-	  $(crashdbDATA_INSTALL) "$$d$$p" "$(DESTDIR)$(crashdbdir)/$$f"; \
+	  echo "$$d$$p"; \
+	done | $(am__base_list) | \
+	while read files; do \
+	  echo " $(INSTALL_DATA) $$files '$(DESTDIR)$(crashdbdir)'"; \
+	  $(INSTALL_DATA) $$files "$(DESTDIR)$(crashdbdir)" || exit $$?; \
 	done
 
 uninstall-crashdbDATA:
 	@$(NORMAL_UNINSTALL)
-	@list='$(crashdb_DATA)'; for p in $$list; do \
-	  f=$(am__strip_dir) \
-	  echo " rm -f '$(DESTDIR)$(crashdbdir)/$$f'"; \
-	  rm -f "$(DESTDIR)$(crashdbdir)/$$f"; \
-	done
+	@list='$(crashdb_DATA)'; test -n "$(crashdbdir)" || list=; \
+	files=`for p in $$list; do echo $$p; done | sed -e 's|^.*/||'`; \
+	test -n "$$files" || exit 0; \
+	echo " ( cd '$(DESTDIR)$(crashdbdir)' && rm -f" $$files ")"; \
+	cd "$(DESTDIR)$(crashdbdir)" && rm -f $$files
 install-desktopDATA: $(desktop_DATA)
 	@$(NORMAL_INSTALL)
 	test -z "$(desktopdir)" || $(MKDIR_P) "$(DESTDIR)$(desktopdir)"
-	@list='$(desktop_DATA)'; for p in $$list; do \
+	@list='$(desktop_DATA)'; test -n "$(desktopdir)" || list=; \
+	for p in $$list; do \
 	  if test -f "$$p"; then d=; else d="$(srcdir)/"; fi; \
-	  f=$(am__strip_dir) \
-	  echo " $(desktopDATA_INSTALL) '$$d$$p' '$(DESTDIR)$(desktopdir)/$$f'"; \
-	  $(desktopDATA_INSTALL) "$$d$$p" "$(DESTDIR)$(desktopdir)/$$f"; \
+	  echo "$$d$$p"; \
+	done | $(am__base_list) | \
+	while read files; do \
+	  echo " $(INSTALL_DATA) $$files '$(DESTDIR)$(desktopdir)'"; \
+	  $(INSTALL_DATA) $$files "$(DESTDIR)$(desktopdir)" || exit $$?; \
 	done
 
 uninstall-desktopDATA:
 	@$(NORMAL_UNINSTALL)
-	@list='$(desktop_DATA)'; for p in $$list; do \
-	  f=$(am__strip_dir) \
-	  echo " rm -f '$(DESTDIR)$(desktopdir)/$$f'"; \
-	  rm -f "$(DESTDIR)$(desktopdir)/$$f"; \
-	done
+	@list='$(desktop_DATA)'; test -n "$(desktopdir)" || list=; \
+	files=`for p in $$list; do echo $$p; done | sed -e 's|^.*/||'`; \
+	test -n "$$files" || exit 0; \
+	echo " ( cd '$(DESTDIR)$(desktopdir)' && rm -f" $$files ")"; \
+	cd "$(DESTDIR)$(desktopdir)" && rm -f $$files
 install-oauthDATA: $(oauth_DATA)
 	@$(NORMAL_INSTALL)
 	test -z "$(oauthdir)" || $(MKDIR_P) "$(DESTDIR)$(oauthdir)"
-	@list='$(oauth_DATA)'; for p in $$list; do \
+	@list='$(oauth_DATA)'; test -n "$(oauthdir)" || list=; \
+	for p in $$list; do \
 	  if test -f "$$p"; then d=; else d="$(srcdir)/"; fi; \
-	  f=$(am__strip_dir) \
-	  echo " $(oauthDATA_INSTALL) '$$d$$p' '$(DESTDIR)$(oauthdir)/$$f'"; \
-	  $(oauthDATA_INSTALL) "$$d$$p" "$(DESTDIR)$(oauthdir)/$$f"; \
+	  echo "$$d$$p"; \
+	done | $(am__base_list) | \
+	while read files; do \
+	  echo " $(INSTALL_DATA) $$files '$(DESTDIR)$(oauthdir)'"; \
+	  $(INSTALL_DATA) $$files "$(DESTDIR)$(oauthdir)" || exit $$?; \
 	done
 
 uninstall-oauthDATA:
 	@$(NORMAL_UNINSTALL)
-	@list='$(oauth_DATA)'; for p in $$list; do \
-	  f=$(am__strip_dir) \
-	  echo " rm -f '$(DESTDIR)$(oauthdir)/$$f'"; \
-	  rm -f "$(DESTDIR)$(oauthdir)/$$f"; \
-	done
+	@list='$(oauth_DATA)'; test -n "$(oauthdir)" || list=; \
+	files=`for p in $$list; do echo $$p; done | sed -e 's|^.*/||'`; \
+	test -n "$$files" || exit 0; \
+	echo " ( cd '$(DESTDIR)$(oauthdir)' && rm -f" $$files ")"; \
+	cd "$(DESTDIR)$(oauthdir)" && rm -f $$files
 install-serviceDATA: $(service_DATA)
 	@$(NORMAL_INSTALL)
 	test -z "$(servicedir)" || $(MKDIR_P) "$(DESTDIR)$(servicedir)"
-	@list='$(service_DATA)'; for p in $$list; do \
+	@list='$(service_DATA)'; test -n "$(servicedir)" || list=; \
+	for p in $$list; do \
 	  if test -f "$$p"; then d=; else d="$(srcdir)/"; fi; \
-	  f=$(am__strip_dir) \
-	  echo " $(serviceDATA_INSTALL) '$$d$$p' '$(DESTDIR)$(servicedir)/$$f'"; \
-	  $(serviceDATA_INSTALL) "$$d$$p" "$(DESTDIR)$(servicedir)/$$f"; \
+	  echo "$$d$$p"; \
+	done | $(am__base_list) | \
+	while read files; do \
+	  echo " $(INSTALL_DATA) $$files '$(DESTDIR)$(servicedir)'"; \
+	  $(INSTALL_DATA) $$files "$(DESTDIR)$(servicedir)" || exit $$?; \
 	done
 
 uninstall-serviceDATA:
 	@$(NORMAL_UNINSTALL)
-	@list='$(service_DATA)'; for p in $$list; do \
-	  f=$(am__strip_dir) \
-	  echo " rm -f '$(DESTDIR)$(servicedir)/$$f'"; \
-	  rm -f "$(DESTDIR)$(servicedir)/$$f"; \
-	done
+	@list='$(service_DATA)'; test -n "$(servicedir)" || list=; \
+	files=`for p in $$list; do echo $$p; done | sed -e 's|^.*/||'`; \
+	test -n "$$files" || exit 0; \
+	echo " ( cd '$(DESTDIR)$(servicedir)' && rm -f" $$files ")"; \
+	cd "$(DESTDIR)$(servicedir)" && rm -f $$files
 tags: TAGS
 TAGS:
 
@@ -419,13 +450,17 @@
 	  if test -f $$file || test -d $$file; then d=.; else d=$(srcdir); fi; \
 	  if test -d $$d/$$file; then \
 	    dir=`echo "/$$file" | sed -e 's,/[^/]*$$,,'`; \
+	    if test -d "$(distdir)/$$file"; then \
+	      find "$(distdir)/$$file" -type d ! -perm -700 -exec chmod u+rwx {} \;; \
+	    fi; \
 	    if test -d $(srcdir)/$$file && test $$d != $(srcdir); then \
-	      cp -pR $(srcdir)/$$file $(distdir)$$dir || exit 1; \
+	      cp -fpR $(srcdir)/$$file "$(distdir)$$dir" || exit 1; \
+	      find "$(distdir)/$$file" -type d ! -perm -700 -exec chmod u+rwx {} \;; \
 	    fi; \
-	    cp -pR $$d/$$file $(distdir)$$dir || exit 1; \
+	    cp -fpR $$d/$$file "$(distdir)$$dir" || exit 1; \
 	  else \
-	    test -f $(distdir)/$$file \
-	    || cp -p $$d/$$file $(distdir)/$$file \
+	    test -f "$(distdir)/$$file" \
+	    || cp -p $$d/$$file "$(distdir)/$$file" \
 	    || exit 1; \
 	  fi; \
 	done
@@ -460,6 +495,7 @@
 
 distclean-generic:
 	-test -z "$(CONFIG_CLEAN_FILES)" || rm -f $(CONFIG_CLEAN_FILES)
+	-test . = "$(srcdir)" || test -z "$(CONFIG_CLEAN_VPATH_FILES)" || rm -f $(CONFIG_CLEAN_VPATH_FILES)
 
 maintainer-clean-generic:
 	@echo "This command is intended for maintainers to use"
@@ -479,6 +515,8 @@
 
 html: html-am
 
+html-am:
+
 info: info-am
 
 info-am:
@@ -489,18 +527,28 @@
 
 install-dvi: install-dvi-am
 
+install-dvi-am:
+
 install-exec-am:
 
 install-html: install-html-am
 
+install-html-am:
+
 install-info: install-info-am
 
+install-info-am:
+
 install-man:
 
 install-pdf: install-pdf-am
 
+install-pdf-am:
+
 install-ps: install-ps-am
 
+install-ps-am:
+
 installcheck-am:
 
 maintainer-clean: maintainer-clean-am
@@ -621,6 +669,7 @@
 
 maintainer-clean-local:
 	rm -rf icons
+
 # Tell versions [3.59,3.63) of GNU make to not export all variables.
 # Otherwise a system limit (for SysV at least) may be exceeded.
 .NOEXPORT:

=== removed directory 'data/icons/16x16/animations'
=== removed file 'data/icons/16x16/animations/ubuntuone-client-working.png'
Binary files data/icons/16x16/animations/ubuntuone-client-working.png and data/icons/16x16/animations/ubuntuone-client-working.png differ
=== removed directory 'data/icons/24x24/animations'
=== removed file 'data/icons/24x24/animations/ubuntuone-client-working.png'
Binary files data/icons/24x24/animations/ubuntuone-client-working.png and data/icons/24x24/animations/ubuntuone-client-working.png differ
=== removed directory 'data/icons/48x48/animations'
=== removed file 'data/icons/48x48/animations/ubuntuone-client-working.png'
Binary files data/icons/48x48/animations/ubuntuone-client-working.png and data/icons/48x48/animations/ubuntuone-client-working.png differ
=== modified file 'data/syncdaemon.conf'
--- data/syncdaemon.conf	2009-08-11 16:45:00 +0000
+++ data/syncdaemon.conf	2009-08-26 12:15:00 +0000
@@ -18,8 +18,12 @@
 root_dir.parser = home_dir
 root_dir.help = Use the specified directory as the root
 
+shares_dir.default = ubuntuone/shares
+shares_dir.parser = xdg_data
+shares_dir.help = Use the specified directory as shares root
+
 data_dir.default = ubuntuone/syncdaemon
-data_dir.parser = cache_dir
+data_dir.parser = xdg_cache
 data_dir.help = Use the specified directory to store the metadata
 
 realm.default = https://ubuntuone.com
@@ -48,18 +52,21 @@
 log_level.help = Set the log level (TRACE, DEBUG, INFO, WARNING, ERROR, NOTE 
     CRITICAL, FATAL)
 
-disable_fsync_md.default = False
-disable_fsync_md.parser = bool
-disable_fsync_md.action = store_true
-disable_fsync_md.help = Disable fsync of metadata files on each write.
-    *WARNING*: this might cause metadata corruption on power failure
-
 send_events_over_dbus.default = False
 send_events_over_dbus.parser = bool
 send_events_over_dbus.action = store_true
 send_events_over_dbus.help = Enable sending "Event" singals for each internal 
     event
 
+handshake_timeout.default = 30
+handshake_timeout.parser = int
+handshake_timeout.help = The timeout for the connection and related states, in seconds
+
+max_handshake_timeouts.default = 10
+max_handshake_timeouts.parser = int
+max_handshake_timeouts.help = The number of consecutive handshake timeouts
+                              before we give up
+
 [debug]
 lsprof_file.metavar = FILE
 lsprof_file.help = Profile execution using the lsprof profiler, and write the 

=== removed file 'data/ubuntuone-animations.rendercache'
--- data/ubuntuone-animations.rendercache	2009-06-30 12:00:00 +0000
+++ data/ubuntuone-animations.rendercache	1970-01-01 00:00:00 +0000
@@ -1,1 +0,0 @@
-animations/ubuntuone-client-working.png

=== removed file 'data/ubuntuone-animations.svg'
--- data/ubuntuone-animations.svg	2009-06-30 12:00:00 +0000
+++ data/ubuntuone-animations.svg	1970-01-01 00:00:00 +0000
@@ -1,2842 +0,0 @@
-<?xml version="1.0" encoding="UTF-8" standalone="no"?>
-<!-- Created with Inkscape (http://www.inkscape.org/) -->
-<svg
-   xmlns:dc="http://purl.org/dc/elements/1.1/"
-   xmlns:cc="http://creativecommons.org/ns#"
-   xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
-   xmlns:svg="http://www.w3.org/2000/svg"
-   xmlns="http://www.w3.org/2000/svg"
-   xmlns:xlink="http://www.w3.org/1999/xlink"
-   xmlns:sodipodi="http://sodipodi.sourceforge.net/DTD/sodipodi-0.dtd"
-   xmlns:inkscape="http://www.inkscape.org/namespaces/inkscape"
-   inkscape:export-ydpi="90.000000"
-   inkscape:export-xdpi="90.000000"
-   inkscape:export-filename="/home/jimmac/Desktop/wi-fi.png"
-   width="400"
-   height="600"
-   id="svg11300"
-   sodipodi:version="0.32"
-   inkscape:version="0.46"
-   sodipodi:docname="ubuntuone-animations.svg"
-   inkscape:output_extension="org.inkscape.output.svg.inkscape"
-   version="1.0"
-   style="display:inline;enable-background:new">
-  <defs
-     id="defs3">
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient11639"
-       id="linearGradient3834"
-       gradientUnits="userSpaceOnUse"
-       x1="611.125"
-       y1="-404.84375"
-       x2="613.92871"
-       y2="-402.37305" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient11639"
-       id="linearGradient3832"
-       gradientUnits="userSpaceOnUse"
-       x1="611.125"
-       y1="-404.84375"
-       x2="613.92871"
-       y2="-402.37305" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient11629"
-       id="linearGradient3830"
-       gradientUnits="userSpaceOnUse"
-       x1="615"
-       y1="-406.78125"
-       x2="618.875"
-       y2="-403.36459" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient11639"
-       id="linearGradient3828"
-       gradientUnits="userSpaceOnUse"
-       x1="611.125"
-       y1="-404.84375"
-       x2="613.92871"
-       y2="-402.37305" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient11639"
-       id="linearGradient3826"
-       gradientUnits="userSpaceOnUse"
-       x1="611.125"
-       y1="-404.84375"
-       x2="613.92871"
-       y2="-402.37305" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient11639"
-       id="linearGradient3824"
-       gradientUnits="userSpaceOnUse"
-       x1="611.125"
-       y1="-404.84375"
-       x2="613.92871"
-       y2="-402.37305" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient11629"
-       id="linearGradient3822"
-       gradientUnits="userSpaceOnUse"
-       x1="615"
-       y1="-406.78125"
-       x2="618.875"
-       y2="-403.36459" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1334"
-       id="linearGradient4749"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="matrix(7.8321048,0,0,7.7379665,-6.1189808,-131.64379)"
-       x1="1.0448723"
-       y1="22.382998"
-       x2="45.43124"
-       y2="31.877295" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1334"
-       id="linearGradient6759"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="matrix(5.1625373,0,0,5.1812621,94.39518,-122.05712)"
-       x1="31.784821"
-       y1="14.882939"
-       x2="76.798752"
-       y2="26.225924" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1334"
-       id="linearGradient4745"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="matrix(5.1625371,0,0,5.1811574,94.395187,-23.544563)"
-       x1="3.5197463"
-       y1="16.549366"
-       x2="45.43124"
-       y2="31.877295" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1334"
-       id="linearGradient4743"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="matrix(7.8321048,0,0,7.7379665,-6.1189782,-131.64379)"
-       x1="31.784821"
-       y1="14.882939"
-       x2="76.798752"
-       y2="26.225924" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1334"
-       id="linearGradient4741"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="matrix(5.1625377,0,0,5.1811564,6.6320258,-72.800391)"
-       x1="1.0448723"
-       y1="22.382998"
-       x2="45.43124"
-       y2="31.877295" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1334"
-       id="linearGradient4739"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="matrix(7.8321048,0,0,7.7379665,-6.1189782,-131.64379)"
-       x1="3.5197463"
-       y1="16.549366"
-       x2="45.43124"
-       y2="31.877295" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient11639"
-       id="linearGradient20482"
-       gradientUnits="userSpaceOnUse"
-       x1="611.125"
-       y1="-404.84375"
-       x2="613.92871"
-       y2="-402.37305" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient11639"
-       id="linearGradient20480"
-       gradientUnits="userSpaceOnUse"
-       x1="611.125"
-       y1="-404.84375"
-       x2="613.92871"
-       y2="-402.37305" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient11629"
-       id="linearGradient20478"
-       gradientUnits="userSpaceOnUse"
-       x1="615"
-       y1="-406.78125"
-       x2="618.875"
-       y2="-403.36459" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient11639"
-       id="linearGradient20476"
-       gradientUnits="userSpaceOnUse"
-       x1="611.125"
-       y1="-404.84375"
-       x2="613.92871"
-       y2="-402.37305" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient11639"
-       id="linearGradient20474"
-       gradientUnits="userSpaceOnUse"
-       x1="611.125"
-       y1="-404.84375"
-       x2="613.92871"
-       y2="-402.37305" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient11639"
-       id="linearGradient20472"
-       gradientUnits="userSpaceOnUse"
-       x1="611.125"
-       y1="-404.84375"
-       x2="613.92871"
-       y2="-402.37305" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient11629"
-       id="linearGradient20470"
-       gradientUnits="userSpaceOnUse"
-       x1="615"
-       y1="-406.78125"
-       x2="618.875"
-       y2="-403.36459" />
-    <linearGradient
-       inkscape:collect="always"
-       id="linearGradient4187">
-      <stop
-         style="stop-color:#000000;stop-opacity:1;"
-         offset="0"
-         id="stop4189" />
-      <stop
-         style="stop-color:#000000;stop-opacity:0;"
-         offset="1"
-         id="stop4191" />
-    </linearGradient>
-    <linearGradient
-       inkscape:collect="always"
-       id="linearGradient3385">
-      <stop
-         style="stop-color:#ffffff;stop-opacity:1;"
-         offset="0"
-         id="stop3387" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0;"
-         offset="1"
-         id="stop3389" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient1334">
-      <stop
-         style="stop-color:#ffffff;stop-opacity:1;"
-         offset="0"
-         id="stop1336" />
-      <stop
-         id="stop1346"
-         offset="0.25"
-         style="stop-color:#ffffff;stop-opacity:0;" />
-      <stop
-         id="stop1342"
-         offset="0.3448838"
-         style="stop-color:#ffffff;stop-opacity:1;" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0;"
-         offset="0.86309522"
-         id="stop1344" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:1;"
-         offset="1"
-         id="stop1338" />
-    </linearGradient>
-    <linearGradient
-       inkscape:collect="always"
-       id="linearGradient11629">
-      <stop
-         style="stop-color:#ffffff;stop-opacity:1;"
-         offset="0"
-         id="stop11631" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0;"
-         offset="1"
-         id="stop11633" />
-    </linearGradient>
-    <linearGradient
-       inkscape:collect="always"
-       id="linearGradient11639">
-      <stop
-         style="stop-color:#ffffff;stop-opacity:1;"
-         offset="0"
-         id="stop11641" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0;"
-         offset="1"
-         id="stop11643" />
-    </linearGradient>
-    <inkscape:perspective
-       sodipodi:type="inkscape:persp3d"
-       inkscape:vp_x="-50 : 600 : 1"
-       inkscape:vp_y="0 : 1000 : 0"
-       inkscape:vp_z="700 : 600 : 1"
-       inkscape:persp3d-origin="300 : 400 : 1"
-       id="perspective242" />
-    <inkscape:perspective
-       sodipodi:type="inkscape:persp3d"
-       inkscape:vp_x="-50 : 600 : 1"
-       inkscape:vp_y="0 : 1000 : 0"
-       inkscape:vp_z="700 : 600 : 1"
-       inkscape:persp3d-origin="300 : 400 : 1"
-       id="perspective241" />
-    <inkscape:perspective
-       sodipodi:type="inkscape:persp3d"
-       inkscape:vp_x="-50 : 600 : 1"
-       inkscape:vp_y="0 : 1000 : 0"
-       inkscape:vp_z="700 : 600 : 1"
-       inkscape:persp3d-origin="300 : 400 : 1"
-       id="perspective243" />
-    <linearGradient
-       inkscape:collect="always"
-       id="linearGradient7010">
-      <stop
-         style="stop-color:#ffffff;stop-opacity:1;"
-         offset="0"
-         id="stop7012" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0;"
-         offset="1"
-         id="stop7014" />
-    </linearGradient>
-    <linearGradient
-       inkscape:collect="always"
-       id="linearGradient6992">
-      <stop
-         style="stop-color:#ffffff;stop-opacity:1;"
-         offset="0"
-         id="stop6994" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0;"
-         offset="1"
-         id="stop6996" />
-    </linearGradient>
-    <linearGradient
-       inkscape:collect="always"
-       id="linearGradient6982">
-      <stop
-         style="stop-color:#ffffff;stop-opacity:1;"
-         offset="0"
-         id="stop6984" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0;"
-         offset="1"
-         id="stop6986" />
-    </linearGradient>
-    <radialGradient
-       r="55.921093"
-       fy="199.40643"
-       fx="67.131371"
-       cy="199.40643"
-       cx="67.131371"
-       gradientTransform="matrix(1.0864204,-6.9984547e-2,3.1641036e-2,0.4877152,-12.138491,98.480368)"
-       gradientUnits="userSpaceOnUse"
-       id="radialGradient5384"
-       xlink:href="#linearGradient6016"
-       inkscape:collect="always" />
-    <radialGradient
-       r="55.921093"
-       fy="199.40643"
-       fx="67.131371"
-       cy="199.40643"
-       cx="67.131371"
-       gradientTransform="matrix(1.1273876,-7.2623556e-2,3.283417e-2,0.5061061,-15.126596,94.990248)"
-       gradientUnits="userSpaceOnUse"
-       id="radialGradient5382"
-       xlink:href="#linearGradient6016"
-       inkscape:collect="always" />
-    <linearGradient
-       id="linearGradient6124">
-      <stop
-         style="stop-color:#9db029;stop-opacity:1;"
-         offset="0"
-         id="stop6126" />
-      <stop
-         style="stop-color:#9db029;stop-opacity:0.61616164;"
-         offset="1"
-         id="stop6128" />
-    </linearGradient>
-    <linearGradient
-       inkscape:collect="always"
-       id="linearGradient5957">
-      <stop
-         style="stop-color:#000000;stop-opacity:1;"
-         offset="0"
-         id="stop5959" />
-      <stop
-         style="stop-color:#000000;stop-opacity:0;"
-         offset="1"
-         id="stop5961" />
-    </linearGradient>
-    <linearGradient
-       inkscape:collect="always"
-       id="linearGradient5948">
-      <stop
-         style="stop-color:#000000;stop-opacity:1;"
-         offset="0"
-         id="stop5950" />
-      <stop
-         style="stop-color:#000000;stop-opacity:0;"
-         offset="1"
-         id="stop5952" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient6016">
-      <stop
-         id="stop6020"
-         offset="0"
-         style="stop-color:#000000;stop-opacity:0;" />
-      <stop
-         style="stop-color:#000000;stop-opacity:0;"
-         offset="0.5"
-         id="stop6054" />
-      <stop
-         id="stop6018"
-         offset="1"
-         style="stop-color:#000000;stop-opacity:1;" />
-    </linearGradient>
-    <linearGradient
-       inkscape:collect="always"
-       id="linearGradient6002">
-      <stop
-         style="stop-color:#ffffff;stop-opacity:1;"
-         offset="0"
-         id="stop6004" />
-      <stop
-         style="stop-color:#ffffff;stop-opacity:0;"
-         offset="1"
-         id="stop6006" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient5821">
-      <stop
-         style="stop-color:#dbf6c0;stop-opacity:1;"
-         offset="0"
-         id="stop5823" />
-      <stop
-         style="stop-color:#8ae234;stop-opacity:0;"
-         offset="1"
-         id="stop5825" />
-    </linearGradient>
-    <linearGradient
-       id="linearGradient2315"
-       inkscape:collect="always">
-      <stop
-         id="stop2317"
-         offset="0"
-         style="stop-color:#ffffff;stop-opacity:1;" />
-      <stop
-         id="stop2319"
-         offset="1"
-         style="stop-color:#ffffff;stop-opacity:0;" />
-    </linearGradient>
-    <clipPath
-       clipPathUnits="userSpaceOnUse"
-       id="clipPath5886">
-      <path
-         style="fill:#9db029;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:1;stroke-linecap:round;stroke-linejoin:round;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dashoffset:0;stroke-opacity:1;visibility:visible;display:block"
-         d="M 236.67749,14.951907 C 236.67749,14.951907 105.34425,31.00775 105.34425,31.00775 L 104.84425,165.90582 C 94.65034,162.45211 69.49348,163.04926 53.9748,166.24457 C 26.99479,171.79978 7.66209,186.67932 10.62162,199.34008 C 13.58116,212.00084 37.83308,217.86254 64.8131,212.30733 C 90.30874,207.05775 112.40327,193.49327 111.89857,181.34077 L 112.86628,63.474309 C 112.86628,63.474309 229.72187,46.042775 229.72187,46.042775 L 229.72187,149.59177 C 166.24043,140.30181 135.39913,170.51049 138.35867,183.17125 C 141.31821,195.83201 165.57014,201.69371 192.55015,196.1385 C 216.48963,191.20933 233.62673,179.02507 235.32271,167.49443 L 236.67749,14.951907 z"
-         id="path5888"
-         sodipodi:nodetypes="cccccccccccccc" />
-    </clipPath>
-    <clipPath
-       clipPathUnits="userSpaceOnUse"
-       id="clipPath6065">
-      <path
-         style="opacity:1;fill:#9db029;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:1;stroke-linecap:round;stroke-linejoin:round;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dashoffset:0;stroke-opacity:1;visibility:visible;display:block"
-         d="M 147.82406,39.783969 C 147.82406,39.783969 17.159722,29.925321 17.159722,29.925321 L -9.2554986,160.34072 C -18.494091,155.02837 -43.046448,150.74218 -58.735599,150.83316 C -86.011994,150.99134 -107.65202,161.64924 -107.2107,174.47056 C -106.76938,187.29188 -84.337576,197.65196 -57.061175,197.49378 C -31.285455,197.34431 -7.215345,188.49269 -5.3697143,176.63773 L 18.226102,62.790618 C 18.226102,62.790618 135.09117,68.519141 135.09117,68.519141 L 115.18743,168.7014 C 55.306732,147.43975 19.540667,170.70327 19.981991,183.52459 C 20.423316,196.34592 42.855125,206.70599 70.13152,206.54782 C 94.333986,206.40746 113.32311,197.9327 117.18696,187.10487 L 147.82406,39.783969 z"
-         id="path6067"
-         sodipodi:nodetypes="cccccccccccccc" />
-    </clipPath>
-    <clipPath
-       clipPathUnits="userSpaceOnUse"
-       id="clipPath6069">
-      <path
-         style="opacity:1;fill:#9db029;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:1;stroke-linecap:round;stroke-linejoin:round;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dashoffset:0;stroke-opacity:1;visibility:visible;display:block"
-         d="M 273.29692,48.665497 C 273.29692,48.665497 142.63258,38.806848 142.63258,38.806848 L 116.21736,169.22225 C 106.97877,163.9099 82.426409,159.62371 66.737258,159.71469 C 39.460862,159.87287 17.820836,170.53076 18.262157,183.35209 C 18.703479,196.17341 41.135281,206.53348 68.411682,206.37531 C 94.187402,206.22583 118.25751,197.37422 120.10314,185.51926 L 143.69896,71.672145 C 143.69896,71.672145 260.56403,77.400668 260.56403,77.400668 L 240.66029,177.58293 C 180.77959,156.32128 145.01352,179.5848 145.45485,192.40612 C 145.89617,205.22744 168.32798,215.58752 195.60438,215.42934 C 219.80684,215.28899 238.79596,206.81423 242.65982,195.9864 L 273.29692,48.665497 z"
-         id="path6071"
-         sodipodi:nodetypes="cccccccccccccc" />
-    </clipPath>
-    <radialGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient6016"
-       id="radialGradient6220"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="matrix(1.1273876,-7.2623556e-2,3.283417e-2,0.5061061,-15.126596,94.990248)"
-       cx="67.131371"
-       cy="199.40643"
-       fx="67.131371"
-       fy="199.40643"
-       r="55.921093" />
-    <radialGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient6016"
-       id="radialGradient6222"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="matrix(1.0864204,-6.9984547e-2,3.1641036e-2,0.4877152,-12.138491,98.480368)"
-       cx="67.131371"
-       cy="199.40643"
-       fx="67.131371"
-       fy="199.40643"
-       r="55.921093" />
-    <radialGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient6016"
-       id="radialGradient6317"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="matrix(1.1273876,-7.2623556e-2,3.283417e-2,0.5061061,-15.126596,94.990248)"
-       cx="67.131371"
-       cy="199.40643"
-       fx="67.131371"
-       fy="199.40643"
-       r="55.921093" />
-    <radialGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient6016"
-       id="radialGradient6319"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="matrix(1.0864204,-6.9984547e-2,3.1641036e-2,0.4877152,-12.138491,98.480368)"
-       cx="67.131371"
-       cy="199.40643"
-       fx="67.131371"
-       fy="199.40643"
-       r="55.921093" />
-    <radialGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient6982"
-       id="radialGradient7210"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="matrix(0.9070253,0,1.2968623e-8,1.3298547,298.37473,44.196753)"
-       cx="29.6742"
-       cy="13.771779"
-       fx="29.6742"
-       fy="13.771779"
-       r="17.742022" />
-    <radialGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient2315"
-       id="radialGradient7212"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="matrix(1,0,0,0.509804,0,16.05392)"
-       cx="4.3920336"
-       cy="32.307854"
-       fx="4.3920336"
-       fy="32.307854"
-       r="6.375" />
-    <radialGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient2315"
-       id="radialGradient7214"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="matrix(1,0,0,0.509804,0,16.05392)"
-       cx="4.3920336"
-       cy="32.307854"
-       fx="4.3920336"
-       fy="32.307854"
-       r="6.375" />
-    <radialGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient6992"
-       id="radialGradient7216"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="matrix(1.4476199,-5.1119044e-6,2.2611777e-6,0.6403339,-145.93333,19.733632)"
-       cx="326.02042"
-       cy="58.370884"
-       fx="326.02042"
-       fy="58.370884"
-       r="11.09274" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient6002"
-       id="linearGradient7218"
-       gradientUnits="userSpaceOnUse"
-       x1="181.84053"
-       y1="149.63168"
-       x2="191.14145"
-       y2="181.2997" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient6002"
-       id="linearGradient7220"
-       gradientUnits="userSpaceOnUse"
-       x1="181.84053"
-       y1="149.63168"
-       x2="191.14145"
-       y2="181.2997" />
-    <radialGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient7010"
-       id="radialGradient7222"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="matrix(1.6443661,0,0,2.1729477,-195.14919,-102.18432)"
-       cx="302.85449"
-       cy="86.96299"
-       fx="302.85449"
-       fy="86.96299"
-       r="0.78358209" />
-    <radialGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient7010"
-       id="radialGradient7224"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="matrix(1.6443661,0,0,2.1729477,-195.14919,-102.18432)"
-       cx="302.85449"
-       cy="86.96299"
-       fx="302.85449"
-       fy="86.96299"
-       r="0.78358209" />
-    <radialGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient5957"
-       id="radialGradient7275"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="matrix(1,0,0,0.2921348,0,150.06742)"
-       cx="72.5"
-       cy="212"
-       fx="72.5"
-       fy="212"
-       r="44.5" />
-    <radialGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient5948"
-       id="radialGradient7277"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="matrix(1,0,0,0.2921348,0,150.06742)"
-       cx="72.5"
-       cy="212"
-       fx="72.5"
-       fy="212"
-       r="44.5" />
-    <radialGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient5957"
-       id="radialGradient7279"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="matrix(1,0,0,0.2921348,0,150.06742)"
-       cx="72.5"
-       cy="212"
-       fx="72.5"
-       fy="212"
-       r="44.5" />
-    <radialGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient5948"
-       id="radialGradient7281"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="matrix(1,0,0,0.2921348,0,150.06742)"
-       cx="72.5"
-       cy="212"
-       fx="72.5"
-       fy="212"
-       r="44.5" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient6002"
-       id="linearGradient7289"
-       gradientUnits="userSpaceOnUse"
-       x1="181.84053"
-       y1="149.63168"
-       x2="191.14145"
-       y2="181.2997" />
-    <inkscape:perspective
-       id="perspective2727"
-       inkscape:persp3d-origin="0.5 : 0.33333333 : 1"
-       inkscape:vp_z="1 : 0.5 : 1"
-       inkscape:vp_y="0 : 1000 : 0"
-       inkscape:vp_x="0 : 0.5 : 1"
-       sodipodi:type="inkscape:persp3d" />
-    <inkscape:perspective
-       id="perspective2769"
-       inkscape:persp3d-origin="0.5 : 0.33333333 : 1"
-       inkscape:vp_z="1 : 0.5 : 1"
-       inkscape:vp_y="0 : 1000 : 0"
-       inkscape:vp_x="0 : 0.5 : 1"
-       sodipodi:type="inkscape:persp3d" />
-    <inkscape:perspective
-       id="perspective2804"
-       inkscape:persp3d-origin="0.5 : 0.33333333 : 1"
-       inkscape:vp_z="1 : 0.5 : 1"
-       inkscape:vp_y="0 : 1000 : 0"
-       inkscape:vp_x="0 : 0.5 : 1"
-       sodipodi:type="inkscape:persp3d" />
-    <inkscape:perspective
-       id="perspective2828"
-       inkscape:persp3d-origin="0.5 : 0.33333333 : 1"
-       inkscape:vp_z="1 : 0.5 : 1"
-       inkscape:vp_y="0 : 1000 : 0"
-       inkscape:vp_x="0 : 0.5 : 1"
-       sodipodi:type="inkscape:persp3d" />
-    <inkscape:perspective
-       id="perspective2858"
-       inkscape:persp3d-origin="0.5 : 0.33333333 : 1"
-       inkscape:vp_z="1 : 0.5 : 1"
-       inkscape:vp_y="0 : 1000 : 0"
-       inkscape:vp_x="0 : 0.5 : 1"
-       sodipodi:type="inkscape:persp3d" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient11629"
-       id="linearGradient8135"
-       gradientUnits="userSpaceOnUse"
-       x1="615"
-       y1="-406.78125"
-       x2="618.875"
-       y2="-403.36459" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient11639"
-       id="linearGradient8137"
-       gradientUnits="userSpaceOnUse"
-       x1="611.125"
-       y1="-404.84375"
-       x2="613.92871"
-       y2="-402.37305" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient11639"
-       id="linearGradient8139"
-       gradientUnits="userSpaceOnUse"
-       x1="611.125"
-       y1="-404.84375"
-       x2="613.92871"
-       y2="-402.37305" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient11639"
-       id="linearGradient8141"
-       gradientUnits="userSpaceOnUse"
-       x1="611.125"
-       y1="-404.84375"
-       x2="613.92871"
-       y2="-402.37305" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient11629"
-       id="linearGradient8143"
-       gradientUnits="userSpaceOnUse"
-       x1="615"
-       y1="-406.78125"
-       x2="618.875"
-       y2="-403.36459" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient11639"
-       id="linearGradient8145"
-       gradientUnits="userSpaceOnUse"
-       x1="611.125"
-       y1="-404.84375"
-       x2="613.92871"
-       y2="-402.37305" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient11639"
-       id="linearGradient8147"
-       gradientUnits="userSpaceOnUse"
-       x1="611.125"
-       y1="-404.84375"
-       x2="613.92871"
-       y2="-402.37305" />
-    <radialGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient4187"
-       id="radialGradient8183"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="matrix(8.716285e-6,-0.665592,0.957576,0,178.4903,133.0866)"
-       cx="191.41389"
-       cy="7.7861371"
-       fx="191.41389"
-       fy="7.7861371"
-       r="153.39676" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1334"
-       id="linearGradient8185"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="matrix(7.8321048,0,0,7.7379665,-6.1189782,-131.64379)"
-       x1="3.5197463"
-       y1="16.549366"
-       x2="45.43124"
-       y2="31.877295" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1334"
-       id="linearGradient8187"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="matrix(6.4333395,0,0,6.4401842,-1.6083373,-102.05672)"
-       x1="1.0448723"
-       y1="22.382998"
-       x2="45.43124"
-       y2="31.877295" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1334"
-       id="linearGradient8189"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="matrix(7.8321048,0,0,7.7379665,-6.1189782,-131.64379)"
-       x1="31.784821"
-       y1="14.882939"
-       x2="76.798752"
-       y2="26.225924" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1334"
-       id="linearGradient8191"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="matrix(6.3996815,0,0,6.4564645,52.610375,-75.576302)"
-       x1="3.5197463"
-       y1="16.549366"
-       x2="45.43124"
-       y2="31.877295" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1334"
-       id="linearGradient8193"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="matrix(6.3995804,0,0,6.4319234,52.61452,-129.20466)"
-       x1="31.784821"
-       y1="14.882939"
-       x2="76.798752"
-       y2="26.225924" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1334"
-       id="linearGradient8195"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="matrix(7.8321048,0,0,7.7379665,-6.1189808,-131.64379)"
-       x1="1.0448723"
-       y1="22.382998"
-       x2="45.43124"
-       y2="31.877295" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient3385"
-       id="linearGradient8197"
-       gradientUnits="userSpaceOnUse"
-       x1="23.472849"
-       y1="14.625"
-       x2="20.594484"
-       y2="48.086678" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient11629"
-       id="linearGradient8241"
-       gradientUnits="userSpaceOnUse"
-       x1="615"
-       y1="-406.78125"
-       x2="618.875"
-       y2="-403.36459" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient11639"
-       id="linearGradient8243"
-       gradientUnits="userSpaceOnUse"
-       x1="611.125"
-       y1="-404.84375"
-       x2="613.92871"
-       y2="-402.37305" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient11639"
-       id="linearGradient8245"
-       gradientUnits="userSpaceOnUse"
-       x1="611.125"
-       y1="-404.84375"
-       x2="613.92871"
-       y2="-402.37305" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient11639"
-       id="linearGradient8247"
-       gradientUnits="userSpaceOnUse"
-       x1="611.125"
-       y1="-404.84375"
-       x2="613.92871"
-       y2="-402.37305" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient11629"
-       id="linearGradient8249"
-       gradientUnits="userSpaceOnUse"
-       x1="615"
-       y1="-406.78125"
-       x2="618.875"
-       y2="-403.36459" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient11639"
-       id="linearGradient8251"
-       gradientUnits="userSpaceOnUse"
-       x1="611.125"
-       y1="-404.84375"
-       x2="613.92871"
-       y2="-402.37305" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient11639"
-       id="linearGradient8253"
-       gradientUnits="userSpaceOnUse"
-       x1="611.125"
-       y1="-404.84375"
-       x2="613.92871"
-       y2="-402.37305" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient11629"
-       id="linearGradient8297"
-       gradientUnits="userSpaceOnUse"
-       x1="615"
-       y1="-406.78125"
-       x2="618.875"
-       y2="-403.36459" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient11639"
-       id="linearGradient8299"
-       gradientUnits="userSpaceOnUse"
-       x1="611.125"
-       y1="-404.84375"
-       x2="613.92871"
-       y2="-402.37305" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient11639"
-       id="linearGradient8301"
-       gradientUnits="userSpaceOnUse"
-       x1="611.125"
-       y1="-404.84375"
-       x2="613.92871"
-       y2="-402.37305" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient11639"
-       id="linearGradient8303"
-       gradientUnits="userSpaceOnUse"
-       x1="611.125"
-       y1="-404.84375"
-       x2="613.92871"
-       y2="-402.37305" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient11629"
-       id="linearGradient8305"
-       gradientUnits="userSpaceOnUse"
-       x1="615"
-       y1="-406.78125"
-       x2="618.875"
-       y2="-403.36459" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient11639"
-       id="linearGradient8307"
-       gradientUnits="userSpaceOnUse"
-       x1="611.125"
-       y1="-404.84375"
-       x2="613.92871"
-       y2="-402.37305" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient11639"
-       id="linearGradient8309"
-       gradientUnits="userSpaceOnUse"
-       x1="611.125"
-       y1="-404.84375"
-       x2="613.92871"
-       y2="-402.37305" />
-    <radialGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient4187"
-       id="radialGradient8345"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="matrix(8.716285e-6,-0.665592,0.957576,0,178.4903,133.0866)"
-       cx="191.41389"
-       cy="7.7861371"
-       fx="191.41389"
-       fy="7.7861371"
-       r="153.39676" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1334"
-       id="linearGradient8347"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="matrix(7.8321048,0,0,7.7379665,-6.1189782,-131.64379)"
-       x1="3.5197463"
-       y1="16.549366"
-       x2="45.43124"
-       y2="31.877295" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1334"
-       id="linearGradient8349"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="matrix(6.4333395,0,0,6.4401842,-1.6083373,-102.05672)"
-       x1="1.0448723"
-       y1="22.382998"
-       x2="45.43124"
-       y2="31.877295" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1334"
-       id="linearGradient8351"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="matrix(7.8321048,0,0,7.7379665,-6.1189782,-131.64379)"
-       x1="31.784821"
-       y1="14.882939"
-       x2="76.798752"
-       y2="26.225924" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1334"
-       id="linearGradient8353"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="matrix(6.3996815,0,0,6.4564645,52.610375,-75.576302)"
-       x1="3.5197463"
-       y1="16.549366"
-       x2="45.43124"
-       y2="31.877295" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1334"
-       id="linearGradient8355"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="matrix(6.3995804,0,0,6.4319234,52.61452,-129.20466)"
-       x1="31.784821"
-       y1="14.882939"
-       x2="76.798752"
-       y2="26.225924" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1334"
-       id="linearGradient8357"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="matrix(7.8321048,0,0,7.7379665,-6.1189808,-131.64379)"
-       x1="1.0448723"
-       y1="22.382998"
-       x2="45.43124"
-       y2="31.877295" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient3385"
-       id="linearGradient8359"
-       gradientUnits="userSpaceOnUse"
-       x1="23.472849"
-       y1="14.625"
-       x2="20.594484"
-       y2="48.086678" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient11629"
-       id="linearGradient8403"
-       gradientUnits="userSpaceOnUse"
-       x1="615"
-       y1="-406.78125"
-       x2="618.875"
-       y2="-403.36459" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient11639"
-       id="linearGradient8405"
-       gradientUnits="userSpaceOnUse"
-       x1="611.125"
-       y1="-404.84375"
-       x2="613.92871"
-       y2="-402.37305" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient11639"
-       id="linearGradient8407"
-       gradientUnits="userSpaceOnUse"
-       x1="611.125"
-       y1="-404.84375"
-       x2="613.92871"
-       y2="-402.37305" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient11639"
-       id="linearGradient8409"
-       gradientUnits="userSpaceOnUse"
-       x1="611.125"
-       y1="-404.84375"
-       x2="613.92871"
-       y2="-402.37305" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient11629"
-       id="linearGradient8411"
-       gradientUnits="userSpaceOnUse"
-       x1="615"
-       y1="-406.78125"
-       x2="618.875"
-       y2="-403.36459" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient11639"
-       id="linearGradient8413"
-       gradientUnits="userSpaceOnUse"
-       x1="611.125"
-       y1="-404.84375"
-       x2="613.92871"
-       y2="-402.37305" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient11639"
-       id="linearGradient8415"
-       gradientUnits="userSpaceOnUse"
-       x1="611.125"
-       y1="-404.84375"
-       x2="613.92871"
-       y2="-402.37305" />
-    <radialGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient4187"
-       id="radialGradient8451"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="matrix(8.716285e-6,-0.665592,0.957576,0,178.4903,133.0866)"
-       cx="191.41389"
-       cy="7.7861371"
-       fx="191.41389"
-       fy="7.7861371"
-       r="153.39676" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1334"
-       id="linearGradient8453"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="matrix(7.8321048,0,0,7.7379665,-6.1189782,-131.64379)"
-       x1="3.5197463"
-       y1="16.549366"
-       x2="45.43124"
-       y2="31.877295" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1334"
-       id="linearGradient8455"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="matrix(6.4333395,0,0,6.4401842,-1.6083373,-102.05672)"
-       x1="1.0448723"
-       y1="22.382998"
-       x2="45.43124"
-       y2="31.877295" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1334"
-       id="linearGradient8457"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="matrix(7.8321048,0,0,7.7379665,-6.1189782,-131.64379)"
-       x1="31.784821"
-       y1="14.882939"
-       x2="76.798752"
-       y2="26.225924" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1334"
-       id="linearGradient8459"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="matrix(6.3996815,0,0,6.4564645,52.610375,-75.576302)"
-       x1="3.5197463"
-       y1="16.549366"
-       x2="45.43124"
-       y2="31.877295" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1334"
-       id="linearGradient8461"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="matrix(6.3995804,0,0,6.4319234,52.61452,-129.20466)"
-       x1="31.784821"
-       y1="14.882939"
-       x2="76.798752"
-       y2="26.225924" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1334"
-       id="linearGradient8463"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="matrix(7.8321048,0,0,7.7379665,-6.1189808,-131.64379)"
-       x1="1.0448723"
-       y1="22.382998"
-       x2="45.43124"
-       y2="31.877295" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient3385"
-       id="linearGradient8465"
-       gradientUnits="userSpaceOnUse"
-       x1="23.472849"
-       y1="14.625"
-       x2="20.594484"
-       y2="48.086678" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient11629"
-       id="linearGradient8509"
-       gradientUnits="userSpaceOnUse"
-       x1="615"
-       y1="-406.78125"
-       x2="618.875"
-       y2="-403.36459" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient11639"
-       id="linearGradient8511"
-       gradientUnits="userSpaceOnUse"
-       x1="611.125"
-       y1="-404.84375"
-       x2="613.92871"
-       y2="-402.37305" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient11639"
-       id="linearGradient8513"
-       gradientUnits="userSpaceOnUse"
-       x1="611.125"
-       y1="-404.84375"
-       x2="613.92871"
-       y2="-402.37305" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient11639"
-       id="linearGradient8515"
-       gradientUnits="userSpaceOnUse"
-       x1="611.125"
-       y1="-404.84375"
-       x2="613.92871"
-       y2="-402.37305" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient11629"
-       id="linearGradient8517"
-       gradientUnits="userSpaceOnUse"
-       x1="615"
-       y1="-406.78125"
-       x2="618.875"
-       y2="-403.36459" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient11639"
-       id="linearGradient8519"
-       gradientUnits="userSpaceOnUse"
-       x1="611.125"
-       y1="-404.84375"
-       x2="613.92871"
-       y2="-402.37305" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient11639"
-       id="linearGradient8521"
-       gradientUnits="userSpaceOnUse"
-       x1="611.125"
-       y1="-404.84375"
-       x2="613.92871"
-       y2="-402.37305" />
-    <radialGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient4187"
-       id="radialGradient8557"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="matrix(8.716285e-6,-0.665592,0.957576,0,178.4903,133.0866)"
-       cx="191.41389"
-       cy="7.7861371"
-       fx="191.41389"
-       fy="7.7861371"
-       r="153.39676" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1334"
-       id="linearGradient8559"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="matrix(7.8321048,0,0,7.7379665,-6.1189782,-131.64379)"
-       x1="3.5197463"
-       y1="16.549366"
-       x2="45.43124"
-       y2="31.877295" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1334"
-       id="linearGradient8561"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="matrix(6.4333395,0,0,6.4401842,-1.6083373,-102.05672)"
-       x1="1.0448723"
-       y1="22.382998"
-       x2="45.43124"
-       y2="31.877295" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1334"
-       id="linearGradient8563"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="matrix(7.8321048,0,0,7.7379665,-6.1189782,-131.64379)"
-       x1="31.784821"
-       y1="14.882939"
-       x2="76.798752"
-       y2="26.225924" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1334"
-       id="linearGradient8565"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="matrix(6.3996815,0,0,6.4564645,52.610375,-75.576302)"
-       x1="3.5197463"
-       y1="16.549366"
-       x2="45.43124"
-       y2="31.877295" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1334"
-       id="linearGradient8567"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="matrix(6.3995804,0,0,6.4319234,52.61452,-129.20466)"
-       x1="31.784821"
-       y1="14.882939"
-       x2="76.798752"
-       y2="26.225924" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient1334"
-       id="linearGradient8569"
-       gradientUnits="userSpaceOnUse"
-       gradientTransform="matrix(7.8321048,0,0,7.7379665,-6.1189808,-131.64379)"
-       x1="1.0448723"
-       y1="22.382998"
-       x2="45.43124"
-       y2="31.877295" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient3385"
-       id="linearGradient8571"
-       gradientUnits="userSpaceOnUse"
-       x1="23.472849"
-       y1="14.625"
-       x2="20.594484"
-       y2="48.086678" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient11629"
-       id="linearGradient8615"
-       gradientUnits="userSpaceOnUse"
-       x1="615"
-       y1="-406.78125"
-       x2="618.875"
-       y2="-403.36459" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient11639"
-       id="linearGradient8617"
-       gradientUnits="userSpaceOnUse"
-       x1="611.125"
-       y1="-404.84375"
-       x2="613.92871"
-       y2="-402.37305" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient11639"
-       id="linearGradient8619"
-       gradientUnits="userSpaceOnUse"
-       x1="611.125"
-       y1="-404.84375"
-       x2="613.92871"
-       y2="-402.37305" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient11639"
-       id="linearGradient8621"
-       gradientUnits="userSpaceOnUse"
-       x1="611.125"
-       y1="-404.84375"
-       x2="613.92871"
-       y2="-402.37305" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient11629"
-       id="linearGradient8623"
-       gradientUnits="userSpaceOnUse"
-       x1="615"
-       y1="-406.78125"
-       x2="618.875"
-       y2="-403.36459" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient11639"
-       id="linearGradient8625"
-       gradientUnits="userSpaceOnUse"
-       x1="611.125"
-       y1="-404.84375"
-       x2="613.92871"
-       y2="-402.37305" />
-    <linearGradient
-       inkscape:collect="always"
-       xlink:href="#linearGradient11639"
-       id="linearGradient8627"
-       gradientUnits="userSpaceOnUse"
-       x1="611.125"
-       y1="-404.84375"
-       x2="613.92871"
-       y2="-402.37305" />
-  </defs>
-  <sodipodi:namedview
-     stroke="#ef2929"
-     fill="#f57900"
-     id="base"
-     pagecolor="#ffffff"
-     bordercolor="#666666"
-     borderopacity="0.25490196"
-     inkscape:pageopacity="0.0"
-     inkscape:pageshadow="2"
-     inkscape:zoom="1.4142136"
-     inkscape:cx="47.756524"
-     inkscape:cy="396.37829"
-     inkscape:current-layer="layer6"
-     showgrid="false"
-     inkscape:grid-bbox="true"
-     inkscape:document-units="px"
-     inkscape:showpageshadow="false"
-     inkscape:window-width="1417"
-     inkscape:window-height="1117"
-     inkscape:window-x="1855"
-     inkscape:window-y="0"
-     width="400px"
-     height="300px"
-     inkscape:snap-nodes="false"
-     inkscape:snap-bbox="true"
-     objecttolerance="7"
-     gridtolerance="12"
-     guidetolerance="13"
-     showguides="true"
-     inkscape:guide-bbox="true"
-     inkscape:snap-global="true">
-    <inkscape:grid
-       type="xygrid"
-       id="grid5883"
-       spacingx="1px"
-       spacingy="1px"
-       enabled="true"
-       visible="true" />
-    <sodipodi:guide
-       orientation="0,1"
-       position="98.641396,191.97949"
-       id="guide5228" />
-    <sodipodi:guide
-       orientation="0,1"
-       position="100.144,216.02112"
-       id="guide5230" />
-    <sodipodi:guide
-       orientation="0,1"
-       position="101.29305,240.01856"
-       id="guide5236" />
-    <sodipodi:guide
-       orientation="0,1"
-       position="97.403959,168.02625"
-       id="guide5238" />
-    <sodipodi:guide
-       orientation="0,1"
-       position="99.083338,143.98462"
-       id="guide5240" />
-    <sodipodi:guide
-       orientation="1,0"
-       position="103.99994,210.86145"
-       id="guide5242" />
-    <sodipodi:guide
-       orientation="1,0"
-       position="127.98633,199.84605"
-       id="guide5244" />
-    <sodipodi:guide
-       orientation="1,0"
-       position="152.00586,217.65631"
-       id="guide5246" />
-    <sodipodi:guide
-       orientation="1,0"
-       position="175.9812,202.76287"
-       id="guide5248" />
-    <sodipodi:guide
-       orientation="1,0"
-       position="200.02283,201.87899"
-       id="guide5250" />
-    <sodipodi:guide
-       orientation="1,0"
-       position="223.97607,201.34866"
-       id="guide5252" />
-    <sodipodi:guide
-       orientation="1,0"
-       position="248.0177,196.31052"
-       id="guide5254" />
-    <sodipodi:guide
-       orientation="1,0"
-       position="271.97095,198.96217"
-       id="guide5256" />
-    <sodipodi:guide
-       orientation="1,0"
-       position="296.01258,196.4873"
-       id="guide5258" />
-  </sodipodi:namedview>
-  <metadata
-     id="metadata4">
-    <rdf:RDF>
-      <cc:Work
-         rdf:about="">
-        <dc:format>image/svg+xml</dc:format>
-        <dc:type
-           rdf:resource="http://purl.org/dc/dcmitype/StillImage" />
-        <dc:creator>
-          <cc:Agent>
-            <dc:title>Rodney Dawes</dc:title>
-          </cc:Agent>
-        </dc:creator>
-        <dc:source />
-        <cc:license
-           rdf:resource="http://creativecommons.org/licenses/by-sa/3.0/" />
-        <dc:title>Ubuntu One Busy Animation</dc:title>
-        <dc:subject>
-          <rdf:Bag>
-            <rdf:li>ubuntuone ubuntu animation</rdf:li>
-          </rdf:Bag>
-        </dc:subject>
-        <dc:date>2009-04-20</dc:date>
-        <dc:rights>
-          <cc:Agent>
-            <dc:title />
-          </cc:Agent>
-        </dc:rights>
-        <dc:publisher>
-          <cc:Agent>
-            <dc:title />
-          </cc:Agent>
-        </dc:publisher>
-        <dc:identifier />
-        <dc:relation />
-        <dc:language />
-        <dc:coverage />
-        <dc:description />
-        <dc:contributor>
-          <cc:Agent>
-            <dc:title>Lapo Calamandrei
-Ryan Collier</dc:title>
-          </cc:Agent>
-        </dc:contributor>
-      </cc:Work>
-      <cc:License
-         rdf:about="http://creativecommons.org/licenses/by-sa/3.0/">
-        <cc:permits
-           rdf:resource="http://creativecommons.org/ns#Reproduction" />
-        <cc:permits
-           rdf:resource="http://creativecommons.org/ns#Distribution" />
-        <cc:requires
-           rdf:resource="http://creativecommons.org/ns#Notice" />
-        <cc:requires
-           rdf:resource="http://creativecommons.org/ns#Attribution" />
-        <cc:permits
-           rdf:resource="http://creativecommons.org/ns#DerivativeWorks" />
-        <cc:requires
-           rdf:resource="http://creativecommons.org/ns#ShareAlike" />
-      </cc:License>
-    </rdf:RDF>
-  </metadata>
-  <g
-     id="layer1"
-     inkscape:label="process-working-ubuntuone"
-     inkscape:groupmode="layer"
-     style="display:inline">
-    <g
-       inkscape:groupmode="layer"
-       id="layer6"
-       inkscape:label="plate"
-       style="display:none">
-      <rect
-         style="opacity:1;fill:#eeeeec;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:2;marker:none;marker-start:none;marker-mid:none;marker-end:none;visibility:visible;display:inline;overflow:visible;enable-background:accumulate"
-         id="rect8104"
-         width="192"
-         height="96"
-         x="104"
-         y="360"
-         inkscape:label="24x24" />
-      <rect
-         inkscape:label="48x48"
-         y="30"
-         x="8"
-         height="187"
-         width="384"
-         id="rect6284"
-         style="opacity:1;fill:#eeeeec;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:2;marker:none;marker-start:none;marker-mid:none;marker-end:none;visibility:visible;display:inline;overflow:visible;enable-background:accumulate" />
-      <path
-         style="opacity:1;fill:#eeeeec;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:2;marker:none;marker-start:none;marker-mid:none;marker-end:none;visibility:visible;display:inline;overflow:visible;enable-background:accumulate"
-         d="M 81.000001,225 L 81.000001,353 L 209,353 L 337,353 L 337,225 L 209,225 L 81.000001,225 z"
-         id="rect6592"
-         inkscape:label="32x32" />
-      <rect
-         style="opacity:1;fill:#eeeeec;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:2;marker:none;marker-start:none;marker-mid:none;marker-end:none;visibility:visible;display:inline;overflow:visible;enable-background:accumulate"
-         id="rect6833"
-         width="128"
-         height="64"
-         x="145"
-         y="465"
-         inkscape:label="16x16" />
-      <text
-         xml:space="preserve"
-         style="font-size:18.30070686px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;display:inline;enable-background:new;font-family:Bitstream Vera Sans"
-         x="9.3193045"
-         y="19.74086"
-         id="context"
-         inkscape:label="context"><tspan
-           sodipodi:role="line"
-           x="9.3193045"
-           y="19.74086"
-           id="tspan5232">animations</tspan></text>
-      <text
-         inkscape:label="icon-name"
-         id="text3021"
-         y="16.050335"
-         x="120.56645"
-         style="font-size:18.30070686px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;display:inline;enable-background:new;font-family:Droid Sans;-inkscape-font-specification:Droid Sans Bold"
-         xml:space="preserve"
-         sodipodi:linespacing="125%"><tspan
-           y="16.050335"
-           x="120.56645"
-           id="tspan3023"
-           sodipodi:role="line">ubuntuone-client-working</tspan></text>
-    </g>
-    <g
-       style="display:inline;enable-background:new"
-       id="g3780"
-       transform="translate(-558.98434,820.00062)"
-       inkscape:export-filename="/home/rcollier/Desktop/weather-few-clouds.png"
-       inkscape:export-xdpi="89.999954"
-       inkscape:export-ydpi="89.999954">
-      <path
-         transform="matrix(1.149931,0,0,1.131587,-38.47337,25.73056)"
-         d="M 619.9375,-417.5 A 2.46875,2.46875 0 1 1 615,-417.5 A 2.46875,2.46875 0 1 1 619.9375,-417.5 z"
-         sodipodi:ry="2.46875"
-         sodipodi:rx="2.46875"
-         sodipodi:cy="-417.5"
-         sodipodi:cx="617.46875"
-         id="path3782"
-         style="opacity:1;fill:#c4c5c2;fill-opacity:1;stroke:#888a85;stroke-width:0.87663645;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1"
-         sodipodi:type="arc" />
-      <path
-         transform="matrix(0.811692,0,0,0.809856,166.3021,-107.3858)"
-         d="M 619.9375,-417.5 A 2.46875,2.46875 0 1 1 615,-417.5 A 2.46875,2.46875 0 1 1 619.9375,-417.5 z"
-         sodipodi:ry="2.46875"
-         sodipodi:rx="2.46875"
-         sodipodi:cy="-417.5"
-         sodipodi:cx="617.46875"
-         id="path3784"
-         style="opacity:1;fill:#c4c5c2;fill-opacity:1;stroke:#888a85;stroke-width:1.23338699;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1"
-         sodipodi:type="arc" />
-      <path
-         transform="matrix(0.806943,0,0,0.809856,177.238,-107.3858)"
-         d="M 619.9375,-417.5 A 2.46875,2.46875 0 1 1 615,-417.5 A 2.46875,2.46875 0 1 1 619.9375,-417.5 z"
-         sodipodi:ry="2.46875"
-         sodipodi:rx="2.46875"
-         sodipodi:cy="-417.5"
-         sodipodi:cx="617.46875"
-         id="path3786"
-         style="opacity:1;fill:#c4c5c2;fill-opacity:1;stroke:#888a85;stroke-width:1.23701191;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1"
-         sodipodi:type="arc" />
-      <path
-         transform="matrix(0.823174,0,0,0.810621,168.1833,-105.0598)"
-         d="M 619.9375,-417.5 A 2.46875,2.46875 0 1 1 615,-417.5 A 2.46875,2.46875 0 1 1 619.9375,-417.5 z"
-         sodipodi:ry="2.46875"
-         sodipodi:rx="2.46875"
-         sodipodi:cy="-417.5"
-         sodipodi:cx="617.46875"
-         id="path3788"
-         style="opacity:1;fill:#c4c5c2;fill-opacity:1;stroke:#888a85;stroke-width:1.22417819;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1"
-         sodipodi:type="arc" />
-      <path
-         transform="matrix(0.847801,0,0,0.81977,143.1175,-101.2625)"
-         d="M 619.9375,-417.5 A 2.46875,2.46875 0 1 1 615,-417.5 A 2.46875,2.46875 0 1 1 619.9375,-417.5 z"
-         sodipodi:ry="2.46875"
-         sodipodi:rx="2.46875"
-         sodipodi:cy="-417.5"
-         sodipodi:cx="617.46875"
-         id="path3790"
-         style="opacity:1;fill:#c4c5c2;fill-opacity:1;stroke:#888a85;stroke-width:1.1995163;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1"
-         sodipodi:type="arc" />
-      <rect
-         y="-446.33786"
-         x="667.06281"
-         height="4.8453441"
-         width="8.9945145"
-         id="rect3792"
-         style="opacity:1;fill:#c4c5c2;fill-opacity:1;stroke:#888a85;stroke-width:0.99999923;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1" />
-      <rect
-         y="-446"
-         x="666.46967"
-         height="3.9999948"
-         width="9.9519758"
-         id="rect3794"
-         style="opacity:1;fill:#c4c5c2;fill-opacity:1;stroke:none;stroke-width:0.99999946;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1" />
-      <path
-         transform="matrix(1.292523,0,0,1.790887,-127.0007,271.832)"
-         d="M 619.71875,-401.15625 A 1.890625,1.34375 0 1 1 615.9375,-401.15625 A 1.890625,1.34375 0 1 1 619.71875,-401.15625 z"
-         sodipodi:ry="1.34375"
-         sodipodi:rx="1.890625"
-         sodipodi:cy="-401.15625"
-         sodipodi:cx="617.82812"
-         id="path3796"
-         style="opacity:1;fill:#c4c5c2;fill-opacity:1;stroke:none;stroke-width:0.99999946;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1"
-         sodipodi:type="arc" />
-      <path
-         transform="matrix(0.793381,0,0,1.116281,177.3269,2.303102)"
-         d="M 619.71875,-401.15625 A 1.890625,1.34375 0 1 1 615.9375,-401.15625 A 1.890625,1.34375 0 1 1 619.71875,-401.15625 z"
-         sodipodi:ry="1.34375"
-         sodipodi:rx="1.890625"
-         sodipodi:cy="-401.15625"
-         sodipodi:cx="617.82812"
-         id="path3798"
-         style="opacity:1;fill:#c4c5c2;fill-opacity:1;stroke:none;stroke-width:0.99999946;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1"
-         sodipodi:type="arc" />
-      <path
-         transform="matrix(0.788213,0,0,1.116278,188.5099,2.301954)"
-         d="M 619.71875,-401.15625 A 1.890625,1.34375 0 1 1 615.9375,-401.15625 A 1.890625,1.34375 0 1 1 619.71875,-401.15625 z"
-         sodipodi:ry="1.34375"
-         sodipodi:rx="1.890625"
-         sodipodi:cy="-401.15625"
-         sodipodi:cx="617.82812"
-         id="path3800"
-         style="opacity:1;fill:#c4c5c2;fill-opacity:1;stroke:none;stroke-width:0.99999946;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1"
-         sodipodi:type="arc" />
-      <path
-         transform="matrix(0.793399,0,0,1.116277,186.3161,4.301582)"
-         d="M 619.71875,-401.15625 A 1.890625,1.34375 0 1 1 615.9375,-401.15625 A 1.890625,1.34375 0 1 1 619.71875,-401.15625 z"
-         sodipodi:ry="1.34375"
-         sodipodi:rx="1.890625"
-         sodipodi:cy="-401.15625"
-         sodipodi:cx="617.82812"
-         id="path3802"
-         style="opacity:1;fill:#c4c5c2;fill-opacity:1;stroke:none;stroke-width:0.99999946;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1"
-         sodipodi:type="arc" />
-      <path
-         transform="matrix(0.777806,0,0,1.116225,185.9792,4.280759)"
-         d="M 619.71875,-401.15625 A 1.890625,1.34375 0 1 1 615.9375,-401.15625 A 1.890625,1.34375 0 1 1 619.71875,-401.15625 z"
-         sodipodi:ry="1.34375"
-         sodipodi:rx="1.890625"
-         sodipodi:cy="-401.15625"
-         sodipodi:cx="617.82812"
-         id="path3804"
-         style="opacity:1;fill:#c4c5c2;fill-opacity:1;stroke:none;stroke-width:0.99999946;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1"
-         sodipodi:type="arc" />
-      <path
-         transform="matrix(0.840877,0,0,0.953678,151.9334,-61.06155)"
-         d="M 620.8125,-404.21875 A 2.90625,2.5625 0 1 1 615,-404.21875 A 2.90625,2.5625 0 1 1 620.8125,-404.21875 z"
-         sodipodi:ry="2.5625"
-         sodipodi:rx="2.90625"
-         sodipodi:cy="-404.21875"
-         sodipodi:cx="617.90625"
-         id="path3806"
-         style="opacity:1;fill:url(#linearGradient3822);fill-opacity:1;stroke:none;stroke-width:0.99999946;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1"
-         sodipodi:type="arc" />
-      <path
-         transform="matrix(0.827591,0,0,0.872728,160.2384,-93.68171)"
-         d="M 614.75,-403.125 A 1.8125,1.71875 0 1 1 611.125,-403.125 A 1.8125,1.71875 0 1 1 614.75,-403.125 z"
-         sodipodi:ry="1.71875"
-         sodipodi:rx="1.8125"
-         sodipodi:cy="-403.125"
-         sodipodi:cx="612.9375"
-         id="path3808"
-         style="opacity:1;fill:url(#linearGradient3824);fill-opacity:1;stroke:none;stroke-width:0.99999946;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1"
-         sodipodi:type="arc" />
-      <path
-         transform="matrix(0.827591,0,0,0.872728,168.2384,-93.68171)"
-         d="M 614.75,-403.125 A 1.8125,1.71875 0 1 1 611.125,-403.125 A 1.8125,1.71875 0 1 1 614.75,-403.125 z"
-         sodipodi:ry="1.71875"
-         sodipodi:rx="1.8125"
-         sodipodi:cy="-403.125"
-         sodipodi:cx="612.9375"
-         id="path3810"
-         style="opacity:1;fill:url(#linearGradient3826);fill-opacity:1;stroke:none;stroke-width:0.99999946;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1"
-         sodipodi:type="arc" />
-      <path
-         transform="matrix(0.827593,0,0,0.872739,159.2369,-91.67695)"
-         d="M 614.75,-403.125 A 1.8125,1.71875 0 1 1 611.125,-403.125 A 1.8125,1.71875 0 1 1 614.75,-403.125 z"
-         sodipodi:ry="1.71875"
-         sodipodi:rx="1.8125"
-         sodipodi:cy="-403.125"
-         sodipodi:cx="612.9375"
-         id="path3812"
-         style="opacity:1;fill:url(#linearGradient3828);fill-opacity:1;stroke:none;stroke-width:0.99999946;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1"
-         sodipodi:type="arc" />
-      <path
-         transform="matrix(0.860215,0,0,0.97561,139.2657,-50.1402)"
-         d="M 620.8125,-404.21875 A 2.90625,2.5625 0 1 1 615,-404.21875 A 2.90625,2.5625 0 1 1 620.8125,-404.21875 z"
-         sodipodi:ry="2.5625"
-         sodipodi:rx="2.90625"
-         sodipodi:cy="-404.21875"
-         sodipodi:cx="617.90625"
-         id="path3814"
-         style="opacity:1;fill:#c4c5c2;fill-opacity:1;stroke:none;stroke-width:0.99999946;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1"
-         sodipodi:type="arc" />
-      <path
-         transform="matrix(0.860215,0,0,0.97561,139.2657,-50.1402)"
-         d="M 620.8125,-404.21875 A 2.90625,2.5625 0 1 1 615,-404.21875 A 2.90625,2.5625 0 1 1 620.8125,-404.21875 z"
-         sodipodi:ry="2.5625"
-         sodipodi:rx="2.90625"
-         sodipodi:cy="-404.21875"
-         sodipodi:cx="617.90625"
-         id="path3816"
-         style="opacity:1;fill:url(#linearGradient3830);fill-opacity:1;stroke:none;stroke-width:0.99999946;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1"
-         sodipodi:type="arc" />
-      <path
-         transform="matrix(0.827591,0,0,0.872728,161.2384,-92.68171)"
-         d="M 614.75,-403.125 A 1.8125,1.71875 0 1 1 611.125,-403.125 A 1.8125,1.71875 0 1 1 614.75,-403.125 z"
-         sodipodi:ry="1.71875"
-         sodipodi:rx="1.8125"
-         sodipodi:cy="-403.125"
-         sodipodi:cx="612.9375"
-         id="path3818"
-         style="opacity:1;fill:url(#linearGradient3832);fill-opacity:1;stroke:none;stroke-width:0.99999946;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1"
-         sodipodi:type="arc" />
-      <path
-         transform="matrix(0.827591,0,0,0.872728,166.2384,-92.68171)"
-         d="M 614.75,-403.125 A 1.8125,1.71875 0 1 1 611.125,-403.125 A 1.8125,1.71875 0 1 1 614.75,-403.125 z"
-         sodipodi:ry="1.71875"
-         sodipodi:rx="1.8125"
-         sodipodi:cy="-403.125"
-         sodipodi:cx="612.9375"
-         id="path3820"
-         style="opacity:1;fill:url(#linearGradient3834);fill-opacity:1;stroke:none;stroke-width:0.99999946;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1"
-         sodipodi:type="arc" />
-    </g>
-    <g
-       transform="matrix(5.5343769e-2,0,0,5.513163e-2,106.07692,369.40829)"
-       style="display:inline;enable-background:new"
-       id="g4703">
-      <path
-         transform="matrix(0.794862,0,0,0.8010002,2.0532901,9.4770633)"
-         d="M 75.318237,46.856956 A 33.967049,33.967049 0 1 1 7.38414,46.856956 A 33.967049,33.967049 0 1 1 75.318237,46.856956 z"
-         sodipodi:ry="33.967049"
-         sodipodi:rx="33.967049"
-         sodipodi:cy="46.856956"
-         sodipodi:cx="41.351189"
-         id="path4707"
-         style="fill:#ff6309;fill-opacity:1;stroke:#cc4a00;stroke-width:22.6883564;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1;display:inline"
-         sodipodi:type="arc" />
-      <path
-         id="path4709"
-         d="M 194.5787,-95.855694 C 178.98355,-94.71655 164.11923,-90.860888 150.27835,-85.215991 L 178.18023,-37.82095 C 185.3395,-40.064518 192.85854,-41.296928 200.69753,-41.689932 C 202.23197,-41.766863 203.79415,-41.689932 205.34783,-41.689932 C 248.33291,-41.689932 284.26278,-11.86477 293.21426,27.951761 L 349.018,27.951761 C 345.05428,-0.99248716 332.30845,-27.195136 313.52878,-47.977029 C 305.81602,-43.883584 296.94762,-41.689932 287.58493,-41.689932 C 258.18864,-41.689932 234.11203,-64.481127 232.7602,-93.195768 C 223.91309,-94.865805 214.68159,-95.855694 205.34783,-95.855694 C 203.47328,-95.855691 201.57588,-95.925517 199.71851,-95.855694 C 199.11389,-95.832964 198.60794,-95.885746 198.00524,-95.855694 C 197.43738,-95.827378 196.85833,-95.890508 196.29197,-95.855694 C 195.7433,-95.821967 195.12589,-95.895664 194.5787,-95.855694 z"
-         style="fill:#ff6309;fill-opacity:1;stroke:#cc4a00;stroke-width:13.55168533;stroke-linejoin:round;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1;display:inline" />
-      <path
-         id="path4711"
-         d="M 116.50241,-65.871076 C 94.010347,-48.569216 76.932373,-24.738424 67.796505,2.5615606 C 82.227424,12.321519 91.782325,28.726294 91.782325,47.296676 C 91.782325,65.867052 82.227424,82.271842 67.796505,92.031792 C 76.929334,119.33842 94.002499,143.17968 116.50241,160.46443 L 144.40428,112.82757 C 126.51917,96.564337 115.27864,73.180946 115.27864,47.296676 C 115.27864,21.421746 126.5409,-1.9305066 144.40428,-18.234223 L 116.50241,-65.871076 z"
-         style="fill:#ffb515;fill-opacity:1;stroke:#d89400;stroke-width:13.55168533;stroke-linejoin:round;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1;display:inline" />
-      <path
-         transform="matrix(0.7979299,0,0,0.8010002,254.99497,154.58432)"
-         d="M 75.318237,46.856956 A 33.967049,33.967049 0 1 1 7.38414,46.856956 A 33.967049,33.967049 0 1 1 75.318237,46.856956 z"
-         sodipodi:ry="33.967049"
-         sodipodi:rx="33.967049"
-         sodipodi:cy="46.856956"
-         sodipodi:cx="41.351189"
-         id="path4713"
-         style="fill:#ffb515;fill-opacity:1;stroke:#d89400;stroke-width:22.64469719;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1;display:inline"
-         sodipodi:type="arc" />
-      <path
-         transform="matrix(0.7979299,0,0,0.8010002,254.99497,-135.63021)"
-         d="M 75.318237,46.856956 A 33.967049,33.967049 0 1 1 7.38414,46.856956 A 33.967049,33.967049 0 1 1 75.318237,46.856956 z"
-         sodipodi:ry="33.967049"
-         sodipodi:rx="33.967049"
-         sodipodi:cy="46.856956"
-         sodipodi:cx="41.351189"
-         id="path4715"
-         style="fill:#c90016;fill-opacity:1;stroke:#8c000f;stroke-width:22.64469719;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1;display:inline"
-         sodipodi:type="arc" />
-      <path
-         id="path4717"
-         d="M 293.21426,66.641591 C 284.2628,106.45812 248.33291,136.28329 205.34783,136.28329 C 195.83146,136.28331 186.77007,134.8631 178.18023,132.17249 L 150.27835,179.56754 C 167.27521,186.50006 185.82164,190.44904 205.34783,190.44904 C 214.68159,190.44906 223.91309,189.45916 232.7602,187.78913 C 234.12302,160.2796 256.42758,138.02166 284.15838,136.28329 C 285.32203,136.21036 286.40279,136.2833 287.58493,136.28329 C 296.94763,136.2833 305.81601,138.47693 313.52878,142.57038 C 332.30847,121.78849 345.05428,95.585848 349.018,66.641591 L 293.21426,66.641591 z"
-         style="fill:#c90016;fill-opacity:1;stroke:#8c000f;stroke-width:13.55168533;stroke-linejoin:round;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1;display:inline" />
-      <path
-         d="M 115.125,-57.40625 C 96.824285,-41.952934 82.604158,-21.909592 74.28125,0.90625 C 88.135322,11.805926 97.21875,28.427623 97.21875,47.28125 C 97.218753,66.134878 88.136362,82.78572 74.28125,93.6875 C 82.600371,116.50955 96.822563,136.55882 115.125,152 L 137.59375,113.5 C 120.52044,96.45137 109.84375,73.125212 109.84375,47.28125 C 109.84375,21.420353 120.51995,-1.8621454 137.59375,-18.9375 L 115.125,-57.40625 z"
-         id="path4719"
-         style="opacity:0.51764706;fill:url(#linearGradient4739);fill-opacity:1;stroke:none;stroke-width:11.2583437;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1;display:inline"
-         inkscape:original="M 115.53125 -59.8125 C 96.072816 -43.814965 81.012958 -22.733382 72.4375 1.34375 C 86.468934 11.950413 95.6875 28.505539 95.6875 47.28125 C 95.687503 66.056962 86.468934 82.643345 72.4375 93.25 C 81.008853 117.33377 96.070379 138.42195 115.53125 154.40625 L 139.5 113.3125 C 122.19189 96.466321 111.375 73.136728 111.375 47.28125 C 111.375 21.424155 122.2068 -1.8427399 139.5 -18.71875 L 115.53125 -59.8125 z "
-         inkscape:radius="-1.5447201"
-         sodipodi:type="inkscape:offset" />
-      <path
-         sodipodi:nodetypes="csssssc"
-         id="path4721"
-         d="M 32.928704,28.879806 C 23.917571,29.899971 16.957103,37.666359 16.957103,47.013854 C 16.957103,57.052234 25.023679,65.147896 35.025985,65.147901 C 45.028291,65.147901 53.094864,57.052234 53.094866,47.013854 C 53.094865,36.975473 45.028288,28.879806 35.025985,28.879806 C 34.363091,28.879806 33.830707,28.860185 33.574021,28.879806 C 33.3555,28.896511 33.144971,28.85532 32.928704,28.879806 z"
-         style="opacity:0.51764706;fill:url(#linearGradient4741);fill-opacity:1;stroke:none;stroke-width:11.2583437;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1;display:inline" />
-      <path
-         d="M 297.4375,72.625 C 286.10123,112.59987 249.32877,142.28124 205.34375,142.28125 C 196.93154,142.28128 189.01624,140.6959 181.40625,138.6875 L 159.28125,176.21875 C 173.76898,181.34835 189.13396,184.46876 205.34375,184.46875 C 212.9174,184.46877 220.43871,183.49226 227.84375,182.25 C 231.78748,154.23363 254.84072,132.12671 283.78125,130.3125 C 285.42038,130.20978 286.70285,130.28126 287.59375,130.28125 C 296.06525,130.28125 303.92769,132.56952 311.15625,135.65625 C 326.36903,117.91745 336.76765,96.390451 341.28125,72.625 L 297.4375,72.625 z"
-         id="path4723"
-         style="opacity:0.33333333;fill:url(#linearGradient4743);fill-opacity:1;stroke:none;stroke-width:11.2583437;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1;display:inline"
-         inkscape:original="M 295.90625 70.5 C 285.3558 110.38026 248.95868 140.15624 205.34375 140.15625 C 196.62689 140.15628 188.36856 138.46883 180.375 136.28125 L 156.15625 177.40625 C 171.52247 183.11935 187.97448 186.59376 205.34375 186.59375 C 213.56677 186.59377 221.69466 185.52295 229.59375 184.15625 C 232.70872 156.34201 255.40024 134.19322 283.90625 132.40625 C 285.38742 132.31343 286.57464 132.40626 287.59375 132.40625 C 296.25577 132.40625 304.34178 134.87329 311.8125 138.21875 C 328.35022 119.36386 339.48001 96.134475 343.875 70.5 L 295.90625 70.5 z "
-         inkscape:radius="-2.1109395"
-         sodipodi:type="inkscape:offset" />
-      <path
-         sodipodi:nodetypes="csssssc"
-         id="path4725"
-         d="M 285.89305,173.98707 C 276.88191,175.00722 269.92144,182.77361 269.92144,192.12111 C 269.92144,202.15949 277.98804,210.25517 287.99033,210.25517 C 297.99265,210.25517 306.0592,202.15948 306.05921,192.12111 C 306.0592,182.08272 297.99263,173.98707 287.99033,173.98707 C 287.32747,173.98706 286.79504,173.96746 286.53837,173.98707 C 286.31984,174.00377 286.10932,173.96258 285.89305,173.98707 z"
-         style="opacity:0.51764706;fill:url(#linearGradient4745);fill-opacity:1;stroke:none;stroke-width:11.2583437;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1;display:inline" />
-      <path
-         sodipodi:nodetypes="cssssssc"
-         id="path4727"
-         d="M 285.89305,-116.22819 C 276.88376,-115.20838 269.92144,-107.44147 269.92144,-98.093776 C 269.92144,-88.055199 277.98804,-79.959359 287.99032,-79.959363 C 297.99264,-79.959363 306.05921,-88.055198 306.05921,-98.093776 C 306.05921,-108.13236 297.99265,-116.22819 287.99032,-116.22819 C 287.49316,-116.22819 286.98878,-116.23095 286.69969,-116.22819 C 286.65927,-116.22686 286.57045,-116.23065 286.53836,-116.22819 C 286.31984,-116.21149 286.10926,-116.25267 285.89305,-116.22819 z"
-         style="opacity:0.33333333;fill:url(#linearGradient6759);fill-opacity:1;stroke:none;stroke-width:11.2583437;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1;display:inline" />
-      <path
-         transform="translate(0,4.2095e-6)"
-         d="M 192.25,-90.59375 C 180.35805,-89.470579 168.94281,-86.53359 158,-82.53125 L 180.84375,-43.78125 C 187.16057,-45.438495 193.60757,-46.629472 200.375,-46.96875 C 202.26644,-47.063581 203.98044,-46.96875 205.34375,-46.96875 C 249.30195,-46.968749 286.23265,-17.398823 297.21875,22.6875 L 342.65625,22.6875 C 338.23224,-1.4976757 327.56176,-23.419524 312.125,-41.46875 C 304.60257,-38.191927 296.24249,-36.40625 287.59375,-36.40625 C 256.93766,-36.406251 231.46588,-59.164061 227.84375,-88.5625 C 220.4584,-89.778528 212.96877,-90.593751 205.34375,-90.59375 C 203.34114,-90.59375 201.61599,-90.653325 200.03125,-90.59375 C 199.19545,-90.562331 198.52121,-90.591789 198.3125,-90.59375 C 198.30491,-90.593821 198.25626,-90.593753 198.25,-90.59375 C 197.74735,-90.570829 197.3334,-90.555221 197.03125,-90.5625 C 196.87243,-90.566326 196.74372,-90.590232 196.65625,-90.59375 C 196.56878,-90.597268 196.44969,-90.582974 196.625,-90.59375 C 195.86561,-90.547073 195.2668,-90.580609 195,-90.59375 C 194.98958,-90.593634 194.97917,-90.593634 194.96875,-90.59375 C 195.05138,-90.5878 194.97868,-90.594291 194.9375,-90.59375 C 194.92721,-90.593615 194.91574,-90.593929 194.90625,-90.59375 C 194.80206,-90.586141 194.78516,-90.597451 194.6875,-90.59375 C 194.17128,-90.574186 193.67396,-90.588592 193.53125,-90.59375 C 193.51042,-90.593287 193.48958,-90.593287 193.46875,-90.59375 C 193.402,-90.588135 193.40521,-90.596954 193.34375,-90.59375 C 192.80598,-90.565712 192.38888,-90.606867 192.25,-90.59375 z"
-         id="path4729"
-         style="opacity:0.51764706;fill:url(#linearGradient4749);fill-opacity:1;stroke:none;stroke-width:11.2583437;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1;display:inline"
-         inkscape:original="M 192.125 -92 C 179.50786 -90.808337 167.41923 -87.619329 155.90625 -83.28125 L 180.125 -42.1875 C 186.71206 -43.980703 193.40212 -45.209788 200.4375 -45.5625 C 202.23829 -45.652786 203.92091 -45.5625 205.34375 -45.5625 C 249.05692 -45.562499 285.70024 -15.923253 296.15625 24.09375 L 344.375 24.09375 C 340.04446 -1.3424713 328.86447 -24.365906 312.5625 -43.15625 C 304.97389 -39.676 296.43348 -37.8125 287.59375 -37.8125 C 257.25941 -37.812501 232.13026 -60.600561 229.09375 -89.8125 C 221.33425 -91.131903 213.41104 -92.000001 205.34375 -92 C 203.37076 -92 201.62575 -92.062291 199.96875 -92 C 199.16572 -91.969813 198.53057 -92.000118 198.25 -92 C 197.25566 -91.95042 196.63968 -92.006665 196.53125 -92 C 195.8542 -91.958384 195.33819 -91.986421 195.0625 -92 C 194.98918 -92.005279 194.80704 -91.999602 194.8125 -92 C 194.26592 -91.960081 193.82636 -91.991593 193.59375 -92 C 193.55497 -92.003153 193.36328 -91.996586 193.34375 -92 C 192.93571 -91.965676 192.532 -92.03844 192.125 -92 z "
-         inkscape:radius="-1.407293"
-         sodipodi:type="inkscape:offset" />
-    </g>
-    <g
-       style="display:inline;enable-background:new"
-       id="g20424"
-       transform="translate(-551.99973,823.99252)"
-       inkscape:export-filename="/home/rcollier/Desktop/weather-few-clouds.png"
-       inkscape:export-xdpi="89.999954"
-       inkscape:export-ydpi="89.999954">
-      <path
-         transform="matrix(1.149931,0,0,1.131587,-38.47337,25.73056)"
-         d="M 619.9375,-417.5 A 2.46875,2.46875 0 1 1 615,-417.5 A 2.46875,2.46875 0 1 1 619.9375,-417.5 z"
-         sodipodi:ry="2.46875"
-         sodipodi:rx="2.46875"
-         sodipodi:cy="-417.5"
-         sodipodi:cx="617.46875"
-         id="path20426"
-         style="opacity:1;fill:#c4c5c2;fill-opacity:1;stroke:#888a85;stroke-width:0.87663645;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1"
-         sodipodi:type="arc" />
-      <path
-         transform="matrix(0.811692,0,0,0.809856,166.3021,-107.3858)"
-         d="M 619.9375,-417.5 A 2.46875,2.46875 0 1 1 615,-417.5 A 2.46875,2.46875 0 1 1 619.9375,-417.5 z"
-         sodipodi:ry="2.46875"
-         sodipodi:rx="2.46875"
-         sodipodi:cy="-417.5"
-         sodipodi:cx="617.46875"
-         id="path20428"
-         style="opacity:1;fill:#c4c5c2;fill-opacity:1;stroke:#888a85;stroke-width:1.23338699;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1"
-         sodipodi:type="arc" />
-      <path
-         transform="matrix(0.806943,0,0,0.809856,177.238,-107.3858)"
-         d="M 619.9375,-417.5 A 2.46875,2.46875 0 1 1 615,-417.5 A 2.46875,2.46875 0 1 1 619.9375,-417.5 z"
-         sodipodi:ry="2.46875"
-         sodipodi:rx="2.46875"
-         sodipodi:cy="-417.5"
-         sodipodi:cx="617.46875"
-         id="path20430"
-         style="opacity:1;fill:#c4c5c2;fill-opacity:1;stroke:#888a85;stroke-width:1.23701191;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1"
-         sodipodi:type="arc" />
-      <path
-         transform="matrix(0.823174,0,0,0.810621,168.1833,-105.0598)"
-         d="M 619.9375,-417.5 A 2.46875,2.46875 0 1 1 615,-417.5 A 2.46875,2.46875 0 1 1 619.9375,-417.5 z"
-         sodipodi:ry="2.46875"
-         sodipodi:rx="2.46875"
-         sodipodi:cy="-417.5"
-         sodipodi:cx="617.46875"
-         id="path20432"
-         style="opacity:1;fill:#c4c5c2;fill-opacity:1;stroke:#888a85;stroke-width:1.22417819;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1"
-         sodipodi:type="arc" />
-      <path
-         transform="matrix(0.847801,0,0,0.81977,143.1175,-101.2625)"
-         d="M 619.9375,-417.5 A 2.46875,2.46875 0 1 1 615,-417.5 A 2.46875,2.46875 0 1 1 619.9375,-417.5 z"
-         sodipodi:ry="2.46875"
-         sodipodi:rx="2.46875"
-         sodipodi:cy="-417.5"
-         sodipodi:cx="617.46875"
-         id="path20434"
-         style="opacity:1;fill:#c4c5c2;fill-opacity:1;stroke:#888a85;stroke-width:1.1995163;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1"
-         sodipodi:type="arc" />
-      <rect
-         y="-446.33786"
-         x="667.06281"
-         height="4.8453441"
-         width="8.9945145"
-         id="rect20436"
-         style="opacity:1;fill:#c4c5c2;fill-opacity:1;stroke:#888a85;stroke-width:0.99999923;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1" />
-      <rect
-         y="-446"
-         x="666.46967"
-         height="3.9999948"
-         width="9.9519758"
-         id="rect20438"
-         style="opacity:1;fill:#c4c5c2;fill-opacity:1;stroke:none;stroke-width:0.99999946;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1" />
-      <path
-         transform="matrix(1.292523,0,0,1.790887,-127.0007,271.832)"
-         d="M 619.71875,-401.15625 A 1.890625,1.34375 0 1 1 615.9375,-401.15625 A 1.890625,1.34375 0 1 1 619.71875,-401.15625 z"
-         sodipodi:ry="1.34375"
-         sodipodi:rx="1.890625"
-         sodipodi:cy="-401.15625"
-         sodipodi:cx="617.82812"
-         id="path20440"
-         style="opacity:1;fill:#c4c5c2;fill-opacity:1;stroke:none;stroke-width:0.99999946;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1"
-         sodipodi:type="arc" />
-      <path
-         transform="matrix(0.793381,0,0,1.116281,177.3269,2.303102)"
-         d="M 619.71875,-401.15625 A 1.890625,1.34375 0 1 1 615.9375,-401.15625 A 1.890625,1.34375 0 1 1 619.71875,-401.15625 z"
-         sodipodi:ry="1.34375"
-         sodipodi:rx="1.890625"
-         sodipodi:cy="-401.15625"
-         sodipodi:cx="617.82812"
-         id="path20442"
-         style="opacity:1;fill:#c4c5c2;fill-opacity:1;stroke:none;stroke-width:0.99999946;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1"
-         sodipodi:type="arc" />
-      <path
-         transform="matrix(0.788213,0,0,1.116278,188.5099,2.301954)"
-         d="M 619.71875,-401.15625 A 1.890625,1.34375 0 1 1 615.9375,-401.15625 A 1.890625,1.34375 0 1 1 619.71875,-401.15625 z"
-         sodipodi:ry="1.34375"
-         sodipodi:rx="1.890625"
-         sodipodi:cy="-401.15625"
-         sodipodi:cx="617.82812"
-         id="path20444"
-         style="opacity:1;fill:#c4c5c2;fill-opacity:1;stroke:none;stroke-width:0.99999946;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1"
-         sodipodi:type="arc" />
-      <path
-         transform="matrix(0.793399,0,0,1.116277,186.3161,4.301582)"
-         d="M 619.71875,-401.15625 A 1.890625,1.34375 0 1 1 615.9375,-401.15625 A 1.890625,1.34375 0 1 1 619.71875,-401.15625 z"
-         sodipodi:ry="1.34375"
-         sodipodi:rx="1.890625"
-         sodipodi:cy="-401.15625"
-         sodipodi:cx="617.82812"
-         id="path20446"
-         style="opacity:1;fill:#c4c5c2;fill-opacity:1;stroke:none;stroke-width:0.99999946;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1"
-         sodipodi:type="arc" />
-      <path
-         transform="matrix(0.777806,0,0,1.116225,185.9792,4.280759)"
-         d="M 619.71875,-401.15625 A 1.890625,1.34375 0 1 1 615.9375,-401.15625 A 1.890625,1.34375 0 1 1 619.71875,-401.15625 z"
-         sodipodi:ry="1.34375"
-         sodipodi:rx="1.890625"
-         sodipodi:cy="-401.15625"
-         sodipodi:cx="617.82812"
-         id="path20448"
-         style="opacity:1;fill:#c4c5c2;fill-opacity:1;stroke:none;stroke-width:0.99999946;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1"
-         sodipodi:type="arc" />
-      <path
-         transform="matrix(0.840877,0,0,0.953678,151.9334,-61.06155)"
-         d="M 620.8125,-404.21875 A 2.90625,2.5625 0 1 1 615,-404.21875 A 2.90625,2.5625 0 1 1 620.8125,-404.21875 z"
-         sodipodi:ry="2.5625"
-         sodipodi:rx="2.90625"
-         sodipodi:cy="-404.21875"
-         sodipodi:cx="617.90625"
-         id="path20450"
-         style="opacity:1;fill:url(#linearGradient20470);fill-opacity:1;stroke:none;stroke-width:0.99999946;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1"
-         sodipodi:type="arc" />
-      <path
-         transform="matrix(0.827591,0,0,0.872728,160.2384,-93.68171)"
-         d="M 614.75,-403.125 A 1.8125,1.71875 0 1 1 611.125,-403.125 A 1.8125,1.71875 0 1 1 614.75,-403.125 z"
-         sodipodi:ry="1.71875"
-         sodipodi:rx="1.8125"
-         sodipodi:cy="-403.125"
-         sodipodi:cx="612.9375"
-         id="path20452"
-         style="opacity:1;fill:url(#linearGradient20472);fill-opacity:1;stroke:none;stroke-width:0.99999946;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1"
-         sodipodi:type="arc" />
-      <path
-         transform="matrix(0.827591,0,0,0.872728,168.2384,-93.68171)"
-         d="M 614.75,-403.125 A 1.8125,1.71875 0 1 1 611.125,-403.125 A 1.8125,1.71875 0 1 1 614.75,-403.125 z"
-         sodipodi:ry="1.71875"
-         sodipodi:rx="1.8125"
-         sodipodi:cy="-403.125"
-         sodipodi:cx="612.9375"
-         id="path20454"
-         style="opacity:1;fill:url(#linearGradient20474);fill-opacity:1;stroke:none;stroke-width:0.99999946;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1"
-         sodipodi:type="arc" />
-      <path
-         transform="matrix(0.827593,0,0,0.872739,159.2369,-91.67695)"
-         d="M 614.75,-403.125 A 1.8125,1.71875 0 1 1 611.125,-403.125 A 1.8125,1.71875 0 1 1 614.75,-403.125 z"
-         sodipodi:ry="1.71875"
-         sodipodi:rx="1.8125"
-         sodipodi:cy="-403.125"
-         sodipodi:cx="612.9375"
-         id="path20456"
-         style="opacity:1;fill:url(#linearGradient20476);fill-opacity:1;stroke:none;stroke-width:0.99999946;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1"
-         sodipodi:type="arc" />
-      <path
-         transform="matrix(0.860215,0,0,0.97561,139.2657,-50.1402)"
-         d="M 620.8125,-404.21875 A 2.90625,2.5625 0 1 1 615,-404.21875 A 2.90625,2.5625 0 1 1 620.8125,-404.21875 z"
-         sodipodi:ry="2.5625"
-         sodipodi:rx="2.90625"
-         sodipodi:cy="-404.21875"
-         sodipodi:cx="617.90625"
-         id="path20458"
-         style="opacity:1;fill:#c4c5c2;fill-opacity:1;stroke:none;stroke-width:0.99999946;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1"
-         sodipodi:type="arc" />
-      <path
-         transform="matrix(0.860215,0,0,0.97561,139.2657,-50.1402)"
-         d="M 620.8125,-404.21875 A 2.90625,2.5625 0 1 1 615,-404.21875 A 2.90625,2.5625 0 1 1 620.8125,-404.21875 z"
-         sodipodi:ry="2.5625"
-         sodipodi:rx="2.90625"
-         sodipodi:cy="-404.21875"
-         sodipodi:cx="617.90625"
-         id="path20460"
-         style="opacity:1;fill:url(#linearGradient20478);fill-opacity:1;stroke:none;stroke-width:0.99999946;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1"
-         sodipodi:type="arc" />
-      <path
-         transform="matrix(0.827591,0,0,0.872728,161.2384,-92.68171)"
-         d="M 614.75,-403.125 A 1.8125,1.71875 0 1 1 611.125,-403.125 A 1.8125,1.71875 0 1 1 614.75,-403.125 z"
-         sodipodi:ry="1.71875"
-         sodipodi:rx="1.8125"
-         sodipodi:cy="-403.125"
-         sodipodi:cx="612.9375"
-         id="path20462"
-         style="opacity:1;fill:url(#linearGradient20480);fill-opacity:1;stroke:none;stroke-width:0.99999946;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1"
-         sodipodi:type="arc" />
-      <path
-         transform="matrix(0.827591,0,0,0.872728,166.2384,-92.68171)"
-         d="M 614.75,-403.125 A 1.8125,1.71875 0 1 1 611.125,-403.125 A 1.8125,1.71875 0 1 1 614.75,-403.125 z"
-         sodipodi:ry="1.71875"
-         sodipodi:rx="1.8125"
-         sodipodi:cy="-403.125"
-         sodipodi:cx="612.9375"
-         id="path20464"
-         style="opacity:1;fill:url(#linearGradient20482);fill-opacity:1;stroke:none;stroke-width:0.99999946;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1"
-         sodipodi:type="arc" />
-    </g>
-    <use
-       x="0"
-       y="0"
-       xlink:href="#g3780"
-       id="use7023"
-       transform="translate(23.999999,4.462122e-7)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#g4703"
-       id="use7025"
-       transform="translate(23.999999,4.462122e-7)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#g20424"
-       id="use7027"
-       transform="translate(23.999999,4.462122e-7)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7023"
-       id="use7029"
-       transform="translate(24,0)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7025"
-       id="use7031"
-       transform="matrix(0.9795296,0.2013002,-0.2013002,0.9795296,101.85786,-20.897252)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7027"
-       id="use7033"
-       transform="translate(24,0)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7029"
-       id="use7035"
-       transform="translate(23.969225,-4.01798e-6)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7031"
-       id="use7037"
-       transform="matrix(0.9795296,0.2013002,-0.2013002,0.9795296,102.2346,-25.710998)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7033"
-       id="use7039"
-       transform="translate(23.969225,-4.01798e-6)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7035"
-       id="use7041"
-       transform="translate(24,0)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7037"
-       id="use7043"
-       transform="matrix(0.9795296,0.2013002,-0.2013002,0.9795296,102.80898,-30.458133)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7039"
-       id="use7045"
-       transform="translate(24,0)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7041"
-       id="use7047"
-       transform="translate(24,4.01798e-6)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7043"
-       id="use7049"
-       transform="matrix(0.9795296,0.2013002,-0.2013002,0.9795296,103.20351,-35.400944)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7045"
-       id="use7051"
-       transform="translate(24,4.01798e-6)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7047"
-       id="use7053"
-       transform="translate(24,0)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7049"
-       id="use7055"
-       transform="matrix(0.9795296,0.2013002,-0.2013002,0.9795296,103.17485,-40.109045)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7051"
-       id="use7057"
-       transform="translate(24,0)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7053"
-       id="use7059"
-       transform="translate(24.030775,-4.01798e-6)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7055"
-       id="use7061"
-       transform="matrix(0.9795296,0.2013002,-0.2013002,0.9795296,104.22456,-45.067313)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7057"
-       id="use7063"
-       transform="translate(24.030775,-4.01798e-6)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7059"
-       id="use7065"
-       transform="translate(-168.03078,24)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7061"
-       id="use7067"
-       transform="matrix(0.9795296,0.2013002,-0.2013002,0.9795296,-86.641331,-25.640129)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7063"
-       id="use7069"
-       transform="translate(-168.03078,24)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7065"
-       id="use7071"
-       transform="translate(24.03078,4.01798e-6)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7067"
-       id="use7073"
-       transform="matrix(0.9795296,0.2013002,-0.2013002,0.9795296,106.09695,-15.551321)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7069"
-       id="use7075"
-       transform="translate(24.03078,4.01798e-6)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7071"
-       id="use7077"
-       transform="translate(24,-4.01798e-6)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7073"
-       id="use7079"
-       transform="matrix(0.9795296,0.2013002,-0.2013002,0.9795296,106.57093,-20.368781)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7075"
-       id="use7081"
-       transform="translate(24,-4.01798e-6)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7077"
-       id="use7083"
-       transform="translate(24,0)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7079"
-       id="use7085"
-       transform="matrix(0.9795296,0.2013002,-0.2013002,0.9795296,107.08123,-25.267784)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7081"
-       id="use7087"
-       transform="translate(24,0)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7083"
-       id="use7089"
-       transform="translate(23.969225,0)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7085"
-       id="use7091"
-       transform="matrix(0.9795296,0.2013002,-0.2013002,0.9795296,107.62078,-29.966462)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7087"
-       id="use7093"
-       transform="translate(23.969225,0)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7089"
-       id="use7095"
-       transform="translate(24.030775,4.01798e-6)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7091"
-       id="use7097"
-       transform="matrix(0.9795296,0.2013002,-0.2013002,0.9795296,108.11406,-34.883377)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7093"
-       id="use7099"
-       transform="translate(24.030775,4.01798e-6)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7095"
-       id="use7101"
-       transform="translate(23.969225,0)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7097"
-       id="use7103"
-       transform="matrix(0.9795296,0.2013002,-0.2013002,0.9795296,108.54427,-39.699493)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7099"
-       id="use7105"
-       transform="translate(23.969225,0)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7101"
-       id="use7107"
-       transform="translate(24,0)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7103"
-       id="use7109"
-       transform="matrix(0.9795296,0.2013002,-0.2013002,0.9795296,109.06758,-44.533576)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7105"
-       id="use7111"
-       transform="translate(24,0)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7107"
-       id="use7113"
-       transform="translate(-168,24)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7109"
-       id="use7115"
-       transform="matrix(0.9795296,0.2013002,-0.2013002,0.9795296,-83.200364,-25.422262)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7111"
-       id="use7117"
-       transform="translate(-168,24)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7113"
-       id="use7119"
-       transform="translate(24.030775,0)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7115"
-       id="use7121"
-       transform="matrix(0.9795296,0.2013002,-0.2013002,0.9795296,110.81693,-15.009411)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7117"
-       id="use7123"
-       transform="translate(24.030775,0)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7119"
-       id="use7125"
-       transform="translate(24,0)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7121"
-       id="use7127"
-       transform="matrix(0.9795296,0.2013002,-0.2013002,0.9795296,112.12661,-19.707335)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7123"
-       id="use7129"
-       transform="translate(24,0)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7125"
-       id="use7131"
-       transform="translate(23.969225,0)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7127"
-       id="use7133"
-       transform="matrix(0.9795296,0.2013002,-0.2013002,0.9795296,112.01486,-24.540492)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7129"
-       id="use7135"
-       transform="translate(23.969225,0)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7131"
-       id="use7137"
-       transform="translate(24,-4.01798e-6)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7133"
-       id="use7139"
-       transform="matrix(0.9795296,0.2013002,-0.2013002,0.9795296,112.47923,-29.515213)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7135"
-       id="use7141"
-       transform="translate(24,-4.01798e-6)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7137"
-       id="use7143"
-       transform="translate(24.030775,4.01798e-6)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7139"
-       id="use7145"
-       transform="matrix(0.9795296,0.2013002,-0.2013002,0.9795296,112.92417,-34.429832)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7141"
-       id="use7147"
-       transform="translate(24.030775,4.01798e-6)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7143"
-       id="use7149"
-       transform="translate(23.969225,0)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7145"
-       id="use7151"
-       transform="matrix(0.9795296,0.2013002,-0.2013002,0.9795296,113.36724,-39.162519)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7147"
-       id="use7153"
-       transform="translate(23.969225,0)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7149"
-       id="use7155"
-       transform="translate(24,-4.01798e-6)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7151"
-       id="use7157"
-       transform="matrix(0.9795296,0.2013002,-0.2013002,0.9795296,113.86685,-43.99837)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7153"
-       id="use7159"
-       transform="translate(24,-4.01798e-6)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7155"
-       id="use7161"
-       transform="translate(-168,24.000004)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7157"
-       id="use7163"
-       transform="matrix(0.9795296,0.2013002,-0.2013002,0.9795296,-77.529981,-24.910134)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7159"
-       id="use7165"
-       transform="translate(-168,24.000004)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7161"
-       id="use7167"
-       transform="translate(24.030775,-4e-6)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7163"
-       id="use7169"
-       transform="matrix(0.9795296,0.2013002,-0.2013002,0.9795296,115.76144,-14.531102)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7165"
-       id="use7171"
-       transform="translate(24.030775,-4e-6)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7167"
-       id="use7173"
-       transform="translate(24,4.01798e-6)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7169"
-       id="use7175"
-       transform="matrix(0.9795296,0.2013002,-0.2013002,0.9795296,115.66057,-19.235279)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7171"
-       id="use7177"
-       transform="translate(24,4.01798e-6)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7173"
-       id="use7179"
-       transform="translate(24,-4.01798e-6)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7175"
-       id="use7181"
-       transform="matrix(0.9795296,0.2013002,-0.2013002,0.9795296,116.90892,-24.182897)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7177"
-       id="use7183"
-       transform="translate(24,-4.01798e-6)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7179"
-       id="use7185"
-       transform="translate(23.969225,4.01798e-6)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7181"
-       id="use7187"
-       transform="matrix(0.9795296,0.2013002,-0.2013002,0.9795296,117.69596,-29.028433)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7183"
-       id="use7189"
-       transform="translate(23.969225,4.01798e-6)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7185"
-       id="use7191"
-       transform="translate(24.030775,-4.01798e-6)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7187"
-       id="use7193"
-       transform="matrix(0.9795296,0.2013002,-0.2013002,0.9795296,117.82669,-33.91686)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7189"
-       id="use7195"
-       transform="translate(24.030775,-4.01798e-6)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7191"
-       id="use7197"
-       transform="translate(23.969225,4.01798e-6)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7193"
-       id="use7199"
-       transform="matrix(0.9795296,0.2013002,-0.2013002,0.9795296,118.18637,-38.762044)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7195"
-       id="use7201"
-       transform="translate(23.969225,4.01798e-6)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7197"
-       id="use7203"
-       transform="translate(24,0)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7199"
-       id="use7205"
-       transform="matrix(0.9795296,0.2013002,-0.2013002,0.9795296,118.76746,-43.526789)"
-       width="400"
-       height="600" />
-    <use
-       x="0"
-       y="0"
-       xlink:href="#use7201"
-       id="use7207"
-       transform="translate(24,0)"
-       width="400"
-       height="600" />
-  </g>
-</svg>

=== modified file 'depcomp'
--- depcomp	2009-06-30 12:00:00 +0000
+++ depcomp	2009-08-26 12:15:00 +0000
@@ -1,10 +1,10 @@
 #! /bin/sh
 # depcomp - compile a program generating dependencies as side-effects
 
-scriptversion=2007-03-29.01
+scriptversion=2009-04-28.21; # UTC
 
-# Copyright (C) 1999, 2000, 2003, 2004, 2005, 2006, 2007 Free Software
-# Foundation, Inc.
+# Copyright (C) 1999, 2000, 2003, 2004, 2005, 2006, 2007, 2009 Free
+# Software Foundation, Inc.
 
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -17,9 +17,7 @@
 # GNU General Public License for more details.
 
 # You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
-# 02110-1301, USA.
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
 
 # As a special exception to the GNU General Public License, if you
 # distribute this file as part of a program that contains a
@@ -87,6 +85,15 @@
    depmode=dashmstdout
 fi
 
+cygpath_u="cygpath -u -f -"
+if test "$depmode" = msvcmsys; then
+   # This is just like msvisualcpp but w/o cygpath translation.
+   # Just convert the backslash-escaped backslashes to single forward
+   # slashes to satisfy depend.m4
+   cygpath_u="sed s,\\\\\\\\,/,g"
+   depmode=msvisualcpp
+fi
+
 case "$depmode" in
 gcc3)
 ## gcc 3 implements dependency tracking that does exactly what
@@ -192,14 +199,14 @@
 ' < "$tmpdepfile" \
     | sed -e 's/^.*\.o://' -e 's/#.*$//' -e '/^$/ d' | \
     tr '
-' ' ' >> $depfile
-    echo >> $depfile
+' ' ' >> "$depfile"
+    echo >> "$depfile"
 
     # The second pass generates a dummy entry for each header file.
     tr ' ' '
 ' < "$tmpdepfile" \
    | sed -e 's/^.*\.o://' -e 's/#.*$//' -e '/^$/ d' -e 's/$/:/' \
-   >> $depfile
+   >> "$depfile"
   else
     # The sourcefile does not contain any dependencies, so just
     # store a dummy comment line, to avoid errors with the Makefile
@@ -328,7 +335,12 @@
   if test -f "$tmpdepfile"; then
     sed -e "s,^.*\.[a-z]*:,$object:," "$tmpdepfile" > "$depfile"
     # Add `dependent.h:' lines.
-    sed -ne '2,${; s/^ *//; s/ \\*$//; s/$/:/; p;}' "$tmpdepfile" >> "$depfile"
+    sed -ne '2,${
+	       s/^ *//
+	       s/ \\*$//
+	       s/$/:/
+	       p
+	     }' "$tmpdepfile" >> "$depfile"
   else
     echo "#dummy" > "$depfile"
   fi
@@ -404,7 +416,7 @@
 
   # Remove the call to Libtool.
   if test "$libtool" = yes; then
-    while test $1 != '--mode=compile'; do
+    while test "X$1" != 'X--mode=compile'; do
       shift
     done
     shift
@@ -455,32 +467,39 @@
   "$@" || exit $?
   # Remove any Libtool call
   if test "$libtool" = yes; then
-    while test $1 != '--mode=compile'; do
+    while test "X$1" != 'X--mode=compile'; do
       shift
     done
     shift
   fi
   # X makedepend
   shift
-  cleared=no
-  for arg in "$@"; do
+  cleared=no eat=no
+  for arg
+  do
     case $cleared in
     no)
       set ""; shift
       cleared=yes ;;
     esac
+    if test $eat = yes; then
+      eat=no
+      continue
+    fi
     case "$arg" in
     -D*|-I*)
       set fnord "$@" "$arg"; shift ;;
     # Strip any option that makedepend may not understand.  Remove
     # the object too, otherwise makedepend will parse it as a source file.
+    -arch)
+      eat=yes ;;
     -*|$object)
       ;;
     *)
       set fnord "$@" "$arg"; shift ;;
     esac
   done
-  obj_suffix="`echo $object | sed 's/^.*\././'`"
+  obj_suffix=`echo "$object" | sed 's/^.*\././'`
   touch "$tmpdepfile"
   ${MAKEDEPEND-makedepend} -o"$obj_suffix" -f"$tmpdepfile" "$@"
   rm -f "$depfile"
@@ -500,7 +519,7 @@
 
   # Remove the call to Libtool.
   if test "$libtool" = yes; then
-    while test $1 != '--mode=compile'; do
+    while test "X$1" != 'X--mode=compile'; do
       shift
     done
     shift
@@ -538,13 +557,27 @@
 
 msvisualcpp)
   # Important note: in order to support this mode, a compiler *must*
-  # always write the preprocessed file to stdout, regardless of -o,
-  # because we must use -o when running libtool.
+  # always write the preprocessed file to stdout.
   "$@" || exit $?
+
+  # Remove the call to Libtool.
+  if test "$libtool" = yes; then
+    while test "X$1" != 'X--mode=compile'; do
+      shift
+    done
+    shift
+  fi
+
   IFS=" "
   for arg
   do
     case "$arg" in
+    -o)
+      shift
+      ;;
+    $object)
+      shift
+      ;;
     "-Gm"|"/Gm"|"-Gi"|"/Gi"|"-ZI"|"/ZI")
 	set fnord "$@"
 	shift
@@ -557,16 +590,23 @@
 	;;
     esac
   done
-  "$@" -E |
-  sed -n '/^#line [0-9][0-9]* "\([^"]*\)"/ s::echo "`cygpath -u \\"\1\\"`":p' | sort | uniq > "$tmpdepfile"
+  "$@" -E 2>/dev/null |
+  sed -n '/^#line [0-9][0-9]* "\([^"]*\)"/ s::\1:p' | $cygpath_u | sort -u > "$tmpdepfile"
   rm -f "$depfile"
   echo "$object : \\" > "$depfile"
-  . "$tmpdepfile" | sed 's% %\\ %g' | sed -n '/^\(.*\)$/ s::	\1 \\:p' >> "$depfile"
+  sed < "$tmpdepfile" -n -e 's% %\\ %g' -e '/^\(.*\)$/ s::	\1 \\:p' >> "$depfile"
   echo "	" >> "$depfile"
-  . "$tmpdepfile" | sed 's% %\\ %g' | sed -n '/^\(.*\)$/ s::\1\::p' >> "$depfile"
+  sed < "$tmpdepfile" -n -e 's% %\\ %g' -e '/^\(.*\)$/ s::\1\::p' >> "$depfile"
   rm -f "$tmpdepfile"
   ;;
 
+msvcmsys)
+  # This case exists only to let depend.m4 do its work.  It works by
+  # looking at the text of this script.  This case will never be run,
+  # since it is checked for above.
+  exit 1
+  ;;
+
 none)
   exec "$@"
   ;;
@@ -585,5 +625,6 @@
 # eval: (add-hook 'write-file-hooks 'time-stamp)
 # time-stamp-start: "scriptversion="
 # time-stamp-format: "%:y-%02m-%02d.%02H"
-# time-stamp-end: "$"
+# time-stamp-time-zone: "UTC"
+# time-stamp-end: "; # UTC"
 # End:

=== modified file 'install-sh'
--- install-sh	2009-06-30 12:00:00 +0000
+++ install-sh	2009-08-26 12:15:00 +0000
@@ -1,7 +1,7 @@
 #!/bin/sh
 # install - install a program, script, or datafile
 
-scriptversion=2006-12-25.00
+scriptversion=2009-04-28.21; # UTC
 
 # This originates from X11R5 (mit/util/scripts/install.sh), which was
 # later released in X11R6 (xc/config/util/install.sh) with the
@@ -515,5 +515,6 @@
 # eval: (add-hook 'write-file-hooks 'time-stamp)
 # time-stamp-start: "scriptversion="
 # time-stamp-format: "%:y-%02m-%02d.%02H"
-# time-stamp-end: "$"
+# time-stamp-time-zone: "UTC"
+# time-stamp-end: "; # UTC"
 # End:

=== modified file 'missing'
--- missing	2009-06-30 12:00:00 +0000
+++ missing	2009-08-26 12:15:00 +0000
@@ -1,10 +1,10 @@
 #! /bin/sh
 # Common stub for a few missing GNU programs while installing.
 
-scriptversion=2006-05-10.23
+scriptversion=2009-04-28.21; # UTC
 
-# Copyright (C) 1996, 1997, 1999, 2000, 2002, 2003, 2004, 2005, 2006
-#   Free Software Foundation, Inc.
+# Copyright (C) 1996, 1997, 1999, 2000, 2002, 2003, 2004, 2005, 2006,
+# 2008, 2009 Free Software Foundation, Inc.
 # Originally by Fran,cois Pinard <pinard@iro.umontreal.ca>, 1996.
 
 # This program is free software; you can redistribute it and/or modify
@@ -18,9 +18,7 @@
 # GNU General Public License for more details.
 
 # You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
-# 02110-1301, USA.
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
 
 # As a special exception to the GNU General Public License, if you
 # distribute this file as part of a program that contains a
@@ -89,6 +87,9 @@
   tar          try tar, gnutar, gtar, then tar without non-portable flags
   yacc         create \`y.tab.[ch]', if possible, from existing .[ch]
 
+Version suffixes to PROGRAM as well as the prefixes \`gnu-', \`gnu', and
+\`g' are ignored when checking the name.
+
 Send bug reports to <bug-automake@gnu.org>."
     exit $?
     ;;
@@ -106,15 +107,22 @@
 
 esac
 
+# normalize program name to check for.
+program=`echo "$1" | sed '
+  s/^gnu-//; t
+  s/^gnu//; t
+  s/^g//; t'`
+
 # Now exit if we have it, but it failed.  Also exit now if we
 # don't have it and --version was passed (most likely to detect
-# the program).
+# the program).  This is about non-GNU programs, so use $1 not
+# $program.
 case $1 in
-  lex|yacc)
+  lex*|yacc*)
     # Not GNU programs, they don't have --version.
     ;;
 
-  tar)
+  tar*)
     if test -n "$run"; then
        echo 1>&2 "ERROR: \`tar' requires --run"
        exit 1
@@ -138,7 +146,7 @@
 
 # If it does not exist, or fails to run (possibly an outdated version),
 # try to emulate it.
-case $1 in
+case $program in
   aclocal*)
     echo 1>&2 "\
 WARNING: \`$1' is $msg.  You should only need it if
@@ -148,7 +156,7 @@
     touch aclocal.m4
     ;;
 
-  autoconf)
+  autoconf*)
     echo 1>&2 "\
 WARNING: \`$1' is $msg.  You should only need it if
          you modified \`${configure_ac}'.  You might want to install the
@@ -157,7 +165,7 @@
     touch configure
     ;;
 
-  autoheader)
+  autoheader*)
     echo 1>&2 "\
 WARNING: \`$1' is $msg.  You should only need it if
          you modified \`acconfig.h' or \`${configure_ac}'.  You might want
@@ -187,7 +195,7 @@
 	   while read f; do touch "$f"; done
     ;;
 
-  autom4te)
+  autom4te*)
     echo 1>&2 "\
 WARNING: \`$1' is needed, but is $msg.
          You might have modified some files without having the
@@ -210,7 +218,7 @@
     fi
     ;;
 
-  bison|yacc)
+  bison*|yacc*)
     echo 1>&2 "\
 WARNING: \`$1' $msg.  You should only need it if
          you modified a \`.y' file.  You may need the \`Bison' package
@@ -240,7 +248,7 @@
     fi
     ;;
 
-  lex|flex)
+  lex*|flex*)
     echo 1>&2 "\
 WARNING: \`$1' is $msg.  You should only need it if
          you modified a \`.l' file.  You may need the \`Flex' package
@@ -263,7 +271,7 @@
     fi
     ;;
 
-  help2man)
+  help2man*)
     echo 1>&2 "\
 WARNING: \`$1' is $msg.  You should only need it if
 	 you modified a dependency of a manual page.  You may need the
@@ -277,11 +285,11 @@
     else
 	test -z "$file" || exec >$file
 	echo ".ab help2man is required to generate this page"
-	exit 1
+	exit $?
     fi
     ;;
 
-  makeinfo)
+  makeinfo*)
     echo 1>&2 "\
 WARNING: \`$1' is $msg.  You should only need it if
          you modified a \`.texi' or \`.texinfo' file, or any other file
@@ -310,7 +318,7 @@
     touch $file
     ;;
 
-  tar)
+  tar*)
     shift
 
     # We have already tried tar in the generic part.
@@ -363,5 +371,6 @@
 # eval: (add-hook 'write-file-hooks 'time-stamp)
 # time-stamp-start: "scriptversion="
 # time-stamp-format: "%:y-%02m-%02d.%02H"
-# time-stamp-end: "$"
+# time-stamp-time-zone: "UTC"
+# time-stamp-end: "; # UTC"
 # End:

=== modified file 'nautilus/Makefile.in'
--- nautilus/Makefile.in	2009-08-11 16:45:00 +0000
+++ nautilus/Makefile.in	2009-08-26 12:15:00 +0000
@@ -1,8 +1,9 @@
-# Makefile.in generated by automake 1.10.2 from Makefile.am.
+# Makefile.in generated by automake 1.11 from Makefile.am.
 # @configure_input@
 
 # Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2000, 2001, 2002,
-# 2003, 2004, 2005, 2006, 2007, 2008  Free Software Foundation, Inc.
+# 2003, 2004, 2005, 2006, 2007, 2008, 2009  Free Software Foundation,
+# Inc.
 # This Makefile.in is free software; the Free Software Foundation
 # gives unlimited permission to copy and/or distribute it,
 # with or without modifications, as long as this notice is preserved.
@@ -16,8 +17,9 @@
 
 VPATH = @srcdir@
 pkgdatadir = $(datadir)/@PACKAGE@
+pkgincludedir = $(includedir)/@PACKAGE@
 pkglibdir = $(libdir)/@PACKAGE@
-pkgincludedir = $(includedir)/@PACKAGE@
+pkglibexecdir = $(libexecdir)/@PACKAGE@
 am__cd = CDPATH="$${ZSH_VERSION+.}$(PATH_SEPARATOR)" && cd
 install_sh_DATA = $(install_sh) -c -m 644
 install_sh_PROGRAM = $(install_sh) -c
@@ -44,14 +46,29 @@
 mkinstalldirs = $(install_sh) -d
 CONFIG_HEADER = $(top_builddir)/config.h
 CONFIG_CLEAN_FILES =
+CONFIG_CLEAN_VPATH_FILES =
 am__vpath_adj_setup = srcdirstrip=`echo "$(srcdir)" | sed 's|.|.|g'`;
 am__vpath_adj = case $$p in \
     $(srcdir)/*) f=`echo "$$p" | sed "s|^$$srcdirstrip/||"`;; \
     *) f=$$p;; \
   esac;
-am__strip_dir = `echo $$p | sed -e 's|^.*/||'`;
+am__strip_dir = f=`echo $$p | sed -e 's|^.*/||'`;
+am__install_max = 40
+am__nobase_strip_setup = \
+  srcdirstrip=`echo "$(srcdir)" | sed 's/[].[^$$\\*|]/\\\\&/g'`
+am__nobase_strip = \
+  for p in $$list; do echo "$$p"; done | sed -e "s|$$srcdirstrip/||"
+am__nobase_list = $(am__nobase_strip_setup); \
+  for p in $$list; do echo "$$p $$p"; done | \
+  sed "s| $$srcdirstrip/| |;"' / .*\//!s/ .*/ ./; s,\( .*\)/[^/]*$$,\1,' | \
+  $(AWK) 'BEGIN { files["."] = "" } { files[$$2] = files[$$2] " " $$1; \
+    if (++n[$$2] == $(am__install_max)) \
+      { print $$2, files[$$2]; n[$$2] = 0; files[$$2] = "" } } \
+    END { for (dir in files) print dir, files[dir] }'
+am__base_list = \
+  sed '$$!N;$$!N;$$!N;$$!N;$$!N;$$!N;$$!N;s/\n/ /g' | \
+  sed '$$!N;$$!N;$$!N;$$!N;s/\n/ /g'
 am__installdirs = "$(DESTDIR)$(extensiondir)"
-extensionLTLIBRARIES_INSTALL = $(INSTALL)
 LTLIBRARIES = $(extension_LTLIBRARIES)
 am__DEPENDENCIES_1 =
 libnautilus_ubuntuone_la_DEPENDENCIES = $(am__DEPENDENCIES_1) \
@@ -67,6 +84,7 @@
 DEFAULT_INCLUDES = -I.@am__isrc@ -I$(top_builddir)
 depcomp = $(SHELL) $(top_srcdir)/depcomp
 am__depfiles_maybe = depfiles
+am__mv = mv -f
 COMPILE = $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) \
 	$(CPPFLAGS) $(AM_CFLAGS) $(CFLAGS)
 LTCOMPILE = $(LIBTOOL) --tag=CC $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) \
@@ -256,9 +274,9 @@
 	      exit 1;; \
 	  esac; \
 	done; \
-	echo ' cd $(top_srcdir) && $(AUTOMAKE) --foreign  nautilus/Makefile'; \
-	cd $(top_srcdir) && \
-	  $(AUTOMAKE) --foreign  nautilus/Makefile
+	echo ' cd $(top_srcdir) && $(AUTOMAKE) --foreign nautilus/Makefile'; \
+	$(am__cd) $(top_srcdir) && \
+	  $(AUTOMAKE) --foreign nautilus/Makefile
 .PRECIOUS: Makefile
 Makefile: $(srcdir)/Makefile.in $(top_builddir)/config.status
 	@case '$?' in \
@@ -276,23 +294,28 @@
 	cd $(top_builddir) && $(MAKE) $(AM_MAKEFLAGS) am--refresh
 $(ACLOCAL_M4):  $(am__aclocal_m4_deps)
 	cd $(top_builddir) && $(MAKE) $(AM_MAKEFLAGS) am--refresh
+$(am__aclocal_m4_deps):
 install-extensionLTLIBRARIES: $(extension_LTLIBRARIES)
 	@$(NORMAL_INSTALL)
 	test -z "$(extensiondir)" || $(MKDIR_P) "$(DESTDIR)$(extensiondir)"
-	@list='$(extension_LTLIBRARIES)'; for p in $$list; do \
+	@list='$(extension_LTLIBRARIES)'; test -n "$(extensiondir)" || list=; \
+	list2=; for p in $$list; do \
 	  if test -f $$p; then \
-	    f=$(am__strip_dir) \
-	    echo " $(LIBTOOL) $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=install $(extensionLTLIBRARIES_INSTALL) $(INSTALL_STRIP_FLAG) '$$p' '$(DESTDIR)$(extensiondir)/$$f'"; \
-	    $(LIBTOOL) $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=install $(extensionLTLIBRARIES_INSTALL) $(INSTALL_STRIP_FLAG) "$$p" "$(DESTDIR)$(extensiondir)/$$f"; \
+	    list2="$$list2 $$p"; \
 	  else :; fi; \
-	done
+	done; \
+	test -z "$$list2" || { \
+	  echo " $(LIBTOOL) $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=install $(INSTALL) $(INSTALL_STRIP_FLAG) $$list2 '$(DESTDIR)$(extensiondir)'"; \
+	  $(LIBTOOL) $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=install $(INSTALL) $(INSTALL_STRIP_FLAG) $$list2 "$(DESTDIR)$(extensiondir)"; \
+	}
 
 uninstall-extensionLTLIBRARIES:
 	@$(NORMAL_UNINSTALL)
-	@list='$(extension_LTLIBRARIES)'; for p in $$list; do \
-	  p=$(am__strip_dir) \
-	  echo " $(LIBTOOL) $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=uninstall rm -f '$(DESTDIR)$(extensiondir)/$$p'"; \
-	  $(LIBTOOL) $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=uninstall rm -f "$(DESTDIR)$(extensiondir)/$$p"; \
+	@list='$(extension_LTLIBRARIES)'; test -n "$(extensiondir)" || list=; \
+	for p in $$list; do \
+	  $(am__strip_dir) \
+	  echo " $(LIBTOOL) $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=uninstall rm -f '$(DESTDIR)$(extensiondir)/$$f'"; \
+	  $(LIBTOOL) $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=uninstall rm -f "$(DESTDIR)$(extensiondir)/$$f"; \
 	done
 
 clean-extensionLTLIBRARIES:
@@ -316,31 +339,31 @@
 
 .c.o:
 @am__fastdepCC_TRUE@	$(COMPILE) -MT $@ -MD -MP -MF $(DEPDIR)/$*.Tpo -c -o $@ $<
-@am__fastdepCC_TRUE@	mv -f $(DEPDIR)/$*.Tpo $(DEPDIR)/$*.Po
+@am__fastdepCC_TRUE@	$(am__mv) $(DEPDIR)/$*.Tpo $(DEPDIR)/$*.Po
 @AMDEP_TRUE@@am__fastdepCC_FALSE@	source='$<' object='$@' libtool=no @AMDEPBACKSLASH@
 @AMDEP_TRUE@@am__fastdepCC_FALSE@	DEPDIR=$(DEPDIR) $(CCDEPMODE) $(depcomp) @AMDEPBACKSLASH@
 @am__fastdepCC_FALSE@	$(COMPILE) -c $<
 
 .c.obj:
 @am__fastdepCC_TRUE@	$(COMPILE) -MT $@ -MD -MP -MF $(DEPDIR)/$*.Tpo -c -o $@ `$(CYGPATH_W) '$<'`
-@am__fastdepCC_TRUE@	mv -f $(DEPDIR)/$*.Tpo $(DEPDIR)/$*.Po
+@am__fastdepCC_TRUE@	$(am__mv) $(DEPDIR)/$*.Tpo $(DEPDIR)/$*.Po
 @AMDEP_TRUE@@am__fastdepCC_FALSE@	source='$<' object='$@' libtool=no @AMDEPBACKSLASH@
 @AMDEP_TRUE@@am__fastdepCC_FALSE@	DEPDIR=$(DEPDIR) $(CCDEPMODE) $(depcomp) @AMDEPBACKSLASH@
 @am__fastdepCC_FALSE@	$(COMPILE) -c `$(CYGPATH_W) '$<'`
 
 .c.lo:
 @am__fastdepCC_TRUE@	$(LTCOMPILE) -MT $@ -MD -MP -MF $(DEPDIR)/$*.Tpo -c -o $@ $<
-@am__fastdepCC_TRUE@	mv -f $(DEPDIR)/$*.Tpo $(DEPDIR)/$*.Plo
+@am__fastdepCC_TRUE@	$(am__mv) $(DEPDIR)/$*.Tpo $(DEPDIR)/$*.Plo
 @AMDEP_TRUE@@am__fastdepCC_FALSE@	source='$<' object='$@' libtool=yes @AMDEPBACKSLASH@
 @AMDEP_TRUE@@am__fastdepCC_FALSE@	DEPDIR=$(DEPDIR) $(CCDEPMODE) $(depcomp) @AMDEPBACKSLASH@
 @am__fastdepCC_FALSE@	$(LTCOMPILE) -c -o $@ $<
 
 libnautilus_ubuntuone_la-ubuntuone-nautilus.lo: ubuntuone-nautilus.c
-@am__fastdepCC_TRUE@	$(LIBTOOL) --tag=CC $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(libnautilus_ubuntuone_la_CFLAGS) $(CFLAGS) -MT libnautilus_ubuntuone_la-ubuntuone-nautilus.lo -MD -MP -MF $(DEPDIR)/libnautilus_ubuntuone_la-ubuntuone-nautilus.Tpo -c -o libnautilus_ubuntuone_la-ubuntuone-nautilus.lo `test -f 'ubuntuone-nautilus.c' || echo '$(srcdir)/'`ubuntuone-nautilus.c
-@am__fastdepCC_TRUE@	mv -f $(DEPDIR)/libnautilus_ubuntuone_la-ubuntuone-nautilus.Tpo $(DEPDIR)/libnautilus_ubuntuone_la-ubuntuone-nautilus.Plo
+@am__fastdepCC_TRUE@	$(LIBTOOL)  --tag=CC $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(libnautilus_ubuntuone_la_CFLAGS) $(CFLAGS) -MT libnautilus_ubuntuone_la-ubuntuone-nautilus.lo -MD -MP -MF $(DEPDIR)/libnautilus_ubuntuone_la-ubuntuone-nautilus.Tpo -c -o libnautilus_ubuntuone_la-ubuntuone-nautilus.lo `test -f 'ubuntuone-nautilus.c' || echo '$(srcdir)/'`ubuntuone-nautilus.c
+@am__fastdepCC_TRUE@	$(am__mv) $(DEPDIR)/libnautilus_ubuntuone_la-ubuntuone-nautilus.Tpo $(DEPDIR)/libnautilus_ubuntuone_la-ubuntuone-nautilus.Plo
 @AMDEP_TRUE@@am__fastdepCC_FALSE@	source='ubuntuone-nautilus.c' object='libnautilus_ubuntuone_la-ubuntuone-nautilus.lo' libtool=yes @AMDEPBACKSLASH@
 @AMDEP_TRUE@@am__fastdepCC_FALSE@	DEPDIR=$(DEPDIR) $(CCDEPMODE) $(depcomp) @AMDEPBACKSLASH@
-@am__fastdepCC_FALSE@	$(LIBTOOL) --tag=CC $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(libnautilus_ubuntuone_la_CFLAGS) $(CFLAGS) -c -o libnautilus_ubuntuone_la-ubuntuone-nautilus.lo `test -f 'ubuntuone-nautilus.c' || echo '$(srcdir)/'`ubuntuone-nautilus.c
+@am__fastdepCC_FALSE@	$(LIBTOOL)  --tag=CC $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(libnautilus_ubuntuone_la_CFLAGS) $(CFLAGS) -c -o libnautilus_ubuntuone_la-ubuntuone-nautilus.lo `test -f 'ubuntuone-nautilus.c' || echo '$(srcdir)/'`ubuntuone-nautilus.c
 
 mostlyclean-libtool:
 	-rm -f *.lo
@@ -360,7 +383,7 @@
 
 TAGS:  $(HEADERS) $(SOURCES)  $(TAGS_DEPENDENCIES) \
 		$(TAGS_FILES) $(LISP)
-	tags=; \
+	set x; \
 	here=`pwd`; \
 	list='$(SOURCES) $(HEADERS)  $(LISP) $(TAGS_FILES)'; \
 	unique=`for i in $$list; do \
@@ -368,29 +391,34 @@
 	  done | \
 	  $(AWK) '{ files[$$0] = 1; nonempty = 1; } \
 	      END { if (nonempty) { for (i in files) print i; }; }'`; \
-	if test -z "$(ETAGS_ARGS)$$tags$$unique"; then :; else \
+	shift; \
+	if test -z "$(ETAGS_ARGS)$$*$$unique"; then :; else \
 	  test -n "$$unique" || unique=$$empty_fix; \
-	  $(ETAGS) $(ETAGSFLAGS) $(AM_ETAGSFLAGS) $(ETAGS_ARGS) \
-	    $$tags $$unique; \
+	  if test $$# -gt 0; then \
+	    $(ETAGS) $(ETAGSFLAGS) $(AM_ETAGSFLAGS) $(ETAGS_ARGS) \
+	      "$$@" $$unique; \
+	  else \
+	    $(ETAGS) $(ETAGSFLAGS) $(AM_ETAGSFLAGS) $(ETAGS_ARGS) \
+	      $$unique; \
+	  fi; \
 	fi
 ctags: CTAGS
 CTAGS:  $(HEADERS) $(SOURCES)  $(TAGS_DEPENDENCIES) \
 		$(TAGS_FILES) $(LISP)
-	tags=; \
 	list='$(SOURCES) $(HEADERS)  $(LISP) $(TAGS_FILES)'; \
 	unique=`for i in $$list; do \
 	    if test -f "$$i"; then echo $$i; else echo $(srcdir)/$$i; fi; \
 	  done | \
 	  $(AWK) '{ files[$$0] = 1; nonempty = 1; } \
 	      END { if (nonempty) { for (i in files) print i; }; }'`; \
-	test -z "$(CTAGS_ARGS)$$tags$$unique" \
+	test -z "$(CTAGS_ARGS)$$unique" \
 	  || $(CTAGS) $(CTAGSFLAGS) $(AM_CTAGSFLAGS) $(CTAGS_ARGS) \
-	     $$tags $$unique
+	     $$unique
 
 GTAGS:
 	here=`$(am__cd) $(top_builddir) && pwd` \
-	  && cd $(top_srcdir) \
-	  && gtags -i $(GTAGS_ARGS) $$here
+	  && $(am__cd) $(top_srcdir) \
+	  && gtags -i $(GTAGS_ARGS) "$$here"
 
 distclean-tags:
 	-rm -f TAGS ID GTAGS GRTAGS GSYMS GPATH tags
@@ -411,13 +439,17 @@
 	  if test -f $$file || test -d $$file; then d=.; else d=$(srcdir); fi; \
 	  if test -d $$d/$$file; then \
 	    dir=`echo "/$$file" | sed -e 's,/[^/]*$$,,'`; \
+	    if test -d "$(distdir)/$$file"; then \
+	      find "$(distdir)/$$file" -type d ! -perm -700 -exec chmod u+rwx {} \;; \
+	    fi; \
 	    if test -d $(srcdir)/$$file && test $$d != $(srcdir); then \
-	      cp -pR $(srcdir)/$$file $(distdir)$$dir || exit 1; \
+	      cp -fpR $(srcdir)/$$file "$(distdir)$$dir" || exit 1; \
+	      find "$(distdir)/$$file" -type d ! -perm -700 -exec chmod u+rwx {} \;; \
 	    fi; \
-	    cp -pR $$d/$$file $(distdir)$$dir || exit 1; \
+	    cp -fpR $$d/$$file "$(distdir)$$dir" || exit 1; \
 	  else \
-	    test -f $(distdir)/$$file \
-	    || cp -p $$d/$$file $(distdir)/$$file \
+	    test -f "$(distdir)/$$file" \
+	    || cp -p $$d/$$file "$(distdir)/$$file" \
 	    || exit 1; \
 	  fi; \
 	done
@@ -448,6 +480,7 @@
 
 distclean-generic:
 	-test -z "$(CONFIG_CLEAN_FILES)" || rm -f $(CONFIG_CLEAN_FILES)
+	-test . = "$(srcdir)" || test -z "$(CONFIG_CLEAN_VPATH_FILES)" || rm -f $(CONFIG_CLEAN_VPATH_FILES)
 
 maintainer-clean-generic:
 	@echo "This command is intended for maintainers to use"
@@ -470,6 +503,8 @@
 
 html: html-am
 
+html-am:
+
 info: info-am
 
 info-am:
@@ -478,18 +513,28 @@
 
 install-dvi: install-dvi-am
 
+install-dvi-am:
+
 install-exec-am:
 
 install-html: install-html-am
 
+install-html-am:
+
 install-info: install-info-am
 
+install-info-am:
+
 install-man:
 
 install-pdf: install-pdf-am
 
+install-pdf-am:
+
 install-ps: install-ps-am
 
+install-ps-am:
+
 installcheck-am:
 
 maintainer-clean: maintainer-clean-am
@@ -529,6 +574,7 @@
 	pdf pdf-am ps ps-am tags uninstall uninstall-am \
 	uninstall-extensionLTLIBRARIES
 
+
 # Tell versions [3.59,3.63) of GNU make to not export all variables.
 # Otherwise a system limit (for SysV at least) may be exceeded.
 .NOEXPORT:

=== modified file 'nautilus/ubuntuone-nautilus.c'
--- nautilus/ubuntuone-nautilus.c	2009-08-11 16:45:00 +0000
+++ nautilus/ubuntuone-nautilus.c	2009-08-26 12:15:00 +0000
@@ -104,13 +104,13 @@
 					       gchar * path,
 					       gpointer user_data);
 static void ubuntuone_nautilus_upload_finished (DBusGProxy * proxy,
-						 gchar * path,
+						 gchar * path, GHashTable * info,
 						 gpointer user_data);
 static void ubuntuone_nautilus_download_started (DBusGProxy * proxy,
 						 gchar * path,
 						 gpointer user_data);
 static void ubuntuone_nautilus_download_finished (DBusGProxy * proxy,
-						  gchar * path,
+						  gchar * path, GHashTable * info,
 						  gpointer user_data);
 static void ubuntuone_nautilus_share_created (DBusGProxy * proxy,
 					      GHashTable * hash,
@@ -431,7 +431,7 @@
   path = g_filename_from_uri (nautilus_file_info_get_uri (file), NULL, NULL);
 
   shared = g_build_filename (uon->managed, "Shared with Me", NULL);
-  myfiles = g_build_filename (uon->managed, "My Files", G_DIR_SEPARATOR_S, NULL);
+  myfiles = g_build_filename (uon->managed, G_DIR_SEPARATOR_S, NULL);
 
   if (!path || !ubuntuone_is_storagefs (uon, path))
     goto done;
@@ -562,6 +562,9 @@
 			       uon, NULL);
   dbus_g_proxy_add_signal (uon->u1_status, "UploadFinished",
 			   G_TYPE_STRING,
+			   dbus_g_type_get_map ("GHashTable",
+						G_TYPE_STRING,
+						G_TYPE_STRING),
 			   G_TYPE_INVALID);
   dbus_g_proxy_connect_signal (uon->u1_status, "UploadFinished",
 			       G_CALLBACK (ubuntuone_nautilus_upload_finished),
@@ -574,6 +577,9 @@
 			       uon, NULL);
   dbus_g_proxy_add_signal (uon->u1_status, "DownloadFinished",
 			   G_TYPE_STRING,
+			   dbus_g_type_get_map ("GHashTable",
+						G_TYPE_STRING,
+						G_TYPE_STRING),
 			   G_TYPE_INVALID);
   dbus_g_proxy_connect_signal (uon->u1_status, "DownloadFinished",
 			       G_CALLBACK (ubuntuone_nautilus_download_finished),
@@ -801,7 +807,7 @@
 }
 
 static void ubuntuone_nautilus_upload_finished (DBusGProxy * proxy,
-						gchar * path,
+						gchar * path, GHashTable * info,
 						gpointer user_data) {
   UbuntuOneNautilus * uon = UBUNTUONE_NAUTILUS (user_data);
 
@@ -860,7 +866,7 @@
 }
 
 static void ubuntuone_nautilus_download_finished (DBusGProxy * proxy,
-						  gchar * path,
+						  gchar * path, GHashTable * info,
 						  gpointer user_data) {
   UbuntuOneNautilus * uon = UBUNTUONE_NAUTILUS (user_data);
   gchar * partial = NULL;

=== modified file 'po/Makefile.in.in'
--- po/Makefile.in.in	2009-07-16 17:00:00 +0000
+++ po/Makefile.in.in	2009-08-26 12:15:00 +0000
@@ -129,7 +129,7 @@
 	done
 
 # Empty stubs to satisfy archaic automake needs
-dvi info ctags tags CTAGS TAGS ID:
+dvi info tags TAGS ID:
 
 # Define this as empty until I found a useful application.
 install-exec installcheck:

=== added file 'tests/__init__.pyc'
Binary files tests/__init__.pyc and tests/__init__.pyc differ
=== added file 'tests/oauthdesktop/__init__.pyc'
Binary files tests/oauthdesktop/__init__.pyc and tests/oauthdesktop/__init__.pyc differ
=== added file 'tests/oauthdesktop/test_auth.pyc'
Binary files tests/oauthdesktop/test_auth.pyc and tests/oauthdesktop/test_auth.pyc differ
=== added file 'tests/oauthdesktop/test_config.pyc'
Binary files tests/oauthdesktop/test_config.pyc and tests/oauthdesktop/test_config.pyc differ
=== added file 'tests/oauthdesktop/test_key_acls.pyc'
Binary files tests/oauthdesktop/test_key_acls.pyc and tests/oauthdesktop/test_key_acls.pyc differ
=== added file 'tests/oauthdesktop/test_main.pyc'
Binary files tests/oauthdesktop/test_main.pyc and tests/oauthdesktop/test_main.pyc differ
=== added file 'tests/syncdaemon/__init__.pyc'
Binary files tests/syncdaemon/__init__.pyc and tests/syncdaemon/__init__.pyc differ
=== added file 'tests/syncdaemon/fsm/__init__.pyc'
Binary files tests/syncdaemon/fsm/__init__.pyc and tests/syncdaemon/fsm/__init__.pyc differ
=== added file 'tests/syncdaemon/fsm/test_fsm.pyc'
Binary files tests/syncdaemon/fsm/test_fsm.pyc and tests/syncdaemon/fsm/test_fsm.pyc differ
=== added file 'tests/syncdaemon/fsm/test_fsm_run.pyc'
Binary files tests/syncdaemon/fsm/test_fsm_run.pyc and tests/syncdaemon/fsm/test_fsm_run.pyc differ
=== added file 'tests/syncdaemon/fsm/test_run_hello.pyc'
Binary files tests/syncdaemon/fsm/test_run_hello.pyc and tests/syncdaemon/fsm/test_run_hello.pyc differ
=== added file 'tests/syncdaemon/test_action_predicates.py'
--- tests/syncdaemon/test_action_predicates.py	1970-01-01 00:00:00 +0000
+++ tests/syncdaemon/test_action_predicates.py	2009-08-26 12:15:00 +0000
@@ -0,0 +1,143 @@
+# ubuntuone.syncdaemon.tests.test_action_queue - action queue tests
+#
+# Author: Tim Cole <tim.cole@canonical.com>
+#
+# Copyright 2009 Canonical Ltd.
+#
+# This program is free software: you can redistribute it and/or modify it
+# under the terms of the GNU General Public License version 3, as published
+# by the Free Software Foundation.
+#
+# This program is distributed in the hope that it will be useful, but
+# WITHOUT ANY WARRANTY; without even the implied warranties of
+# MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
+# PURPOSE.  See the GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License along
+# with this program.  If not, see <http://www.gnu.org/licenses/>.
+""" ActionQueue tests """
+
+from ubuntuone.syncdaemon.action_queue import (
+    ActionQueue, ActionQueueCommand, RequestQueue, WaitForCondition)
+from twisted.internet import defer
+from twisted.internet.defer import inlineCallbacks
+from twisted.trial.unittest import TestCase as TwistedTestCase
+
+
+class AppendCommand(ActionQueueCommand):
+    """Simple command which appends a value to a list."""
+    blocked = False
+
+    def __init__(self, request_queue, append_to, value):
+        """Initialize, remembering list and value."""
+        super(AppendCommand, self).__init__(request_queue)
+        self.append_to = append_to
+        self.value = value
+
+    def _is_runnable(self):
+        """Returns the opposite of self.blocked."""
+        return not self.blocked
+
+    def _run(self):
+        """Do the actual append."""
+        self.append_to.append(self.value)
+        return defer.succeed(None)
+
+
+class FakeEventQueue(object):
+    def __init__(self):
+        """Initialize fake event queue instance."""
+        self.events = []
+        self._listeners = []
+
+    def subscribe(self, listener):
+        """Minimum to deal with listener."""
+        self._listeners.append(listener)
+
+    def push(self, name, *args, **kw):
+        """Push event onto queue."""
+        self.events.append((name, args, kw))
+
+
+class FakeActionQueue(object):
+    def __init__(self, event_queue):
+        self.event_queue = event_queue
+
+
+class CommandTests(TwistedTestCase):
+    """Isolated tests of the action queue command running infrastructure."""
+
+    @inlineCallbacks
+    def setUp(self):
+        """Set up mocked event queue and so on."""
+        yield TwistedTestCase.setUp(self)
+        self.event_queue = FakeEventQueue()
+        self.action_queue = ActionQueue(self.event_queue,
+                                        host="bogus", port=1234,
+                                        dns_srv=False)
+        self.request_queue = RequestQueue("TEST_QUEUE",
+                                          self.action_queue)
+
+    def test_simple_commands(self):
+        """Test command execution."""
+        out = []
+        cmd = AppendCommand(self.request_queue,
+                            append_to=out, value="a").start()
+        cmd = AppendCommand(self.request_queue,
+                            append_to=out, value="b").start()
+        self.request_queue.run()
+        self.request_queue.run()
+        self.assertEqual(["a", "b"], out)
+
+    def test_blocked_command_commutative(self):
+        """Test blocked command execution in a commutative queue."""
+        self.request_queue.commutative = True
+        out = []
+        cmds = [AppendCommand(self.request_queue, append_to=out, value=v) \
+                for v in ("a", "b", "c")]
+        for cmd in cmds:
+            cmd.start()
+        cmds[1].blocked = True
+        self.request_queue.run()
+        self.request_queue.run()
+        self.assertEqual(["a", "c"], out)
+        self.request_queue.run()
+        self.assertEqual(["a", "c"], out)
+        cmds[1].blocked = False
+        self.request_queue.run()
+        self.assertEqual(["a", "c", "b"], out)
+
+    def test_blocked_command_noncommutative(self):
+        """Test blocked command execution in a non-commutative queue."""
+        out = []
+        cmds = [AppendCommand(self.request_queue, append_to=out, value=v) \
+                for v in ("a", "b", "c")]
+        for cmd in cmds:
+            cmd.start()
+        cmds[1].blocked = True
+        self.request_queue.run()
+        self.request_queue.run()
+        self.assertEqual(["a"], out)
+        cmds[1].blocked = False
+        self.request_queue.run()
+        self.assertEqual(["a", "b"], out)
+        self.request_queue.run()
+        self.assertEqual(["a", "b", "c"], out)
+
+    def test_predicate_satisfaction(self):
+        """Test that waits really wait."""
+        fixture = [False]
+        cmd = WaitForCondition(self.request_queue,
+                               condition=lambda: fixture[0])
+        cmd.start()
+        d = self.request_queue.run()
+        d.addCallback(lambda _: fixture.append('x'))
+
+        self.request_queue.check_conditions()
+        self.assertEqual(1, len(fixture))
+        self.assertEqual(0, len(self.request_queue.waiting))
+
+        fixture[0] = True
+        self.request_queue.check_conditions()
+        self.assertEqual(2, len(fixture))
+        self.assertEqual(0, len(self.request_queue.waiting))

=== added file 'tests/syncdaemon/test_action_predicates.pyc'
Binary files tests/syncdaemon/test_action_predicates.pyc and tests/syncdaemon/test_action_predicates.pyc differ
=== added file 'tests/syncdaemon/test_action_queue.py'
--- tests/syncdaemon/test_action_queue.py	1970-01-01 00:00:00 +0000
+++ tests/syncdaemon/test_action_queue.py	2009-08-26 12:15:00 +0000
@@ -0,0 +1,161 @@
+# -*- coding: utf-8 -*-
+#
+# Author: John R. Lenton <john.lenton@canonical.com>
+#
+# Copyright 2009 Canonical Ltd.
+#
+# This program is free software: you can redistribute it and/or modify it
+# under the terms of the GNU General Public License version 3, as published
+# by the Free Software Foundation.
+#
+# This program is distributed in the hope that it will be useful, but
+# WITHOUT ANY WARRANTY; without even the implied warranties of
+# MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
+# PURPOSE.  See the GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License along
+# with this program.  If not, see <http://www.gnu.org/licenses/>.
+""" Tests for the action queue """
+from __future__ import with_statement
+
+import logging
+import shutil
+import unittest
+
+import dbus
+from dbus.mainloop.glib import DBusGMainLoop
+from twisted.internet import defer
+
+from contrib.testing.testcase import (
+    BaseTwistedTestCase,
+    MementoHandler,
+)
+
+from ubuntuone.syncdaemon.dbus_interface import DBusInterface
+from ubuntuone.syncdaemon.main import Main
+from ubuntuone.syncdaemon.action_queue import NoisyRequestQueue
+
+DBusInterface.test = True
+
+
+class AcionQueueTests(BaseTwistedTestCase):
+    """ Basic tests to check ActionQueue """
+
+    def setUp(self):
+        '''
+        prepare to run the test
+        '''
+        BaseTwistedTestCase.setUp(self)
+        self.root = self.mktemp('root')
+        self.shares = self.mktemp('shares')
+        self.data = self.mktemp('data')
+        self.handler = MementoHandler()
+        self.handler.setLevel(logging.ERROR)
+        self.main = Main(root_dir=self.root,
+                         shares_dir=self.shares,
+                         data_dir=self.data,
+                         host='localhost', port=0,
+                         dns_srv=False, ssl=False,
+                         disable_ssl_verify=True,
+                         realm='fake.realm',
+                         mark_interval=60,
+                         handshake_timeout=2,
+                         glib_loop=DBusGMainLoop(set_as_default=True))
+        logging.getLogger('ubuntuone.SyncDaemon').addHandler(self.handler)
+        dbus.service.BusName.__del__ = lambda _: None
+
+    def tearDown(self):
+        '''
+        cleanup after the test
+        '''
+        self.main.shutdown()
+        shutil.rmtree(self.root)
+        shutil.rmtree(self.shares)
+        shutil.rmtree(self.data)
+        for record in self.handler.records:
+            exc_info = getattr(record, 'exc_info', None)
+            if exc_info is not None:
+                raise exc_info[0], exc_info[1], exc_info[2]
+        BaseTwistedTestCase.tearDown(self)
+
+    @defer.inlineCallbacks
+    def test_content_queue_has_only_one_op_per_node(self):
+        '''
+        Check that the content queue uniquifies operations per node.
+        '''
+        yield self.main.start()
+        # totally fake, we don't care: the messages are only validated on run
+        self.main.action_q.download('foo', 'bar', 0, 0)
+        self.main.action_q.upload('foo', 'bar', 0, 0, 0, 0, 0)
+        self.assertEqual(len(self.main.action_q.content_queue.waiting), 1)
+
+    @defer.inlineCallbacks
+    def test_content_queue_has_only_one_op_per_node_even_counting_markers(self):
+        '''
+        Check that the content queue uniquifies operations per node
+        even when some of the operations were added using markers.
+        '''
+        yield self.main.start()
+        self.main.action_q.download('foo', 'bar', 0, 0)
+        self.main.action_q.uuid_map.set('foo', 'feh')
+        self.main.action_q.uuid_map.set('bar', 'bah')
+        self.main.action_q.upload('feh', 'bah', 0, 0, 0, 0, 0)
+        self.assertEqual(len(self.main.action_q.content_queue.waiting), 1)
+
+    @defer.inlineCallbacks
+    def test_aq_resolve_uuid_maybe(self):
+        '''
+        Check action_q.resolve_uuid_maybe does what it's supposed to
+        '''
+        yield self.main.start()
+        self.assertEqual(self.main.action_q.resolve_uuid_maybe('foo'), 'foo')
+        self.main.action_q.uuid_map.set('foo', 'feh')
+        self.assertEqual(self.main.action_q.resolve_uuid_maybe('foo'), 'feh')
+
+
+class TestNoisyRQ(unittest.TestCase):
+    '''
+    Tests for NoisyRequestQueue
+    '''
+
+    def test_noisy_rq_blurts_about_head(self):
+        '''
+        Test NRQ calls its callback when head is set
+        '''
+        rq = NoisyRequestQueue('name', None,
+                               lambda h, w:
+                                   setattr(self, 'result', (h, tuple(w))))
+        rq._head = 'blah'
+        self.assertEqual(self.result, ('blah', ()))
+
+    def test_noisy_rq_blurts_about_waiting(self):
+        '''
+        Test NRQ calls its callback when the waiting queue is altered.
+        '''
+        class BlackHole(object):
+            '''The universal tool.'''
+            __call__ = __getattr__ = lambda *_, **__: BlackHole()
+        class FakeCommand(object):
+            '''Yet another fake action queue command'''
+            def run(self):
+                '''run that just succeeds'''
+                return defer.succeed(None)
+            def is_runnable(self):
+                """returns True"""
+                return True
+        def cb(head, waiting):
+            '''NRQ testing callback'''
+            evts.append((head, tuple(waiting)))
+        evts = []
+        cmd = FakeCommand()
+        cmd2 = FakeCommand()
+        rq = NoisyRequestQueue('name', BlackHole(), cb)
+        rq.queue(cmd2)
+        rq.queue_top(cmd)
+        rq.run()
+        self.assertEqual(evts, [(None, ()),           # __init__
+                                (None, (cmd2,)),      # queue
+                                (None, (cmd, cmd2)),  # queue_top
+                                (cmd, (cmd2,)),       # run
+                                (None, (cmd2,)),      # done
+                                ])

=== added file 'tests/syncdaemon/test_action_queue.pyc'
Binary files tests/syncdaemon/test_action_queue.pyc and tests/syncdaemon/test_action_queue.pyc differ
=== modified file 'tests/syncdaemon/test_dbus.py'
--- tests/syncdaemon/test_dbus.py	2009-08-11 16:45:00 +0000
+++ tests/syncdaemon/test_dbus.py	2009-08-26 12:15:00 +0000
@@ -16,6 +16,8 @@
 # You should have received a copy of the GNU General Public License along
 # with this program.  If not, see <http://www.gnu.org/licenses/>.
 """ Tests for the DBUS interface """
+
+import inspect
 import os
 import unittest
 
@@ -28,6 +30,8 @@
     DBUS_IFACE_FS_NAME,
     DBUS_IFACE_SYNC_NAME,
     DBUS_IFACE_SHARES_NAME,
+    DBUS_IFACE_CONFIG_NAME,
+    EventListener,
 )
 from ubuntuone.syncdaemon.volume_manager import Share
 from ubuntuone.syncdaemon.tools import DBusClient
@@ -177,9 +181,14 @@
         data in the AQ
         """
         class FakeCommand(object):
+            """A fake command"""
             def __init__(self, share_id, node_id):
+                """create it"""
                 self.share_id = share_id
                 self.node_id = node_id
+            def is_runnable(self):
+                '''is runnable'''
+                return True
 
         # prepare the VM so it lies for us
         share_path = os.path.join(self.shares_dir, 'share')
@@ -234,6 +243,48 @@
                            error_handler=self.error_handler)
         return d
 
+    def test_contq_changed(self):
+        '''
+        Test the Status.ContentQueueChanged signal
+        '''
+        class FakeCommand(object):
+            '''
+            A fake command
+            '''
+            def __init__(self, share_id, node_id):
+                self.share_id = share_id
+                self.node_id = node_id
+            def is_runnable(self):
+                '''is runnable'''
+                return True
+            def run(self):
+                '''just succeed'''
+                return defer.succeed(None)
+        # prepare the VM so it lies for us
+        share_path = os.path.join(self.shares_dir, 'share')
+        self.main.vm.add_share(Share(share_path, share_id='share_id'))
+        a_path = os.path.join(share_path, "path_a")
+        self.fs_manager.create(a_path, "share_id")
+        self.fs_manager.set_node_id(a_path, "node_id")
+        # OK, testing time
+        d = defer.Deferred()
+        def content_queue_change_helepr(result):
+            '''
+            signal handler, test checker
+            '''
+            head_path = result['head']['path']
+            assert head_path == '' or head_path.endswith('/path_a')
+            assert result['head']['command'] == 'FakeCommand'
+            assert result.get('FakeCommand') in (None, {'size': '0',
+                                                        'count': '1'})
+            d.callback(None)
+        match = self.bus.add_signal_receiver(content_queue_change_helepr,
+                                             'ContentQueueChanged')
+        self.signal_receivers.add(match)
+        # inject the fake data
+        self.action_q.content_queue.queue(FakeCommand("share_id", "node_id"))
+        return d
+
     def test_current_downloads(self):
         """ Test Status.current_downloads with fake data in the AQ """
         share_path = os.path.join(self.shares_dir, 'share')
@@ -521,7 +572,7 @@
         d = defer.Deferred()
         def reply_handler(result):
             """ handle get_rootdir reply """
-            current_root = os.path.dirname(self.main.root_dir)
+            current_root = self.main.get_rootdir()
             self.assertEquals(current_root, str(result))
             d.callback(True)
         client.call_method('get_rootdir',
@@ -790,7 +841,7 @@
     def test_download_started(self):
         """ Test the DBus signals in Status """
         a_dir = os.path.join(self.root_dir, u'ñoño'.encode('utf-8'))
-        self.fs_manager.create(a_dir, "", is_dir=True)
+        self.fs_manager.create(a_dir, "", is_dir=False)
         self.fs_manager.set_node_id(a_dir, "node_id")
 
         d = defer.Deferred()
@@ -808,11 +859,11 @@
     def test_download_finished(self):
         """ Test the DBus signals in Status """
         a_dir = os.path.join(self.root_dir, u'ñoño'.encode('utf-8'))
-        self.fs_manager.create(a_dir, "", is_dir=True)
+        self.fs_manager.create(a_dir, "", is_dir=False)
         self.fs_manager.set_node_id(a_dir, "node_id")
 
         d = defer.Deferred()
-        def download_handler(path):
+        def download_handler(path, info):
             """ handler for DownloadFinished signal. """
             self.assertEquals(a_dir, path.encode('utf-8'))
             d.callback(True)
@@ -823,10 +874,49 @@
         self.main.event_q.push('AQ_DOWNLOAD_FINISHED', '', 'node_id', '')
         return d
 
+    def test_download_error(self):
+        """ Test the DBus signals in Status """
+        a_dir = os.path.join(self.root_dir, u'ñoño'.encode('utf-8'))
+        self.fs_manager.create(a_dir, "", is_dir=False)
+        self.fs_manager.set_node_id(a_dir, "node_id")
+
+        d = defer.Deferred()
+        def download_handler(path, info):
+            """ handler for DownloadFinished signal. """
+            self.assertEquals(a_dir, path.encode('utf-8'))
+            self.assertEquals('AN_ERROR', info['error'])
+            d.callback(True)
+
+        match = self.bus.add_signal_receiver(download_handler,
+                                     signal_name='DownloadFinished')
+        self.signal_receivers.add(match)
+        self.main.event_q.push('AQ_DOWNLOAD_ERROR',
+                               '', 'node_id', '', error='AN_ERROR')
+        return d
+
+    def test_download_cancelled(self):
+        """ Test the DBus signals in Status """
+        a_dir = os.path.join(self.root_dir, u'ñoño'.encode('utf-8'))
+        self.fs_manager.create(a_dir, "", is_dir=False)
+        self.fs_manager.set_node_id(a_dir, "node_id")
+
+        d = defer.Deferred()
+        def download_handler(path, info):
+            """ handler for DownloadFinished signal. """
+            self.assertEquals(a_dir, path.encode('utf-8'))
+            self.assertEquals('CANCELLED', info['error'])
+            d.callback(True)
+
+        match = self.bus.add_signal_receiver(download_handler,
+                                     signal_name='DownloadFinished')
+        self.signal_receivers.add(match)
+        self.main.event_q.push('AQ_DOWNLOAD_CANCELLED', '', 'node_id', 'hash')
+        return d
+
     def test_upload_started(self):
         """ Test the DBus signals in Status """
         a_dir = os.path.join(self.root_dir, u'ñoño'.encode('utf-8'))
-        self.fs_manager.create(a_dir, "", is_dir=True)
+        self.fs_manager.create(a_dir, "", is_dir=False)
         self.fs_manager.set_node_id(a_dir, "node_id")
 
         d = defer.Deferred()
@@ -844,11 +934,11 @@
     def test_upload_finished(self):
         """ Test the DBus signals in Status """
         a_dir = os.path.join(self.root_dir, u'ñoño'.encode('utf-8'))
-        self.fs_manager.create(a_dir, "", is_dir=True)
+        self.fs_manager.create(a_dir, "", is_dir=False)
         self.fs_manager.set_node_id(a_dir, "node_id")
 
         d = defer.Deferred()
-        def upload_handler(path):
+        def upload_handler(path, info):
             """ handler for UploadFinished signal. """
             self.assertEquals(a_dir, path.encode('utf-8'))
             d.callback(True)
@@ -859,6 +949,26 @@
         self.main.event_q.push('AQ_UPLOAD_FINISHED', '', 'node_id', '')
         return d
 
+    def test_upload_error(self):
+        """ Test the DBus signals in Status """
+        a_dir = os.path.join(self.root_dir, u'ñoño'.encode('utf-8'))
+        self.fs_manager.create(a_dir, "", is_dir=False)
+        self.fs_manager.set_node_id(a_dir, "node_id")
+
+        d = defer.Deferred()
+        def upload_handler(path, info):
+            """ handler for UploadFinished signal. """
+            self.assertEquals(a_dir, path.encode('utf-8'))
+            self.assertEquals('AN_ERROR', info['error'])
+            d.callback(True)
+
+        match = self.bus.add_signal_receiver(upload_handler,
+                                     signal_name='UploadFinished')
+        self.signal_receivers.add(match)
+        self.main.event_q.push('AQ_UPLOAD_ERROR',
+                               '', 'node_id', 'AN_ERROR', 'hash')
+        return d
+
     def test_status_changed(self):
         """ Test the DBus signals in Status """
         client = DBusClient(self.bus, '/status', DBUS_IFACE_STATUS_NAME)
@@ -901,8 +1011,17 @@
         a_path = os.path.join(share_path, "a_path")
         self.fs_manager.create(a_path, "share_id")
         self.fs_manager.set_node_id(a_path, "node_id")
-        event_names = sorted(event_queue.EVENTS.keys())
-        events_copy = event_queue.EVENTS.copy()
+        handled_events = {}
+        # filter only event we handle
+        for (name, kind, _, _) in \
+                                  inspect.classify_class_attrs(EventListener):
+            if kind == 'method' and name.startswith('handle_') \
+               and not name == 'handle_default':
+                key = name.split('handle_')[1]
+                handled_events[key] = event_queue.EVENTS[key]
+
+        event_names = sorted(handled_events.keys())
+        events_copy = handled_events.copy()
         d = defer.Deferred()
         def event_handler(event_dict):
             """ event handler that pop the received event from a list """
@@ -925,7 +1044,6 @@
                 return error
 
         d.addCallbacks(callback, errback)
-
         def cleanup(result):
             """ remove the signal receiver """
             self.event_q.subscribe(self.main.vm)
@@ -938,7 +1056,6 @@
         for event_name in event_names:
             args = event_queue.EVENTS[event_name]
             self.event_q.push(event_name, *args)
-
         return d
 
     def test_share_changed(self):
@@ -1077,6 +1194,108 @@
         return d
 
 
+class ConfigTests(DBusTwistedTestCase):
+    """ Basic tests to the Config object exposed via D-Bus"""
+
+    def get_client(self):
+        """returns a Config DBusClient"""
+        return DBusClient(self.bus, '/config', DBUS_IFACE_CONFIG_NAME)
+
+    def test_get_throttling_limits(self):
+        """test get_throttling_limits exposed method"""
+        client = self.get_client()
+        d = defer.Deferred()
+        aq = self.main.action_q
+        def reply_handler(result):
+            """ handle the reply """
+            self.assertEquals(aq.readLimit, result['download'])
+            self.assertEquals(aq.writeLimit, result['upload'])
+            self.assertEquals(100, result['download'])
+            self.assertEquals(200, result['upload'])
+            d.callback(True)
+        def reply_handler_None(result):
+            """ handle the reply """
+            self.assertEquals(-1, result['download'])
+            self.assertEquals(-1, result['upload'])
+            aq.readLimit = 100
+            aq.writeLimit = 200
+            client.call_method('get_throttling_limits',
+                               reply_handler=reply_handler,
+                               error_handler=self.error_handler)
+        client.call_method('get_throttling_limits',
+                           reply_handler=reply_handler_None,
+                           error_handler=self.error_handler)
+        return d
+
+
+    def test_set_throttling_limits(self):
+        """test set_throttling_limits exposed method"""
+        client = self.get_client()
+        d = defer.Deferred()
+        def reply_handler(_):
+            """ handle the reply """
+            aq = self.main.action_q
+            self.assertEquals(aq.readLimit, 100)
+            self.assertEquals(aq.writeLimit, 500)
+            d.callback(True)
+        client.call_method('set_throttling_limits', 100, 500,
+                           reply_handler=reply_handler,
+                           error_handler=self.error_handler)
+        return d
+
+    def test_enable_bandwidth_throttling(self):
+        """test enable_bandwidth_throttling exposed method"""
+        client = self.get_client()
+        d = defer.Deferred()
+        aq = self.main.action_q
+        aq.throttling = False
+        def reply_handler(_):
+            """ handle the reply """
+            self.assertTrue(aq.throttling)
+            d.callback(True)
+        client.call_method('enable_bandwidth_throttling',
+                           reply_handler=reply_handler,
+                           error_handler=self.error_handler)
+        return d
+
+    def test_disable_bandwidth_throttling(self):
+        """test disable_bandwidth_throttling exposed method"""
+        client = self.get_client()
+        d = defer.Deferred()
+        aq = self.main.action_q
+        aq.throttling = True
+        def reply_handler(_):
+            """ handle the reply """
+            self.assertFalse(aq.throttling)
+            d.callback(True)
+        client.call_method('disable_bandwidth_throttling',
+                           reply_handler=reply_handler,
+                           error_handler=self.error_handler)
+        return d
+
+    def test_bandwidth_throttling_enabled(self):
+        """test bandwidth_throttling_enabled exposed method"""
+        client = self.get_client()
+        d = defer.Deferred()
+        def reply_handler_enabled(result):
+            """ handle the reply """
+            self.assertEquals(1, result)
+            d.callback(True)
+
+        def reply_handler_disabled(result):
+            """ handle the reply """
+            self.assertEquals(0, result)
+            self.main.action_q.throttling = True
+            client.call_method('bandwidth_throttling_enabled',
+                               reply_handler=reply_handler_enabled,
+                               error_handler=self.error_handler)
+        client.call_method('bandwidth_throttling_enabled',
+                           reply_handler=reply_handler_disabled,
+                           error_handler=self.error_handler)
+        return d
+
+
+
 def test_suite():
     # pylint: disable-msg=C0111
     return unittest.TestLoader().loadTestsFromName(__name__)

=== added file 'tests/syncdaemon/test_dbus.pyc'
Binary files tests/syncdaemon/test_dbus.pyc and tests/syncdaemon/test_dbus.pyc differ
=== modified file 'tests/syncdaemon/test_eq_inotify.py'
--- tests/syncdaemon/test_eq_inotify.py	2009-07-16 17:00:00 +0000
+++ tests/syncdaemon/test_eq_inotify.py	2009-08-26 12:15:00 +0000
@@ -582,6 +582,36 @@
         os.rename(fromdir, todir)
         return self._deferred
 
+    def test_delete_inside_moving_directory(self):
+        '''Test to assure that the DELETE signal has the correct path.'''
+        # basedir
+        basedir = os.path.join(self.root_dir, "basedir")
+        os.mkdir(basedir)
+        self.fs.create(path=basedir, share_id='', is_dir=True)
+
+        # working stuff
+        dir1 = os.path.join(basedir, "inside_d")
+        dir2 = os.path.join(basedir, "new_d")
+        fromfile = os.path.join(dir1, "test_f")
+        tofile = os.path.join(dir2, "test_f")
+        os.mkdir(dir1)
+        open(fromfile, "w").close()
+
+        should_events = [
+            ("FS_DIR_MOVE", dir1, dir2),
+            ("FS_FILE_DELETE", tofile),
+        ]
+        self.eq.subscribe(DynamicHitMe(should_events, self))
+        self.eq.inotify_add_watch(self.root_dir)
+        self.eq.inotify_add_watch(basedir)
+        self.eq.inotify_add_watch(dir1)
+
+        # generate the event
+        os.rename(dir1, dir2)
+        os.remove(tofile)
+        return self._deferred
+
+
 class FreezeTests(BaseTwisted):
     '''Test the freeze mechanism.'''
 

=== added file 'tests/syncdaemon/test_eq_inotify.pyc'
Binary files tests/syncdaemon/test_eq_inotify.pyc and tests/syncdaemon/test_eq_inotify.pyc differ
=== added file 'tests/syncdaemon/test_eventqueue.pyc'
Binary files tests/syncdaemon/test_eventqueue.pyc and tests/syncdaemon/test_eventqueue.pyc differ
=== modified file 'tests/syncdaemon/test_fileshelf.py'
--- tests/syncdaemon/test_fileshelf.py	2009-07-27 16:00:00 +0000
+++ tests/syncdaemon/test_fileshelf.py	2009-08-26 12:15:00 +0000
@@ -16,6 +16,7 @@
 # with this program.  If not, see <http://www.gnu.org/licenses/>.
 
 """ Test file based persistent shelf """
+from __future__ import with_statement
 
 import os
 import hashlib
@@ -31,6 +32,9 @@
 from contrib.testing import testcase
 
 
+BROKEN_PICKLE = '\axb80\x02}q\x01(U\x01aU\x04testq\x02U\x01bU\x06brokenq\x03u.'
+
+
 class TestFileShelf(testcase.BaseTwistedTestCase):
     """ Test the FileShelf """
     fileshelf_class = FileShelf
@@ -128,6 +132,99 @@
         self.assertTrue(('foo', 'bar') and ('foo1', 'bar1') in \
                         [(k, v) for k, v in shelf.items()])
 
+    def test_broked_metadata_without_backup(self):
+        """test the shelf behavior when it hit a broken metadata file without
+        backup.
+        """
+        self.shelf['bad_file'] = {}
+        path = self.shelf.key_file('bad_file')
+        open(path, 'w').close()
+        self.assertRaises(KeyError, self.shelf.__getitem__, 'bad_file')
+
+        self.shelf['broken_pickle'] = {}
+        path = self.shelf.key_file('broken_pickle')
+        with open(path, 'w') as f:
+            f.write(BROKEN_PICKLE)
+        self.assertRaises(KeyError, self.shelf.__getitem__, 'broken_pickle')
+
+    def test_broked_metadata_with_backup(self):
+        """test that each time a metadata file is updated a .old is kept"""
+        self.shelf['bad_file'] = {'value':'old'}
+        path = self.shelf.key_file('bad_file')
+        self.assertFalse(os.path.exists(path+'.old'))
+        self.assertEquals({'value':'old'}, self.shelf['bad_file'])
+        # force the creation of the .old file
+        self.shelf['bad_file'] = {'value':'new'}
+        self.assertTrue(os.path.exists(path+'.old'))
+        # check that the new value is there
+        self.assertEquals({'value':'new'}, self.shelf['bad_file'])
+        # write the current md file fwith 0 bytes
+        open(path, 'w').close()
+        # test that the old value is retrieved
+        self.assertEquals({'value':'old'}, self.shelf['bad_file'])
+
+        self.shelf['broken_pickle'] = {'value':'old'}
+        path = self.shelf.key_file('broken_pickle')
+        # check that .old don't exist
+        self.assertFalse(os.path.exists(path+'.old'))
+        # force the creation of the .old file
+        self.shelf['broken_pickle'] = {'value':'new'}
+        # check that .old exists
+        self.assertTrue(os.path.exists(path+'.old'))
+        # check that the new value is there
+        self.assertEquals({'value':'new'}, self.shelf['broken_pickle'])
+        # write random bytes to the md file
+        with open(path, 'w') as f:
+            f.write(BROKEN_PICKLE)
+        # check that the old value is retrieved
+        self.assertEquals({'value':'old'}, self.shelf['broken_pickle'])
+
+    def test_keys_with_old_and_new(self):
+        """test keys() with .old and .new files around"""
+        self.shelf["foo"] = "bar"
+        self.shelf["foo1"] = "bar1"
+        open(self.shelf.key_file('foo')+'.old', 'w').close()
+        open(self.shelf.key_file('foo1')+'.old', 'w').close()
+        open(self.shelf.key_file('foo')+'.new', 'w').close()
+        open(self.shelf.key_file('foo1')+'.new', 'w').close()
+        self.assertEquals(set(['foo', 'foo1']), set(self.shelf.keys()))
+
+    def test_corrupted_backup(self):
+        """test getitem if also the .old file is corrupted"""
+        self.shelf["foo"] = "bar"
+        # create the .old backup
+        self.shelf["foo"] = "bar1"
+        # write 0 bytes to both
+        open(self.shelf.key_file('foo')+'.old', 'w').close()
+        open(self.shelf.key_file('foo'), 'w').close()
+        self.assertRaises(KeyError, self.shelf.__getitem__, 'foo')
+
+    def test_endless_borken_backups(self):
+        """test getitem  with a lot of files named .old.old.....old"""
+        self.shelf["foo"] = "bar"
+        path = self.shelf.key_file('foo')
+        open(self.shelf.key_file('foo'), 'w').close()
+        for _ in xrange(63):
+            open(path+'.old', 'w').close()
+            path=path+'.old'
+        self.assertRaises(KeyError, self.shelf.__getitem__, 'foo')
+
+    def test_delete_backups_too(self):
+        """test that delitem also deletes the .old/.new files left around"""
+        self.shelf["foo"] = "bar"
+        # create the .old backup
+        self.shelf["foo"] = "bar1"
+        path = self.shelf.key_file('foo')
+        # create a .new file (a hard reboot during the rename dance)
+        open(path+'.new', 'w').close()
+        # write 0 bytes to both
+        del self.shelf['foo']
+        self.assertFalse(os.path.exists(path))
+        self.assertFalse(os.path.exists(path+'.old'), 'there is a .old file!')
+        self.assertFalse(os.path.exists(path+'.new'), 'there is a .new file!')
+
+
+
 
 class CachedFileShelfTests(TestFileShelf):
     """TestFileShelf tests but using CachedFileShelf"""
@@ -147,6 +244,40 @@
         self.shelf['realkey']
         self.assertEquals(self.shelf.cache_hits, 1)
 
+    def test_broked_metadata_with_backup(self):
+        """overrides parent test as we have the value in the cache."""
+        self.shelf['bad_file'] = {'value':'old'}
+        path = self.shelf.key_file('bad_file')
+        self.assertFalse(os.path.exists(path+'.old'))
+        self.assertEquals({'value':'old'}, self.shelf['bad_file'])
+        # force the creation of the .old file
+        self.shelf['bad_file'] = {'value':'new'}
+        self.assertTrue(os.path.exists(path+'.old'))
+        # check that the new value is there
+        self.assertEquals({'value':'new'}, self.shelf['bad_file'])
+        # write the current md file fwith 0 bytes
+        open(path, 'w').close()
+        # HERE IS THE DIFFERENCE with the parent tests
+        # test that the new value is retrieved from the cache!
+        self.assertEquals({'value':'new'}, self.shelf['bad_file'])
+
+        self.shelf['broken_pickle'] = {'value':'old'}
+        path = self.shelf.key_file('broken_pickle')
+        # check that .old don't exist
+        self.assertFalse(os.path.exists(path+'.old'))
+        # force the creation of the .old file
+        self.shelf['broken_pickle'] = {'value':'new'}
+        # check that .old exists
+        self.assertTrue(os.path.exists(path+'.old'))
+        # check that the new value is there
+        self.assertEquals({'value':'new'}, self.shelf['broken_pickle'])
+        # write random bytes to the md file
+        with open(path, 'w') as f:
+            f.write(BROKEN_PICKLE)
+        # HERE IS THE DIFFERENCE with the parent tests
+        # test that the new value is retrieved from the cache!
+        self.assertEquals({'value':'new'}, self.shelf['broken_pickle'])
+
 
 class LRUCacheTests(unittest.TestCase):
     '''Test the LRUCache class'''

=== added file 'tests/syncdaemon/test_fileshelf.pyc'
Binary files tests/syncdaemon/test_fileshelf.pyc and tests/syncdaemon/test_fileshelf.pyc differ
=== modified file 'tests/syncdaemon/test_fsm.py'
--- tests/syncdaemon/test_fsm.py	2009-08-11 16:45:00 +0000
+++ tests/syncdaemon/test_fsm.py	2009-08-26 12:15:00 +0000
@@ -321,6 +321,399 @@
         # pylint: disable-msg=W0212
         self.assertEqual(1, len(newfsm._idx_node_id))
 
+    def test_fresh_metadata_broken_pickle_without_backup(self):
+        '''Initing with latest metadata, but with broked value in the shelf'''
+        md_version = open(os.path.join(self.fsmdir, "metadata_version")).read()
+        self.assertEqual(md_version, "3")
+        path = os.path.join(self.share.path, 'path')
+        path1 = os.path.join(self.share.path, 'path1')
+        path2 = os.path.join(self.share.path, 'path2')
+        for p in [path, path1, path2]:
+            open(p, "w").close()
+        mdid = self.fsm.create(path, "share", node_id='uuid')
+        mdid1 = self.fsm.create(path1, "share", node_id='uuid1')
+        mdid2 = self.fsm.create(path2, "share", node_id='uuid2')
+
+        # break the node on purpose
+        with open(self.fsm.fs.key_file(mdid1), 'w') as f:
+            f.write(os.urandom(100))
+            os.fsync(f.fileno())
+
+        #break the node by creating a 0 byte pickle
+        with open(self.fsm.fs.key_file(mdid2), 'w') as f:
+            os.fsync(f.fileno())
+
+        # start up again, and check
+        newfsm = FileSystemManager(self.fsmdir, self.fsm.vm)
+        version_file = os.path.join(self.fsmdir, "metadata_version")
+        md_version = open(version_file).read()
+        self.assertEqual(md_version, "3")
+        self.assertTrue(newfsm.get_by_mdid(mdid) is not None)
+        self.assertRaises(KeyError, newfsm.get_by_mdid, mdid1)
+        self.assertRaises(KeyError, newfsm.get_by_mdid, mdid2)
+
+    def test_old_metadata_None_broken_pickle_wihtout_backup(self):
+        '''Faking an old metadata situation, in None with broken metadata
+        values.
+        '''
+        # create some stuff
+        path = os.path.join(self.share.path, 'path')
+        path1 = os.path.join(self.share.path, 'path1')
+        path2 = os.path.join(self.share.path, 'path2')
+        for p in [path, path1, path2]:
+            open(p, "w").close()
+        mdid = self.fsm.create(path, "share", node_id='uuid')
+        mdid1 = self.fsm.create(path1, "share", node_id='uuid1')
+        mdid2 = self.fsm.create(path2, "share", node_id='uuid2')
+
+        # break the node on purpose
+        with open(self.fsm.fs.key_file(mdid1), 'w') as f:
+            f.write(os.urandom(100))
+            os.fsync(f.fileno())
+
+        #break the node by creating a 0 byte pickle
+        with open(self.fsm.fs.key_file(mdid2), 'w') as f:
+            os.fsync(f.fileno())
+
+        # delete the version that should have left the previous fsm
+        version_file = os.path.join(self.fsmdir, "metadata_version")
+        os.remove(version_file)
+
+        # start up again, and check
+        newfsm = FileSystemManager(self.fsmdir, self.fsm.vm)
+        md_version = open(version_file).read()
+        self.assertEqual(md_version, "3")
+        self.assertTrue(newfsm.get_by_mdid(mdid) is not None)
+        self.assertRaises(KeyError, newfsm.get_by_mdid, mdid1)
+        self.assertRaises(KeyError, newfsm.get_by_mdid, mdid2)
+
+    def test_old_metadata_1_broken_pickle_without_backup(self):
+        '''Faking an old metadata situation, in v1 with broken metadata values.
+        '''
+        # create some stuff
+        path = os.path.join(self.share.path, 'path')
+        path1 = os.path.join(self.share.path, 'path1')
+        path2 = os.path.join(self.share.path, 'path2')
+        mdid = self.fsm.create(path, "share", node_id='uuid')
+        mdid1 = self.fsm.create(path1, "share", node_id='uuid1')
+        mdid2 = self.fsm.create(path2, "share", node_id='uuid2')
+
+        # break the node on purpose
+        real_mdobj = self.fsm.fs[mdid]
+        real_mdobj["path"] = unicode(real_mdobj["path"])
+        real_mdobj["local_hash"] = None
+        real_mdobj["server_hash"] = None
+        self.fsm.fs[mdid] = real_mdobj
+
+        # break the second node on purpose but with an invalid pickle
+        with open(self.fsm.fs.key_file(mdid1), 'w') as f:
+            f.write(os.urandom(100))
+            os.fsync(f.fileno())
+        #break the third node by creating a 0 byte pickle
+        with open(self.fsm.fs.key_file(mdid2), 'w') as f:
+            os.fsync(f.fileno())
+
+        # put the version file in 1
+        version_file = os.path.join(self.fsmdir, "metadata_version")
+        with open(version_file, "w") as fh:
+            fh.write("1")
+
+        # start up again, and check
+        newfsm = FileSystemManager(self.fsmdir, self.fsm.vm)
+        md_version = open(version_file).read()
+        self.assertEqual(md_version, "3")
+        newmdobj = newfsm.get_by_path(path)
+        self.assertEqual(newmdobj.mdid, mdid)
+        self.assertEqual(newmdobj.local_hash, "")
+        self.assertEqual(newmdobj.server_hash, "")
+        self.assertTrue(isinstance(newmdobj.path, str))
+        self.assertRaises(KeyError, newfsm.get_by_mdid, mdid1)
+        self.assertRaises(KeyError, newfsm.get_by_mdid, mdid2)
+        # pylint: disable-msg=W0212
+        self.assertEqual(1, len(newfsm._idx_node_id))
+
+    def test_old_metadata_2_broken_pickle_without_backup(self):
+        '''Faking an old metadata situation, in v2 with broken metadata values.
+        '''
+        # create some stuff
+        path = os.path.join(self.share.path, 'path')
+        path1 = os.path.join(self.share.path, 'path1')
+        path2 = os.path.join(self.share.path, 'path2')
+        for p in [path, path1, path2]:
+            open(p, "w").close()
+        mdid = self.fsm.create(path, "share", node_id='uuid')
+        mdid1 = self.fsm.create(path1, "share", node_id='uuid1')
+        mdid2 = self.fsm.create(path2, "share", node_id='uuid2')
+
+        # break the node on purpose, with hashes in None
+        real_mdobj = self.fsm.fs[mdid]
+        real_mdobj["local_hash"] = None
+        real_mdobj["server_hash"] = None
+        self.fsm.fs[mdid] = real_mdobj
+
+        # put the version file in 1
+        version_file = os.path.join(self.fsmdir, "metadata_version")
+        with open(version_file, "w") as fh:
+            fh.write("2")
+        # break the second node on purpose but with an invalid pickle
+        with open(self.fsm.fs.key_file(mdid1), 'w') as f:
+            f.write(os.urandom(100))
+            os.fsync(f.fileno())
+        #break the third node by creating a 0 byte pickle
+        with open(self.fsm.fs.key_file(mdid2), 'w') as f:
+            os.fsync(f.fileno())
+        # start up again, and check
+        newfsm = FileSystemManager(self.fsmdir, self.fsm.vm)
+        md_version = open(version_file).read()
+        self.assertEqual(md_version, "3")
+        newmdobj = newfsm.get_by_path(path)
+        self.assertEqual(newmdobj.mdid, mdid)
+        self.assertEqual(newmdobj.local_hash, "")
+        self.assertEqual(newmdobj.server_hash, "")
+        self.assertTrue(isinstance(newmdobj.path, str))
+        self.assertRaises(KeyError, newfsm.get_by_mdid, mdid1)
+        self.assertRaises(KeyError, newfsm.get_by_mdid, mdid2)
+        # pylint: disable-msg=W0212
+        self.assertEqual(1, len(newfsm._idx_node_id))
+
+    def test_fresh_metadata_broken_pickle_with_backup(self):
+        '''Initing with latest metadata, but with broked value in the shelf'''
+        md_version = open(os.path.join(self.fsmdir, "metadata_version")).read()
+        self.assertEqual(md_version, "3")
+        path = os.path.join(self.share.path, 'path')
+        path1 = os.path.join(self.share.path, 'path1')
+        path2 = os.path.join(self.share.path, 'path2')
+        for p in [path, path1, path2]:
+            open(p, "w").close()
+        mdid = self.fsm.create(path, "share")
+        self.fsm.set_node_id(path, "uuid")
+        mdid1 = self.fsm.create(path1, "share")
+        self.fsm.set_node_id(path1, "uuid1")
+        mdid2 = self.fsm.create(path2, "share")
+        self.fsm.set_node_id(path2, "uuid2")
+
+        # break the node on purpose
+        with open(self.fsm.fs.key_file(mdid1), 'w') as f:
+            f.write(os.urandom(100))
+            os.fsync(f.fileno())
+
+        #break the node by creating a 0 byte pickle
+        with open(self.fsm.fs.key_file(mdid2), 'w') as f:
+            os.fsync(f.fileno())
+
+        # start up again, and check
+        newfsm = FileSystemManager(self.fsmdir, self.fsm.vm)
+        version_file = os.path.join(self.fsmdir, "metadata_version")
+        md_version = open(version_file).read()
+        self.assertEqual(md_version, "3")
+        self.assertTrue(newfsm.get_by_mdid(mdid) is not None)
+        # pylint: disable-msg=W0212
+        self.assertEqual(1, len(newfsm._idx_node_id))
+        self.assertEqual(3, len(newfsm._idx_path))
+        # check that the broken mdid's load the old metadata
+        self.assertEquals(None, newfsm.get_by_mdid(mdid1).node_id)
+        self.assertEquals(None, newfsm.get_by_mdid(mdid2).node_id)
+
+    def test_old_metadata_None_broken_pickle_with_backup(self):
+        '''Faking an old metadata situation, in None with broken metadata
+        values.
+        '''
+        # create some stuff
+        path = os.path.join(self.share.path, 'path')
+        path1 = os.path.join(self.share.path, 'path1')
+        path2 = os.path.join(self.share.path, 'path2')
+        for p in [path, path1, path2]:
+            open(p, "w").close()
+        mdid = self.fsm.create(path, "share")
+        self.fsm.set_node_id(path, "uuid")
+        mdid1 = self.fsm.create(path1, "share")
+        self.fsm.set_node_id(path1, "uuid1")
+        mdid2 = self.fsm.create(path2, "share")
+        self.fsm.set_node_id(path2, "uuid2")
+
+        # break the node on purpose
+        with open(self.fsm.fs.key_file(mdid1), 'w') as f:
+            f.write(os.urandom(100))
+            os.fsync(f.fileno())
+
+        #break the node by creating a 0 byte pickle
+        with open(self.fsm.fs.key_file(mdid2), 'w') as f:
+            os.fsync(f.fileno())
+
+        # delete the version that should have left the previous fsm
+        version_file = os.path.join(self.fsmdir, "metadata_version")
+        os.remove(version_file)
+
+        # start up again, and check
+        newfsm = FileSystemManager(self.fsmdir, self.fsm.vm)
+        md_version = open(version_file).read()
+        self.assertEqual(md_version, "3")
+        self.assertTrue(newfsm.get_by_mdid(mdid) is not None)
+        # pylint: disable-msg=W0212
+        self.assertEqual(1, len(newfsm._idx_node_id))
+        self.assertEqual(3, len(newfsm._idx_path))
+        # check that the broken mdid's load the old metadata
+        self.assertEquals(None, newfsm.get_by_mdid(mdid1).node_id)
+        self.assertEquals(None, newfsm.get_by_mdid(mdid2).node_id)
+
+    def test_old_metadata_1_broken_pickle_with_backup(self):
+        '''Faking an old metadata situation, in v1 with broken metadata values.
+        '''
+        # create some stuff
+        path = os.path.join(self.share.path, 'path')
+        path1 = os.path.join(self.share.path, 'path1')
+        path2 = os.path.join(self.share.path, 'path2')
+        mdid = self.fsm.create(path, "share")
+        self.fsm.set_node_id(path, "uuid")
+        mdid1 = self.fsm.create(path1, "share")
+        self.fsm.set_node_id(path1, "uuid1")
+        mdid2 = self.fsm.create(path2, "share")
+        self.fsm.set_node_id(path2, "uuid2")
+
+        # break the node on purpose
+        real_mdobj = self.fsm.fs[mdid]
+        real_mdobj["path"] = unicode(real_mdobj["path"])
+        real_mdobj["local_hash"] = None
+        real_mdobj["server_hash"] = None
+        self.fsm.fs[mdid] = real_mdobj
+
+        # break the second node on purpose but with an invalid pickle
+        with open(self.fsm.fs.key_file(mdid1), 'w') as f:
+            f.write(os.urandom(100))
+            os.fsync(f.fileno())
+        #break the third node by creating a 0 byte pickle
+        with open(self.fsm.fs.key_file(mdid2), 'w') as f:
+            os.fsync(f.fileno())
+
+        # put the version file in 1
+        version_file = os.path.join(self.fsmdir, "metadata_version")
+        with open(version_file, "w") as fh:
+            fh.write("1")
+
+        # start up again, and check
+        newfsm = FileSystemManager(self.fsmdir, self.fsm.vm)
+        md_version = open(version_file).read()
+        self.assertEqual(md_version, "3")
+        newmdobj = newfsm.get_by_path(path)
+        self.assertEqual(newmdobj.mdid, mdid)
+        self.assertEqual(newmdobj.local_hash, "")
+        self.assertEqual(newmdobj.server_hash, "")
+        self.assertTrue(isinstance(newmdobj.path, str))
+        # pylint: disable-msg=W0212
+        self.assertEqual(1, len(newfsm._idx_node_id))
+        self.assertEqual(3, len(newfsm._idx_path))
+        # check that the broken mdid's load the old metadata
+        self.assertEquals(None, newfsm.get_by_mdid(mdid1).node_id)
+        self.assertEquals(None, newfsm.get_by_mdid(mdid2).node_id)
+
+    def test_old_metadata_2_broken_pickle_with_backup(self):
+        '''Faking an old metadata situation, in v2 with broken metadata values.
+        '''
+        # create some stuff
+        path = os.path.join(self.share.path, 'path')
+        path1 = os.path.join(self.share.path, 'path1')
+        path2 = os.path.join(self.share.path, 'path2')
+        for p in [path, path1, path2]:
+            open(p, "w").close()
+        mdid = self.fsm.create(path, "share")
+        self.fsm.set_node_id(path, "uuid")
+        self.assertTrue(os.path.exists(self.fsm.fs.key_file(mdid+'.old')))
+        mdid1 = self.fsm.create(path1, "share")
+        self.fsm.set_node_id(path1, "uuid1")
+        self.assertTrue(os.path.exists(self.fsm.fs.key_file(mdid1+'.old')))
+        mdid2 = self.fsm.create(path2, "share")
+        self.fsm.set_node_id(path2, "uuid2")
+        self.assertTrue(os.path.exists(self.fsm.fs.key_file(mdid2+'.old')))
+
+        # break the node on purpose, with hashes in None
+        real_mdobj = self.fsm.fs[mdid]
+        real_mdobj["local_hash"] = None
+        real_mdobj["server_hash"] = None
+        self.fsm.fs[mdid] = real_mdobj
+
+        # put the version file in 1
+        version_file = os.path.join(self.fsmdir, "metadata_version")
+        with open(version_file, "w") as fh:
+            fh.write("2")
+        # break the second node on purpose but with an invalid pickle
+        with open(self.fsm.fs.key_file(mdid1), 'w') as f:
+            f.write(os.urandom(100))
+            os.fsync(f.fileno())
+        #break the third node by creating a 0 byte pickle
+        with open(self.fsm.fs.key_file(mdid2), 'w') as f:
+            os.fsync(f.fileno())
+        # start up again, and check
+        newfsm = FileSystemManager(self.fsmdir, self.fsm.vm)
+        md_version = open(version_file).read()
+        self.assertEqual(md_version, "3")
+        newmdobj = newfsm.get_by_path(path)
+        self.assertEqual(newmdobj.mdid, mdid)
+        self.assertEqual(newmdobj.local_hash, "")
+        self.assertEqual(newmdobj.server_hash, "")
+        self.assertTrue(isinstance(newmdobj.path, str))
+        # pylint: disable-msg=W0212
+        self.assertEqual(1, len(newfsm._idx_node_id))
+        self.assertEqual(3, len(newfsm._idx_path))
+        # check that the broken mdid's load the old metadata
+        self.assertEquals(None, newfsm.get_by_mdid(mdid1).node_id)
+        self.assertEquals(None, newfsm.get_by_mdid(mdid2).node_id)
+
+    def test_broken_metadata_while_running(self):
+        """test fsm.fs with broken metadata while running"""
+        # create some stuff
+        path = os.path.join(self.share.path, 'path')
+        path1 = os.path.join(self.share.path, 'path1')
+        path2 = os.path.join(self.share.path, 'path2')
+        for p in [path, path1, path2]:
+            open(p, "w").close()
+        mdid = self.fsm.create(path, "share")
+        self.fsm.set_node_id(path, "uuid")
+        self.assertTrue(os.path.exists(self.fsm.fs.key_file(mdid+'.old')))
+        mdid1 = self.fsm.create(path1, "share")
+        self.fsm.set_node_id(path1, "uuid1")
+        self.assertTrue(os.path.exists(self.fsm.fs.key_file(mdid1+'.old')))
+        mdid2 = self.fsm.create(path2, "share")
+        self.fsm.set_node_id(path2, "uuid2")
+        self.assertTrue(os.path.exists(self.fsm.fs.key_file(mdid2+'.old')))
+
+        # break the second node on purpose but with an invalid pickle
+        with open(self.fsm.fs.key_file(mdid1), 'w') as f:
+            f.write(os.urandom(100))
+            os.fsync(f.fileno())
+        #break the third node by creating a 0 byte pickle
+        with open(self.fsm.fs.key_file(mdid2), 'w') as f:
+            os.fsync(f.fileno())
+
+        # create a new fsm to avoid hitting the cache
+        fsm = FileSystemManager(self.fsmdir, self.fsm.vm)
+        # check
+        # pylint: disable-msg=W0212
+        self.assertEqual(1, len(fsm._idx_node_id))
+        self.assertEqual(3, len(fsm._idx_path))
+        # check that the broken mdid's load the old metadata
+        self.assertEquals(None, fsm.get_by_mdid(mdid1).node_id)
+        self.assertEquals(None, fsm.get_by_mdid(mdid2).node_id)
+        # now, set the ndoe_id, change another value to get the backup
+        # with node_id, and check if the new back contains the node_id
+        fsm.set_node_id(path1, "uuid1")
+        fsm.set_node_id(path2, "uuid2")
+        self.assertTrue(os.path.exists(fsm.fs.key_file(mdid1+'.old')))
+        self.assertTrue(os.path.exists(fsm.fs.key_file(mdid2+'.old')))
+        fsm.refresh_stat(path1)
+        fsm.refresh_stat(path2)
+        self.assertTrue(os.path.exists(self.fsm.fs.key_file(mdid1+'.old')))
+        self.assertTrue(os.path.exists(self.fsm.fs.key_file(mdid2+'.old')))
+        # break the second node on purpose but with an invalid pickle
+        with open(self.fsm.fs.key_file(mdid1), 'w') as f:
+            f.write(os.urandom(100))
+            os.fsync(f.fileno())
+        #break the third node by creating a 0 byte pickle
+        with open(self.fsm.fs.key_file(mdid2), 'w') as f:
+            os.fsync(f.fileno())
+        # create a new fsm to avoid hitting the cache
+        fsm = FileSystemManager(self.fsmdir, self.fsm.vm)
+        self.assertEquals('uuid1', fsm.get_by_mdid(mdid1).node_id)
+        self.assertEquals('uuid2', fsm.get_by_mdid(mdid2).node_id)
 
 
 class GetSetTests(FSMTestCase):

=== added file 'tests/syncdaemon/test_fsm.pyc'
Binary files tests/syncdaemon/test_fsm.pyc and tests/syncdaemon/test_fsm.pyc differ
=== modified file 'tests/syncdaemon/test_hashqueue.py'
--- tests/syncdaemon/test_hashqueue.py	2009-07-16 17:00:00 +0000
+++ tests/syncdaemon/test_hashqueue.py	2009-08-26 12:15:00 +0000
@@ -72,8 +72,7 @@
         # "I see dead threads"
         self.assertFalse(hasher.isAlive())
 
-
-    def test_called_back(self):
+    def test_called_back_ok(self):
         '''Tests that the hasher produces correct info.'''
         # create the hasher
         mark = object()
@@ -92,12 +91,13 @@
         testfile = os.path.join(self.test_dir, "testfile")
         with open(testfile, "w") as fh:
             fh.write("foobar")
-        queue.put(testfile)
+        queue.put((testfile, "mdid"))
 
         def check_info(args):
             """check the info pushed by the hasher"""
             # pylint: disable-msg=W0612
             event, path, hash, crc, size, stat = args
+            self.assertEqual(event, "HQ_HASH_NEW")
             # calculate what we should receive
             realh = content_hash_factory()
             realh.hash_object.update("foobar")
@@ -113,6 +113,35 @@
         # release the processor and check
         return d
 
+    def test_called_back_error(self):
+        '''Tests that the hasher signals error when no file.'''
+        # create the hasher
+        mark = object()
+        queue = hash_queue.UniqueQueue()
+        d = defer.Deferred()
+        class Helper(object):
+            '''helper class'''
+            def push(self, *args):
+                '''callback'''
+                d.callback(args)
+        receiver = Helper()
+        hasher = hash_queue._Hasher(queue, mark, receiver)
+        hasher.start()
+
+        # send what to hash
+        queue.put(("not_to_be_found", "foo"))
+
+        def check_info(args):
+            """check the info pushed by the hasher"""
+            event, mdid = args
+            self.assertEqual(event, "HQ_HASH_ERROR")
+            self.assertEqual(mdid, "foo")
+
+
+        d.addCallback(check_info)
+        # release the processor and check
+        return d
+
     def test_order(self):
         '''The hasher should return in order.'''
         # calculate what we should receive
@@ -153,7 +182,7 @@
         # send what to hash
         for i in range(10):
             tfile = os.path.join(self.test_dir, "tfile"+str(i))
-            queue.put(tfile)
+            queue.put((tfile, "mdid"))
         return d
 
     def test_large_content(self):
@@ -189,7 +218,7 @@
         # send what to hash
         with open(testfile, "w") as fh:
             fh.write(testinfo)
-        queue.put(testfile)
+        queue.put((testfile, "mdid"))
         return d
 
 
@@ -211,7 +240,7 @@
                       self._testMethodName)
         testcase.BaseTwistedTestCase.tearDown(self)
 
-    def test_called_back(self):
+    def test_called_back_ok(self):
         '''Tests that the hasher produces correct info.'''
         # create the hasher
         d = defer.Deferred()
@@ -228,12 +257,13 @@
         testfile = os.path.join(self.test_dir, "testfile")
         with open(testfile, "w") as fh:
             fh.write("foobar")
-        hq.insert(testfile)
+        hq.insert(testfile, "mdid")
 
         def check_info(args):
             """check the info pushed by the hasher"""
             # pylint: disable-msg=W0612
             event, path, hash, crc, size, stat = args
+            self.assertEqual(event, "HQ_HASH_NEW")
             # calculate what we should receive
             realh = content_hash_factory()
             realh.hash_object.update("foobar")
@@ -248,6 +278,31 @@
         d.addCallback(check_info)
         return d
 
+    def test_called_back_error(self):
+        '''Tests that the hasher generates an error when no file.'''
+        # create the hasher
+        d = defer.Deferred()
+        class Helper(object):
+            '''helper class'''
+            def push(self, *args):
+                '''callback'''
+                d.callback(args)
+        receiver = Helper()
+        hq = hash_queue.HashQueue(receiver)
+        self.addCleanup(hq.shutdown)
+
+        # send what to hash
+        hq.insert("not_to_be_found", "foo")
+
+        def check_info(args):
+            """check the info pushed by the hasher"""
+            event, mdid = args
+            self.assertEqual(event, "HQ_HASH_ERROR")
+            self.assertEqual(mdid, "foo")
+
+        d.addCallback(check_info)
+        return d
+
     def test_order(self):
         '''The hasher should return in order.'''
         # calculate what we should receive
@@ -284,7 +339,7 @@
         # send what to hash
         for i in range(10):
             tfile = os.path.join(self.test_dir, "tfile"+str(i))
-            hq.insert(tfile)
+            hq.insert(tfile, "mdid")
         return d
 
     def test_unique(self):
@@ -335,8 +390,8 @@
         # send to hash twice
         for i in range(10):
             tfile = os.path.join(self.test_dir, "tfile"+str(i))
-            hq.insert(tfile)
-            hq.insert(tfile)
+            hq.insert(tfile, "mdid")
+            hq.insert(tfile, "mdid")
         # start the hasher
         self.log.debug('Hasher started (forced)')
         hq.hasher.start()
@@ -344,7 +399,7 @@
         # the hasher is running
         for i in range(9, 10):
             tfile = os.path.join(self.test_dir, "tfile"+str(i))
-            hq.insert(tfile)
+            hq.insert(tfile, "mdid")
         return d
 
     def test_interrupt_current(self):
@@ -380,9 +435,9 @@
 
         # read in small chunks, so we have more iterations
         hq.hasher.chunk_size = 2**8
-        hq.insert(testfile)
+        hq.insert(testfile, "mdid")
         # insert it again, to cancel the first one
-        reactor.callLater(0.1, hq.insert, testfile)
+        reactor.callLater(0.1, hq.insert, testfile, "mdid")
         return d
     # timeout is used by trial, pylint: disable-msg=W0612
     test_interrupt_current.timeout = 5
@@ -396,7 +451,7 @@
         receiver = Helper()
         hq = hash_queue.HashQueue(receiver)
         hq.shutdown()
-        self.assertRaises(RuntimeError, hq.insert, 'foo')
+        self.assertRaises(RuntimeError, hq.insert, 'foo', "mdid")
 
     def test_shutdown_while_hashing(self):
         """Test that the HashQueue is shutdown ASAP while it's hashing."""
@@ -419,7 +474,7 @@
         self.addCleanup(hq.shutdown)
         # read in small chunks, so we have more iterations
         hq.hasher.chunk_size = 2**10
-        hq.insert(testfile)
+        hq.insert(testfile, "mdid")
         time.sleep(0.1)
         hq.shutdown()
         # block until the hash is stopped and the queue is empty
@@ -439,7 +494,7 @@
         receiver = Helper()
         hq = hash_queue.HashQueue(receiver)
         hq.shutdown()
-        self.assertRaises(RuntimeError, hq.insert, '/foo/bar')
+        self.assertRaises(RuntimeError, hq.insert, '/foo/bar', "mdid")
 
 
 class UniqueQueueTests(TwistedTestCase):
@@ -448,17 +503,17 @@
     def test_unique_elements(self):
         """Test that the queue actually holds unique elements."""
         queue = hash_queue.UniqueQueue()
-        queue.put('item1')
-        queue.put('item1')
+        queue.put(('item1', "mdid"))
+        queue.put(('item1', "mdid"))
         self.assertEquals(1, queue.qsize())
         self.assertEquals(1, len(queue._set))
         queue.get()
         self.assertEquals(0, queue.qsize())
         self.assertEquals(0, len(queue._set))
-        queue.put('item1')
-        queue.put('item2')
-        queue.put('item1')
-        queue.put('item2')
+        queue.put(('item1', "mdid"))
+        queue.put(('item2', "mdid"))
+        queue.put(('item1', "mdid"))
+        queue.put(('item2', "mdid"))
         self.assertEquals(2, queue.qsize())
         self.assertEquals(2, len(queue._set))
         queue.get()
@@ -469,14 +524,14 @@
     def test_clear(self):
         '''test clear method'''
         queue = hash_queue.UniqueQueue()
-        queue.put('item1')
-        queue.put('item2')
+        queue.put(('item1', "mdid"))
+        queue.put(('item2', "mdid"))
         self.assertEquals(2, queue.qsize())
         # check that queue.clear actually clear the queue
         queue.clear()
         self.assertEquals(0, queue.qsize())
-        queue.put('item3')
-        queue.put('item4')
+        queue.put(('item3', "mdid"))
+        queue.put(('item4', "mdid"))
         queue.get()
         self.assertEquals(2, queue.unfinished_tasks)
         self.assertEquals(1, queue.qsize())
@@ -502,7 +557,7 @@
         d.addCallback(check)
         t = threading.Thread(target=consumer, args=(queue, d))
         t.setDaemon(True)
-        queue.put('item1')
+        queue.put(('item1', "mdid"))
         t.start()
         reactor.callLater(0.1, queue.clear)
         return d

=== added file 'tests/syncdaemon/test_hashqueue.pyc'
Binary files tests/syncdaemon/test_hashqueue.pyc and tests/syncdaemon/test_hashqueue.pyc differ
=== added file 'tests/syncdaemon/test_localrescan.pyc'
Binary files tests/syncdaemon/test_localrescan.pyc and tests/syncdaemon/test_localrescan.pyc differ
=== added file 'tests/syncdaemon/test_logger.py'
--- tests/syncdaemon/test_logger.py	1970-01-01 00:00:00 +0000
+++ tests/syncdaemon/test_logger.py	2009-08-26 12:15:00 +0000
@@ -0,0 +1,212 @@
+# -*- coding: utf-8 -*-
+#
+# Author: Guillermo Gonzalez <guillermo.gonzalez@canonical.com>
+#
+# Copyright 2009 Canonical Ltd.
+#
+# This program is free software: you can redistribute it and/or modify it
+# under the terms of the GNU General Public License version 3, as published
+# by the Free Software Foundation.
+#
+# This program is distributed in the hope that it will be useful, but
+# WITHOUT ANY WARRANTY; without even the implied warranties of
+# MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
+# PURPOSE.  See the GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License along
+# with this program.  If not, see <http://www.gnu.org/licenses/>.
+""" Tests for logger utils """
+from __future__ import with_statement
+
+import logging
+import unittest
+from contrib.testing.testcase import MementoHandler
+from ubuntuone.syncdaemon.logger import (
+    DebugCapture,
+    NOTE,
+    TRACE,
+)
+
+
+class DebugCaptureTest(unittest.TestCase):
+    """Tests for DebugCapture context manager."""
+
+    def setUp(self):
+        """Setup the logger and the handler"""
+        self.handler = MementoHandler()
+        self.logger = logging.getLogger(self.__class__.__name__)
+        self.logger.addHandler(self.handler)
+        self.logger.setLevel(logging.DEBUG)
+
+    def tearDown(self):
+        """close the handler and restore the logger (Logger's are global)"""
+        self.handler.close()
+        self.logger.removeHandler(self.handler)
+        self.logger.setLevel(logging.DEBUG)
+
+    def test_capture_in_debug_or_lower(self):
+        """Test simple capture with the logger in DEBUG level"""
+        self.logger.debug('a message')
+        self.assertEquals(1, len(self.handler.records))
+        self.handler.records = []
+
+        self.logger.setLevel(TRACE)
+        with DebugCapture(self.logger) as dc:
+            self.logger.debug('a message that should never reach the handler')
+            self.assertEquals(0, len(dc.records))
+        messages = [r.getMessage() for r in self.handler.records]
+        self.assertEquals(1, len(self.handler.records), messages)
+        self.handler.records = []
+
+        with DebugCapture(self.logger) as dc:
+            self.logger.debug('a message that should never reach the handler')
+            self.logger.warning('a warning')
+            self.logger.debug('another debug message')
+            self.assertEquals(0, len(dc.records))
+        messages = [r.getMessage() for r in self.handler.records]
+        self.assertEquals(3, len(self.handler.records), messages)
+        self.handler.records = []
+
+        with DebugCapture(self.logger) as dc:
+            self.logger.debug('a message that should never reach the handler')
+            self.logger.info('a info message')
+            self.logger.debug('another debug message')
+            self.assertEquals(0, len(dc.records))
+        messages = [r.getMessage() for r in self.handler.records]
+        self.assertEquals(3, len(self.handler.records), messages)
+
+    def test_capture_non_debug_levels(self):
+        """Test debug log capture in levels > DEBUG"""
+        levels = [logging.INFO, logging.ERROR,
+                 NOTE, logging.CRITICAL]
+        for level in levels:
+            self.logger.setLevel(level)
+            self._test_capture()
+            self.logger.setLevel(logging.DEBUG)
+            self.handler.records = []
+
+    def _test_capture(self):
+        """Tests for simple debug capture in INFO level"""
+        self.logger.debug('a message')
+        self.assertEquals(0, len(self.handler.records))
+        self.handler.records = []
+
+        with DebugCapture(self.logger) as dc:
+            self.logger.debug('a message that should never reach the handler')
+            self.assertEquals(1, len(dc.records))
+        messages = [r.getMessage() for r in self.handler.records]
+        self.assertEquals(0, len(self.handler.records), messages)
+        self.handler.records = []
+
+        with DebugCapture(self.logger) as dc:
+            self.logger.debug('a message that should never reach the handler')
+            self.logger.warning('a warning')
+            self.logger.debug('another debug message')
+            self.assertEquals(2, len(dc.records))
+        messages = [r.getMessage() for r in self.handler.records]
+        self.assertEquals(1, len(self.handler.records), messages)
+        self.handler.records = []
+
+        with DebugCapture(self.logger) as dc:
+            self.logger.debug('a message that should never reach the handler')
+            self.logger.info('a info message')
+            self.logger.debug('another debug message')
+            self.assertEquals(2, len(dc.records))
+        messages = [r.getMessage() for r in self.handler.records]
+        self.assertEquals(1, len(self.handler.records), messages)
+
+    def test_dump_on_unhandled_error(self):
+        """Test that all captured debug info is dumped on a unhandled error and
+        the error itself is logged too
+        """
+        self.logger.setLevel(logging.INFO)
+        with DebugCapture(self.logger) as dc:
+            self.logger.debug('a message that should go to the handler 1')
+            self.assertEquals(1, len(dc.records))
+            raise Exception('Expected exception!')
+        messages = [r.getMessage() for r in self.handler.records]
+        self.assertEquals(2, len(self.handler.records), messages)
+
+    def test_dump_on_unhandled_error_in_DEBUG(self):
+        """Test that all captured debug info is dumped on a unhandled error and
+        the error itself is logged too (in DEBUG level)
+        """
+        # now with level <= DEBUG
+        self.logger.setLevel(logging.DEBUG)
+        self.handler.records = []
+        self.logger.setLevel(logging.INFO)
+        with DebugCapture(self.logger) as dc:
+            self.logger.debug('a message that should go to the handler 1')
+            self.assertEquals(1, len(dc.records))
+            raise Exception('Expected exception!')
+        messages = [r.getMessage() for r in self.handler.records]
+        self.assertEquals(2, len(self.handler.records), messages)
+
+    def test_dump_on_error_log(self):
+        """Test that all captured debug info is dumped on ERROR log"""
+        self.logger.setLevel(logging.INFO)
+        with DebugCapture(self.logger) as dc:
+            self.logger.debug('a message that should go to the handler')
+            self.logger.error('Oops! an error')
+            self.assertEquals(2, len(dc.records))
+        messages = [r.getMessage() for r in self.handler.records]
+        self.assertEquals(2, len(self.handler.records), messages)
+        self.handler.records = []
+
+        with DebugCapture(self.logger) as dc:
+            self.logger.debug('a message that should go to the handler')
+            self.logger.error('Oops! an error')
+            self.logger.debug('another message')
+            self.assertEquals(3, len(dc.records))
+        messages = [r.getMessage() for r in self.handler.records]
+        self.assertEquals(3, len(self.handler.records), messages)
+        self.handler.records = []
+
+        with DebugCapture(self.logger) as dc:
+            self.logger.debug('a message that should go to the handler')
+            self.logger.error('Oops! an error')
+            self.logger.debug('another message')
+            self.logger.error('Oh my! another error!')
+            self.assertEquals(4, len(dc.records))
+        messages = [r.getMessage() for r in self.handler.records]
+        self.assertEquals(4, len(self.handler.records), messages)
+
+    def test_dump_on_error_log_DEBUG(self):
+        """Test that all captured debug info is dumped on ERROR log"""
+        self.logger.setLevel(logging.DEBUG)
+        with DebugCapture(self.logger) as dc:
+            self.logger.debug('a message that should go to the handler')
+            self.logger.error('Oops! an error')
+            self.assertEquals(0, len(dc.records))
+        messages = [r.getMessage() for r in self.handler.records]
+        self.assertEquals(2, len(self.handler.records), messages)
+        self.handler.records = []
+
+        with DebugCapture(self.logger) as dc:
+            self.logger.debug('a message that should go to the handler')
+            self.logger.error('Oops! an error')
+            self.logger.debug('another message')
+            self.assertEquals(0, len(dc.records))
+        messages = [r.getMessage() for r in self.handler.records]
+        self.assertEquals(3, len(self.handler.records), messages)
+        self.handler.records = []
+
+        with DebugCapture(self.logger) as dc:
+            self.logger.debug('a message that should go to the handler')
+            self.logger.error('Oops! an error')
+            self.logger.debug('another message')
+            self.logger.error('Oh my! another error!')
+            self.assertEquals(0, len(dc.records))
+        messages = [r.getMessage() for r in self.handler.records]
+        self.assertEquals(4, len(self.handler.records), messages)
+
+    def test_dump_on_critical_log(self):
+        """Test that the dump also works on levels > ERROR"""
+        self.logger.setLevel(logging.INFO)
+        with DebugCapture(self.logger) as dc:
+            self.logger.debug('a message that should go to the handler')
+            self.logger.critical('Oops! an error')
+            self.assertEquals(2, len(dc.records))
+        messages = [r.getMessage() for r in self.handler.records]
+        self.assertEquals(2, len(self.handler.records), messages)
+

=== added file 'tests/syncdaemon/test_logger.pyc'
Binary files tests/syncdaemon/test_logger.pyc and tests/syncdaemon/test_logger.pyc differ
=== modified file 'tests/syncdaemon/test_main.py'
--- tests/syncdaemon/test_main.py	2009-08-11 16:45:00 +0000
+++ tests/syncdaemon/test_main.py	2009-08-26 12:15:00 +0000
@@ -17,13 +17,21 @@
 # with this program.  If not, see <http://www.gnu.org/licenses/>.
 """ Tests for main.Main class """
 import dbus
+from dbus.mainloop.glib import DBusGMainLoop
+import os
 import shutil
 
+from twisted.internet import defer, reactor
+
 from ubuntuone.syncdaemon.main import Main
+from ubuntuone.syncdaemon.dbus_interface import DBusInterface
+from ubuntuone.syncdaemon.action_queue import passit
 from contrib.testing.testcase import (
     BaseTwistedTestCase,
 )
 
+DBusInterface.test =True
+
 
 class MainTests(BaseTwistedTestCase):
     """ Basic tests to check main.Main """
@@ -38,6 +46,23 @@
         # we take care of releasing the name in shutdown
         dbus.service.BusName.__del__ = lambda _: None
 
+    def build_main(self, **kwargs):
+        '''
+        Build and return a Main object, using reasonable defaults for
+        the tests, plus whatever extra kwargs are passed in.
+        '''
+        params = dict(root_dir=self.root,
+                      shares_dir=self.shares,
+                      data_dir=self.data,
+                      host='localhost', port=0,
+                      dns_srv=False, ssl=False,
+                      realm='fake.realm',
+                      mark_interval=60,
+                      handshake_timeout=2,
+                      glib_loop=DBusGMainLoop(set_as_default=True))
+        params.update(kwargs)
+        return Main(**params)
+
     def tearDown(self):
         '''Clean up the tests.'''
         shutil.rmtree(self.root)
@@ -47,16 +72,12 @@
 
     def test_main_initialization(self):
         """test that creating a Main instance works as expected."""
-        main = Main(self.root, self.shares, self.data,
-                host='fake_host', port=0, dns_srv=False, ssl=False,
-                disable_ssl_verify=True, realm='fake.realm', mark_interval=60)
+        main = self.build_main()
         main.shutdown()
 
     def test_main_start(self):
         """test that Main.start works"""
-        main = Main(self.root, self.shares, self.data,
-                host='fake_host', port=0, dns_srv=False, ssl=False,
-                disable_ssl_verify=True, realm='fake.realm', mark_interval=60)
+        main = self.build_main()
         d = main.start()
         d.addCallbacks(lambda r: main.shutdown(),
                        lambda r: self.fail('Test failed: %r' % r))
@@ -65,9 +86,7 @@
     def test_main_restarts_on_critical_error(self):
         """test that Main restarts when syncdaemon gets into UNKNOWN_ERROR"""
         self.restarted = False
-        main = Main(self.root, self.shares, self.data,
-                host='fake_host', port=0, dns_srv=False, ssl=False,
-                disable_ssl_verify=True, realm='fake.realm', mark_interval=60)
+        main = self.build_main()
         main.restart = lambda: setattr(self, 'restarted', True)
         d = main.start()
         d.addCallbacks(lambda _: main.event_q.push('SYS_UNKNOWN_ERROR'),
@@ -77,3 +96,124 @@
                            else self.fail('Main was not restarted.'),
                        lambda f: self.fail('Test failed: %r' % f))
         return d
+
+    def test_handshake_timeout(self):
+        """
+        Check connecting times out
+        """
+        d0 = defer.Deferred()
+
+        class handler:
+            """
+            trivial event handler
+            """
+
+            @staticmethod
+            def handle_SYS_HANDSHAKE_TIMEOUT():
+                """
+                Pass the test when we get this event
+                """
+                reactor.callLater(0, d0.callback, None)
+
+        main = self.build_main(handshake_timeout=.5)
+        main.event_q.subscribe(handler)
+        d = main.start()
+        d.addCallback(lambda _: main.event_q.push('SYS_NET_CONNECTED'))
+        d.addCallback(lambda _: main.event_q.push('SYS_CONNECT', ''))
+        d0.addBoth(passit(lambda _: main.shutdown()))
+        return d0
+
+    def test_handshake_timeout_many(self):
+        """
+        Check connecting only times out a specified number of times
+        before giving up
+        """
+        max_timeouts = 10
+        d0 = defer.Deferred()
+
+        class handler:
+            """
+            trivial event handler
+            """
+            num_timeouts = 0
+
+            @classmethod
+            def handle_SYS_HANDSHAKE_TIMEOUT(cls):
+                """
+                after max_timeouts have happened, check the state
+                """
+                cls.num_timeouts += 1
+                if cls.num_timeouts > max_timeouts:
+                    reactor.callLater(0, cls.check)
+
+            @classmethod
+            def check(cls):
+                """
+                if the state is ok, pass the test
+                """
+                if main.state.name != 'EXCESSIVE_TIMEOUTS':
+                    d0.errback(Exception('Too many timeouts'))
+                else:
+                    d0.callback('OK!')
+
+        main = self.build_main(handshake_timeout=.1)
+        main.event_q.subscribe(handler)
+        d = main.start()
+        d.addCallback(lambda _: main.event_q.push('SYS_NET_CONNECTED'))
+        d.addCallback(lambda _: main.event_q.push('SYS_CONNECT', ''))
+        d0.addBoth(passit(lambda _: main.shutdown()))
+        return d0
+
+    def test_create_dirs_already_exists_dirs(self):
+        """test that creating a Main instance works as expected."""
+        link = os.path.join(self.root, 'Shared With Me')
+        self.assertFalse(os.path.exists(link))
+        self.assertTrue(os.path.exists(self.shares))
+        self.assertTrue(os.path.exists(self.root))
+        main = self.build_main()
+        self.assertTrue(os.path.exists(main.shares_dir_link))
+        # check that the shares link is actually a link
+        self.assertTrue(os.path.islink(main.shares_dir_link))
+        self.assertEquals(link, main.shares_dir_link)
+        main.shutdown()
+
+    def test_create_dirs_already_exists_symlink_too(self):
+        """test that creating a Main instance works as expected."""
+        link = os.path.join(self.root, 'Shared With Me')
+        os.symlink(self.shares, link)
+        self.assertTrue(os.path.exists(link))
+        self.assertTrue(os.path.islink(link))
+        self.assertTrue(os.path.exists(self.shares))
+        self.assertTrue(os.path.exists(self.root))
+        main = self.build_main()
+        # check that the shares link is actually a link
+        self.assertTrue(os.path.islink(main.shares_dir_link))
+        main.shutdown()
+
+    def test_create_dirs_already_exists_but_not_symlink(self):
+        """test that creating a Main instance works as expected."""
+        link = os.path.join(self.root, 'Shared With Me')
+        os.makedirs(link)
+        self.assertTrue(os.path.exists(link))
+        self.assertFalse(os.path.islink(link))
+        self.assertTrue(os.path.exists(self.shares))
+        self.assertTrue(os.path.exists(self.root))
+        main = self.build_main()
+        # check that the shares link is actually a link
+        self.assertEquals(main.shares_dir_link, link)
+        self.assertFalse(os.path.islink(main.shares_dir_link))
+        main.shutdown()
+
+    def test_create_dirs_none_exists(self):
+        """test that creating a Main instance works as expected."""
+        link = os.path.join(self.root, 'Shared With Me')
+        # remove the existing dirs
+        os.rmdir(self.root)
+        os.rmdir(self.shares)
+        main = self.build_main()
+        # check that the shares link is actually a link
+        self.assertTrue(os.path.exists(link))
+        self.assertTrue(os.path.islink(main.shares_dir_link))
+        self.assertTrue(os.path.exists(self.shares))
+        self.assertTrue(os.path.exists(self.root))
+        main.shutdown()

=== added file 'tests/syncdaemon/test_main.pyc'
Binary files tests/syncdaemon/test_main.pyc and tests/syncdaemon/test_main.pyc differ
=== added file 'tests/syncdaemon/test_sync.py'
--- tests/syncdaemon/test_sync.py	1970-01-01 00:00:00 +0000
+++ tests/syncdaemon/test_sync.py	2009-08-26 12:15:00 +0000
@@ -0,0 +1,235 @@
+#
+# Author: Guillermo Gonzalez <guillermo.gonzalez@canonical.com>
+#
+# Copyright 2009 Canonical Ltd.
+#
+# This program is free software: you can redistribute it and/or modify it
+# under the terms of the GNU General Public License version 3, as published
+# by the Free Software Foundation.
+#
+# This program is distributed in the hope that it will be useful, but
+# WITHOUT ANY WARRANTY; without even the implied warranties of
+# MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
+# PURPOSE.  See the GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License along
+# with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+'''Tests for Sync.'''
+
+from __future__ import with_statement
+
+import logging
+import os
+import shutil
+import unittest
+
+import dbus
+from dbus.mainloop.glib import DBusGMainLoop
+
+from contrib.testing.testcase import (
+    FakeVolumeManager,
+    BaseTwistedTestCase,
+    MementoHandler,
+)
+
+from ubuntuone.syncdaemon.dbus_interface import DBusInterface
+from ubuntuone.syncdaemon.filesystem_manager import FileSystemManager
+from ubuntuone.syncdaemon.main import Main
+from ubuntuone.syncdaemon.sync import FSKey
+from ubuntuone.syncdaemon.volume_manager import Share
+
+DBusInterface.test = True
+
+class FSKeyTestCase(BaseTwistedTestCase):
+    """ Base test case for FSKey """
+
+    def setUp(self):
+        """ Setup the test """
+        unittest.TestCase.setUp(self)
+        self.test_dir = self.mktemp("test_dir")
+        self.shares_dir = os.path.join(self.test_dir, 'shares')
+        os.makedirs(self.shares_dir)
+        self.root_dir = os.path.join(self.test_dir, 'root')
+        os.makedirs(self.root_dir)
+        self.fsmdir = os.path.join(self.test_dir, "fsmdir")
+        self.fsm = FileSystemManager(self.fsmdir,
+                                     FakeVolumeManager(self.root_dir))
+        self.share = self.create_share('share', 'share_name',
+                                            self.fsm, self.shares_dir)
+        self.share_path = self.share.path
+
+    def tearDown(self):
+        """ Clean up the test dir"""
+        shutil.rmtree(self.test_dir)
+
+    @staticmethod
+    def create_share(share_id, share_name, fsm, shares_dir,
+                     access_level='Modify'):
+        """ creates a share """
+        share_path = os.path.join(shares_dir, share_name)
+        os.makedirs(share_path)
+        share = Share(share_path, share_id=share_id,
+                      access_level=access_level)
+        fsm.vm.add_share(share)
+        return share
+
+
+class FSKeyTests(FSKeyTestCase):
+    '''Test FSKey methods.'''
+
+    def test_get_mdid(self):
+        """simple tests for get_mdid"""
+        path = os.path.join(self.share.path, 'path')
+        mdid = self.fsm.create(path, "share", node_id='uuid1')
+        key = FSKey(self.fsm, path=path)
+        self.assertEquals(mdid, key.get_mdid())
+        key = FSKey(self.fsm, share_id='share', node_id='uuid1')
+        self.assertEquals(mdid, key.get_mdid())
+        key = FSKey(self.fsm, mdid=mdid)
+        self.assertEquals(mdid, key.get_mdid())
+        # with bad keys
+        key = FSKey(self.fsm, share='share', node_id='uuid1')
+        self.assertRaises(KeyError, key.get_mdid)
+        # 1 valid and 1 invalid key
+        key = FSKey(self.fsm, share='share', mdid=mdid)
+        self.assertRaises(KeyError, key.get_mdid)
+
+    def test_set(self):
+        """test that changes to the key are keeped in _changes until sync"""
+        path = os.path.join(self.share.path, 'path')
+        mdid = self.fsm.create(path, "share", node_id='uuid1')
+        key = FSKey(self.fsm, path=path)
+        key.set(local_hash='a_hash')
+        self.assertEquals('a_hash', key._changes['local_hash'])
+        key.set(server_hash='a_hash_1')
+        self.assertEquals('a_hash_1', key._changes['server_hash'])
+        key.sync()
+        self.assertEquals({}, key._changes)
+
+    def test_sync(self):
+        """test sync of the changes to the fsm"""
+        path = os.path.join(self.share.path, 'path')
+        mdid = self.fsm.create(path, "share", node_id='uuid1')
+        key = FSKey(self.fsm, path=path)
+        # change it
+        key.set(local_hash='local_hash', server_hash='server_hash')
+        # sync!
+        key.sync()
+        # get the mdobj and check the values
+        mdobj = self.fsm.get_by_mdid(mdid)
+        self.assertEquals('server_hash', mdobj.server_hash)
+        self.assertEquals('local_hash', mdobj.local_hash)
+        self.assertEquals('share', mdobj.share_id)
+        self.assertEquals('uuid1', mdobj.node_id)
+
+    def test_mdid_reset(self):
+        '''Test for mdid reset after a deletion'''
+        # create a node
+        path = os.path.join(self.share.path, 'path')
+        self.fsm.create(path, "share", node_id='uuid1')
+        key = FSKey(self.fsm, path=path)
+        # fake a conflict and delete the metadata
+        key.move_to_conflict()
+        key.delete_metadata()
+        # create the node again
+        self.fsm.create(path, "share", node_id='uuid1')
+        key.set(server_hash="")
+        key.set(local_hash="")
+        # fail no more!
+        key.sync()
+        # now check the delete_file method
+        # fake a conflict and delete the metadata
+        key.delete_file()
+        # create the node again
+        self.fsm.create(path, "share", node_id='uuid1')
+        key.set(server_hash="")
+        key.set(local_hash="")
+        # fail no more!
+        key.sync()
+
+    def test_changes_reset(self):
+        '''Test for _changes reset after a deletion'''
+        # create a node
+        path = os.path.join(self.share.path, 'path')
+        self.fsm.create(path, "share", node_id='uuid1')
+        key = FSKey(self.fsm, path=path)
+        # set a value and delete the metadata
+        key.set(server_hash="server_hash")
+        key.delete_metadata()
+        # create the node again
+        self.fsm.create(path, "share", node_id='uuid1')
+        key.sync()
+        self.assertNotEquals('server_hash',
+                             self.fsm.get_by_path(path).server_hash)
+        # now check the delete_file method
+        key = FSKey(self.fsm, path=path)
+        key.set(server_hash="server_hash1")
+        # fake a conflict and delete the metadata
+        key.delete_file()
+        # create the node again
+        self.fsm.create(path, "share", node_id='uuid1')
+        key.sync()
+        self.assertNotEquals('server_hash1',
+                             self.fsm.get_by_path(path).server_hash)
+
+
+class TestSync(BaseTwistedTestCase):
+    def setUp(self):
+        BaseTwistedTestCase.setUp(self)
+        self.root = self.mktemp('root')
+        self.shares = self.mktemp('shares')
+        self.data = self.mktemp('data')
+        self.handler = MementoHandler()
+        self.handler.setLevel(logging.ERROR)
+        self.main = Main(root_dir=self.root,
+                         shares_dir=self.shares,
+                         data_dir=self.data,
+                         host='localhost', port=0,
+                         dns_srv=False, ssl=False,
+                         disable_ssl_verify=True,
+                         realm='fake.realm',
+                         mark_interval=60,
+                         handshake_timeout=2,
+                         glib_loop=DBusGMainLoop(set_as_default=True))
+        logging.getLogger('ubuntuone.SyncDaemon').addHandler(self.handler)
+        dbus.service.BusName.__del__ = lambda _: None
+
+    def tearDown(self):
+        self.main.shutdown()
+        shutil.rmtree(self.root)
+        shutil.rmtree(self.shares)
+        shutil.rmtree(self.data)
+        for record in self.handler.records:
+            exc_info = getattr(record, 'exc_info', None)
+            if exc_info is not None:
+                raise exc_info[0], exc_info[1], exc_info[2]
+        BaseTwistedTestCase.tearDown(self)
+
+    def test_deleting_open_files_is_no_cause_for_despair(self):
+        def cb(_):
+            d0 = self.main.wait_for('HQ_HASH_NEW')
+            f = file(self.root + '/a_file', 'w')
+            print >> f, 'hola'
+            os.unlink(self.root + '/a_file')
+            f.close()
+            print >> file(self.root + '/b_file', 'w'), 'chau'
+            return d0
+        d = self.main.wait_for('SYS_LOCAL_RESCAN_DONE')
+        self.main.start()
+        d.addCallback(cb)
+        return d
+
+    def test_stomp_deleted_file_is_no_cause_for_despair_either(self):
+        def cb(_):
+            d0 = self.main.wait_for('HQ_HASH_NEW')
+            f = file(self.root + '/a_file', 'w')
+            print >> f, 'hola'
+            os.unlink(self.root + '/a_file')
+            f.close()
+            print >> file(self.root + '/b_file', 'w'), 'chau'
+            return d0
+        d = self.main.wait_for('SYS_LOCAL_RESCAN_DONE')
+        self.main.start()
+        d.addCallback(cb)
+        return d

=== added file 'tests/syncdaemon/test_sync.pyc'
Binary files tests/syncdaemon/test_sync.pyc and tests/syncdaemon/test_sync.pyc differ
=== added file 'tests/syncdaemon/test_tools.pyc'
Binary files tests/syncdaemon/test_tools.pyc and tests/syncdaemon/test_tools.pyc differ
=== added file 'tests/syncdaemon/test_u1fsfsm.pyc'
Binary files tests/syncdaemon/test_u1fsfsm.pyc and tests/syncdaemon/test_u1fsfsm.pyc differ
=== added file 'tests/syncdaemon/test_u1sdtool.pyc'
Binary files tests/syncdaemon/test_u1sdtool.pyc and tests/syncdaemon/test_u1sdtool.pyc differ
=== modified file 'tests/syncdaemon/test_vm.py'
--- tests/syncdaemon/test_vm.py	2009-08-11 16:45:00 +0000
+++ tests/syncdaemon/test_vm.py	2009-08-26 12:15:00 +0000
@@ -120,7 +120,8 @@
 
     def test_handle_AQ_SHARES_LIST(self):
         """ test the handling of the AQ_SHARE_LIST event. """
-        share_response = ShareResponse.from_params('share_id', 'to_me',
+        share_id = uuid.uuid4()
+        share_response = ShareResponse.from_params(share_id, 'to_me',
                                                    'fake_share_uuid',
                                                    'fake_share', 'username',
                                                    'visible_username', 'yes',
@@ -132,14 +133,17 @@
         self.vm.handle_AQ_SHARES_LIST(response)
         self.assertEquals(2, len(self.vm.shares)) # the new shares and root
         # check that the share is in the shares dict
-        self.assertTrue('share_id' in self.vm.shares)
-        share = self.vm.shares['share_id']
+        self.assertTrue(str(share_id) in self.vm.shares)
+        share = self.vm.shares[str(share_id)]
         self.assertEquals('fake_share', share.name)
         self.assertEquals('fake_share_uuid', share.subtree)
 
+
+
     def test_handle_SV_SHARE_CHANGED(self):
         """ test the handling of the AQ_SHARE_LIST event. """
-        share_holder = NotifyShareHolder.from_params('share_id', None,
+        share_id = uuid.uuid4()
+        share_holder = NotifyShareHolder.from_params(share_id, None,
                                                      'fake_share',
                                                      'test_username',
                                                      'visible_name', 'Modify')
@@ -147,16 +151,17 @@
         self.vm.on_server_root('root_uuid')
         # create a share
         share_path = os.path.join(self.shares_dir, share_holder.share_name)
-        share = Share(share_path, share_id=share_holder.share_id,
+        share = Share(share_path, share_id=str(share_holder.share_id),
                       access_level='View')
         self.vm.add_share(share)
         self.vm.handle_SV_SHARE_CHANGED(message='changed', info=share_holder)
-        self.assertEquals('Modify', self.vm.shares['share_id'].access_level)
+        self.assertEquals('Modify', self.vm.shares[str(share_id)].access_level)
         self.vm.handle_SV_SHARE_CHANGED('deleted', share_holder)
         self.assertNotIn('share_id', self.vm.shares)
 
     def test_persistence(self):
         """ Test that the persistence of shares works as expected. """
+        # create the folders layout
         share_path = os.path.join(self.shares_dir, 'my_share')
         share = Share(share_path, share_id='a_share_id', access_level='View')
         self.vm.add_share(share)
@@ -167,12 +172,14 @@
 
     def test_handle_AQ_SHARES_LIST_shared(self):
         """test the handling of the AQ_SHARE_LIST event, with a shared dir."""
-        share_response = ShareResponse.from_params('share_id', 'to_me',
+        share_id = uuid.uuid4()
+        share_response = ShareResponse.from_params(share_id, 'to_me',
                                                    'fake_share_uuid',
                                                    'fake_share', 'username',
                                                    'visible_username', 'yes',
                                                    'View')
-        shared_response = ShareResponse.from_params('shared_id', 'from_me',
+        shared_id = uuid.uuid4()
+        shared_response = ShareResponse.from_params(shared_id, 'from_me',
                                                    'shared_uuid',
                                                    'fake_shared', 'myname',
                                                    'my_visible_name', 'yes',
@@ -187,7 +194,7 @@
         self.vm.handle_AQ_SHARES_LIST(response)
         self.assertEquals(2, len(self.vm.shares)) # the new shares and root
         self.assertEquals(1, len(self.vm.shared)) # the new shares and root
-        shared = self.vm.shared['shared_id']
+        shared = self.vm.shared[str(shared_id)]
         self.assertEquals('fake_shared', shared.name)
         # check that the uuid is stored in fs
         mdobj = self.main.fs.get_by_path(shared.path)
@@ -471,7 +478,8 @@
         root_share.access_level = 'Modify'
         old_shelf[''] = root_share
         for idx in range(1, 10):
-            old_shelf[str(uuid.uuid4())] = idx
+            old_shelf[str(uuid.uuid4())] = \
+                    Share(os.path.join(self.shares_dir, str(idx)))
         # ShareFileShelf.keys returns a generator
         old_keys = [key for key in old_shelf.keys()]
         self.assertEquals(10, len(old_keys))
@@ -567,7 +575,8 @@
         root_share.access_level = 'Modify'
         maybe_old_shelf[''] = root_share
         for idx in range(1, 10):
-            maybe_old_shelf[str(uuid.uuid4())] = idx
+            maybe_old_shelf[str(uuid.uuid4())] = \
+                    Share(os.path.join(self.shares_dir, str(idx)))
         # ShareFileShelf.keys returns a generator
         maybe_old_keys = [key for key in maybe_old_shelf.keys()]
         self.assertEquals(10, len(maybe_old_keys))
@@ -586,3 +595,92 @@
         self.assertEquals(0, len(backup_keys))
         self.check_version()
 
+    def test_3_to_4(self):
+        """upgrade from version 3 to 4"""
+        vm_data_dir = os.path.join(self.data_dir, 'vm')
+        os.makedirs(vm_data_dir)
+        with open(os.path.join(vm_data_dir, '.version'), 'w') as fd:
+            fd.write('3')
+        os.rmdir(self.shares_dir)
+        # build the old layout
+        old_root = os.path.join(self.root_dir, 'My Files')
+        old_shares = os.path.join(self.root_dir, 'Shared With Me')
+        os.makedirs(os.path.join(old_root, 'test_dir'))
+        open(os.path.join(old_root, 'test_file'), 'w').close()
+        # create a file in the root
+        open(os.path.join(self.root_dir, 'test_file'), 'w').close()
+        share_path = os.path.join(old_shares, 'Bla from Foo')
+        os.makedirs(share_path)
+        os.makedirs(os.path.join(share_path, 'test_dir'))
+        open(os.path.join(share_path, 'test_file'), 'w').close()
+        # fix permissions
+        os.chmod(self.root_dir, 0555)
+        os.chmod(old_shares, 0555)
+        # migrate the data
+        self.main = FakeMain(self.root_dir, self.shares_dir, self.data_dir)
+        self.assertFalse(os.path.exists(old_root))
+        self.assertTrue(os.path.exists(old_shares))
+        self.assertTrue(os.path.islink(old_shares))
+        self.assertEquals(old_shares, self.main.shares_dir_link)
+        self.assertTrue(os.path.exists(os.path.join(self.root_dir,
+                                                    'test_dir')))
+        self.assertTrue(os.path.exists(os.path.join(self.root_dir,
+                                                    'test_file')))
+        self.assertTrue(os.path.exists(os.path.join(self.root_dir,
+                                                    'test_file.u1conflict')))
+        self.assertTrue(os.path.exists(share_path))
+        self.assertTrue(os.path.exists(os.path.join(share_path, 'test_dir')))
+        self.assertTrue(os.path.exists(os.path.join(share_path, 'test_file')))
+
+    def test_None_to_4(self):
+        """upgrade from version None to 4 (possibly a clean start)"""
+        vm_data_dir = os.path.join(self.data_dir, 'vm')
+        version_file = os.path.join(vm_data_dir, '.version')
+        if os.path.exists(version_file):
+            os.remove(version_file)
+        os.rmdir(self.shares_dir)
+        os.rmdir(self.root_dir)
+        old_root = os.path.join(self.root_dir, 'My Files')
+        old_shares = os.path.join(self.root_dir, 'Shared With Me')
+        # start and check that everything is ok
+        self.main = FakeMain(self.root_dir, self.shares_dir, self.data_dir)
+        self.assertFalse(os.path.exists(old_root))
+        self.assertTrue(os.path.exists(old_shares))
+        self.assertTrue(os.path.islink(old_shares))
+        self.assertEquals(old_shares, self.main.shares_dir_link)
+        if os.path.exists(version_file):
+            with open(os.path.join(vm_data_dir, '.version'), 'r') as fd:
+                self.assertEquals('4', fd.read())
+        else:
+            self.fail('missing .version file')
+
+    def test_None_to_4_phantom_share_path(self):
+        """upgrade from version None to 4 (possibly a clean start)"""
+        vm_data_dir = os.path.join(self.data_dir, 'vm')
+        version_file = os.path.join(vm_data_dir, '.version')
+        if os.path.exists(version_file):
+            os.remove(version_file)
+        os.rmdir(self.shares_dir)
+        os.rmdir(self.root_dir)
+        old_root = os.path.join(self.root_dir, 'My Files')
+        old_shares = os.path.join(self.root_dir, 'Shared With Me')
+        # start and check that everything is ok
+        self.main = FakeMain(self.root_dir, self.shares_dir, self.data_dir)
+        root = self.main.vm.shares['']
+        # set None to the share path
+        root.path = None
+        self.main.vm.shares['test'] = root
+        if os.path.exists(version_file):
+            os.remove(version_file)
+        self.main.shutdown()
+        # rcheck that it's all OK
+        self.main = FakeMain(self.root_dir, self.shares_dir, self.data_dir)
+        self.assertFalse(os.path.exists(old_root))
+        self.assertTrue(os.path.exists(old_shares))
+        self.assertTrue(os.path.islink(old_shares))
+        self.assertEquals(old_shares, self.main.shares_dir_link)
+        if os.path.exists(version_file):
+            with open(os.path.join(vm_data_dir, '.version'), 'r') as fd:
+                self.assertEquals('4', fd.read())
+        else:
+            self.fail('missing .version file')

=== added file 'tests/syncdaemon/test_vm.pyc'
Binary files tests/syncdaemon/test_vm.pyc and tests/syncdaemon/test_vm.pyc differ
=== added file 'tests/u1sync/__init__.pyc'
Binary files tests/u1sync/__init__.pyc and tests/u1sync/__init__.pyc differ
=== added file 'tests/u1sync/test_init.pyc'
Binary files tests/u1sync/test_init.pyc and tests/u1sync/test_init.pyc differ
=== modified file 'ubuntuone/clientdefs.py.in'
--- ubuntuone/clientdefs.py.in	2009-07-16 17:00:00 +0000
+++ ubuntuone/clientdefs.py.in	2009-08-26 12:15:00 +0000
@@ -25,4 +25,5 @@
 # pylint: disable-msg=C0301
 VERSION = "@VERSION@"
 LOCALEDIR = "@localedir@"
+LIBEXECDIR = "@libexecdir@"
 GETTEXT_PACKAGE = "@GETTEXT_PACKAGE@"

=== modified file 'ubuntuone/oauthdesktop/main.py'
--- ubuntuone/oauthdesktop/main.py	2009-07-27 16:00:00 +0000
+++ ubuntuone/oauthdesktop/main.py	2009-08-26 12:15:00 +0000
@@ -95,6 +95,24 @@
         logger.debug("Calling auth.client.ensure_access_token in thread")
         deferToThread(client.ensure_access_token).addErrback(self.error_handler)
 
+    def clear_token(self, realm, consumer_key):
+        """Remove the currently stored OAuth token from the keyring."""
+        self.realm = str(realm)
+        self.consumer_key = str(consumer_key)
+        (request_token_url, user_authorisation_url,
+          access_token_url, consumer_secret) =  self.get_config_urls(self.realm)
+        from ubuntuone.oauthdesktop.auth import AuthorisationClient
+        client = AuthorisationClient(self.realm,
+                                     request_token_url,
+                                     user_authorisation_url,
+                                     access_token_url,
+                                     self.consumer_key, consumer_secret,
+                                     callback_parent=self.got_token,
+                                     callback_denied=self.got_denial,
+                                     callback_notoken=self.got_no_token,
+                                     callback_error=self.got_error)
+        deferToThread(client.clear_token).addErrback(self.error_handler)
+        
     def error_handler(self, failure):
         """Deal with errors returned from auth process"""
         logger.debug("Error returned from auth process")
@@ -239,6 +257,14 @@
         self.currently_authing = True
         self.processor.login(realm, consumer_key, do_login)
 
+    @dbus.service.method(dbus_interface='com.ubuntuone.Authentication',
+                         in_signature='ss', out_signature='')
+    def clear_token(self, realm, consumer_key):
+        """
+        D-Bus method, exported over the bus, to clear the existing token.
+        """
+        self.processor.clear_token(realm, consumer_key)
+
     @dbus.service.signal(dbus_interface='com.ubuntuone.Authentication',
                                              signature='ss')
     def NewCredentials(self, realm, consumer_key):

=== modified file 'ubuntuone/syncdaemon/__init__.py'
--- ubuntuone/syncdaemon/__init__.py	2009-08-11 16:45:00 +0000
+++ ubuntuone/syncdaemon/__init__.py	2009-08-26 12:15:00 +0000
@@ -16,4 +16,4 @@
 """ client module """
 
 # required capabilities
-REQUIRED_CAPS = frozenset(["no-content"])
+REQUIRED_CAPS = frozenset(["no-content", "account-info", "resumable-uploads"])

=== modified file 'ubuntuone/syncdaemon/action_queue.py'
--- ubuntuone/syncdaemon/action_queue.py	2009-08-11 16:45:00 +0000
+++ ubuntuone/syncdaemon/action_queue.py	2009-08-26 12:15:00 +0000
@@ -23,6 +23,7 @@
 """
 from collections import deque, defaultdict
 from functools import wraps, partial
+import itertools
 import logging
 import os
 import random
@@ -43,8 +44,8 @@
 from ubuntuone.storageprotocol import oauth
 from ubuntuone.storageprotocol.context import get_ssl_context
 from ubuntuone.storageprotocol import protocol_pb2
-from ubuntuone.storageprotocol.client import StorageClient, \
-    StorageClientFactory
+from ubuntuone.storageprotocol.client import ThrottlingStorageClient, \
+    ThrottlingStorageClientFactory
 from ubuntuone.syncdaemon.logger import mklog, TRACE
 from ubuntuone.syncdaemon.interfaces import IActionQueue, \
     IMarker
@@ -119,14 +120,14 @@
         return 'MultiProxy(%s)' % (super(MultiProxy, self).__repr__(),)
 
 
-class LoggingStorageClient(StorageClient):
+class LoggingStorageClient(ThrottlingStorageClient):
     """ A subclass of StorageClient that adds logging to
     processMessage and sendMessage.
     """
 
     def __init__(self):
         """ setup logging and create the instance. """
-        StorageClient.__init__(self)
+        ThrottlingStorageClient.__init__(self)
         self.log = logging.getLogger('ubuntuone.SyncDaemon.StorageClient')
         # configure the handler level to be < than DEBUG
         self.log.setLevel(TRACE)
@@ -144,7 +145,7 @@
         if message.id in self.requests:
             req = self.requests[message.id]
             req.deferred.addCallbacks(self.log_success, self.log_error)
-        result = StorageClient.processMessage(self, message)
+        result = ThrottlingStorageClient.processMessage(self, message)
         self.log.debug('end - processMessage: id: %s - result: %s',
                        message.id, result)
         return result
@@ -170,7 +171,7 @@
         else:
             self.log.debug('start - sendMessage: %s',
                           str(message).replace("\n", " "))
-        result = StorageClient.sendMessage(self, message)
+        result = ThrottlingStorageClient.sendMessage(self, message)
         self.log.debug('end - sendMessage: id: %s', message.id)
         return result
 
@@ -188,12 +189,14 @@
         All the state is saved in the factory.
         """
         logger.debug("connection made")
+        LoggingStorageClient.connectionMade(self)
         self.connection_state = 'connected'
-        self.factory.client = self
         # pylint: disable-msg=W0212
         self.set_node_state_callback(self.factory._node_state_callback)
         self.set_share_change_callback(self.factory._share_change_callback)
         self.set_share_answer_callback(self.factory._share_answer_callback)
+        self.set_free_space_callback(self.factory._free_space_callback)
+        self.set_account_info_callback(self.factory._account_info_callback)
         self.factory.event_queue.push('SYS_CONNECTION_MADE')
 
     def disconnect(self):
@@ -318,9 +321,9 @@
         d_zip = defer.Deferred()
         d_lck = self.acquire()
         d_lck.addCallback(
-            lambda _: reactor.callFromThread(self._compress,
-                                             d_zip, upload) or d_zip)
-        d_lck.addCallback(lambda _: self.release())
+            lambda _: reactor.callInThread(self._compress,
+                                           d_zip, upload) or d_zip)
+        d_lck.addBoth(passit(lambda _: self.release()))
 
         return d_lck
 
@@ -331,6 +334,8 @@
     request at a time 'on the wire', and that uses the action queue's
     states for its syncrhonization.
     """
+    commutative = False
+
     def __init__(self, name, action_queue):
         super(RequestQueue, self).__init__()
         self.name = name
@@ -349,9 +354,11 @@
 
     def schedule_next(self, share_id, node_id):
         """
-        Make the command on the given share and node be next in the
-        queue of waiting commands.
+        Promote the newest command on the given share and node to
+        the front of the queue, if it is possible to do so.
         """
+        if not self.commutative:
+            return
         for cmd in reversed(self.waiting):
             try:
                 if cmd.share_id == share_id and cmd.node_id == node_id:
@@ -372,6 +379,8 @@
         if len(self.waiting) == 1 and not self._head:
             self.action_queue.event_queue.push('SYS_' + self.name
                                                + '_WAITING')
+        if command.is_runnable():
+            self.check_conditions()
 
     def queue_top(self, command):
         """
@@ -392,17 +401,149 @@
         if self.waiting:
             self.action_queue.event_queue.push('SYS_' + self.name + '_WAITING')
 
+    def _is_empty_or_runnable_waiting(self):
+        """Returns True if there is an immediately runnable command in the
+        queue, or if the queue is empty.
+        """
+        if not self.waiting:
+            return True
+        if self.commutative:
+            for command in self.waiting:
+                if command.is_runnable():
+                    return True
+            return False
+        else:
+            return self.waiting[0].is_runnable()
+
+    def _get_next_runnable_command(self):
+        """Returns the next runnable command, if there is one."""
+        if self.commutative:
+            n_skipped = 0
+            for command in self.waiting:
+                if command.is_runnable():
+                    break
+                n_skipped += 1
+            if n_skipped < len(self.waiting):
+                # we found a runnable command
+                if n_skipped > 0:
+                    # move the skipped commands to the end
+                    self.waiting.rotate(-n_skipped)
+                command = self.waiting.popleft()
+            else:
+                command = None
+        else:
+            if self.waiting and self.waiting[0].is_runnable():
+                command = self.waiting.popleft()
+            else:
+                command = None
+        if command is None:
+            command = WaitForCondition(self, self._is_empty_or_runnable_waiting)
+            command.start_unqueued()
+        return command
+
+    def check_conditions(self):
+        """Checks conditions on which the currently running command may be
+        waiting.
+        """
+        if self._head is not None:
+            self._head.check_conditions()
+
     def run(self):
         """
-        Empty the queue.
+        Run the next available command in the queue.
         """
         if self.waiting:
-            self._head = command = self.waiting.popleft()
+            self._head = command = self._get_next_runnable_command()
             d = command.run()
             d.addBoth(passit(lambda _: self.done()))
+            return d
         else:
             self.action_queue.event_queue.push('SYS_' + self.name + '_DONE')
 
+    def node_is_queued(self, command, share_id, node_id):
+        '''True if a command is queued for that node.'''
+        for cmd in itertools.chain((self._head,), self.waiting):
+            if isinstance(cmd, command):
+                if getattr(cmd, "node_id", None) == node_id and \
+                   getattr(cmd, "share_id", None) == share_id:
+                    return True
+
+
+class UniqueRequestQueue(RequestQueue):
+    '''
+    A RequestQueue that only ever queues one command for each
+    (share_id, node_id) pair.
+    '''
+    def queue(self, command):
+        """
+        Add a command to the queue. If there are commands in the queue for the
+        same node, they will be dropped on the floor and laughed at.
+        """
+        for wc in iter(self.waiting):
+            wc_share = self.action_queue.resolve_uuid_maybe(wc.share_id)
+            wc_node =  self.action_queue.resolve_uuid_maybe(wc.node_id)
+            if wc_share == command.share_id and wc_node == command.node_id:
+                self.waiting.remove(wc)
+                break
+        return super(UniqueRequestQueue, self).queue(command)
+
+
+class NoisyRequestQueue(RequestQueue):
+    """
+    A RequestQueue that notifies when it's changed
+    """
+    def __init__(self, name, action_queue, change_notification_cb=None):
+        self.set_change_notification_cb(change_notification_cb)
+        super(NoisyRequestQueue, self).__init__(name, action_queue)
+
+    def set_change_notification_cb(self, change_notification_cb):
+        '''
+        Set the change notification callback.
+        '''
+        if change_notification_cb is None:
+            self.change_notification_cb = lambda *_: None
+        else:
+            self.change_notification_cb = change_notification_cb
+
+    def queue(self, command):
+        '''
+        Add a command to the queue.
+        Calls the change notification callback
+        '''
+        super(NoisyRequestQueue, self).queue(command)
+        self.change_notification_cb(self._head, self.waiting)
+
+    def queue_top(self, command):
+        '''
+        Add a command to the head of the queue.
+        Calls the change notification callback
+        '''
+        super(NoisyRequestQueue, self).queue_top(command)
+        self.change_notification_cb(self._head, self.waiting)
+
+    def get_head(self):
+        """
+        Getter for the queue's head
+        """
+        return self.__head
+
+    def set_head(self, head):
+        """
+        Setter for the queue's head. Calls he change notification callback.
+        """
+        self.change_notification_cb(head, self.waiting)
+        self.__head = head
+
+    _head = property(get_head, set_head)
+
+
+class ContentQueue(NoisyRequestQueue, UniqueRequestQueue):
+    '''
+    The content queue is a commutative (uniquified), noisy request
+    queue.
+    '''
+    commutative = True
+
 
 class DeferredMap(object):
     """
@@ -455,6 +596,13 @@
         for d in self.waiting.pop(key, ()):
             d.errback(failure)
 
+    def resolve_maybe(self, key):
+        """
+        Return either the mapping of key (if key has been resolved),
+        or key itself (if not).
+        """
+        return self.map.get(key, key)
+
 
 class UploadProgressWrapper(object):
     """
@@ -462,6 +610,7 @@
     we can keep track of the number of bytes that have been written to
     the store.
     """
+    __slots__ = ('fd', 'data_dict', 'n_bytes_read')
     def __init__(self, fd, data_dict):
         """
         fd is the file-like object used for uploads. data_dict is the
@@ -492,7 +641,51 @@
         return getattr(self.fd, attr)
 
 
-class ActionQueue(StorageClientFactory, object):
+class ConfigurableThrottlingFactory(ThrottlingStorageClientFactory):
+    """ThrottlingStorageClientFactory that support configuring it at runtime"""
+
+    def __init__(self, read_limit=None, write_limit=None,
+                 throttling_enabled=False):
+        """Create the instance"""
+        ThrottlingStorageClientFactory.__init__(self, read_limit=read_limit,
+                                                write_limit=write_limit)
+        self.throttling = read_limit is not None or write_limit is not None
+        self.enable_throttling(self.throttling)
+
+    def registerWritten(self, length):
+        """Only call registerWritten if we are throttling"""
+        # only do something if throttling is enabled
+        if self.throttling:
+            ThrottlingStorageClientFactory.registerWritten(self, length)
+
+    def registerRead(self, length):
+        """Only call registerRead if we are throttling"""
+        # only do something if throttling is enabled
+        if self.throttling:
+            ThrottlingStorageClientFactory.registerRead(self, length)
+
+    def enable_throttling(self, enable):
+        """Enable/Disable throttling. Start the counter reset loops or cancel
+        them if throttling is being disabled.
+        """
+        if enable:
+            # check if we need to start the reset loops
+            if self.resetReadThisSecondID is None:
+                self._resetReadThisSecond()
+            if self.resetWriteThisSecondID is None:
+                self._resetWrittenThisSecond()
+        else:
+            if self.throttling:
+                # if it's currently enabled, stop the reset loops
+                if self.resetReadThisSecondID is not None:
+                    self._cancel_delayed_call(self.resetReadThisSecondID)
+                if self.resetWriteThisSecondID is not None:
+                    self._cancel_delayed_call(self.resetWriteThisSecondID)
+            # else leave it as it is
+        self.throttling = enable
+
+
+class ActionQueue(ConfigurableThrottlingFactory, object):
     """
     This is the ActionQueue itself.
     """
@@ -500,7 +693,11 @@
     protocol = ActionQueueProtocol
 
     def __init__(self, event_queue, host, port, dns_srv,
-                 use_ssl=False, disable_ssl_verify=False):
+                 use_ssl=False, disable_ssl_verify=False,
+                 read_limit=None, write_limit=None, throttling_enabled=False):
+        ConfigurableThrottlingFactory.__init__(self, read_limit=read_limit,
+                                      write_limit=write_limit,
+                                      throttling_enabled=throttling_enabled)
         self.event_queue = event_queue
         self.host = host
         self.port = port
@@ -512,16 +709,40 @@
         self.client = None
         self.deferred = None
 
-        self.content_queue = RequestQueue('CONTENT_QUEUE', self)
+        self.content_queue = ContentQueue('CONTENT_QUEUE', self)
         self.meta_queue = RequestQueue('META_QUEUE', self)
         self.uuid_map = DeferredMap()
         self.zip_queue = ZipQueue()
 
+        self.estimated_free_space = {}
+
         self.uploading = {}
         self.downloading = {}
 
         event_queue.subscribe(self)
 
+    def check_conditions(self):
+        """Poll conditions on which running actions may be waiting."""
+        self.content_queue.check_conditions()
+        self.meta_queue.check_conditions()
+
+    def have_sufficient_space_for_upload(self, share_id, upload_size):
+        """Returns True if we have sufficient space for the given upload."""
+        return self.estimated_free_space.get(share_id, 0) >= upload_size
+
+    def handle_SV_FREE_SPACE(self, share_id, free_bytes):
+        """Update estimated free space for a share."""
+        share_id = str(share_id)
+        self.estimated_free_space[share_id] = free_bytes
+        self.check_conditions()
+
+    def handle_SV_SHARE_CHANGED(self, message, info):
+        """Drop disappearing shares from estimated free space."""
+        if message == 'deleted':
+            share_id = str(info.share_id)
+            if share_id in self.estimated_free_space:
+                del self.estimated_free_space[share_id]
+
     def handle_SYS_CONNECT(self, access_token):
         """
         Stow the access token away for later use
@@ -561,6 +782,20 @@
         self.event_queue.push('SV_SHARE_ANSWERED',
                               share_id=str(share_id), answer=answer)
 
+    def _free_space_callback(self, share_id, free_bytes):
+        """
+        Called by the client when it gets a free space notification.
+        """
+        self.event_queue.push('SV_FREE_SPACE',
+                              share_id=str(share_id), free_bytes=free_bytes)
+
+    def _account_info_callback(self, account_info):
+        """
+        Called by the client when it gets an account info notification.
+        """
+        self.event_queue.push('SV_ACCOUNT_CHANGED',
+                              account_info=account_info)
+
     def _lookup_srv(self):
         """ do the SRV lookup and return a deferred whose callback is going
         to be called with (host, port). If we can't do the lookup, the default
@@ -608,7 +843,6 @@
             """ do the real thing """
             host, port = result
             ssl_context = get_ssl_context(self.disable_ssl_verify)
-
             if self.use_ssl:
                 reactor.connectSSL(host, port, self, ssl_context)
             else:
@@ -640,64 +874,78 @@
         """
         See .interfaces.IMetaQueue
         """
-        return MakeFile(self, share_id, parent_id, name, marker).start()
+        return MakeFile(self.meta_queue, share_id, parent_id,
+                        name, marker).start()
 
     def make_dir(self, share_id, parent_id, name, marker):
         """
         See .interfaces.IMetaQueue
         """
-        return MakeDir(self, share_id, parent_id, name, marker).start()
+        return MakeDir(self.meta_queue, share_id, parent_id,
+                       name, marker).start()
 
     def move(self, share_id, node_id, old_parent_id, new_parent_id, new_name):
         """
         See .interfaces.IMetaQueue
         """
-        return Move(self, share_id, node_id, old_parent_id,
+        return Move(self.meta_queue, share_id, node_id, old_parent_id,
                     new_parent_id, new_name).start()
 
     def unlink(self, share_id, parent_id, node_id):
         """
         See .interfaces.IMetaQueue
         """
-        return Unlink(self, share_id, parent_id, node_id).start()
+        return Unlink(self.meta_queue, share_id, parent_id, node_id).start()
 
     def query(self, items):
         """
         See .interfaces.IMetaQueue
         """
-        return Query(self, items).start()
+        return Query(self.meta_queue, items).start()
+
+    def inquire_free_space(self, share_id):
+        """
+        See .interfaces.IMetaQueue
+        """
+        return FreeSpaceInquiry(self.meta_queue, share_id).start()
+
+    def inquire_account_info(self):
+        """
+        see .interfaces.IMetaQueue
+        """
+        return AccountInquiry(self.meta_queue).start()
 
     def list_shares(self):
         """
         List the shares; put the result on the event queue
         """
-        return ListShares(self).start()
+        return ListShares(self.meta_queue).start()
 
     def answer_share(self, share_id, answer):
         """
         Answer the offer of a share.
         """
-        return AnswerShare(self, share_id, answer).start()
+        return AnswerShare(self.meta_queue, share_id, answer).start()
 
     def create_share(self, node_id, share_to, name, access_level, marker):
         """
         Share a node with somebody.
         """
-        return CreateShare(self, node_id, share_to, name, access_level,
-                           marker).start()
+        return CreateShare(self.meta_queue, node_id, share_to, name,
+                           access_level, marker).start()
 
     def listdir(self, share_id, node_id, server_hash, fileobj_factory):
         """
         See .interfaces.IMetaQueue.listdir
         """
-        return ListDir(self, share_id, node_id, server_hash,
+        return ListDir(self.meta_queue, share_id, node_id, server_hash,
                        fileobj_factory).start()
 
     def download(self, share_id, node_id, server_hash, fileobj_factory):
         """
         See .interfaces.IContentQueue.download
         """
-        return Download(self, share_id, node_id, server_hash,
+        return Download(self.content_queue, share_id, node_id, server_hash,
                         fileobj_factory).start()
 
     def upload(self, share_id, node_id, previous_hash, hash, crc32,
@@ -705,8 +953,9 @@
         """
         See .interfaces.IContentQueue
         """
-        return Upload(self, share_id, node_id, previous_hash, hash,
-                      crc32, size, fileobj_factory, tempfile_factory).start()
+        return Upload(self.content_queue, share_id, node_id, previous_hash,
+                      hash, crc32, size,
+                      fileobj_factory, tempfile_factory).start()
 
     def cancel_upload(self, share_id, node_id):
         """
@@ -736,6 +985,17 @@
                 log.debug("cancelled")
         log.debug('finished')
 
+    def node_is_with_queued_move(self, share_id, node_id):
+        '''True if a Move is queued for that node.'''
+        return self.meta_queue.node_is_queued(Move, share_id, node_id)
+
+    def resolve_uuid_maybe(self, marker_maybe):
+        '''
+        Resolve the maybe_marker if it is a marker and has been
+        resolved. Otherwise just return the marker_maybe back again.
+        '''
+        return self.uuid_map.resolve_maybe(marker_maybe)
+
 
 SKIP_THIS_ITEM = object()
 
@@ -762,7 +1022,36 @@
             'Connection to the other side was lost in a non-clean fashion.',
             ])
 
-    start_done = False
+    logged_attrs = ()
+
+    __slots__ = ('_queue', 'start_done', 'running', 'log')
+    def __init__(self, request_queue):
+        """Initialize a command instance."""
+        self._queue = request_queue
+        self.start_done = False
+        self.running = False
+        self.log = None
+
+    def make_logger(self):
+        """Create a logger for this object."""
+        share_id = getattr(self, "share_id", UNKNOWN)
+        node_id = getattr(self, "node_id", None) or \
+                      getattr(self, "marker", UNKNOWN)
+        attr_dict = dict([(n, getattr(self, n)) for n in self.logged_attrs])
+        return mklog(logger, self.__class__.__name__,
+                     share_id, node_id, **attr_dict)
+
+    def is_runnable(self):
+        """Returns True if the command is eligible to run."""
+        return self._is_runnable()
+
+    def _is_runnable(self):
+        """Hook for subclasses to supply a predicate for runnability."""
+        return True
+
+    def check_conditions(self):
+        """Check conditions on which the command may be waiting."""
+        pass
 
     def demark(self, *maybe_markers):
         """
@@ -810,7 +1099,7 @@
         It worked!
         """
         if self.running:
-            self.log.debug('success')
+            self.log.info('success')
             return self.handle_success(arg)
         else:
             self.log.debug('not running, so no success')
@@ -827,14 +1116,20 @@
             self.log.warn('failure', error_message)
         self.cleanup()
         if error_message in self.retryable_errors:
-            reactor.callLater(0.1, self.retry)
+            if self.running:
+                reactor.callLater(0.1, self.retry)
         else:
             return self.handle_failure(failure)
 
+    def start_unqueued(self):
+        """Do basic pre-start setup."""
+        self.log = self.make_logger()
+
     def start(self, _=None):
         """
         Queue the command.
         """
+        self.start_unqueued()
         self.log.debug('queueing in the %s' % self._queue.name)
         self._queue.queue(self)
 
@@ -863,17 +1158,28 @@
         Do the deed.
         """
         self.running = True
-        self.log.debug('starting')
         if self.start_done:
+            self.log.debug('retrying')
             d = defer.succeed(None)
         else:
+            self.log.debug('starting')
             d = self._start()
             d.addCallback(self.store_marker_result)
-            d.addCallback(lambda _: setattr(self, 'start_done', True))
-        d.addCallback(lambda _: self.log.debug('running'))
-        d.addCallback(lambda _: self.running and self._run())
+        d.addCallbacks(self._ready_to_run, self.end_errback)
+        d.addBoth(self._done_running)
+        return d
+
+    def _done_running(self, x):
+        self.running = False
+        return x
+
+    def _ready_to_run(self, _):
+        self.log.debug('running')
+        if self.running:
+            d = self._run()
+        else:
+            d = defer.succeed(None)
         d.addCallbacks(self.end_callback, self.end_errback)
-        d.addBoth(passit(lambda _: setattr(self, 'running', False)))
         return d
 
     def handle_success(self, success):
@@ -905,48 +1211,64 @@
         self.log.debug('will retry')
         return self._queue.queue_top(self)
 
-
-class ActionQueueMetaCommand(ActionQueueCommand):
-    """
-    Base of metadata-related commands (commands that are queued in the
-    meta queue)
-    """
-    @property
-    def _queue(self):
-        """
-        Get at the meta queue
-        """
-        return self.action_queue.meta_queue
-
-
-class ActionQueueContentCommand(ActionQueueCommand):
-    """
-    Base of content-related commands (commands that are queued in the
-    content queue)
-    """
-    @property
-    def _queue(self):
-        """
-        Get at the content queue
-        """
-        return self.action_queue.content_queue
-
-
-class MakeThing(ActionQueueMetaCommand):
+    @property
+    def action_queue(self):
+        """Returns the action queue."""
+        return self._queue.action_queue
+
+
+class WaitForCondition(ActionQueueCommand):
+    """A command which waits for some condition to be satisfied."""
+
+    __slots__ = ('_condition', '_deferred')
+    def __init__(self, request_queue, condition):
+        """Initializes the command instance."""
+        ActionQueueCommand.__init__(self, request_queue)
+        self._condition = condition
+        self._deferred = None
+
+    def _run(self):
+        """Returns a deferred which blocks until the condition is satisfied."""
+        if self._condition():
+            d = defer.succeed(None)
+            self._deferred = None
+        else:
+            d = defer.Deferred()
+            self._deferred = d
+            event_name = 'SYS_' + self._queue.name + '_BLOCKED'
+            self.action_queue.event_queue.push(event_name)
+        return d
+
+    def check_conditions(self):
+        """Poll the action's condition."""
+        if self._deferred is not None and self._condition():
+            try:
+                self._deferred.callback(None)
+                self._deferred = None
+            except defer.AlreadyCalledError:
+                return
+
+    def cleanup(self):
+        """Does cleanup."""
+        self._deferred = None
+        ActionQueueCommand.cleanup(self)
+
+
+class MakeThing(ActionQueueCommand):
     """
     Base of MakeFile and MakeDir
     """
-    def __init__(self, action_queue, share_id, parent_id, name, marker):
-        self.action_queue = action_queue
+    __slots__ = ('share_id', 'parent_id', 'name', 'marker')
+    logged_attrs = __slots__
+
+    def __init__(self, request_queue, share_id, parent_id, name, marker):
+        super(MakeThing, self).__init__(request_queue)
         self.share_id = share_id
         self.parent_id = parent_id
         # Unicode boundary! the name is Unicode in protocol and server, but
         # here we use bytes for paths
         self.name = name.decode("utf8")
         self.marker = marker
-        self.log = mklog(logger, self.__class__.__name__, share_id, marker,
-                         share=share_id, parent=parent_id, name=name,
-                         marker=marker)
 
     def _start(self):
         """
@@ -960,6 +1282,7 @@
         """
         self.share_id = share_id
         self.parent_id = parent_id
+        self.start_done = True
 
     def _run(self):
         """
@@ -1000,6 +1323,7 @@
     """
     Make a file
     """
+    __slots__ = ()
     ok_event_name = 'AQ_FILE_NEW_OK'
     error_event_name = 'AQ_FILE_NEW_ERROR'
     client_method = 'make_file'
@@ -1009,18 +1333,23 @@
     """
     Make a directory
     """
+    __slots__ = ()
     ok_event_name = 'AQ_DIR_NEW_OK'
     error_event_name = 'AQ_DIR_NEW_ERROR'
     client_method = 'make_dir'
 
 
-class Move(ActionQueueMetaCommand):
+class Move(ActionQueueCommand):
     """
     Move a file or directory
     """
-    def __init__(self, action_queue, share_id, node_id, old_parent_id,
+    __slots__ = ('share_id', 'node_id', 'old_parent_id',
+                 'new_parent_id', 'new_name')
+    logged_attrs =  __slots__
+
+    def __init__(self, request_queue, share_id, node_id, old_parent_id,
                  new_parent_id, new_name):
-        self.action_queue = action_queue
+        super(Move, self).__init__(request_queue)
         self.share_id = share_id
         self.node_id = node_id
         self.old_parent_id = old_parent_id
@@ -1028,10 +1357,6 @@
         # Unicode boundary! the name is Unicode in protocol and server, but
         # here we use bytes for paths
         self.new_name = new_name.decode("utf8")
-        self.log = mklog(logger, self.__class__.__name__, share_id, node_id,
-                         share=share_id, node=node_id,
-                         old_parent=old_parent_id, new_parent=new_parent_id,
-                         new_name=new_name)
 
     def _start(self):
         """
@@ -1046,6 +1371,7 @@
         self.share_id = share_id
         self.node_id = node_id
         self.new_parent_id = new_parent_id
+        self.start_done = True
 
     def _run(self):
         """
@@ -1077,17 +1403,18 @@
                                            new_name=self.new_name)
 
 
-class Unlink(ActionQueueMetaCommand):
+class Unlink(ActionQueueCommand):
     """
     Unlink a file or dir
     """
-    def __init__(self, action_queue, share_id, parent_id, node_id):
-        self.action_queue = action_queue
+    __slots__ = ('share_id', 'node_id', 'parent_id')
+    logged_attrs = __slots__
+
+    def __init__(self, request_queue, share_id, parent_id, node_id):
+        super(Unlink, self).__init__(request_queue)
         self.share_id = share_id
         self.node_id = node_id
         self.parent_id = parent_id
-        self.log = mklog(logger, self.__class__.__name__, share_id, node_id,
-                         share=share_id, node=node_id, parent=parent_id)
 
     def _start(self):
         """
@@ -1102,6 +1429,7 @@
         self.share_id = share_id
         self.node_id = node_id
         self.parent_id = parent_id
+        self.start_done = True
 
     def _run(self):
         """
@@ -1130,23 +1458,28 @@
                                            node_id=self.node_id)
 
 
-class Query(ActionQueueMetaCommand):
+class Query(ActionQueueCommand):
     """
     Ask about the freshness of server hashes
     """
-    def __init__(self, action_queue, items):
-        self.log = MultiProxy(
+    __slots__ = ('items')
+    def __init__(self, request_queue, items):
+        super(Query, self).__init__(request_queue)
+        self.items = items
+
+    def make_logger(self):
+        """Make the magic logger for queries."""
+        return MultiProxy(
             [mklog(logger, '(unrolled) query', share, node,
                    share=share, node=node, hash=hash, index=i)
-             for (i, (share, node, hash)) in enumerate(items)])
-        self.action_queue = action_queue
-        self.items = items
+             for (i, (share, node, hash)) in enumerate(self.items)])
 
     def store_marker_result(self, items):
         """
         Called when all the markers are realized.
         """
         self.items = items
+        self.start_done = True
 
     def _start(self):
         """
@@ -1186,13 +1519,11 @@
         return self.action_queue.client.query(self.items)
 
 
-class ListShares(ActionQueueMetaCommand):
+class ListShares(ActionQueueCommand):
     """
     List shares shared to me
     """
-    def __init__(self, action_queue):
-        self.action_queue = action_queue
-        self.log = mklog(logger, 'list_shares', UNKNOWN, UNKNOWN)
+    __slots__ = ()
 
     def _run(self):
         """
@@ -1215,15 +1546,56 @@
                                            error=failure.getErrorMessage())
 
 
-class AnswerShare(ActionQueueMetaCommand):
+class FreeSpaceInquiry(ActionQueueCommand):
+    """Inquire about free space."""
+
+    def __init__(self, request_queue, share_id):
+        """Initialize the instance."""
+        super(FreeSpaceInquiry, self).__init__(request_queue)
+        self.share_id = share_id
+
+    def _run(self):
+        """Do the query."""
+        return self.action_queue.client.get_free_space(self.share_id)
+
+    def handle_success(self, success):
+        """Publish the free space information."""
+        self.action_queue.event_queue.push('SV_FREE_SPACE',
+                                           share_id=success.share_id,
+                                           free_bytes=success.free_bytes)
+
+    def handle_failure(self, failure):
+        """Publish the error."""
+        self.action_queue.event_queue.push('AQ_FREE_SPACE_ERROR',
+                                           error=failure.getErrorMessage())
+
+
+class AccountInquiry(ActionQueueCommand):
+    """Query user account information."""
+    def _run(self):
+        """Make the actual request."""
+        return self.action_queue.client.get_account_info()
+
+    def handle_success(self, success):
+        """Publish the account information to the event queue."""
+        self.action_queue.event_queue.push('SV_ACCOUNT_CHANGED',
+                                           account_info=success)
+
+    def handle_failure(self, failure):
+        """Publish the error."""
+        self.action_queue.event_queue.push('AQ_ACCOUNT_ERROR',
+                                           error=failure.getErrorMessage())
+
+
+class AnswerShare(ActionQueueCommand):
     """
     Answer a share offer
     """
-    def __init__(self, action_queue, share_id, answer):
-        self.action_queue = action_queue
+    __slots__ = ('share_id', 'answer')
+    def __init__(self, request_queue, share_id, answer):
+        super(AnswerShare, self).__init__(request_queue)
         self.share_id = share_id
         self.answer = answer
-        self.log = mklog(logger, 'answer_share', share_id, UNKNOWN)
 
     def _run(self):
         """
@@ -1251,19 +1623,20 @@
         return failure
 
 
-class CreateShare(ActionQueueMetaCommand):
+class CreateShare(ActionQueueCommand):
     """
     Offer a share to somebody
     """
-    def __init__(self, action_queue, node_id, share_to, name, access_level,
+    __slots__ = ('node_id', 'share_to', 'name', 'access_level',
+                 'marker', 'use_http')
+    def __init__(self, request_queue, node_id, share_to, name, access_level,
                  marker):
-        self.action_queue = action_queue
+        super(CreateShare, self).__init__(request_queue)
         self.node_id = node_id
         self.share_to = share_to
         self.name = name
         self.access_level = access_level
         self.marker = marker
-        self.log = mklog(logger, self.__class__.__name__, UNKNOWN, node_id)
         self.use_http = False
 
         if share_to and re.match(EREGEX, share_to):
@@ -1274,6 +1647,7 @@
         Called when all the markers are realized.
         """
         self.node_id = node_id
+        self.start_done = True
 
     def _start(self):
         """
@@ -1346,23 +1720,23 @@
                                            error=failure.getErrorMessage())
 
 
-class GetContentMixin(object):
+class GetContentMixin(ActionQueueCommand):
     """
     Base for ListDir and Download. It's a mixin (ugh) because
     otherwise things would be even more confusing
     """
-    def __init__(self, action_queue, share_id, node_id, server_hash,
+    __slots__ = ('share_id', 'node_id', 'server_hash', 'fileobj_factory',
+                 'fileobj', 'gunzip')
+    logged_attrs = ('share_id', 'node_id', 'server_hash', 'fileobj_factory')
+    def __init__(self, request_queue, share_id, node_id, server_hash,
                  fileobj_factory):
-        self.action_queue = action_queue
+        super(GetContentMixin, self).__init__(request_queue)
         self.share_id = share_id
         self.node_id = node_id
         self.server_hash = server_hash
         self.fileobj_factory = fileobj_factory
         self.fileobj = None
         self.gunzip = zlib.decompressobj()
-        self.log = mklog(logger, self.__class__.__name__, share_id, node_id,
-                         share=share_id, node=node_id, server_hash=server_hash,
-                         fileobj_factory=fileobj_factory)
         if (self.share_id, self.node_id) in self.action_queue.downloading:
             self.action_queue.cancel_download(self.share_id, self.node_id)
 
@@ -1377,19 +1751,25 @@
         Called when all the markers are realized.
         """
         self.node_id = node_id
+        self.start_done = True
 
     def _run(self):
         """
         Do the actual running
         """
-        try:
-            self.fileobj = self.fileobj_factory()
-        except StandardError:
-            return defer.fail(Failure('unable to build fileobj'
-                                      ' (file went away?)'
-                                      ' so aborting the download.'))
-        self.action_queue.downloading[self.share_id,
-                                      self.node_id] = {'n_bytes_read': 0}
+        if self.fileobj is None:
+            try:
+                self.fileobj = self.fileobj_factory()
+            except StandardError:
+                return defer.fail(Failure('unable to build fileobj'
+                                          ' (file went away?)'
+                                          ' so aborting the download.'))
+        downloading = self.action_queue.downloading
+        if (self.share_id, self.node_id) not in downloading:
+            downloading[self.share_id, self.node_id] = {'n_bytes_read': 0,
+                                                        'command': self}
+        assert downloading[self.share_id, self.node_id]['command'] is self
+        offset = downloading[self.share_id, self.node_id]['n_bytes_read']
 
         self.action_queue.event_queue.push('AQ_DOWNLOAD_STARTED',
                                            share_id=self.share_id,
@@ -1398,19 +1778,19 @@
 
         req = self.action_queue.client.get_content_request(
             self.share_id, self.node_id, self.server_hash,
+            offset=offset,
             callback=self.cb, node_attr_callback=self.nacb)
-        self.action_queue.downloading[self.share_id, self.node_id]['req'] = req
+        downloading[self.share_id, self.node_id]['req'] = req
         d = req.deferred
-        d.addBoth(passit(lambda _:
-                             self.action_queue.downloading.pop((self.share_id,
-                                                                self.node_id))))
-        d.addErrback(passit(lambda _: self.reset_fileobj()))
+        d.addCallback(passit(
+                lambda _: downloading.pop((self.share_id, self.node_id))))
         return d
 
     def handle_success(self, _):
         """
         It worked! Push the event.
         """
+        self.sync()
         self.action_queue.event_queue.push('AQ_DOWNLOAD_FINISHED',
                                            share_id=self.share_id,
                                            node_id=self.node_id,
@@ -1420,11 +1800,22 @@
         """
         It didn't work! Push the event.
         """
-        self.action_queue.event_queue.push('AQ_DOWNLOAD_ERROR',
-                                           error=failure.getErrorMessage(),
-                                           share_id=self.share_id,
-                                           node_id=self.node_id,
-                                           server_hash=self.server_hash)
+        downloading = self.action_queue.downloading
+        if (self.share_id, self.node_id) in downloading \
+                and downloading[self.share_id, self.node_id]['command'] is self:
+            del downloading[self.share_id, self.node_id]
+        self.reset_fileobj()
+        if failure.getErrorMessage() == 'CANCELLED':
+            self.action_queue.event_queue.push('AQ_DOWNLOAD_CANCELLED',
+                                               share_id=self.share_id,
+                                               node_id=self.node_id,
+                                               server_hash=self.server_hash)
+        else:
+            self.action_queue.event_queue.push('AQ_DOWNLOAD_ERROR',
+                                               error=failure.getErrorMessage(),
+                                               share_id=self.share_id,
+                                               node_id=self.node_id,
+                                               server_hash=self.server_hash)
 
     def reset_fileobj(self):
         """
@@ -1453,11 +1844,13 @@
         self.action_queue.downloading[self.share_id,
                                       self.node_id].update(kwargs)
 
-    def sync(self, _):
+    def sync(self):
         """
         Flush the buffers and sync them to disk if possible
         """
-        self.fileobj.write(self.gunzip.flush())
+        remains = self.gunzip.flush()
+        if remains:
+            self.fileobj.write(remains)
         self.fileobj.flush()
         if getattr(self.fileobj, 'fileno', None) is not None:
             # it's a real file, with a fileno! Let's sync its data
@@ -1466,26 +1859,33 @@
         self.fileobj.close()
 
 
-class ListDir(GetContentMixin, ActionQueueMetaCommand):
+class ListDir(GetContentMixin, ActionQueueCommand):
     """
     Get a listing of a directory's contents
     """
+    __slots__ = ()
 
-class Download(GetContentMixin, ActionQueueContentCommand):
+class Download(GetContentMixin, ActionQueueCommand):
     """
     Get the contents of a file.
     """
+    __slots__ = ()
 
-class Upload(ActionQueueContentCommand):
+class Upload(ActionQueueCommand):
     """
     Upload stuff to a file
     """
-    retryable_errors = (ActionQueueContentCommand.retryable_errors
+    __slots__ = ('share_id', 'node_id', 'previous_hash', 'hash', 'crc32',
+                 'size', 'fileobj_factory', 'tempfile_factory', 'deflated_size',
+                 'tempfile', 'cancelled', 'upload_req')
+    logged_attrs = ('share_id', 'node_id', 'previous_hash', 'hash', 'crc32',
+                    'size', 'fileobj_factory')
+    retryable_errors = (ActionQueueCommand.retryable_errors
                         | set(['UPLOAD_IN_PROGRESS']))
 
-    def __init__(self, action_queue, share_id, node_id, previous_hash, hash,
+    def __init__(self, request_queue, share_id, node_id, previous_hash, hash,
                  crc32, size, fileobj_factory, tempfile_factory):
-        self.action_queue = action_queue
+        super(Upload, self).__init__(request_queue)
         self.share_id = share_id
         self.node_id = node_id
         self.previous_hash = previous_hash
@@ -1498,13 +1898,15 @@
         self.tempfile = None
         self.cancelled = False
         self.upload_req = None
-        self.log = mklog(logger, 'upload', share_id, node_id, share=share_id,
-                         node=node_id, previous_hash=previous_hash,
-                         hash=hash, crc32=crc32, size=size,
-                         fileobj_factory=fileobj_factory)
         if (self.share_id, self.node_id) in self.action_queue.uploading:
             self.action_queue.cancel_upload(self.share_id, self.node_id)
 
+    def _is_runnable(self):
+        """Returns True if there is sufficient space available to complete
+        the upload."""
+        return self.action_queue.have_sufficient_space_for_upload(self.share_id,
+                                                                  self.size)
+
     def cancel(self):
         """Cancel the upload."""
         self.cancelled = True
@@ -1542,7 +1944,7 @@
                                                      self.node_id))
         self.node_id = node_id
         self.action_queue.uploading[self.share_id, node_id] = uploading
-
+        self.start_done = True
 
     def _run(self):
         """

=== modified file 'ubuntuone/syncdaemon/dbus_interface.py'
--- ubuntuone/syncdaemon/dbus_interface.py	2009-08-11 16:45:00 +0000
+++ ubuntuone/syncdaemon/dbus_interface.py	2009-08-26 12:15:00 +0000
@@ -16,6 +16,8 @@
 # You should have received a copy of the GNU General Public License along
 # with this program.  If not, see <http://www.gnu.org/licenses/>.
 """ DBUS interface module """
+from itertools import groupby, chain
+
 import dbus.service
 
 from ubuntuone.syncdaemon.event_queue import EVENTS
@@ -31,6 +33,7 @@
 DBUS_IFACE_EVENTS_NAME = DBUS_IFACE_NAME+'.Events'
 DBUS_IFACE_FS_NAME = DBUS_IFACE_NAME+'.FileSystem'
 DBUS_IFACE_SHARES_NAME = DBUS_IFACE_NAME+'.Shares'
+DBUS_IFACE_CONFIG_NAME = DBUS_IFACE_NAME+'.Config'
 
 # NetworkManager State constants
 NM_STATE_UNKNOWN = 0
@@ -43,6 +46,17 @@
                    NM_STATE_DISCONNECTED: 'SYS_NET_DISCONNECTED'}
 
 
+logger = logging.getLogger("ubuntuone.SyncDaemon.DBus")
+
+def get_classname(thing):
+    """
+    Get the clasname of the thing.
+    If we could forget 2.5, we could do attrgetter('__class__.__name__')
+    Alas, we can't forget it yet.
+    """
+    return thing.__class__.__name__
+
+
 class DBusExposedObject(dbus.service.Object):
     """ Base class that provides some helper methods to
     DBus exposed objects.
@@ -88,6 +102,7 @@
         """ return the current status of the system, one of: local_rescan,
         offline, trying_to_connect, server_rescan or online.
         """
+        logger.debug('called current_status')
         state = self.dbus_iface.main.state.state
         self.emit_status_changed(state)
         state_dict = {'name':state.name,
@@ -100,6 +115,7 @@
     @dbus.service.method(DBUS_IFACE_STATUS_NAME, out_signature='aa{ss}')
     def current_downloads(self):
         """ return list of files with a download in progress. """
+        logger.debug('called current_downloads')
         current_downloads = []
         for download in self.action_queue.downloading:
             try:
@@ -127,6 +143,7 @@
         """
         returns a list of files that are waiting to be up- or downloaded
         """
+        logger.debug('called waiting_content')
         waiting_content = []
         for cmd in self.action_queue.content_queue.waiting:
             try:
@@ -152,11 +169,13 @@
         Make the command on the given share and node be next in the
         queue of waiting commands.
         """
+        logger.debug('called schedule_next')
         self.action_queue.content_queue.schedule_next(share_id, node_id)
 
     @dbus.service.method(DBUS_IFACE_STATUS_NAME, out_signature='aa{ss}')
     def current_uploads(self):
         """ return a list of files with a upload in progress """
+        logger.debug('called current_uploads')
         current_uploads = []
         for upload in self.action_queue.uploading:
             share_id, node_id = upload
@@ -187,8 +206,9 @@
         """ Fire a D-BUS signal, notifying a download has started.  """
         pass
 
-    @dbus.service.signal(DBUS_IFACE_STATUS_NAME)
-    def DownloadFinished(self, path):
+    @dbus.service.signal(DBUS_IFACE_STATUS_NAME,
+                         signature='sa{ss}')
+    def DownloadFinished(self, path, info):
         """ Fire a D-BUS signal, notifying a download has finished.  """
         pass
 
@@ -197,8 +217,9 @@
         """ Fire a D-BUS signal, notifying an upload has started.  """
         pass
 
-    @dbus.service.signal(DBUS_IFACE_STATUS_NAME)
-    def UploadFinished(self, path):
+    @dbus.service.signal(DBUS_IFACE_STATUS_NAME,
+                         signature='sa{ss}')
+    def UploadFinished(self, path, info):
         """ Fire a D-BUS signal, notifying an upload has finished.  """
         pass
 
@@ -209,6 +230,49 @@
         """
         pass
 
+    @dbus.service.signal(DBUS_IFACE_STATUS_NAME)
+    def AccountChanged(self, account_info):
+        """ Fire a D-BUS signal, notifying that account information
+        has changed.
+        """
+        pass
+
+    @dbus.service.signal(DBUS_IFACE_STATUS_NAME, signature='a{sa{ss}}')
+    def ContentQueueChanged(self, message):
+        """
+        Fire a D-BUS signal, notifying that the content queue has
+        changed.
+        """
+
+    def emit_content_queue_changed(self, head, waiting):
+        """
+        Emits the signal.
+        """
+        if head is None or getattr(head, 'node_id', None) is None:
+            head_path = ''
+            head_cmd = ''
+        else:
+            waiting = chain((head,), waiting)
+            head_cmd = get_classname(head)
+            try:
+                if IMarker.providedBy(head.node_id):
+                    # it's a marker! so it's the mdid :)
+                    relpath = self.fs_manager.get_by_mdid(head.node_id).path
+                else:
+                    relpath = self.fs_manager.get_by_node_id(head.share_id,
+                                                             head.node_id).path
+            except KeyError:
+                head_path = ''
+            else:
+                head_path = self.fs_manager.get_abspath(head.share_id, relpath)
+        message = dict(
+            (k, {'size': '0', 'count': str(len(tuple(v)))})
+            for (k, v) in groupby(sorted(map(get_classname, waiting))))
+        message['head'] = {'path': head_path,
+                           'command': head_cmd,
+                           'size': '0'}
+        self.ContentQueueChanged(message)
+
     def emit_status_changed(self, state):
         """ Emits the signal """
         state_dict = {'name':state.name,
@@ -222,17 +286,26 @@
         """ Emits the signal """
         self.DownloadStarted(download)
 
-    def emit_download_finished(self, download):
+    def emit_download_finished(self, download, **info):
         """ Emits the signal """
-        self.DownloadFinished(download)
+        for k, v in info.copy().items():
+            info[str(k)] = str(v)
+        self.DownloadFinished(download, info)
 
     def emit_upload_started(self, upload):
         """ Emits the signal """
         self.UploadStarted(upload)
 
-    def emit_upload_finished(self, upload):
-        """ Emits the signal """
-        self.UploadFinished(upload)
+    def emit_upload_finished(self, upload, **info):
+        """ Emits the signal """
+        for k, v in info.copy().items():
+            info[str(k)] = str(v)
+        self.UploadFinished(upload, info)
+
+    def emit_account_changed(self, account_info):
+        """ Emits the signal """
+        info_dict = {'purchased_bytes': account_info.purchased_bytes}
+        self.AccountChanged(info_dict)
 
 
 class Events(DBusExposedObject):
@@ -264,6 +337,7 @@
     @dbus.service.method(DBUS_IFACE_EVENTS_NAME, in_signature='sas')
     def push_event(self, event_name, args):
         """ Push a event to the event queue """
+        logger.debug('push_event: %r with %r', event_name, args)
         str_args = []
         for arg in args:
             str_args.append(str(arg))
@@ -301,6 +375,8 @@
                             server_hash)
         try:
             mdobj = self.dbus_iface.fs_manager.get_by_node_id(share_id, node_id)
+            if mdobj.is_dir:
+                return
             path = self.dbus_iface.fs_manager.get_abspath(share_id, mdobj.path)
             self.dbus_iface.status.emit_download_started(path)
         except KeyError, e:
@@ -317,6 +393,8 @@
                             node_id, server_hash)
         try:
             mdobj = self.dbus_iface.fs_manager.get_by_node_id(share_id, node_id)
+            if mdobj.is_dir:
+                return
             path = self.dbus_iface.fs_manager.get_abspath(share_id, mdobj.path)
             self.dbus_iface.status.emit_download_finished(path)
         except KeyError, e:
@@ -328,11 +406,39 @@
                         node_id=str(node_id))
             self.dbus_iface.status.emit_signal_error('DownloadFinished', args)
 
+    def handle_AQ_DOWNLOAD_CANCELLED(self, share_id, node_id, server_hash):
+        """ handle AQ_DOWNLOAD_CANCELLED """
+        self.handle_AQ_DOWNLOAD_ERROR(share_id, node_id, server_hash,
+                                      'CANCELLED', 'AQ_DOWNLOAD_CANCELLED')
+
+    def handle_AQ_DOWNLOAD_ERROR(self, share_id, node_id, server_hash, error,
+                                 event='AQ_DOWNLOAD_ERROR'):
+        """ handle AQ_DOWNLOAD_ERROR """
+        self.handle_default(event, share_id, node_id,
+                            server_hash, error)
+        try:
+            mdobj = self.dbus_iface.fs_manager.get_by_node_id(share_id, node_id)
+            if mdobj.is_dir:
+                return
+            path = self.dbus_iface.fs_manager.get_abspath(share_id, mdobj.path)
+            self.dbus_iface.status.emit_download_finished(path, error=error)
+        except KeyError, e:
+            # file is gone before we got this
+            args = dict(message='The md is gone before sending '
+                        'DownloadFinished signal',
+                        error=str(e),
+                        share_id=str(share_id),
+                        node_id=str(node_id),
+                        download_error=str(error))
+            self.dbus_iface.status.emit_signal_error('DownloadFinished', args)
+
     def handle_AQ_UPLOAD_STARTED(self, share_id, node_id, hash):
         """ handle AQ_UPLOAD_STARTED """
         self.handle_default('AQ_UPLOAD_STARTED', share_id, node_id, hash)
         try:
             mdobj = self.dbus_iface.fs_manager.get_by_node_id(share_id, node_id)
+            if mdobj.is_dir:
+                return
             path = self.dbus_iface.fs_manager.get_abspath(share_id, mdobj.path)
             self.dbus_iface.status.emit_upload_started(path)
         except KeyError, e:
@@ -348,6 +454,8 @@
         self.handle_default('AQ_UPLOAD_FINISHED', share_id, node_id, hash)
         try:
             mdobj = self.dbus_iface.fs_manager.get_by_node_id(share_id, node_id)
+            if mdobj.is_dir:
+                return
             path = self.dbus_iface.fs_manager.get_abspath(share_id, mdobj.path)
             self.dbus_iface.status.emit_upload_finished(path)
         except KeyError, e:
@@ -359,6 +467,30 @@
                         node_id=str(node_id))
             self.dbus_iface.status.emit_signal_error('UploadFinished', args)
 
+    def handle_SV_ACCOUNT_CHANGED(self, account_info):
+        """ handle SV_ACCOUNT_CHANGED """
+        self.handle_default('SV_ACCOUNT_CHANGED', account_info)
+        self.dbus_iface.status.emit_account_changed(account_info)
+
+    def handle_AQ_UPLOAD_ERROR(self, share_id, node_id, error, hash):
+        """ handle AQ_UPLOAD_ERROR """
+        self.handle_default('AQ_UPLOAD_ERROR', share_id, node_id, error, hash)
+        try:
+            mdobj = self.dbus_iface.fs_manager.get_by_node_id(share_id, node_id)
+            if mdobj.is_dir:
+                return
+            path = self.dbus_iface.fs_manager.get_abspath(share_id, mdobj.path)
+            self.dbus_iface.status.emit_upload_finished(path, error=error)
+        except KeyError, e:
+            # file is gone before we got this
+            args = dict(message='The metadata is gone before sending '
+                        'UploadFinished signal',
+                        error=str(e),
+                        share_id=str(share_id),
+                        node_id=str(node_id),
+                        upload_error=str(error))
+            self.dbus_iface.status.emit_signal_error('UploadFinished', args)
+
     def handle_SYS_STATE_CHANGED(self, state):
         """ handle SYS_STATE_CHANGED """
         self.handle_default('SYS_STATE_CHANGED', state)
@@ -369,6 +501,11 @@
         self.handle_default('SV_SHARE_CHANGED', message, share)
         self.dbus_iface.shares.emit_share_changed(message, share)
 
+    def handle_SV_FREE_SPACE(self, share_id, free_bytes):
+        """ handle SV_FREE_SPACE event, emit ShareChanged signal. """
+        self.handle_default('SV_FREE_SPACE', share_id, free_bytes)
+        self.dbus_iface.shares.emit_free_space(share_id, free_bytes)
+
     def handle_AQ_CREATE_SHARE_OK(self, share_id, marker):
         """ handle AQ_CREATE_SHARE_OK event, emit's ShareCreated signal. """
         self.handle_default('AQ_CREATE_SHARE_OK', share_id, marker)
@@ -418,18 +555,21 @@
                          in_signature='', out_signature='')
     def connect(self):
         """ Connect to the server. """
+        logger.debug('connect requetsed')
         self.dbus_iface.connect()
 
     @dbus.service.method(DBUS_IFACE_SYNC_NAME,
                          in_signature='', out_signature='')
     def disconnect(self):
         """ Disconnect from the server. """
+        logger.debug('disconnect requetsed')
         self.dbus_iface.disconnect()
 
     @dbus.service.method(DBUS_IFACE_SYNC_NAME,
                          in_signature='', out_signature='s')
     def get_rootdir(self):
         """ Returns the root dir/mount point. """
+        logger.debug('called get_rootdir')
         return self.dbus_iface.main.get_rootdir()
 
     @dbus.service.method(DBUS_IFACE_SYNC_NAME,
@@ -440,6 +580,7 @@
         """ call the reply handler when there are no more
         events or transfers.
         """
+        logger.debug('called wait_for_nirvana')
         d = self.dbus_iface.main.wait_for_nirvana(last_event_interval)
         d.addCallbacks(reply_handler, error_handler)
         return d
@@ -448,6 +589,7 @@
                          in_signature='s', out_signature='')
     def query_by_path(self, path):
         """  Request a query of the node identified by path. """
+        logger.debug('query_by_path: %r', path)
         mdobj = self.dbus_iface.fs_manager.get_by_path(path.encode('utf-8'))
         items = [(mdobj.share_id, mdobj.node_id, "")]
         self.dbus_iface.action_queue.query(items)
@@ -457,11 +599,12 @@
                          async_callbacks=('reply_handler', 'error_handler'))
     def quit(self, reply_handler=None, error_handler=None):
         """ shutdown the syncdaemon. """
-        self.dbus_iface.log.debug('Quit requested')
+        logger.debug('Quit requested')
         if reply_handler:
             reply_handler()
         self.dbus_iface.quit()
 
+
 class FileSystem(DBusExposedObject):
     """ A dbus interface to the FileSystem Manager. """
 
@@ -478,6 +621,7 @@
         """ returns the dict with the attributes of the metadata
         for the specified path.
         """
+        logger.debug('get_metadata: %r', path)
         mdobj = self.fs_manager.get_by_path(path.encode('utf-8'))
         md_dict = {}
         for k, v in mdobj.__dict__.items():
@@ -505,6 +649,7 @@
                          in_signature='', out_signature='aa{ss}')
     def get_shares(self):
         """ returns a list of dicts, each dict represents a share """
+        logger.debug('called get_shares')
         shares = []
         for share_id, share in self.vm.shares.items():
             if share_id == '':
@@ -520,6 +665,7 @@
         """ Accepts a share, a ShareAnswerOk|Error signal will be fired in the
         future as a success/failure indicator.
         """
+        logger.debug('accept_share: %r', share_id)
         if str(share_id) in self.vm.shares:
             self.vm.accept_share(str(share_id), True)
             reply_handler()
@@ -532,6 +678,7 @@
                          async_callbacks=('reply_handler', 'error_handler'))
     def reject_share(self, share_id, reply_handler=None, error_handler=None):
         """ Rejects a share. """
+        logger.debug('reject_share: %r', share_id)
         if str(share_id) in self.vm.shares:
             self.vm.accept_share(str(share_id), False)
             reply_handler()
@@ -562,6 +709,14 @@
             share = self.vm.shares[share.share_id]
             self.ShareChanged(self._get_share_dict(share))
 
+    def emit_free_space(self, share_id, free_bytes):
+        """ emits ShareChanged when free space changes """
+        if share_id in self.vm.shares:
+            share = self.vm.shares[share_id]
+            share_dict = self._get_share_dict(share)
+            share_dict['free_bytes'] = unicode(free_bytes)
+            self.ShareChanged(share_dict)
+
     def _get_share_dict(self, share):
         """ get a dict with all the attributes of: share. """
         share_dict = share.__dict__.copy()
@@ -584,6 +739,8 @@
         @param name: the name of the share
         @param access_level: 'View' or 'Modify'
         """
+        logger.debug('create share: %r, %r, %r, %r',
+                     path, username, name, access_level)
         path = path.encode("utf8")
         username = unicode(username)
         name = unicode(name)
@@ -627,6 +784,7 @@
         A share might not have the path set, as we might be still fetching the
         nodes from the server. In this cases the path is ''
         """
+        logger.debug('called get_shared')
         shares = []
         for share_id, share in self.vm.shared.items():
             if share_id == '':
@@ -649,6 +807,121 @@
         self.ShareAnswerResponse(answer_info)
 
 
+class Config(DBusExposedObject):
+    """ The Syncdaemon config/settings dbus interface. """
+
+    def __init__(self, bus_name, dbus_iface):
+        """ Creates the instance.
+
+        @param bus: the BusName of this DBusExposedObject.
+        """
+        self.dbus_iface = dbus_iface
+        self.path = '/config'
+        DBusExposedObject.__init__(self, bus_name=bus_name,
+                                   path=self.path)
+
+    @dbus.service.method(DBUS_IFACE_CONFIG_NAME,
+                         in_signature='', out_signature='a{si}',
+                         async_callbacks=('reply_handler', 'error_handler'))
+    def get_throttling_limits(self, reply_handler=None, error_handler=None):
+        """Get the read/write limit from AQ and return a dict.
+        Returns a dict(download=int, upload=int), if int is -1 the value isn't
+        configured.
+        The values are bytes/second
+        """
+        try:
+            aq = self.dbus_iface.action_queue
+            download = -1
+            upload = -1
+            if aq.readLimit is not None:
+                download = aq.readLimit
+            if aq.writeLimit is not None:
+                upload = aq.writeLimit
+            info = dict(download=download,
+                        upload=upload)
+            if reply_handler:
+                reply_handler(info)
+            else:
+                return info
+            # pylint: disable-msg=W0703
+        except Exception, e:
+            if error_handler:
+                error_handler(e)
+            else:
+                raise
+
+    @dbus.service.method(DBUS_IFACE_CONFIG_NAME,
+                         in_signature='ii', out_signature='',
+                         async_callbacks=('reply_handler', 'error_handler'))
+    def set_throttling_limits(self, download, upload,
+                         reply_handler=None, error_handler=None):
+        """Set the read and write limits. The expected values are bytes/sec."""
+        try:
+            aq = self.dbus_iface.action_queue
+            if download == -1:
+                download = None
+            if upload == -1:
+                upload = None
+            aq.readLimit = download
+            aq.writeLimit = upload
+            if reply_handler:
+                reply_handler()
+            # pylint: disable-msg=W0703
+        except Exception, e:
+            if error_handler:
+                error_handler(e)
+            else:
+                raise
+
+    @dbus.service.method(DBUS_IFACE_CONFIG_NAME,
+                         in_signature='', out_signature='',
+                         async_callbacks=('reply_handler', 'error_handler'))
+    def enable_bandwidth_throttling(self, reply_handler=None,
+                                    error_handler=None):
+        """Enable bandwidth throttling."""
+        try:
+            self.dbus_iface.action_queue.enable_throttling(True)
+            if reply_handler:
+                reply_handler()
+            # pylint: disable-msg=W0703
+        except Exception, e:
+            if error_handler:
+                error_handler(e)
+            else:
+                raise
+
+    @dbus.service.method(DBUS_IFACE_CONFIG_NAME,
+                         in_signature='', out_signature='',
+                         async_callbacks=('reply_handler', 'error_handler'))
+    def disable_bandwidth_throttling(self, reply_handler=None,
+                                     error_handler=None):
+        """Disable bandwidth throttling."""
+        try:
+            self.dbus_iface.action_queue.enable_throttling(False)
+            if reply_handler:
+                reply_handler()
+            # pylint: disable-msg=W0703
+        except Exception, e:
+            if error_handler:
+                error_handler(e)
+            else:
+                raise
+
+    @dbus.service.method(DBUS_IFACE_CONFIG_NAME,
+                         in_signature='', out_signature='b',
+                         async_callbacks=('reply_handler', 'error_handler'))
+    def bandwidth_throttling_enabled(self, reply_handler=None,
+                                     error_handler=None):
+        """Returns True (actually 1) if bandwidth throttling is enabled and
+        False (0) otherwise.
+        """
+        enabled = self.dbus_iface.action_queue.throttling
+        if reply_handler:
+            reply_handler(enabled)
+        else:
+            return enabled
+
+
 class DBusInterface(object):
     """ Holder of all DBus exposed objects """
     test = False
@@ -657,7 +930,6 @@
         """ Create the instance and add the exposed object to the
         specified bus.
         """
-        self.log = logging.getLogger("ubuntuone.SyncDaemon.DBus")
         self.bus = bus
         self.main = main
         self.event_queue = main.event_q
@@ -673,13 +945,14 @@
         self.fs = FileSystem(self.busName, self.fs_manager)
         self.shares = Shares(self.busName, self.fs_manager,
                              self.volume_manager)
+        self.config = Config(self.busName, self)
         if system_bus is None and not DBusInterface.test:
-            self.log.debug('using the real system bus')
+            logger.debug('using the real system bus')
             self.system_bus = self.bus.get_system()
         elif system_bus is None and DBusInterface.test:
             # this is just for the case when test_sync instatiate Main for
             # running it's tests as pqm don't have a system bus running
-            self.log.debug('using the session bus as system bus')
+            logger.debug('using the session bus as system bus')
             self.system_bus = self.bus
         else:
             self.system_bus = system_bus
@@ -688,14 +961,14 @@
             # on initialization, fake a SYS_NET_CONNECTED if appropriate
             if DBusInterface.test:
                 # testing under sync; just do it
-                self.log.debug('using the fake NetworkManager')
+                logger.debug('using the fake NetworkManager')
                 self.connection_state_changed(NM_STATE_CONNECTED)
             else:
                 def error_handler(error):
                     """
                     Handle errors from NM
                     """
-                    self.log.error(
+                    logger.error(
                         "Error while getting the NetworkManager state %s",
                         error)
                     # If we get an error back from NetworkManager, we should
@@ -710,7 +983,7 @@
                     if e.get_dbus_name() == \
                         'org.freedesktop.DBus.Error.ServiceUnknown':
                         # NetworkManager isn't running.
-                        self.log.warn("Unable to connect to NetworkManager. "
+                        logger.warn("Unable to connect to NetworkManager. "
                                       "Assuming we have network.")
                         self.connection_state_changed(NM_STATE_CONNECTED)
                     else:
@@ -725,17 +998,19 @@
                                signal_name='StateChanged',
                                dbus_interface='org.freedesktop.NetworkManager',
                                path='/org/freedesktop/NetworkManager')
+        logger.info('DBusInterface initialized.')
 
     def shutdown(self, with_restart=False):
         """ remove the registered object from the bus and unsubscribe from the
         event queue.
         """
-        self.log.debug('Shuttingdown DBusInterface!')
+        logger.info('Shuttingdown DBusInterface!')
         self.status.remove_from_connection()
         self.events.remove_from_connection()
         self.sync.remove_from_connection()
         self.fs.remove_from_connection()
         self.shares.remove_from_connection()
+        self.config.remove_from_connection()
         self.event_queue.unsubscribe(self.event_listener)
         # remove the NM's StateChanged signal receiver
         self.system_bus.remove_signal_receiver(self.connection_state_changed,
@@ -778,7 +1053,7 @@
             access_token = self.main.get_access_token()
             self.event_queue.push('SYS_CONNECT', access_token)
         except NoAccessToken, e:
-            self.log.exception("Can't get the auth token")
+            logger.exception("Can't get the auth token")
 
     def disconnect(self):
         """ Push the SYS_DISCONNECT event. """
@@ -786,5 +1061,5 @@
 
     def quit(self):
         """ calls Main.quit. """
-        self.log.debug('Calling Main.quit')
+        logger.debug('Calling Main.quit')
         self.main.quit()

=== modified file 'ubuntuone/syncdaemon/event_queue.py'
--- ubuntuone/syncdaemon/event_queue.py	2009-07-27 16:00:00 +0000
+++ ubuntuone/syncdaemon/event_queue.py	2009-08-26 12:15:00 +0000
@@ -52,6 +52,7 @@
     'AQ_DOWNLOAD_STARTED': ('share_id', 'node_id', 'server_hash'),
     'AQ_DOWNLOAD_FINISHED': ('share_id', 'node_id', 'server_hash'),
     'AQ_DOWNLOAD_ERROR': ('share_id', 'node_id', 'server_hash', 'error'),
+    'AQ_DOWNLOAD_CANCELLED': ('share_id', 'node_id', 'server_hash'),
     'AQ_UPLOAD_STARTED' : ('share_id', 'node_id', 'hash'),
     'AQ_UPLOAD_FINISHED': ('share_id', 'node_id', 'hash'),
     'AQ_UPLOAD_ERROR': ('share_id', 'node_id', 'error', 'hash'),
@@ -62,6 +63,8 @@
     'AQ_QUERY_ERROR': ('item', 'error'),
     'AQ_ANSWER_SHARE_OK': ('share_id', 'answer'),
     'AQ_ANSWER_SHARE_ERROR': ('share_id', 'answer', 'error'),
+    'AQ_FREE_SPACE_ERROR': ('error',),
+    'AQ_ACCOUNT_ERROR': ('error',),
 
     'SV_SHARE_CHANGED': ('message', 'info'),
     'SV_SHARE_ANSWERED': ('share_id', 'answer'),
@@ -71,7 +74,10 @@
     'SV_FILE_DELETED': ('share_id', 'node_id'),
     'SV_MOVED': ('share_id', 'node_id', 'new_share_id', 'new_parent_id',
                  'new_name'),
+    'SV_FREE_SPACE': ('share_id', 'free_bytes'),
+    'SV_ACCOUNT_CHANGED': ('account_info',),
     'HQ_HASH_NEW': ('path', 'hash', 'crc32', 'size', 'stat'),
+    'HQ_HASH_ERROR': ('mdid',),
     'SYS_CONNECT': ('access_token',),
     'SYS_DISCONNECT': (),
     'SYS_STATE_CHANGED': ('state',),
@@ -90,12 +96,15 @@
     'SYS_SERVER_RESCAN_STARTING': (),
     'SYS_SERVER_RESCAN_DONE': (),
     'SYS_META_QUEUE_WAITING': (),
+    'SYS_META_QUEUE_BLOCKED': (),
     'SYS_META_QUEUE_DONE': (),
     'SYS_CONTENT_QUEUE_WAITING': (),
+    'SYS_CONTENT_QUEUE_BLOCKED': (),
     'SYS_CONTENT_QUEUE_DONE': (),
     'SYS_CLEANUP_STARTED': (),
     'SYS_CLEANUP_FINISHED': (),
     'SYS_UNKNOWN_ERROR': (),
+    'SYS_HANDSHAKE_TIMEOUT': (),
 }
 
 if 'IN_CREATE' in vars(pyinotify.EventsCodes):

=== modified file 'ubuntuone/syncdaemon/file_shelf.py'
--- ubuntuone/syncdaemon/file_shelf.py	2009-08-11 16:45:00 +0000
+++ ubuntuone/syncdaemon/file_shelf.py	2009-08-26 12:15:00 +0000
@@ -34,14 +34,13 @@
     cPickle).  And support any valid file name as key.
     """
 
-    def __init__(self, path, depth=3, fsync=True):
+    def __init__(self, path, depth=3):
         """ Create a FileShelf.
 
         @param path: the path to use as the root of the shelf
         @param depth: the directory depth to use, can't be < 0. default is 3
         """
         self._path = path
-        self._fsync = fsync
         if depth < 0:
             raise ValueError("depth must be >= 0")
         self._depth = depth
@@ -85,9 +84,13 @@
     def keys(self):
         """ returns a iterator over the keys """
         # pylint: disable-msg=W0612
+        splitext = os.path.splitext
         for dirpath, dirnames, filenames in os.walk(self._path):
             for filename in filenames:
-                yield filename
+                # just in case a .new file was left around
+                ext = splitext(filename)[1]
+                if ext != ".new" and ext != ".old":
+                    yield filename
 
     def pop(self, key):
         """ returns the key and deletes the entry """
@@ -105,32 +108,57 @@
         else:
             return True
 
-    def __getitem__(self, key):
-        """ getitem backed by the file storage """
+    def _load_pickle(self, key, path):
+        """Load a pickle form path that belongs to key"""
         try:
-            with open(self.key_file(key), "rb") as fd:
+            with open(path, "rb") as fd:
                 data = cPickle.load(fd)
-        except (IOError, OSError, EOFError):
+        except (EOFError, cPickle.UnpicklingError, ValueError):
+            # the metadata is broked, try to get .old version if it's available
+            old_path = path+'.old'
+            # only search for a single .old in the name
+            if os.path.splitext(path)[1] != '.old' and \
+               os.path.exists(old_path):
+                return self._load_pickle(key, old_path)
+            else:
+                raise KeyError(key)
+        except (IOError, OSError):
             raise KeyError(key)
         else:
             return data
 
+    def __getitem__(self, key):
+        """ getitem backed by the file storage """
+        return self._load_pickle(key, self.key_file(key))
+
     def __setitem__(self, key, value):
         """ setitem backed by the file storage """
         path = self.key_file(key)
+        new_path = path+".new"
+        old_path = path+".old"
         self._check_and_create_dirs(os.path.dirname(path))
-        with open(path, "wb") as fh:
+        with open(new_path, "wb") as fh:
             cPickle.dump(value, fh, protocol=2)
             fh.flush()
-            if self._fsync:
-                os.fsync(fh.fileno())
+        if os.path.exists(path):
+            os.rename(path, old_path)
+        os.rename(new_path, path)
 
     def __delitem__(self, key):
         """ delitem backed by the file storage """
+        path = self.key_file(key)
         try:
             os.remove(self.key_file(key))
         except OSError:
             raise KeyError(key)
+        # also delete backup files
+        for path in [path+'.old', path+'.new']:
+            try:
+                os.remove(path)
+            except OSError:
+                # ignore any OSError
+                pass
+
 
     def __len__(self):
         """ The len of the shelf.

=== modified file 'ubuntuone/syncdaemon/filesystem_manager.py'
--- ubuntuone/syncdaemon/filesystem_manager.py	2009-08-11 16:45:00 +0000
+++ ubuntuone/syncdaemon/filesystem_manager.py	2009-08-26 12:15:00 +0000
@@ -22,6 +22,7 @@
 import time
 import shutil
 import functools
+import itertools
 import logging
 import contextlib
 import errno
@@ -123,6 +124,7 @@
 fsm_logger = logging.getLogger('ubuntuone.SyncDaemon.fsm')
 logger = functools.partial(fsm_logger.log, logging.INFO)
 log_warning = functools.partial(fsm_logger.log, logging.WARNING)
+log_debug = functools.partial(fsm_logger.log, logging.DEBUG)
 
 is_forbidden = set("info path node_id share_id is_dir".split()
                   ).intersection
@@ -184,13 +186,13 @@
       - idx_path: relationship path -> mdid
       - idx_node_id: relationship (share_id, node_id) -> mdid
     '''
-    def __init__(self, data_dir, vm, fsync_md=True):
+    def __init__(self, data_dir, vm):
         if not isinstance(data_dir, basestring):
             raise TypeError("data_dir should be a string instead of %s" % \
                             type(data_dir))
         fsmdir = os.path.join(data_dir, 'fsm')
-        self.fs = file_shelf.CachedFileShelf(fsmdir, fsync=fsync_md,
-                                 cache_size=1500, cache_compact_threshold=4)
+        self.fs = file_shelf.CachedFileShelf(fsmdir, cache_size=1500,
+                                             cache_compact_threshold=4)
         self.shares = {}
         self.vm = vm
 
@@ -216,13 +218,34 @@
         logger("initialized: idx_path: %s, idx_node_id: %s, shares: %s" %
                (len(self._idx_path), len(self._idx_node_id), len(self.shares)))
 
+    def _safe_fs_iteritems(self):
+        """returns a 'safe' iterator over the items of the FileShelf.
+        it's 'safe' because broked metadata objects are deleted and not
+        returned.
+        """
+        def safeget_mdobj(mdid):
+            """check if the mdobj is valid and return mdid, mdobj.
+            If a KeyError is raised, returns False.
+            """
+            try:
+                mdobj = self.fs[mdid]
+            except KeyError:
+                # oops, we have a key but don't have the value, possibly broken
+                # metadata, remove it and keep going
+                del self.fs[mdid]
+                # return False, in order to be filtered later
+                return False
+            else:
+                return mdid, mdobj
+        safe_iteritems = itertools.imap(safeget_mdobj, self.fs.keys())
+        # filter all False values
+        return itertools.ifilter(None, safe_iteritems)
+
     def _load_metadata_None(self, old_version):
         '''Loads metadata from when it wasn't even versioned.'''
         logger("loading metadata from old version %r", old_version)
 
-        for mdid in self.fs.keys():
-            mdobj = self.fs[mdid]
-
+        for mdid, mdobj in self._safe_fs_iteritems():
             # assure path are bytes (new to version 2)
             try:
                 mdobj["path"] = mdobj["path"].encode("utf8")
@@ -257,9 +280,7 @@
         '''Loads metadata from version 1.'''
         logger("loading metadata from old version %r", old_version)
 
-        for mdid in self.fs.keys():
-            mdobj = self.fs[mdid]
-
+        for mdid, mdobj in self._safe_fs_iteritems():
             # assure path are bytes (new to version 2)
             try:
                 mdobj["path"] = mdobj["path"].encode("utf8")
@@ -291,9 +312,7 @@
         '''Loads metadata from version 2.'''
         logger("loading metadata from old version %r", old_version)
 
-        for mdid in self.fs.keys():
-            mdobj = self.fs[mdid]
-
+        for mdid, mdobj in self._safe_fs_iteritems():
             # convert the "yet without content" hashes to "" (new to v3)
             if mdobj["local_hash"] is None:
                 mdobj["local_hash"] = ""
@@ -316,8 +335,7 @@
     def _load_metadata_updated(self):
         '''Loads metadata of last version.'''
         logger("loading updated metadata")
-        for mdid in self.fs.keys():
-            mdobj = self.fs[mdid]
+        for mdid, mdobj in self._safe_fs_iteritems():
             abspath = self.get_abspath(mdobj["share_id"], mdobj["path"])
             self._idx_path[abspath] = mdid
             if mdobj["node_id"] is not None:
@@ -344,8 +362,8 @@
         if node_id is not None:
             self._set_node_id(newobj, node_id, path)
 
-        logger("create: path=%r mdid=%r share_id=%r node_id=%r is_dir=%r" % (
-                                          path, mdid, share_id, None, is_dir))
+        log_debug("create: path=%r mdid=%r share_id=%r node_id=%r is_dir=%r" \
+                  % (path, mdid, share_id, None, is_dir))
         self.fs[mdid] = newobj
 
         # adjust the index
@@ -366,8 +384,8 @@
         if mdobj["node_id"] is not None:
             # the object is already there! it's ok if it has the same id
             if mdobj["node_id"] == node_id:
-                logger("set_node_id (repeated!): path=%r mdid=%r node_id=%r"
-                                          % (path, mdobj['mdid'], node_id))
+                log_warning("set_node_id (repeated!): path=%r mdid=%r "
+                            "node_id=%r" % (path, mdobj['mdid'], node_id))
                 return
             msg = "The path %r already has node_id (%r)" % (path, node_id)
             raise ValueError(msg)
@@ -379,7 +397,7 @@
         mdobj["node_id"] = node_id
         mdobj["info"]["node_id_assigned"] = time.time()
 
-        logger("set_node_id: path=%r mdid=%r share_id=%r node_id=%r" % (
+        log_debug("set_node_id: path=%r mdid=%r share_id=%r node_id=%r" % (
                                      path, mdobj['mdid'], share_id, node_id))
 
     def get_mdobjs_by_share_id(self, share_id, base_path=None):
@@ -432,7 +450,7 @@
             raise ValueError("The following attributes can not be set "
                              "externally: %s" % forbidden)
 
-        logger("set mdid=%r: %s" % (mdid, kwargs))
+        log_debug("set mdid=%r: %s" % (mdid, kwargs))
         mdobj = self.fs[mdid]
         for k, v in kwargs.items():
             mdobj[k] = v
@@ -455,7 +473,7 @@
 
     def refresh_stat(self, path):
         '''Refreshes the stat of a md object.'''
-        logger("refresh stat to path=%r", path)
+        log_debug("refresh stat to path=%r", path)
         mdid = self._idx_path[path]
         mdobj = self.fs[mdid]
         mdobj["stat"] = get_stat(path)
@@ -497,7 +515,7 @@
 
         # adjust the metadata of "from" file
         mdid = self._idx_path.pop(path_from)
-        logger("move_file: mdid=%r path_from=%r path_to=%r",
+        log_debug("move_file: mdid=%r path_from=%r path_to=%r",
                                                     mdid, path_from, path_to)
         mdobj = self.fs[mdid]
 
@@ -514,14 +532,15 @@
         try:
             mdobj["stat"] = os.stat(path_to)  # needed if not the same FS
         except OSError:
-            logger("Got an OSError while getting the stat of %r", path_to)
+            log_warning("Got an OSError while getting the stat of %r", path_to)
         self.fs[mdid] = mdobj
 
         if mdobj["is_dir"]:
             # change the path for all the children of that node
             path_from = path_from + os.path.sep
             len_from = len(path_from)
-            for path in (x for x in self._idx_path if x.startswith(path_from)):
+            pathstofix = [x for x in self._idx_path if x.startswith(path_from)]
+            for path in pathstofix:
                 newpath = os.path.join(path_to, path[len_from:])
 
                 # change in the index
@@ -540,7 +559,7 @@
         path = os.path.normpath(path)
         mdid = self._idx_path[path]
         mdobj = self.fs[mdid]
-        logger("delete metadata: path=%r mdid=%r" % (path, mdid))
+        log_debug("delete metadata: path=%r mdid=%r" % (path, mdid))
 
         # adjust all
         del self._idx_path[path]
@@ -554,7 +573,7 @@
         path = os.path.normpath(path)
         mdid = self._idx_path[path]
         mdobj = self.fs[mdid]
-        logger("delete: path=%r mdid=%r" % (path, mdid))
+        log_debug("delete: path=%r mdid=%r" % (path, mdid))
 
         # delete the file
         try:
@@ -574,7 +593,7 @@
         '''Moves a file/dir to its .conflict.'''
         mdobj = self.fs[mdid]
         path = self.get_abspath(mdobj['share_id'], mdobj['path'])
-        logger("move_to_conflict: path=%r mdid=%r" % (path, mdid))
+        log_debug("move_to_conflict: path=%r mdid=%r" % (path, mdid))
         base_to_path = to_path =  path + ".u1conflict"
         ind = 0
         while os.path.exists(to_path):
@@ -696,7 +715,7 @@
 
         # move the .partial to the real path, and set the md info
         path = self.get_abspath(mdobj['share_id'], mdobj['path'])
-        logger("commit_partial: path=%r mdid=%r share_id=%r node_id=%r" %
+        log_debug("commit_partial: path=%r mdid=%r share_id=%r node_id=%r" %
                                             (path, mdid, share_id, node_id))
 
         dirname, filename = os.path.split(path)
@@ -718,7 +737,7 @@
         # delete the .partial, and set the md info
         mdobj = self.fs[mdid]
         path = self.get_abspath(mdobj['share_id'], mdobj['path'])
-        logger("remove_partial: path=%r mdid=%r share_id=%r node_id=%r" %
+        log_debug("remove_partial: path=%r mdid=%r share_id=%r node_id=%r" %
                                             (path, mdid, share_id, node_id))
         if self.is_dir(path=path):
             partial_path = os.path.join(path, ".u1partial")

=== modified file 'ubuntuone/syncdaemon/fsm/fsm.py'
--- ubuntuone/syncdaemon/fsm/fsm.py	2009-07-16 17:00:00 +0000
+++ ubuntuone/syncdaemon/fsm/fsm.py	2009-08-26 12:15:00 +0000
@@ -103,7 +103,8 @@
             self.log = log
 
     def on_event(self, event_name, parameters, *args):
-        """Do the transition for this event."""
+        """Do the transition for this event.
+        Returns the function called for the action"""
         # get the state
         self.log.debug("EVENT: %s:%s with ARGS:%s"%(
             event_name, parameters, args))
@@ -158,6 +159,7 @@
                 out_state.values, transition.target))
             raise ValueError("Incorrect out state")
         self.log.debug("Called %s"%action_func_name)
+        return action_func_name
 
     def get_state(self):
         """Get the current state's object"""
@@ -469,6 +471,9 @@
     get one of these. with the corresponding attributes for all sections
     and event name.
     """
+    __slots__ = ('event', 'line', 'source',
+                 'target', 'parameters', 'action_func')
+
     def __init__(self, event, line):
         """Create a transition for event event from line.
 

=== modified file 'ubuntuone/syncdaemon/hash_queue.py'
--- ubuntuone/syncdaemon/hash_queue.py	2009-08-11 16:45:00 +0000
+++ ubuntuone/syncdaemon/hash_queue.py	2009-08-26 12:15:00 +0000
@@ -43,7 +43,8 @@
         self.logger = logging.getLogger('ubuntuone.SyncDaemon.HQ.hasher')
         self.end_mark = end_mark
         self.queue = queue
-        self.push = functools.partial(event_queue.push, "HQ_HASH_NEW")
+        self.push_ok = functools.partial(event_queue.push, "HQ_HASH_NEW")
+        self.push_error = functools.partial(event_queue.push, "HQ_HASH_ERROR")
         # mutex to access _should_cancel and _hashing attributes
         self.mutex = threading.Lock()
         self._should_cancel = None
@@ -58,19 +59,29 @@
         while True:
             if self._stopped:
                 break
-            path = self.queue.get()
-            if path is self.end_mark:
+            info = self.queue.get()
+            if info is self.end_mark:
                 self._stopped = True
                 self.queue.task_done()
                 break
 
-            self.logger.info("Hasher: got path to hash: %r" % path)
-            result = self._hash(path)
+            path, mdid = info
+            m = "Hasher: got file to hash: path %r  mdid %s"
+            self.logger.debug(m, path, mdid)
+            try:
+                result = self._hash(path)
+            except (IOError, OSError), e:
+                m = "Hasher: hash error %s  (path %r  mdid %s)"
+                self.logger.debug(m, e, path, mdid)
+                reactor.callFromThread(self.push_error, mdid)
+            except StopHashing, e:
+                self.logger.debug(str(e))
+            else:
+                m = "Hasher: path hash pushed:  path %r  hash %r"
+                self.logger.debug(m, path, result)
+                reactor.callFromThread(self.push_ok, path, *result)
+
             self.queue.task_done()
-            if result:
-                reactor.callFromThread(self.push, path, *result)
-            self.logger.info("Hasher: path hash pushed:  path %r  hash %r"
-                                                            % (path, result))
 
     def stop(self):
         """Stop the hasher (will be effective in the next loop if a hash
@@ -106,11 +117,6 @@
                     hasher.update(cont)
                     crc = crc32(cont, crc)
                     size += len(cont)
-        except (IOError, OSError):
-            return None
-        except StopHashing, e:
-            self.logger.info(str(e))
-            return None
         finally:
             with self.mutex:
                 self._hashing = None
@@ -143,14 +149,14 @@
         self.hasher.start()
         self.logger.info("HashQueue: _hasher started")
 
-    def insert(self, path):
+    def insert(self, path, mdid):
         '''Insert the path of a file to be hashed.'''
-        self.logger.info("HashQueue: inserting path %r" % path)
+        self.logger.info("HashQueue: inserting path %r  mdid %s", path, mdid)
         # only accept it if we are running
         if self._stopped:
             raise RuntimeError("The HashQueue was stopped")
         self.hasher.cancel_if_running(path)
-        self._queue.put(path)
+        self._queue.put((path, mdid))
 
     def shutdown(self):
         '''Shutdown all resources and clear the queue'''

=== modified file 'ubuntuone/syncdaemon/interfaces.py'
--- ubuntuone/syncdaemon/interfaces.py	2009-07-16 17:00:00 +0000
+++ ubuntuone/syncdaemon/interfaces.py	2009-08-26 12:15:00 +0000
@@ -115,6 +115,15 @@
         Ask the server to create a share.
         """
 
+    def inquire_free_space(share_id):
+        """
+        Inquire after free space in the given volume and put the result on
+        the event queue.
+        """
+
+    def inquire_account_info():
+        """Ask the state of the user's account (purchased space, etc)."""
+
 class IActionQueue(IContentQueue, IMetaQueue):
     """
     The access queue itself.

=== modified file 'ubuntuone/syncdaemon/logger.py'
--- ubuntuone/syncdaemon/logger.py	2009-08-11 16:45:00 +0000
+++ ubuntuone/syncdaemon/logger.py	2009-08-26 12:15:00 +0000
@@ -16,37 +16,49 @@
 # You should have received a copy of the GNU General Public License along
 # with this program.  If not, see <http://www.gnu.org/licenses/>.
 """ SyncDaemon logging utilities and config. """
+from __future__ import with_statement
 
-from itertools import imap
-import functools
+import contextlib
 import logging
 import sys
 import os
 import re
+import weakref
+import zlib
 import xdg.BaseDirectory
 
+from itertools import imap
 from logging.handlers import TimedRotatingFileHandler
 
 # extra levels
 # be more verbose than logging.DEBUG(10)
 TRACE = 5
 # info that we always want to log (logging.ERROR+1)
-NOTE = logging.ERROR + 1
+NOTE = logging.ERROR - 1
 
 # map names to the extra levels
 levels = {'TRACE':TRACE, 'NOTE':NOTE}
 for k, v in levels.items():
     logging.addLevelName(v, k)
 
+
 class Logger(logging.Logger):
     """Logger that support out custom levels."""
 
-    note = functools.partial(logging.Logger.log, NOTE)
-    trace = functools.partial(logging.Logger.log, TRACE)
+    def note(self, msg, *args, **kwargs):
+        """log at NOTE level"""
+        if self.isEnabledFor(NOTE):
+            self._log(NOTE, msg, args, **kwargs)
+
+    def trace(self, msg, *args, **kwargs):
+        """log at TRACE level"""
+        if self.isEnabledFor(TRACE):
+            self._log(TRACE, msg, args, **kwargs)
 
 # use our logger as the default Logger class
 logging.setLoggerClass(Logger)
 
+
 class DayRotatingFileHandler(TimedRotatingFileHandler):
     """ A TimedRotatingFileHandler configured for Day rotation but that uses
     the suffix and extMatch of Hourly rotation, in order to allow seconds based
@@ -72,6 +84,7 @@
     Create a logger that keeps track of the method where it's being
     called from, in order to make more informative messages.
     """
+    __slots__ = ('logger', 'zipped_desc')
     def __init__(self, _logger, _method, _share, _uid, *args, **kwargs):
         # args are _-prepended to lower the chances of them
         # conflicting with kwargs
@@ -86,9 +99,15 @@
             all_args.append("%s=%r" % (k, v))
         args = ", ".join(all_args)
 
-        self.desc = "%-28s share:%-40r node:%-40r %s(%s) " \
-            % (_method, _share, _uid, _method, args)
+        desc = "%-28s share:%-40r node:%-40r %s(%s) " % (_method, _share,
+                                                         _uid, _method, args)
+        self.zipped_desc = zlib.compress(desc, 9)
         self.logger = _logger
+
+    @property
+    def desc(self):
+        return zlib.decompress(self.zipped_desc)
+
     def _log(self, logger_func, *args):
         """
         Generalized form of the different logging functions.
@@ -140,6 +159,112 @@
         return callback, errback
 # pylint: enable-msg=C0103
 
+
+class DebugCapture(logging.Handler):
+    """
+    A context manager to capture debug logs.
+    """
+
+    def __init__(self, logger, raise_unhandled=False, on_error=True):
+        """Creates the instance.
+
+        @param logger: the logger to wrap
+        @param raise_unhandled: raise unhandled errors (which are alse logged)
+        @param on_error: if it's True (default) the captured debug info is
+        dumped if a record with log level >= ERROR is logged.
+        """
+        logging.Handler.__init__(self, logging.DEBUG)
+        self.on_error = on_error
+        self.dirty = False
+        self.raise_unhandled = raise_unhandled
+        self.records = []
+        # insert myself as the handler for the logger
+        self.logger = weakref.proxy(logger)
+        # store the logger log level
+        self.old_level = logger.level
+        # remove us from the Handler list and dict
+        self.close()
+
+    def emit_debug(self):
+        """emit stored records to the original logger handler(s)"""
+        enable_debug = self.enable_debug
+        for record in self.records:
+            for slave in self.slaves:
+                with enable_debug(slave):
+                    slave.handle(record)
+
+    @contextlib.contextmanager
+    def enable_debug(self, obj):
+        """context manager that temporarily changes the level attribute of obj
+        to logging.DEBUG.
+        """
+        old_level = obj.level
+        obj.level = logging.DEBUG
+        yield obj
+        obj.level = old_level
+
+    def clear(self):
+        """cleanup the captured records"""
+        self.records = []
+
+    def install(self):
+        """Install the debug capture in the logger"""
+        self.slaves = self.logger.handlers
+        self.logger.handlers = [self]
+        # set the logger level in DEBUG
+        self.logger.setLevel(logging.DEBUG)
+
+    def uninstall(self):
+        """restore the logger original handlers"""
+        # restore the logger
+        self.logger.handlers = self.slaves
+        self.logger.setLevel(self.old_level)
+        self.clear()
+        self.dirty = False
+        self.slaves = []
+
+    def emit(self, record):
+        """A emit() that append the record to the record list"""
+        self.records.append(record)
+
+    def handle(self, record):
+        """ handle a record """
+        # if its a DEBUG level record then intercept otherwise
+        # pass through to the original logger handler(s)
+        if self.old_level <= logging.DEBUG:
+            return sum(slave.handle(record) for slave in self.slaves)
+        if record.levelno == logging.DEBUG:
+            return logging.Handler.handle(self, record)
+        elif self.on_error and record.levelno >= logging.ERROR and \
+            record.levelno != NOTE:
+            # if it's >= ERROR keep it, but mark the dirty falg
+            self.dirty = True
+            return logging.Handler.handle(self, record)
+        else:
+            return sum(slave.handle(record) for slave in self.slaves)
+
+    def __enter__(self):
+        """ContextManager API"""
+        self.install()
+        return self
+
+    def __exit__(self, exc_type, exc_value, traceback):
+        """ContextManager API"""
+        if exc_type is not None:
+            self.emit_debug()
+            self.on_error = False
+            self.logger.error('unhandled exception', exc_info=(exc_type,
+                exc_value, traceback))
+        elif self.dirty:
+            # emit all debug messages collected after the error
+            self.emit_debug()
+        self.uninstall()
+        if self.raise_unhandled and exc_type is not None:
+            raise exc_type, exc_value, traceback
+        else:
+            return True
+
+
 ### configure the thing ###
 # define the location of the log folder
 home = xdg.BaseDirectory.xdg_cache_home

=== modified file 'ubuntuone/syncdaemon/main.py'
--- ubuntuone/syncdaemon/main.py	2009-08-11 16:45:00 +0000
+++ ubuntuone/syncdaemon/main.py	2009-08-26 12:15:00 +0000
@@ -42,6 +42,33 @@
 from ubuntuone.syncdaemon.state import SyncDaemonStateManager
 
 
+class WaitingHelpingHandler(object):
+    """
+    An auxiliary class that helps wait for events
+    """
+    def __init__(self, event_queue, waiting_events, waiting_kwargs,
+                 result=None):
+        self.deferred = defer.Deferred()
+        self.event_queue = event_queue
+        self.result = result
+        self.waiting_events = waiting_events
+        self.waiting_kwargs = waiting_kwargs
+        event_queue.subscribe(self)
+
+    def handle_default(self, event, *args, **kwargs):
+        """Got an event: fire if it's one we want"""
+        if event in self.waiting_events:
+            for wk, wv in self.waiting_kwargs.items():
+                if not (wk in kwargs and kwargs[wk] == wv):
+                    return
+            self.fire()
+
+    def fire(self):
+        """start fire the callback"""
+        self.event_queue.unsubscribe(self)
+        reactor.callLater(0, lambda: self.deferred.callback(self.result))
+
+
 class Main(object):
     """ The one who executes the syncdaemon """
 
@@ -49,10 +76,13 @@
                  host='fs-1.ubuntuone.com', port=443, dns_srv=None, ssl=True,
                  disable_ssl_verify=False,
                  realm='https://ubuntuone.com', glib_loop=False,
-                 mark_interval=120, fsync_md=True, dbus_events=False):
+                 mark_interval=120, dbus_events=False,
+                 handshake_timeout=30, max_handshake_timeouts=10,
+                 shares_symlink_name='Shared With Me'):
         """ create the instance. """
         self.root_dir = root_dir
         self.shares_dir = shares_dir
+        self.shares_dir_link = os.path.join(self.root_dir, shares_symlink_name)
         self.data_dir = data_dir
         self.logger = logging.getLogger('ubuntuone.SyncDaemon.Main')
         self.host = host
@@ -64,11 +94,11 @@
         self.token = None
 
         self.vm = volume_manager.VolumeManager(self)
-        self.fs = filesystem_manager.FileSystemManager(data_dir, self.vm,
-                                                       fsync_md)
+        self.fs = filesystem_manager.FileSystemManager(data_dir, self.vm)
         self.event_q = event_queue.EventQueue(self.fs)
         self.oauth_client = OAuthClient(self.realm)
-        self.state = SyncDaemonStateManager(self)
+        self.state = SyncDaemonStateManager(self, handshake_timeout,
+                                            max_handshake_timeouts)
         # subscribe VM to EQ
         self.event_q.subscribe(self.vm)
         self.vm.init_root()
@@ -88,6 +118,8 @@
             self.bus = dbus.SessionBus(loop)
         self.dbus_iface = dbus_interface.DBusInterface(self.bus, self,
                                                        send_events=dbus_events)
+        self.action_q.content_queue.set_change_notification_cb(
+            self.dbus_iface.status.emit_content_queue_changed)
         self.logger.info("Using %s as root dir", self.root_dir)
         self.logger.info("Using %s as data dir", self.data_dir)
         self.logger.info("Using %s as shares root dir", self.shares_dir)
@@ -96,7 +128,7 @@
 
     def log_mark(self):
         """ log a "mark" that includes the current AQ state and queue size"""
-        self.logger.info("%s %s (state: %s; queues: metadata: %d; content: %d;"
+        self.logger.note("%s %s (state: %s; queues: metadata: %d; content: %d;"
                          " hash: %d, fsm-cache: hit=%d miss=%d) %s" % ('-'*4,
                                          'MARK', self.state.name,
                                          len(self.action_q.meta_queue),
@@ -134,6 +166,12 @@
         reactor.callLater(last_event_interval, start)
         return d
 
+    def wait_for(self, *waiting_events, **waiting_kwargs):
+        """defer until event appears"""
+        return WaitingHelpingHandler(self.event_q,
+                                     waiting_events,
+                                     waiting_kwargs).deferred
+
     def start(self):
         """setup the daemon to be ready to run"""
         # hook the event queue to the root dir
@@ -141,7 +179,7 @@
         self.event_q.inotify_add_watch(self.root_dir)
 
         # do the local rescan
-        self.logger.info("Local rescan starting...")
+        self.logger.note("Local rescan starting...")
         d = self.lr.start()
 
         def _wait_for_hashq():
@@ -158,7 +196,7 @@
 
         def local_rescan_done(_):
             '''After local rescan finished.'''
-            self.logger.info("Local rescan finished!")
+            self.logger.note("Local rescan finished!")
             _wait_for_hashq()
 
         def stop_the_press(failure):
@@ -306,19 +344,27 @@
 
         d.addCallbacks(query_caps_callback, query_caps_errback)
 
+    @defer.inlineCallbacks
     def server_rescan(self):
         """
         Do the server rescan
         """
-        d = self.get_root(object())
-        d.addCallback(lambda _: self.event_q.push('SYS_SERVER_RESCAN_STARTING'))
-        d.addCallback(lambda _: self.action_q.client.query(
-                self.fs.get_data_for_server_rescan()))
-        d.addCallback(lambda _: self.event_q.push('SYS_SERVER_RESCAN_DONE'))
-        return d
+        yield self.get_root(object())
+        self.event_q.push('SYS_SERVER_RESCAN_STARTING')
+        data = self.fs.get_data_for_server_rescan()
+        self.logger.info("server rescan: will query %d objects" % len(data))
+        # we check we're going to actually log, because this could be expensive
+        if self.logger.isEnabledFor(logging.DEBUG):
+            for share, node, hash in data:
+                self.logger.debug("server rescan: share: %s, node: %s, hash: %s"
+                                  % (share or '/root/', node, hash))
+            self.logger.debug("server rescan: all data shown")
+        yield self.action_q.client.query(data)
+        self.logger.info("server rescan: done")
+        self.event_q.push('SYS_SERVER_RESCAN_DONE')
 
     def set_oauth_token(self, key, secret):
-        """ Set's the oauth token """
+        """ Sets the oauth token """
         self.token = oauth.OAuthToken(key, secret)
 
     def get_access_token(self):
@@ -330,7 +376,7 @@
 
     def get_rootdir(self):
         """ Returns the base dir/mount point"""
-        return os.path.dirname(self.root_dir)
+        return self.root_dir
 
     def quit(self, exit_value=0, with_restart=False):
         """ shutdown and stop the reactor. """

=== added file 'ubuntuone/syncdaemon/sdreactor.py'
--- ubuntuone/syncdaemon/sdreactor.py	1970-01-01 00:00:00 +0000
+++ ubuntuone/syncdaemon/sdreactor.py	2009-08-26 12:15:00 +0000
@@ -0,0 +1,79 @@
+"""
+The SyncDaemon reactor -- a less power-hungry version of twisted's gtk2reactor
+"""
+#
+# This is the quickest way to make twisted's Gtk2Reactor use
+# timeout_add_seconds instead of timeout_add; the former uses high-resolution
+# timers, which are more power-intensive.
+# It's pretty much verbatim from their source.
+
+from twisted.python import log
+from twisted.internet.main import installReactor
+from twisted.internet.gtk2reactor import Gtk2Reactor
+import gobject
+
+class SyncDaemonReactor(Gtk2Reactor):
+    """
+    This is twisted.internet.Gtk2Reactor, but using timeout_add_seconds
+    instead of timeout_add.
+    """
+    def __init__(self, use_gtk):
+        Gtk2Reactor.__init__(self, use_gtk)
+        # ugh... why would somebody make these private?
+        self.__iteration = self._Gtk2Reactor__iteration
+        self.__pending = self._Gtk2Reactor__pending
+        self.__run = self._Gtk2Reactor__run
+
+    def doIteration(self, delay):
+        """
+        Process some events
+        """
+        log.msg(channel='system', event='iteration', reactor=self)
+        if self.__pending():
+            self.__iteration(0)
+            return
+        # nothing to do, must delay
+        if delay == 0:
+            return # shouldn't delay, so just return
+        self.doIterationTimer = gobject.timeout_add_seconds(
+            int(delay), self.doIterationTimeout)
+        # This will either wake up from IO or from a timeout.
+        self.__iteration(1) # block
+        # note: with the .simulate timer below, delays > 0.1 will always be
+        # woken up by the .simulate timer
+        if self.doIterationTimer:
+            # if woken by IO, need to cancel the timer
+            gobject.source_remove(self.doIterationTimer)
+            self.doIterationTimer = None
+
+    def run(self, installSignalHandlers=1):
+        """
+        See IReactorCore.run
+        """
+        self.startRunning(installSignalHandlers=installSignalHandlers)
+        gobject.timeout_add_seconds(0, self.simulate)
+        if self._started:
+            self.__run()
+
+
+    def simulate(self):
+        """
+        Run simulation loops and reschedule callbacks.
+        """
+        if self._simtag is not None:
+            gobject.source_remove(self._simtag)
+        self.runUntilCurrent()
+        timeout = min(self.timeout(), 0.1)
+        if timeout is None:
+            timeout = 0.1
+        # grumble
+        self._simtag = gobject.timeout_add_seconds(int(timeout * 1010/1000),
+                                                   self.simulate)
+
+
+def install(use_gtk):
+    """
+    Configure the twisted mainloop to be run inside the glib mainloop.
+    If use_gtk, then use the gtk mainloop instead.
+    """
+    installReactor(SyncDaemonReactor(use_gtk))

=== modified file 'ubuntuone/syncdaemon/state.py'
--- ubuntuone/syncdaemon/state.py	2009-07-16 17:00:00 +0000
+++ ubuntuone/syncdaemon/state.py	2009-08-26 12:15:00 +0000
@@ -22,6 +22,8 @@
 """
 import logging
 
+from twisted.internet import reactor
+
 from ubuntuone.syncdaemon import states
 
 class SyncDaemonStateManager(object):
@@ -29,8 +31,12 @@
     Keep track of the state of the sync daemon.
     """
 
-    def __init__(self, main):
+    def __init__(self, main, timeout, max_timeouts):
         self.main = main
+        self.timeout = timeout
+        self.max_timeouts = max_timeouts
+        self.num_timeouts = 0
+        self.watchdog = None
         self.state = states.INIT
         self.main.event_q.subscribe(self)
         all_states = (o for o in vars(states).itervalues()
@@ -49,10 +55,24 @@
         # this try/except catches everything on purpose
         # pylint: disable-msg=W0702
         try:
-            next_state = self.state.next(event)
-            if next_state != self.state and next_state.enter is not None:
-                next_state.enter(self.main)
-            if not next_state.is_connected:
+            if self.num_timeouts > self.max_timeouts:
+                next_state = states.EXCESSIVE_TIMEOUTS
+            else:
+                next_state = self.state.next(event)
+            if self.watchdog is not None:
+                self.logger.debug('Event arrived: cancelling timeout watchdog')
+                self.watchdog.cancel()
+                self.watchdog = None
+                self.num_timeouts = 0
+            if next_state.is_handshake:
+                self.logger.debug('Setting up timeout watchdog')
+                self.watchdog = reactor.callLater(
+                    self.timeout * (1 + self.num_timeouts / 2.),
+                    self.handle_timeout)
+            if next_state != self.state:
+                if next_state.enter is not None:
+                    next_state.enter(self.main)
+            if self.state.is_connected and not next_state.is_connected:
                 client = self.main.action_q.client
                 if client is not None:
                     client.disconnect()
@@ -69,6 +89,16 @@
         self.state = next_state
         self.main.event_q.push('SYS_STATE_CHANGED', state=next_state)
 
+    def handle_timeout(self):
+        """
+        React to the timeout of a handshake state.
+        """
+        self.watchdog = None
+        self.num_timeouts += 1
+        client = self.main.action_q.client
+        if client is not None:
+            client.disconnect()
+        self.main.event_q.push('SYS_HANDSHAKE_TIMEOUT')
 
     @property
     def name(self):

=== modified file 'ubuntuone/syncdaemon/states.py'
--- ubuntuone/syncdaemon/states.py	2009-08-11 16:45:00 +0000
+++ ubuntuone/syncdaemon/states.py	2009-08-26 12:15:00 +0000
@@ -50,6 +50,7 @@
         self.is_connected = is_connected
         self.is_online = is_online
         self.enter = enter
+        self.is_handshake = 'SYS_HANDSHAKE_TIMEOUT' in other_transitions
         self.transitions = dict(SYS_NET_CONNECTED=sys_net_connected_trn,
                                 SYS_CONNECT=sys_connect_trn,
                                 SYS_NET_DISCONNECTED=sys_net_disconnected_trn,
@@ -315,7 +316,7 @@
     SYS_META_QUEUE_WAITING='READING_WAITING_WITH_BOTHQ',
     SYS_META_QUEUE_DONE='READING_WAITING_WITH_CONTQ',
     SYS_CONTENT_QUEUE_WAITING='READING_WAITING_WITH_BOTHQ',
-    SYS_CONTENT_QUEUE_DONE='READING_WAITING_WITH_CONTQ',
+    SYS_CONTENT_QUEUE_DONE='READING_WAITING_WITH_METAQ',
     )
 
 READING_WAITING_WITH_NETWORK = SyncDaemonState(
@@ -490,7 +491,7 @@
     'START_CONNECTING_WITH_METAQ', 'READY_WAITING_WITH_METAQ',
     'READY_WAITING_WITH_METAQ', 'READY_FOR_NETWORK_WITH_METAQ',
     'READY_WAITING_WITH_METAQ',
-    SYS_META_QUEUE_DONE='READY_WAITING_WITH_METAQ',
+    SYS_META_QUEUE_DONE='READY_WAITING',
     SYS_META_QUEUE_WAITING='READY_WAITING_WITH_METAQ',
     SYS_CONTENT_QUEUE_WAITING='READY_WAITING_WITH_BOTHQ',
     SYS_CONTENT_QUEUE_DONE='READY_WAITING_WITH_METAQ',
@@ -502,7 +503,7 @@
     'START_CONNECTING_WITH_CONTQ', 'READY_WAITING_WITH_CONTQ',
     'READY_WAITING_WITH_CONTQ', 'READY_FOR_NETWORK_WITH_CONTQ',
     'READY_WAITING_WITH_CONTQ',
-    SYS_META_QUEUE_WAITING='READY_WAITING_WITH_METAQ',
+    SYS_META_QUEUE_WAITING='READY_WAITING_WITH_BOTHQ',
     SYS_META_QUEUE_DONE='READY_WAITING_WITH_CONTQ',
     SYS_CONTENT_QUEUE_WAITING='READY_WAITING_WITH_CONTQ',
     SYS_CONTENT_QUEUE_DONE='READY_WAITING',
@@ -530,6 +531,7 @@
     SYS_META_QUEUE_DONE='CONNECTING',
     SYS_CONTENT_QUEUE_WAITING='CONNECTING_WITH_CONTQ',
     SYS_CONTENT_QUEUE_DONE='CONNECTING',
+    SYS_HANDSHAKE_TIMEOUT='START_CONNECTING',
     enter=lambda m: m.action_q.connect(),
     )
 
@@ -544,6 +546,7 @@
     SYS_META_QUEUE_DONE='CONNECTING',
     SYS_CONTENT_QUEUE_WAITING='CONNECTING_WITH_BOTHQ',
     SYS_CONTENT_QUEUE_DONE='CONNECTING_WITH_METAQ',
+    SYS_HANDSHAKE_TIMEOUT='START_CONNECTING_WITH_METAQ',
     enter=lambda m: m.action_q.connect(),
     )
 
@@ -558,6 +561,7 @@
     SYS_META_QUEUE_DONE='CONNECTING_WITH_CONTQ',
     SYS_CONTENT_QUEUE_WAITING='CONNECTING_WITH_CONTQ',
     SYS_CONTENT_QUEUE_DONE='CONNECTING',
+    SYS_HANDSHAKE_TIMEOUT='START_CONNECTING_WITH_CONTQ',
     enter=lambda m: m.action_q.connect(),
     )
 
@@ -572,6 +576,7 @@
     SYS_META_QUEUE_DONE='CONNECTING_WITH_CONTQ',
     SYS_CONTENT_QUEUE_WAITING='CONNECTING_WITH_BOTHQ',
     SYS_CONTENT_QUEUE_DONE='CONNECTING_WITH_METAQ',
+    SYS_HANDSHAKE_TIMEOUT='START_CONNECTING_WITH_BOTHQ',
     enter=lambda m: m.action_q.connect(),
     )
 
@@ -585,6 +590,7 @@
     SYS_META_QUEUE_DONE='CONNECTING',
     SYS_CONTENT_QUEUE_WAITING='CONNECTING_WITH_CONTQ',
     SYS_CONTENT_QUEUE_DONE='CONNECTING',
+    SYS_HANDSHAKE_TIMEOUT='START_CONNECTING',
     )
 
 CONNECTING_WITH_METAQ = SyncDaemonState(
@@ -598,6 +604,7 @@
     SYS_META_QUEUE_DONE='CONNECTING',
     SYS_CONTENT_QUEUE_WAITING='CONNECTING_WITH_BOTHQ',
     SYS_CONTENT_QUEUE_DONE='CONNECTING_WITH_METAQ',
+    SYS_HANDSHAKE_TIMEOUT='START_CONNECTING_WITH_METAQ',
     )
 
 CONNECTING_WITH_CONTQ = SyncDaemonState(
@@ -611,6 +618,7 @@
     SYS_META_QUEUE_DONE='CONNECTING_WITH_CONTQ',
     SYS_CONTENT_QUEUE_WAITING='CONNECTING_WITH_CONTQ',
     SYS_CONTENT_QUEUE_DONE='CONNECTING',
+    SYS_HANDSHAKE_TIMEOUT='START_CONNECTING_WITH_CONTQ',
     )
 
 CONNECTING_WITH_BOTHQ = SyncDaemonState(
@@ -624,6 +632,7 @@
     SYS_META_QUEUE_DONE='CONNECTING_WITH_CONTQ',
     SYS_CONTENT_QUEUE_WAITING='CONNECTING_WITH_BOTHQ',
     SYS_CONTENT_QUEUE_DONE='CONNECTING_WITH_METAQ',
+    SYS_HANDSHAKE_TIMEOUT='START_CONNECTING_WITH_BOTHQ',
     )
 
 START_CONNECTED = NonActiveConnectedSDState(
@@ -635,6 +644,7 @@
     SYS_META_QUEUE_DONE='CONNECTED',
     SYS_CONTENT_QUEUE_WAITING='CONNECTED_WITH_CONTQ',
     SYS_CONTENT_QUEUE_DONE='CONNECTED',
+    SYS_HANDSHAKE_TIMEOUT='START_CONNECTING',
     enter=lambda m: m.check_version(),
     )
 
@@ -648,6 +658,7 @@
     SYS_META_QUEUE_DONE='CONNECTED',
     SYS_CONTENT_QUEUE_WAITING='CONNECTED_WITH_BOTHQ',
     SYS_CONTENT_QUEUE_DONE='CONNECTED_WITH_METAQ',
+    SYS_HANDSHAKE_TIMEOUT='START_CONNECTING_WITH_METAQ',
     enter=lambda m: m.check_version(),
     )
 
@@ -661,6 +672,7 @@
     SYS_META_QUEUE_DONE='CONNECTED_WITH_CONTQ',
     SYS_CONTENT_QUEUE_WAITING='CONNECTED_WITH_CONTQ',
     SYS_CONTENT_QUEUE_DONE='CONNECTED',
+    SYS_HANDSHAKE_TIMEOUT='START_CONNECTING_WITH_CONTQ',
     enter=lambda m: m.check_version(),
     )
 
@@ -674,6 +686,7 @@
     SYS_META_QUEUE_DONE='CONNECTED_WITH_CONTQ',
     SYS_CONTENT_QUEUE_WAITING='CONNECTED_WITH_BOTHQ',
     SYS_CONTENT_QUEUE_DONE='CONNECTED_WITH_METAQ',
+    SYS_HANDSHAKE_TIMEOUT='START_CONNECTING_WITH_BOTHQ',
     enter=lambda m: m.check_version(),
     )
 
@@ -686,6 +699,7 @@
     SYS_META_QUEUE_DONE='CONNECTED',
     SYS_CONTENT_QUEUE_WAITING='CONNECTED_WITH_CONTQ',
     SYS_CONTENT_QUEUE_DONE='CONNECTED',
+    SYS_HANDSHAKE_TIMEOUT='START_CONNECTING',
     )
 
 CONNECTED_WITH_METAQ = NonActiveConnectedSDState(
@@ -698,6 +712,7 @@
     SYS_META_QUEUE_DONE='CONNECTED',
     SYS_CONTENT_QUEUE_WAITING='CONNECTED_WITH_BOTHQ',
     SYS_CONTENT_QUEUE_DONE='CONNECTED_WITH_METAQ',
+    SYS_HANDSHAKE_TIMEOUT='START_CONNECTING_WITH_METAQ',
     )
 
 CONNECTED_WITH_CONTQ = NonActiveConnectedSDState(
@@ -710,6 +725,7 @@
     SYS_META_QUEUE_DONE='CONNECTED_WITH_CONTQ',
     SYS_CONTENT_QUEUE_WAITING='CONNECTED_WITH_CONTQ',
     SYS_CONTENT_QUEUE_DONE='CONNECTED',
+    SYS_HANDSHAKE_TIMEOUT='START_CONNECTING_WITH_CONTQ',
     )
 
 CONNECTED_WITH_BOTHQ = NonActiveConnectedSDState(
@@ -722,6 +738,7 @@
     SYS_META_QUEUE_DONE='CONNECTED_WITH_CONTQ',
     SYS_CONTENT_QUEUE_WAITING='CONNECTED_WITH_BOTHQ',
     SYS_CONTENT_QUEUE_DONE='CONNECTED_WITH_METAQ',
+    SYS_HANDSHAKE_TIMEOUT='START_CONNECTING_WITH_BOTHQ',
     )
 
 BAD_VERSION = AQErrorState(
@@ -738,6 +755,7 @@
     SYS_META_QUEUE_DONE='SET_CAPABILITIES',
     SYS_CONTENT_QUEUE_WAITING='SET_CAPABILITIES_WITH_CONTQ',
     SYS_CONTENT_QUEUE_DONE='SET_CAPABILITIES',
+    SYS_HANDSHAKE_TIMEOUT='START_CONNECTING',
     enter=lambda m: m.set_capabilities(),
     )
 
@@ -751,6 +769,7 @@
     SYS_META_QUEUE_DONE='SET_CAPABILITIES',
     SYS_CONTENT_QUEUE_WAITING='SET_CAPABILITIES_WITH_BOTHQ',
     SYS_CONTENT_QUEUE_DONE='SET_CAPABILITIES_WITH_METAQ',
+    SYS_HANDSHAKE_TIMEOUT='START_CONNECTING_WITH_METAQ',
     enter=lambda m: m.set_capabilities(),
     )
 
@@ -764,6 +783,7 @@
     SYS_META_QUEUE_DONE='SET_CAPABILITIES_WITH_CONTQ',
     SYS_CONTENT_QUEUE_WAITING='SET_CAPABILITIES_WITH_CONTQ',
     SYS_CONTENT_QUEUE_DONE='SET_CAPABILITIES',
+    SYS_HANDSHAKE_TIMEOUT='START_CONNECTING_WITH_CONTQ',
     enter=lambda m: m.set_capabilities(),
     )
 
@@ -777,6 +797,7 @@
     SYS_META_QUEUE_DONE='SET_CAPABILITIES_WITH_CONTQ',
     SYS_CONTENT_QUEUE_WAITING='START_SET_CAPABILITIES_WITH_BOTHQ',
     SYS_CONTENT_QUEUE_DONE='SET_CAPABILITIES_WITH_METAQ',
+    SYS_HANDSHAKE_TIMEOUT='START_CONNECTING_WITH_BOTHQ',
     enter=lambda m: m.set_capabilities(),
     )
 
@@ -789,6 +810,7 @@
     SYS_META_QUEUE_DONE='SET_CAPABILITIES',
     SYS_CONTENT_QUEUE_WAITING='SET_CAPABILITIES_WITH_CONTQ',
     SYS_CONTENT_QUEUE_DONE='SET_CAPABILITIES',
+    SYS_HANDSHAKE_TIMEOUT='START_CONNECTING',
     )
 
 SET_CAPABILITIES_WITH_METAQ = NonActiveConnectedSDState(
@@ -801,6 +823,7 @@
     SYS_META_QUEUE_DONE='SET_CAPABILITIES',
     SYS_CONTENT_QUEUE_WAITING='SET_CAPABILITIES_WITH_BOTHQ',
     SYS_CONTENT_QUEUE_DONE='SET_CAPABILITIES_WITH_METAQ',
+    SYS_HANDSHAKE_TIMEOUT='START_CONNECTING_WITH_METAQ',
     )
 
 SET_CAPABILITIES_WITH_CONTQ = NonActiveConnectedSDState(
@@ -813,6 +836,7 @@
     SYS_META_QUEUE_DONE='SET_CAPABILITIES_WITH_CONTQ',
     SYS_CONTENT_QUEUE_WAITING='SET_CAPABILITIES_WITH_CONTQ',
     SYS_CONTENT_QUEUE_DONE='SET_CAPABILITIES',
+    SYS_HANDSHAKE_TIMEOUT='START_CONNECTING_WITH_CONTQ',
     )
 
 SET_CAPABILITIES_WITH_BOTHQ = NonActiveConnectedSDState(
@@ -825,6 +849,7 @@
     SYS_META_QUEUE_DONE='SET_CAPABILITIES_WITH_CONTQ',
     SYS_CONTENT_QUEUE_WAITING='SET_CAPABILITIES_WITH_BOTHQ',
     SYS_CONTENT_QUEUE_DONE='SET_CAPABILITIES_WITH_METAQ',
+    SYS_HANDSHAKE_TIMEOUT='START_CONNECTING_WITH_BOTHQ',
     )
 
 CAPABILITIES_MISMATCH = AQErrorState(
@@ -841,6 +866,7 @@
     SYS_META_QUEUE_DONE='AUTHENTICATING',
     SYS_CONTENT_QUEUE_WAITING='AUTHENTICATING_WITH_CONTQ',
     SYS_CONTENT_QUEUE_DONE='AUTHENTICATING',
+    SYS_HANDSHAKE_TIMEOUT='START_CONNECTING',
     enter=lambda m: m.authenticate(),
     )
 
@@ -854,6 +880,7 @@
     SYS_META_QUEUE_DONE='AUTHENTICATING',
     SYS_CONTENT_QUEUE_WAITING='AUTHENTICATING_WITH_BOTHQ',
     SYS_CONTENT_QUEUE_DONE='AUTHENTICATING_WITH_METAQ',
+    SYS_HANDSHAKE_TIMEOUT='START_CONNECTING_WITH_METAQ',
     enter=lambda m: m.authenticate(),
     )
 
@@ -867,6 +894,7 @@
     SYS_META_QUEUE_DONE='AUTHENTICATING_WITH_CONTQ',
     SYS_CONTENT_QUEUE_WAITING='AUTHENTICATING_WITH_CONTQ',
     SYS_CONTENT_QUEUE_DONE='AUTHENTICATING',
+    SYS_HANDSHAKE_TIMEOUT='START_CONNECTING_WITH_CONTQ',
     enter=lambda m: m.authenticate(),
     )
 
@@ -880,6 +908,7 @@
     SYS_META_QUEUE_DONE='AUTHENTICATING_WITH_CONTQ',
     SYS_CONTENT_QUEUE_WAITING='AUTHENTICATING_WITH_BOTHQ',
     SYS_CONTENT_QUEUE_DONE='AUTHENTICATING_WITH_METAQ',
+    SYS_HANDSHAKE_TIMEOUT='START_CONNECTING_WITH_BOTHQ',
     enter=lambda m: m.authenticate(),
     )
 
@@ -892,6 +921,7 @@
     SYS_META_QUEUE_DONE='AUTHENTICATING',
     SYS_CONTENT_QUEUE_WAITING='AUTHENTICATING_WITH_CONTQ',
     SYS_CONTENT_QUEUE_DONE='AUTHENTICATING',
+    SYS_HANDSHAKE_TIMEOUT='START_CONNECTING',
     )
 
 AUTHENTICATING_WITH_METAQ = NonActiveConnectedSDState(
@@ -904,6 +934,7 @@
     SYS_META_QUEUE_DONE='AUTHENTICATING',
     SYS_CONTENT_QUEUE_WAITING='AUTHENTICATING_WITH_BOTHQ',
     SYS_CONTENT_QUEUE_DONE='AUTHENTICATING_WITH_METAQ',
+    SYS_HANDSHAKE_TIMEOUT='START_CONNECTING_WITH_METAQ',
     )
 
 AUTHENTICATING_WITH_CONTQ = NonActiveConnectedSDState(
@@ -916,6 +947,7 @@
     SYS_META_QUEUE_DONE='AUTHENTICATING_WITH_CONTQ',
     SYS_CONTENT_QUEUE_WAITING='AUTHENTICATING_WITH_CONTQ',
     SYS_CONTENT_QUEUE_DONE='AUTHENTICATING',
+    SYS_HANDSHAKE_TIMEOUT='START_CONNECTING_WITH_CONTQ',
     )
 
 AUTHENTICATING_WITH_BOTHQ = NonActiveConnectedSDState(
@@ -928,12 +960,17 @@
     SYS_META_QUEUE_DONE='AUTHENTICATING_WITH_CONTQ',
     SYS_CONTENT_QUEUE_WAITING='AUTHENTICATING_WITH_BOTHQ',
     SYS_CONTENT_QUEUE_DONE='AUTHENTICATING_WITH_METAQ',
+    SYS_HANDSHAKE_TIMEOUT='START_CONNECTING_WITH_BOTHQ',
     )
 
 AUTH_FAILED = AQErrorState(
     'AUTH_FAILED',
     'OAuth failed')
 
+EXCESSIVE_TIMEOUTS = AQErrorState(
+    'EXCESSIVE_TIMEOUTS',
+    'Too many timeouts. Giving up.')
+
 UNKNOWN_ERROR = AQErrorState(
     'UNKNOWN_ERROR',
     "Some kind of strange error happened and I can't continue",

=== modified file 'ubuntuone/syncdaemon/sync.py'
--- ubuntuone/syncdaemon/sync.py	2009-08-11 16:45:00 +0000
+++ ubuntuone/syncdaemon/sync.py	2009-08-26 12:15:00 +0000
@@ -30,6 +30,7 @@
     StateMachineRunner, StateMachine
 from ubuntuone.syncdaemon.interfaces import IMarker
 from ubuntuone.syncdaemon import u1fsfsm
+from ubuntuone.syncdaemon.logger import DebugCapture
 from ubuntuone.syncdaemon.filesystem_manager import \
     InconsistencyError
 empty_hash = ""
@@ -37,6 +38,7 @@
 class FSKey(object):
     """This encapsulates the problem of getting the metadata with different
     keys."""
+    __slots__ = ('fs', 'keys', 'mdid', '_changes')
 
     def __init__(self, fs, **keys):
         """create"""
@@ -97,8 +99,9 @@
 
     def sync(self):
         """sync the changes back to FSM"""
-        if self._changes:
+        if self._changes and self.has_metadata():
             self.fs.set_by_mdid(self.get_mdid(), **self._changes)
+            self._changes = {}
 
     def has_metadata(self):
         """The State Machine value version of has_metadata."""
@@ -107,12 +110,22 @@
         except (KeyError, TypeError):
             return 'NA'
 
+    def is_directory(self):
+        """The State Machine value version of is_dir.
+
+        This is a string like "T" or "F", not useful as a bool.
+        """
+        try:
+            return str(self.fs.is_dir(**self.keys))[0]
+        except KeyError:
+            return 'NA'
+
     def is_dir(self):
-        """The State Machine value version of is_dir."""
-        try:
-            return str(self.fs.is_dir(**self.keys))[0]
-        except KeyError:
-            return 'NA'
+        """If the node is a directory or not.
+
+        This is a direct wrapper around FSM.is_dir().
+        """
+        return self.fs.is_dir(**self.keys)
 
     def changed(self):
         """The State Machine value version of changed."""
@@ -143,11 +156,15 @@
         """delete the file and metadata"""
         path = self["path"]
         self.fs.delete_file(path)
+        self.mdid = None
+        self._changes = {}
 
     def delete_metadata(self):
         """delete the metadata"""
         path = self["path"]
         self.fs.delete_metadata(path)
+        self.mdid = None
+        self._changes = {}
 
     def move_file(self, new_share_id, new_parent_id, new_name):
         """get the stuff we need to move the file."""
@@ -211,6 +228,7 @@
 
 class FileLogger(object):
     """A logger that knows about the file and its state."""
+    __slots__ = ('logger', 'key')
 
     def __init__(self, logger, key):
         """Create a logger for this guy"""
@@ -219,7 +237,6 @@
 
     def log(self, lvl, message, *args, **kwargs):
         """Log."""
-
         format = "%(hasmd)s:%(changed)s:%(isdir)s %(mdid)s "\
                  "[%(share_id)s:%(node_id)s] '%(path)r' | %(message)s"
         exc_info = sys.exc_info
@@ -243,7 +260,7 @@
                          share_id=self.key.safe_get("share_id") or 'root',
                          node_id=self.key.safe_get("node_id"),
                          hasmd=self.key.has_metadata(),
-                         isdir=self.key.is_dir(),
+                         isdir=self.key.is_directory(),
                          changed=self.key.changed())
         else:
             extra = dict(message=message, mdid="-",
@@ -277,13 +294,35 @@
         self.m = main
         self.key = key
 
+    def on_event(self, *args, **kwargs):
+        """Override on_event to capture the debug log"""
+        in_state = '%(hasmd)s:%(changed)s:%(isdir)s' % \
+                dict(hasmd=self.key.has_metadata(),
+                     isdir=self.key.is_directory(),
+                     changed=self.key.changed())
+        is_debug = self.log.logger.isEnabledFor(logging.DEBUG)
+        with DebugCapture(self.log.logger):
+            func_name = super(SyncStateMachineRunner, self).on_event(*args,
+                                                                     **kwargs)
+            if not is_debug:
+                self.log.info("Called %s (In: %s)" % (func_name, in_state))
+
     def signal_event_with_hash(self, event, hash, *args):
         """An event that takes a hash ocurred, build the params and signal."""
         self.on_event(event, self.build_hash_eq(hash), hash, *args)
 
     def validate_actual_data(self, path, oldstat):
         """Validates that the received info is not obsolete."""
-        newstat = os.stat(path)
+        try:
+            newstat = os.stat(path)
+        except OSError:
+            # the file went away between the moment HQ finished and now, we
+            # discard it (if the file would have went away moments before,
+            # this info would have been discarded by HQ itself)
+            m = "Received hash of path, but it's no longer there: %r"
+            self.log.debug(m, path)
+            return False
+
         if newstat.st_ino != oldstat.st_ino or \
            newstat.st_size != oldstat.st_size or \
            newstat.st_mtime != oldstat.st_mtime or \
@@ -315,14 +354,16 @@
 
     def build_error_eq(self, error):
         """Get the error state."""
-        return dict(not_available="F", not_authorized="F")
+        not_available = str(error == 'NOT_AVAILABLE')[0]
+        not_authorized = str(error == 'NOT_AUTHORIZED')[0]
+        return dict(not_available=not_available, not_authorized=not_authorized)
 
     def get_state_values(self):
         """Get the values for the current state."""
         return dict(
             has_metadata=self.key.has_metadata(),
             changed=self.key.changed(),
-            is_directory=self.key.is_dir(),
+            is_directory=self.key.is_directory(),
         )
 
     # EVENT HANDLERS
@@ -447,14 +488,16 @@
                 continue
             mdpath = self.m.fs.get_abspath(md.share_id, md.path)
             if mdpath != os.path.join(self.key['path'], name):
-                # this was moved
-                # mark as moved
-                moved.add(uuid)
-                # signal moved
-                self.m.event_q.push("SV_MOVED",
-                    share_id=md.share_id, node_id=uuid,
-                    new_share_id=share, new_parent_id=self.key['node_id'],
-                    new_name=name)
+                # this was moved, or maybe the server still didn't receive
+                # the move that happened here
+                if not self.m.action_q.node_is_with_queued_move(share, uuid):
+                    # mark as moved
+                    moved.add(uuid)
+                    # signal moved
+                    self.m.event_q.push("SV_MOVED",
+                        share_id=md.share_id, node_id=uuid,
+                        new_share_id=share, new_parent_id=self.key['node_id'],
+                        new_name=name)
 
 
         for name, isdir, uuid in client_dir:
@@ -555,7 +598,10 @@
             self.m.fs.set_by_node_id(old_parent_id, share_id,
                                      server_hash="", local_hash="")
             self.m.action_q.query([(share_id, old_parent_id, "")])
-        self.m.hash_q.insert(self.key['path'])
+
+        # we only hash it if we're a file, not a directory
+        if not self.key.is_dir():
+            self.m.hash_q.insert(self.key['path'], self.key['mdid'])
 
 
     def server_file_changed_back(self, event, params, hash):
@@ -623,7 +669,7 @@
 
     def calculate_hash(self, event, params):
         """calculate the hash of this."""
-        self.m.hash_q.insert(self.key['path'])
+        self.m.hash_q.insert(self.key['path'], self.key['mdid'])
 
     def put_file(self, event, params, hash, crc32, size, stat):
         """upload the file to the server."""
@@ -651,7 +697,7 @@
         self.key.set(local_hash=hash)
         self.key.set(server_hash=hash)
         self.key.sync()
-        self.m.hash_q.insert(self.key['path'])
+        self.m.hash_q.insert(self.key['path'], self.key['mdid'])
 
 
     def reput_file(self, event, param, hash, crc32, size, stat):
@@ -776,8 +822,6 @@
         self.key.set(local_hash=self.key['server_hash'])
         self.key.sync()
         self.client_moved(event, params, path_from, path_to)
-        self.m.hash_q.insert(self.key['path'])
-
 
     def moved_dirty_server(self, event, params, path_from, path_to):
         """file was moved while downloading it"""
@@ -803,6 +847,13 @@
         self.key.set(stat=stat)
         self.key.sync()
 
+    def remove_partial(self, event, params, error=None, server_hash=''):
+        """remove the .partial file"""
+        self.key.remove_partial()
+        local_hash = self.key['local_hash']
+        self.key.set(server_hash=local_hash, local_hash=local_hash)
+        self.key.sync()
+
 
 class Sync(object):
     """Translates from EQ events into state machine events."""
@@ -811,6 +862,8 @@
 
     def __init__(self, main):
         """create"""
+        # XXX: verterok: add a custom Logger to lazyily build the LogRecord,
+        # now that the DebugCapture is enabled
         self.logger = logging.getLogger('ubuntuone.SyncDaemon.sync')
         self.fsm = StateMachine(u1fsfsm.state_machine)
         self.m = main
@@ -855,10 +908,20 @@
         ssmr = SyncStateMachineRunner(self.fsm, self.m, key, log)
         ssmr.signal_event_with_hash("AQ_DOWNLOAD_FINISHED", server_hash)
 
-    def handle_AQ_DOWNLOAD_ERROR(self, *args, **kwargs):
+    def handle_AQ_DOWNLOAD_ERROR(self, share_id, node_id, server_hash, error):
         """on AQ_DOWNLOAD_ERROR"""
-        # for now we pass. later we will feed this into the state machine
-        pass
+        key = FSKey(self.m.fs, share_id=share_id, node_id=node_id)
+        log = FileLogger(self.logger, key)
+        ssmr = SyncStateMachineRunner(self.fsm, self.m, key, log)
+        ssmr.signal_event_with_error_and_hash("AQ_DOWNLOAD_ERROR", error,
+                                              server_hash)
+
+    def handle_AQ_DOWNLOAD_CANCELLED(self, share_id, node_id, server_hash):
+        """on AQ_DOWNLOAD_CANCELLED"""
+        key = FSKey(self.m.fs, share_id=share_id, node_id=node_id)
+        log = FileLogger(self.logger, key)
+        ssmr = SyncStateMachineRunner(self.fsm, self.m, key, log)
+        ssmr.signal_event_with_hash("AQ_DOWNLOAD_CANCELLED", server_hash)
 
     def handle_FS_FILE_CREATE(self, path):
         """on FS_FILE_CREATE"""
@@ -894,7 +957,13 @@
         log = FileLogger(self.logger, key)
         ssmr = SyncStateMachineRunner(self.fsm, self.m, key, log)
         ssmr.on_event("FS_FILE_MOVE", {}, path_from, path_to)
-    handle_FS_DIR_MOVE = handle_FS_FILE_MOVE
+
+    def handle_FS_DIR_MOVE(self, path_from, path_to):
+        """on FS_DIR_MOVE"""
+        key = FSKey(self.m.fs, path=path_from)
+        log = FileLogger(self.logger, key)
+        ssmr = SyncStateMachineRunner(self.fsm, self.m, key, log)
+        ssmr.on_event("FS_DIR_MOVE", {}, path_from, path_to)
 
     def handle_AQ_FILE_NEW_OK(self, marker, new_id):
         """on AQ_FILE_NEW_OK"""
@@ -931,6 +1000,13 @@
         ssmr = SyncStateMachineRunner(self.fsm, self.m, key, log)
         ssmr.on_event('FS_FILE_CLOSE_WRITE', {})
 
+    def handle_HQ_HASH_ERROR(self, mdid):
+        """on HQ_HASH_ERROR"""
+        key = FSKey(self.m.fs, mdid=mdid)
+        log = FileLogger(self.logger, key)
+        ssmr = SyncStateMachineRunner(self.fsm, self.m, key, log)
+        ssmr.on_event('HQ_HASH_ERROR', {})
+
     def handle_HQ_HASH_NEW(self, path, hash, crc32, size, stat):
         """on HQ_HASH_NEW"""
         key = FSKey(self.m.fs, path=path)

=== modified file 'ubuntuone/syncdaemon/u1fsfsm.ods'
Binary files ubuntuone/syncdaemon/u1fsfsm.ods and ubuntuone/syncdaemon/u1fsfsm.ods differ
=== modified file 'ubuntuone/syncdaemon/u1fsfsm.py'
--- ubuntuone/syncdaemon/u1fsfsm.py	2009-06-30 12:00:00 +0000
+++ ubuntuone/syncdaemon/u1fsfsm.py	2009-08-26 12:15:00 +0000
@@ -339,9 +339,35 @@
                                 'STATE_OUT': {u'changed': u'=',
                                               u'has_metadata': u'=',
                                               u'is_directory': u'='}}],
-            u'AQ_DOWNLOAD_ERROR': [{'ACTION': u'pass',
-                                    'ACTION_FUNC': u'nothing',
-                                    'COMMENTS': u'',
+            u'AQ_DOWNLOAD_CANCELLED': [{'ACTION': u'md.remove_partial(uuid);',
+                                        'ACTION_FUNC': u'nothing',
+                                        'COMMENTS': u'Download cancelled, remove the partial file',
+                                        'PARAMETERS': {u'hash_eq_local_hash': u'*',
+                                                       u'hash_eq_server_hash': u'*',
+                                                       u'not_authorized': u'NA',
+                                                       u'not_available': u'NA'},
+                                        'STATE': {u'changed': u'*',
+                                                  u'has_metadata': u'T',
+                                                  u'is_directory': u'*'},
+                                        'STATE_OUT': {u'changed': u'=',
+                                                      u'has_metadata': u'=',
+                                                      u'is_directory': u'='}},
+                                       {'ACTION': u'pass',
+                                        'ACTION_FUNC': u'nothing',
+                                        'COMMENTS': u'',
+                                        'PARAMETERS': {u'hash_eq_local_hash': u'*',
+                                                       u'hash_eq_server_hash': u'*',
+                                                       u'not_authorized': u'NA',
+                                                       u'not_available': u'NA'},
+                                        'STATE': {u'changed': u'*',
+                                                  u'has_metadata': u'F',
+                                                  u'is_directory': u'*'},
+                                        'STATE_OUT': {u'changed': u'=',
+                                                      u'has_metadata': u'=',
+                                                      u'is_directory': u'='}}],
+            u'AQ_DOWNLOAD_ERROR': [{'ACTION': u'md.remove_partial(uuid);',
+                                    'ACTION_FUNC': u'remove_partial',
+                                    'COMMENTS': u'error while downloading, remove the partial file',
                                     'PARAMETERS': {u'hash_eq_local_hash': u'*',
                                                    u'hash_eq_server_hash': u'*',
                                                    u'not_authorized': u'T',
@@ -349,12 +375,12 @@
                                     'STATE': {u'changed': u'*',
                                               u'has_metadata': u'T',
                                               u'is_directory': u'*'},
-                                    'STATE_OUT': {u'changed': u'=',
+                                    'STATE_OUT': {u'changed': u'NONE',
                                                   u'has_metadata': u'=',
                                                   u'is_directory': u'='}},
-                                   {'ACTION': u'pass',
-                                    'ACTION_FUNC': u'nothing',
-                                    'COMMENTS': u'',
+                                   {'ACTION': u'md.remove_partial(uuid);',
+                                    'ACTION_FUNC': u'remove_partial',
+                                    'COMMENTS': u'error while downloading, remove the partial file',
                                     'PARAMETERS': {u'hash_eq_local_hash': u'*',
                                                    u'hash_eq_server_hash': u'*',
                                                    u'not_authorized': u'F',
@@ -362,7 +388,7 @@
                                     'STATE': {u'changed': u'*',
                                               u'has_metadata': u'T',
                                               u'is_directory': u'*'},
-                                    'STATE_OUT': {u'changed': u'=',
+                                    'STATE_OUT': {u'changed': u'NONE',
                                                   u'has_metadata': u'=',
                                                   u'is_directory': u'='}},
                                    {'ACTION': u'NA',
@@ -379,8 +405,8 @@
                                                   u'has_metadata': u'*',
                                                   u'is_directory': u'*'}},
                                    {'ACTION': u'PANIC',
-                                    'ACTION_FUNC': u'DESPAIR',
-                                    'COMMENTS': u'',
+                                    'ACTION_FUNC': u'remove_partial',
+                                    'COMMENTS': u'Should DESPAIR, but ATM we handle this in the handle_AQ_DOWNLOAD_ERROR as we have an extra error type returned by AQ when the .partial file is deleted by the user',
                                     'PARAMETERS': {u'hash_eq_local_hash': u'*',
                                                    u'hash_eq_server_hash': u'*',
                                                    u'not_authorized': u'F',
@@ -388,7 +414,7 @@
                                     'STATE': {u'changed': u'*',
                                               u'has_metadata': u'T',
                                               u'is_directory': u'*'},
-                                    'STATE_OUT': {u'changed': u'=',
+                                    'STATE_OUT': {u'changed': u'NONE',
                                                   u'has_metadata': u'=',
                                                   u'is_directory': u'='}},
                                    {'ACTION': u'NA',
@@ -1522,9 +1548,61 @@
                                 'STATE_OUT': {u'changed': u'NA',
                                               u'has_metadata': u'F',
                                               u'is_directory': u'NA'}}],
-            u'FS_FILE_CLOSE_WRITE': [{'ACTION': u'DESPAIR',
-                                      'ACTION_FUNC': u'DESPAIR',
-                                      'COMMENTS': u'changes from a file that does not exists',
+            u'FS_DIR_MOVE': [{'ACTION': u'',
+                              'ACTION_FUNC': u'nothing',
+                              'COMMENTS': u'side efect of local move',
+                              'PARAMETERS': {u'hash_eq_local_hash': u'NA',
+                                             u'hash_eq_server_hash': u'NA',
+                                             u'not_authorized': u'NA',
+                                             u'not_available': u'NA'},
+                              'STATE': {u'changed': u'NA',
+                                        u'has_metadata': u'F',
+                                        u'is_directory': u'NA'},
+                              'STATE_OUT': {u'changed': u'NA',
+                                            u'has_metadata': u'F',
+                                            u'is_directory': u'NA'}},
+                             {'ACTION': u'aq.move()',
+                              'ACTION_FUNC': u'client_moved',
+                              'COMMENTS': u'vanilla case',
+                              'PARAMETERS': {u'hash_eq_local_hash': u'NA',
+                                             u'hash_eq_server_hash': u'NA',
+                                             u'not_authorized': u'NA',
+                                             u'not_available': u'NA'},
+                              'STATE': {u'changed': u'NONE',
+                                        u'has_metadata': u'T',
+                                        u'is_directory': u'*'},
+                              'STATE_OUT': {u'changed': u'=',
+                                            u'has_metadata': u'T',
+                                            u'is_directory': u'='}},
+                             {'ACTION': u'cancel upload; move; restart upload',
+                              'ACTION_FUNC': u'moved_dirty_local',
+                              'COMMENTS': u'we got a move while we were downloading it',
+                              'PARAMETERS': {u'hash_eq_local_hash': u'NA',
+                                             u'hash_eq_server_hash': u'NA',
+                                             u'not_authorized': u'NA',
+                                             u'not_available': u'NA'},
+                              'STATE': {u'changed': u'LOCAL',
+                                        u'has_metadata': u'T',
+                                        u'is_directory': u'F'},
+                              'STATE_OUT': {u'changed': u'NONE',
+                                            u'has_metadata': u'T',
+                                            u'is_directory': u'F'}},
+                             {'ACTION': u'cancel_download; move; query',
+                              'ACTION_FUNC': u'moved_dirty_server',
+                              'COMMENTS': u'we got a move while we were downloading it',
+                              'PARAMETERS': {u'hash_eq_local_hash': u'NA',
+                                             u'hash_eq_server_hash': u'NA',
+                                             u'not_authorized': u'NA',
+                                             u'not_available': u'NA'},
+                              'STATE': {u'changed': u'SERVER',
+                                        u'has_metadata': u'T',
+                                        u'is_directory': u'*'},
+                              'STATE_OUT': {u'changed': u'NONE',
+                                            u'has_metadata': u'T',
+                                            u'is_directory': u'='}}],
+            u'FS_FILE_CLOSE_WRITE': [{'ACTION': u'pass',
+                                      'ACTION_FUNC': u'nothing',
+                                      'COMMENTS': u'changes from a file that no longer exists',
                                       'PARAMETERS': {u'hash_eq_local_hash': u'NA',
                                                      u'hash_eq_server_hash': u'NA',
                                                      u'not_authorized': u'NA',
@@ -1532,9 +1610,9 @@
                                       'STATE': {u'changed': u'NA',
                                                 u'has_metadata': u'F',
                                                 u'is_directory': u'*'},
-                                      'STATE_OUT': {u'changed': u'*',
-                                                    u'has_metadata': u'*',
-                                                    u'is_directory': u'*'}},
+                                      'STATE_OUT': {u'changed': u'=',
+                                                    u'has_metadata': u'=',
+                                                    u'is_directory': u'='}},
                                      {'ACTION': u'DESPAIR',
                                       'ACTION_FUNC': u'DESPAIR',
                                       'COMMENTS': u'event cant happen in directories',
@@ -1743,6 +1821,45 @@
                                'STATE_OUT': {u'changed': u'NONE',
                                              u'has_metadata': u'T',
                                              u'is_directory': u'='}}],
+            u'HQ_HASH_ERROR': [{'ACTION': u'',
+                                'ACTION_FUNC': u'nothing',
+                                'COMMENTS': u'it was deleted at some point',
+                                'PARAMETERS': {u'hash_eq_local_hash': u'NA',
+                                               u'hash_eq_server_hash': u'NA',
+                                               u'not_authorized': u'NA',
+                                               u'not_available': u'NA'},
+                                'STATE': {u'changed': u'NA',
+                                          u'has_metadata': u'F',
+                                          u'is_directory': u'NA'},
+                                'STATE_OUT': {u'changed': u'NA',
+                                              u'has_metadata': u'F',
+                                              u'is_directory': u'NA'}},
+                               {'ACTION': u'DESPAIR',
+                                'ACTION_FUNC': u'DESPAIR',
+                                'COMMENTS': u'we should never be hashing a directory',
+                                'PARAMETERS': {u'hash_eq_local_hash': u'NA',
+                                               u'hash_eq_server_hash': u'NA',
+                                               u'not_authorized': u'NA',
+                                               u'not_available': u'NA'},
+                                'STATE': {u'changed': u'*',
+                                          u'has_metadata': u'T',
+                                          u'is_directory': u'T'},
+                                'STATE_OUT': {u'changed': u'*',
+                                              u'has_metadata': u'*',
+                                              u'is_directory': u'*'}},
+                               {'ACTION': u'hq.insert(path)',
+                                'ACTION_FUNC': u'calculate_hash',
+                                'COMMENTS': u'we need to re send the hash to the HQ',
+                                'PARAMETERS': {u'hash_eq_local_hash': u'NA',
+                                               u'hash_eq_server_hash': u'NA',
+                                               u'not_authorized': u'NA',
+                                               u'not_available': u'NA'},
+                                'STATE': {u'changed': u'*',
+                                          u'has_metadata': u'T',
+                                          u'is_directory': u'F'},
+                                'STATE_OUT': {u'changed': u'=',
+                                              u'has_metadata': u'=',
+                                              u'is_directory': u'='}}],
             u'HQ_HASH_NEW': [{'ACTION': u'NA',
                               'ACTION_FUNC': u'',
                               'COMMENTS': u'',

=== modified file 'ubuntuone/syncdaemon/volume_manager.py'
--- ubuntuone/syncdaemon/volume_manager.py	2009-08-11 16:45:00 +0000
+++ ubuntuone/syncdaemon/volume_manager.py	2009-08-26 12:15:00 +0000
@@ -27,6 +27,7 @@
 from contextlib import contextmanager
 from itertools import ifilter
 
+from ubuntuone.storageprotocol import request
 from ubuntuone.syncdaemon.marker import MDMarker
 from ubuntuone.syncdaemon import file_shelf
 
@@ -34,9 +35,9 @@
 class Share(object):
     """Representas a share or mount point"""
 
-    def __init__(self, path, share_id='', name=None, access_level='View',
-                 accepted=False, other_username=None, other_visible_name=None,
-                 subtree=None):
+    def __init__(self, path, share_id=request.ROOT, name=None,
+                 access_level='View', accepted=False, other_username=None,
+                 other_visible_name=None, subtree=None):
         """ Creates the instance.
 
         The received path should be 'bytes'
@@ -52,6 +53,7 @@
         self.other_username = other_username
         self.other_visible_name = other_visible_name
         self.subtree = subtree
+        self.free_bytes = None
 
     @classmethod
     def from_response(cls, share_response, path):
@@ -89,7 +91,7 @@
 class VolumeManager(object):
     """Manages shares and mount points."""
 
-    METADATA_VERSION = '3'
+    METADATA_VERSION = '4'
 
     def __init__(self, main):
         """Create the instance and populate the shares/d attributes
@@ -105,6 +107,8 @@
         if not os.path.exists(self._data_dir):
             # first run, the data dir don't exist. No metadata to upgrade
             md_version = VolumeManager.METADATA_VERSION
+            os.makedirs(self._data_dir)
+            self._update_metadata_version()
         elif os.path.exists(self._version_file):
             with open(self._version_file) as fh:
                 md_version = fh.read().strip()
@@ -115,30 +119,38 @@
         else:
             md_version = None
 
-        if not os.path.exists(self._shares_dir):
-            os.makedirs(self._shares_dir)
-        if not os.path.exists(self._shared_dir):
-            os.makedirs(self._shared_dir)
-
         # upgrade the metadata
         if md_version != VolumeManager.METADATA_VERSION:
             upgrade_method = getattr(self, "_upgrade_metadata_%s" % md_version)
             upgrade_method(md_version)
+        if not os.path.exists(self._shares_dir):
+            os.makedirs(self._shares_dir)
+        if not os.path.exists(self._shared_dir):
+            os.makedirs(self._shared_dir)
+
+        # build the dir layout
+        # TODO: migrate from old dir layout
+        if not os.path.exists(self.m.root_dir):
+            os.makedirs(self.m.root_dir)
+        if not os.path.exists(self.m.shares_dir):
+            os.makedirs(self.m.shares_dir)
+        # create the shares symlink
+        if not os.path.exists(self.m.shares_dir_link):
+            os.symlink(self.m.shares_dir, self.m.shares_dir_link)
+        # make the shares_dir read only
+        os.chmod(self.m.shares_dir, 0555)
+        # make the root read write
+        os.chmod(self.m.root_dir, 0775)
 
         self.shares = ShareFileShelf(self._shares_dir)
         self.shared = ShareFileShelf(self._shared_dir)
-        if self.shares.get('') is None:
+        if self.shares.get(request.ROOT) is None:
             self.root = Share(self.m.root_dir)
         else:
-            self.root = self.shares['']
+            self.root = self.shares[request.ROOT]
         self.root.access_level = 'Modify'
         self.root.path = self.m.root_dir
-        self.shares[''] = self.root
-        with allow_writes(os.path.dirname(self.m.shares_dir)):
-            if not os.path.exists(self.m.shares_dir):
-                os.makedirs(self.m.shares_dir)
-                # make it read only
-            os.chmod(self.m.shares_dir, 0555)
+        self.shares[request.ROOT] = self.root
         self.marker_share_map = {}
         self.list_shares_retries = 0
         self.retries_limit = 5
@@ -150,7 +162,7 @@
             self.m.fs.get_by_path(self.root.path)
         except KeyError:
             self.m.fs.create(path=self.root.path,
-                             share_id='', is_dir=True)
+                             share_id=request.ROOT, is_dir=True)
 
     def on_server_root(self, root):
         """Asociate server root"""
@@ -158,9 +170,11 @@
         mdobj = self.m.fs.get_by_path(self.root.path)
         if getattr(mdobj, 'node_id', None) is None:
             self.m.fs.set_node_id(self.root.path, root)
-        share = self.shares['']
+        share = self.shares[request.ROOT]
         self.root.subtree = share.subtree = root
-        self.shares[''] = share
+        self.shares[request.ROOT] = share
+        self.m.action_q.inquire_account_info()
+        self.m.action_q.inquire_free_space(request.ROOT)
         self.refresh_shares()
         return mdobj.mdid
 
@@ -179,8 +193,9 @@
                 mdobj = self.m.fs.get_by_path(self.root.path)
                 mdid = mdobj.mdid
             except KeyError:
-                mdid = self.m.fs.create(path=self.root.path, share_id='',
-                                         is_dir=True)
+                mdid = self.m.fs.create(path=self.root.path,
+                                        share_id=request.ROOT,
+                                        is_dir=True)
             self.m.get_root(MDMarker(mdid))
 
     def handle_AQ_SHARES_LIST(self, shares_list):
@@ -243,10 +258,14 @@
             self.m.action_q.list_shares()
             self.list_shares_retries += 1
 
+    def handle_SV_FREE_SPACE(self, share_id, free_bytes):
+        """ handle SV_FREE_SPACE event """
+        self.update_free_space(str(share_id), free_bytes)
+
     def handle_SV_SHARE_CHANGED(self, message, info):
         """ handle SV_SHARE_CHANGED event """
         if message == 'changed':
-            if info.share_id not in self.shares:
+            if str(info.share_id) not in self.shares:
                 self.log.debug("New share notification, share_id: %s",
                          info.share_id)
                 dir_name = self._build_dirname(info.share_name,
@@ -259,7 +278,7 @@
                 self.share_changed(info)
         elif message == 'deleted':
             self.log.debug('share deleted! %s', info.share_id)
-            self.share_deleted(info.share_id)
+            self.share_deleted(str(info.share_id))
 
     def handle_AQ_CREATE_SHARE_OK(self, share_id, marker):
         """ handle AQ_CREATE_SHARE_OK event. """
@@ -296,6 +315,7 @@
             self._create_fsm_object(share)
             self._create_share_dir(share)
             self.m.action_q.query([(share.id, str(share.subtree), "")])
+            self.m.action_q.inquire_free_space(share.id)
 
 
     def add_share(self, share):
@@ -309,6 +329,13 @@
             self._create_fsm_object(share)
             self._create_share_dir(share)
             self.m.action_q.query([(share.id, str(share.subtree), "")])
+            self.m.action_q.inquire_free_space(share.id)
+
+    def update_free_space(self, share_id, free_bytes):
+        """ Update free space for a given share."""
+        if share_id in self.shares:
+            share = self.shares[share_id]
+            share.free_bytes = free_bytes
 
     def accept_share(self, share_id, answer):
         """ Calls AQ.accept_share with answer ('Yes'/'No')."""
@@ -334,14 +361,15 @@
 
     def share_changed(self, share_holder):
         """ process the share changed event """
-        share = self.shares.get(share_holder.share_id, None)
+        # the holder id is a uuid, use the str
+        share = self.shares.get(str(share_holder.share_id), None)
         if share is None:
             # we don't have this share, ignore it
             self.log.warning("Got a share changed notification (%r), "
                              "but don't have the share", share_holder.share_id)
         else:
             share.access_level = share_holder.access_level
-            self.shares[share_holder.share_id] = share
+            self.shares[share.id] = share
 
     def _create_share_dir(self, share):
         """ Creates the share root dir, and set the permissions. """
@@ -444,6 +472,7 @@
         del sys.modules['canonical.ubuntuone.storage.syncdaemon.volume_manager']
         # now upgrade to metadata 3
         self._upgrade_metadata_2(md_version)
+        self._upgrade_metadata_3(md_version)
         self._update_metadata_version()
 
     def _upgrade_metadata_1(self, md_version):
@@ -494,6 +523,54 @@
                                 os.rename(os.path.join(dirpath, name),
                                           os.path.join(dirpath, new_name))
                                 names[pos] = new_name
+        self._upgrade_metadata_3(md_version)
+        self._update_metadata_version()
+
+    def _upgrade_metadata_3(self, md_version):
+        """
+        Upgrade to version 4 (new layout!)
+        move "~/Ubuntu One/Shared With" Me to XDG_DATA/ubuntuone/shares
+        move "~/Ubuntu One/My Files" contents to "~/Ubuntu One"
+        """
+        self.log.debug('upgrading from metadata 3 (new layout)')
+        old_share_dir = os.path.join(self.m.root_dir, 'Shared With Me')
+        old_root_dir = os.path.join(self.m.root_dir, 'My Files')
+        # change permissions
+        os.chmod(self.m.root_dir, 0775)
+        # update the path's in metadata and move the folder
+        if os.path.exists(old_share_dir) and not os.path.islink(old_share_dir):
+            os.chmod(old_share_dir, 0775)
+            if not os.path.exists(os.path.dirname(self.m.shares_dir)):
+                os.makedirs(os.path.dirname(self.m.shares_dir))
+            shutil.move(old_share_dir, self.m.shares_dir)
+        # update the shares metadata
+        shares = ShareFileShelf(self._shares_dir)
+        for key in shares.keys():
+            share = shares[key]
+            if share.path is not None:
+                share.path = share.path.replace(old_share_dir,
+                                                self.m.shares_dir)
+                shares[key] = share
+
+        shared = ShareFileShelf(self._shared_dir)
+        for key in shared.keys():
+            share = shared[key]
+            share.path = share.path.replace(old_root_dir, self.m.root_dir)
+            shared[key] = share
+        # move the My Files contents, taking care of dir/files with the same
+        # in the new root
+        if os.path.exists(old_root_dir):
+            # make My Files rw
+            os.chmod(old_root_dir, 0775)
+            path_join = os.path.join
+            for relpath in os.listdir(old_root_dir):
+                old_path = path_join(old_root_dir, relpath)
+                new_path = path_join(self.m.root_dir, relpath)
+                if os.path.exists(new_path):
+                    shutil.move(new_path, new_path+'.u1conflict')
+                shutil.move(old_path, new_path)
+            os.rmdir(old_root_dir)
+        # update the .version file
         self._update_metadata_version()
 
     def _update_metadata_version(self):
@@ -502,6 +579,9 @@
             os.makedirs(os.path.dirname(self._version_file))
         with open(self._version_file, 'w') as fd:
             fd.write(VolumeManager.METADATA_VERSION)
+            # make sure the data get to disk
+            fd.flush()
+            os.fsync(fd.fileno())
 
 
 @contextmanager
@@ -514,8 +594,8 @@
 
 
 class ShareFileShelf(file_shelf.FileShelf):
-    """ Custom file shelf that allow '' as key, it's replaced by the string:
-    root_node_id.
+    """ Custom file shelf that allow request.ROOT as key, it's replaced
+    by the string: root_node_id.
     """
 
     def __init__(self, *args, **kwargs):
@@ -524,16 +604,16 @@
         self.key = 'root_node_id'
 
     def key_file(self, key):
-        """ override default key_file, to handle key == ''"""
-        if key == '':
+        """ override default key_file, to handle key == request.ROOT"""
+        if key == request.ROOT:
             key = self.key
         return super(ShareFileShelf, self).key_file(key)
 
     def keys(self):
-        """ override default keys, to handle key == ''"""
+        """ override default keys, to handle key == request.ROOT"""
         for key in super(ShareFileShelf, self).keys():
             if key == self.key:
-                yield ''
+                yield request.ROOT
             else:
                 yield key
 

=== modified file 'ubuntuone/u1sync/client.py'
--- ubuntuone/u1sync/client.py	2009-08-11 16:45:00 +0000
+++ ubuntuone/u1sync/client.py	2009-08-26 12:15:00 +0000
@@ -25,7 +25,7 @@
 import os
 import sys
 import shutil
-from Queue import Queue, Empty
+from Queue import Queue
 from threading import Lock
 import zlib
 import urlparse
@@ -77,6 +77,47 @@
         return ent
     return wrapper
 
+
+class ForcedShutdown(Exception):
+    """Client shutdown forced."""
+
+
+class Waiter(object):
+    """Wait object for blocking waits."""
+
+    def __init__(self):
+        """Initializes the wait object."""
+        self.queue = Queue()
+
+    def wake(self, result):
+        """Wakes the waiter with a result."""
+        self.queue.put((result, None))
+
+    def wakeAndRaise(self, exc_info):
+        """Wakes the waiter, raising the given exception in it."""
+        self.queue.put((None, exc_info))
+
+    def wakeWithResult(self, func, *args, **kw):
+        """Wakes the waiter with the result of the given function."""
+        try:
+            result = func(*args, **kw)
+        except Exception:
+            self.wakeAndRaise(sys.exc_info())
+        else:
+            self.wake(result)
+
+    def wait(self):
+        """Waits for wakeup."""
+        (result, exc_info) = self.queue.get()
+        if exc_info:
+            try:
+                raise exc_info[0], exc_info[1], exc_info[2]
+            finally:
+                exc_info = None
+        else:
+            return result
+
+
 class SyncStorageClient(StorageClient):
     """Simple client that calls a callback on connection."""
 
@@ -149,6 +190,7 @@
         self._status = "disconnected"
         self._status_reason = None
         self._status_waiting = []
+        self._active_waiters = set()
 
         self.realm = realm
 
@@ -182,20 +224,54 @@
         self.user_authorisation_url = get_oauth_url("user_authorisation_url")
         self.access_token_url = get_oauth_url("access_token_url")
 
+    def force_shutdown(self):
+        """Forces the client to shut itself down."""
+        with self._status_lock:
+            self._status = "forced_shutdown"
+            self._reason = None
+            for waiter in self._active_waiters:
+                waiter.wakeAndRaise((ForcedShutdown("Forced shutdown"),
+                                     None, None))
+            self._active_waiters.clear()
+
+    def _get_waiter_locked(self):
+        """Gets a wait object for blocking waits.  Should be called with the
+        status lock held.
+        """
+        waiter = Waiter()
+        if self._status == "forced_shutdown":
+            raise ForcedShutdown("Forced shutdown")
+        self._active_waiters.add(waiter)
+        return waiter
+
+    def _get_waiter(self):
+        """Get a wait object for blocking waits.  Acquires the status lock."""
+        with self._status_lock:
+            return self._get_waiter_locked()
+
+    def _wait(self, waiter):
+        """Waits for the waiter."""
+        try:
+            return waiter.wait()
+        finally:
+            with self._status_lock:
+                if waiter in self._active_waiters:
+                    self._active_waiters.remove(waiter)
+
     @log_timing
     def obtain_oauth_token(self, create_token):
         """Obtains an oauth token, optionally creating one if requried."""
-        token_result = Queue()
+        token_result = self._get_waiter()
 
         @log_timing
         def have_token(token):
             """When a token is available."""
-            token_result.put(token)
+            token_result.wake(token)
 
         @log_timing
         def no_token():
             """When no token is available."""
-            token_result.put(None)
+            token_result.wake(None)
 
         oauth_client = AuthorisationClient(realm=self.realm,
                                            request_token_url=
@@ -220,7 +296,7 @@
             oauth_client.ensure_access_token()
 
         self.reactor.callFromThread(_obtain_token)
-        token = token_result.get()
+        token = self._wait(token_result)
         if token is None:
             raise AuthenticationError("Unable to obtain OAuth token.")
         return token
@@ -232,13 +308,14 @@
 
         """
         with self._status_lock:
+            if self._status == "forced_shutdown":
+                return
             self._status = status
             self._status_reason = reason
             waiting = self._status_waiting
-            if len(waiting) > 0:
-                self._status_waiting = []
-                for waiter in waiting:
-                    waiter.put((status, reason))
+            self._status_waiting = []
+        for waiter in waiting:
+            waiter.wake((status, reason))
 
     @log_timing
     def _await_status_not(self, *ignore_statuses):
@@ -250,13 +327,15 @@
             status = self._status
             reason = self._status_reason
             while status in ignore_statuses:
-                waiter = Queue()
+                waiter = self._get_waiter_locked()
                 self._status_waiting.append(waiter)
                 self._status_lock.release()
                 try:
-                    status, reason = waiter.get()
+                    status, reason = self._wait(waiter)
                 finally:
                     self._status_lock.acquire()
+            if status == "forced_shutdown":
+                raise ForcedShutdown("Forced shutdown.")
             return (status, reason)
 
     def connection_failed(self, reason):
@@ -273,8 +352,7 @@
 
     def defer_from_thread(self, function, *args, **kwargs):
         """Do twisted defer magic to get results and show exceptions."""
-
-        queue = Queue()
+        waiter = self._get_waiter()
         @log_timing
         def runner():
             """inner."""
@@ -283,23 +361,20 @@
             try:
                 d = function(*args, **kwargs)
                 if isinstance(d, defer.Deferred):
-                    d.addCallbacks(lambda r: queue.put((r, None, None)),
-                                   lambda f: queue.put((None, None, f)))
+                    d.addCallbacks(lambda r: waiter.wake((r, None, None)),
+                                   lambda f: waiter.wake((None, None, f)))
                 else:
-                    queue.put((d, None, None))
-            except Exception:
-                queue.put((None, sys.exc_info(), None))
+                    waiter.wake((d, None, None))
+            except Exception, e:
+                waiter.wake((None, sys.exc_info(), None))
 
         self.reactor.callFromThread(runner)
-        while True:
+        result, exc_info, failure = self._wait(waiter)
+        if exc_info:
             try:
-                # poll with a timeout so that interrupts are still serviced
-                result, exc_info, failure = queue.get(True, 1)
-                break
-            except Empty: # pylint: disable-msg=W0704
-                pass
-        if exc_info:
-            raise exc_info[1], None, exc_info[2]
+                raise exc_info[0], exc_info[1], exc_info[2]
+            finally:
+                exc_info = None
         elif failure:
             failure.raiseException()
         else:

=== modified file 'ubuntuone/u1sync/main.py'
--- ubuntuone/u1sync/main.py	2009-08-11 16:45:00 +0000
+++ ubuntuone/u1sync/main.py	2009-08-26 12:15:00 +0000
@@ -22,7 +22,9 @@
 
 from __future__ import with_statement
 
+import signal
 import os
+import sys
 from errno import EEXIST
 
 from optparse import OptionParser, SUPPRESS_HELP
@@ -31,16 +33,16 @@
 gobject.set_application_name('u1sync')
 
 from twisted.internet import reactor
-from threading import Thread
+from Queue import Queue
 
 from ubuntuone.storageprotocol.oauth import OAuthToken
 import ubuntuone.storageprotocol.dircontent_pb2 as dircontent_pb2
-from ubuntuone.storageprotocol.dircontent_pb2 import DIRECTORY
+from ubuntuone.storageprotocol.dircontent_pb2 import DIRECTORY, SYMLINK
 from ubuntuone.u1sync.genericmerge import (
     show_tree, generic_merge)
 from ubuntuone.u1sync.client import (
     ConnectionError, AuthenticationError, NoSuchShareError,
-    Client)
+    ForcedShutdown, Client)
 from ubuntuone.u1sync.scan import scan_directory
 from ubuntuone.u1sync.merge import (
     SyncMerge, ClobberServerMerge, ClobberLocalMerge, merge_trees)
@@ -76,6 +78,8 @@
 
 class TreesDiffer(Exception):
     """Raised when diff tree differs."""
+    def __init__(self, quiet):
+        self.quiet = quiet
 
 
 MERGE_ACTIONS = {
@@ -216,7 +220,8 @@
         user = user.encode("utf-8")
         print "%s  %s (from %s) [%s]%s" % (id, name, user, access, status)
 
-def do_diff(client, share_spec, directory, quiet, subtree_path):
+def do_diff(client, share_spec, directory, quiet, subtree_path,
+            ignore_symlinks=True):
     """Diffs a local directory with the server."""
     if share_spec is not None:
         share_uuid = client.find_share(share_spec)
@@ -241,7 +246,9 @@
             if not quiet:
                 print "%s missing from client" % display_path
         elif remote_node is None:
-            if not quiet:
+            if ignore_symlinks and local_node.node_type == SYMLINK:
+                differs = False
+            elif not quiet:
                 print "%s missing from server" % display_path
         elif local_node.node_type != remote_node.node_type:
             local_type = node_type_str(local_node.node_type)
@@ -270,7 +277,7 @@
                             pre_merge=pre_merge, post_merge=post_merge,
                             partial_parent=("", False), name=u"")
     if differs:
-        raise TreesDiffer()
+        raise TreesDiffer(quiet=quiet)
 
 def do_main(argv):
     """The main user-facing portion of the script."""
@@ -373,14 +380,14 @@
 
 
     if options.oauth is None:
-        token = None
+        passed_token = None
     else:
         try:
             (key, secret) = options.oauth.split(':', 2)
         except ValueError:
             parser.error("--oauth requires a key and secret together in the "
                          " form KEY:SECRET")
-        token = OAuthToken(key, secret)
+        passed_token = OAuthToken(key, secret)
 
     if options.share is not None:
         try:
@@ -391,43 +398,63 @@
     else:
         share_spec = None
 
-    reactor_thread = Thread(target=
-                            lambda: reactor.run(installSignalHandlers=False))
-    reactor_thread.setDaemon(True)
-    reactor_thread.start()
-
     client = Client(realm=options.realm, reactor=reactor)
 
-    if token is None:
-        should_create_token = (options.mode == "authorize")
-        token = client.obtain_oauth_token(create_token=should_create_token)
-
-    client.connect_ssl(options.host, int(options.port), options.no_ssl_verify)
-
-    try:
-        client.set_capabilities()
-        client.oauth_from_token(token)
-
-        if options.mode == "sync":
-            do_sync(client=client, directory=directory, action=options.action,
-                    dry_run=options.dry_run, quiet=options.quiet)
-        elif options.mode == "init":
-            do_init(client=client, share_spec=share_spec, directory=directory,
-                    quiet=options.quiet, subtree_path=options.subtree)
-        elif options.mode == "list-shares":
-            do_list_shares(client=client)
-        elif options.mode == "diff":
-            do_diff(client=client, share_spec=share_spec, directory=directory,
-                    quiet=options.quiet, subtree_path=options.subtree)
-        elif options.mode == "authorize":
-            if not options.quiet:
-                print "Authorized."
-    finally:
+    signal.signal(signal.SIGINT, lambda s, f: client.force_shutdown())
+    signal.signal(signal.SIGTERM, lambda s, f: client.force_shutdown())
+
+    def run_client():
+        """Run the blocking client."""
+        if passed_token is None:
+            should_create_token = (options.mode == "authorize")
+            token = client.obtain_oauth_token(create_token=should_create_token)
+        else:
+            token = passed_token
+
+        client.connect_ssl(options.host, int(options.port), options.no_ssl_verify)
+
         try:
+            client.set_capabilities()
+            client.oauth_from_token(token)
+
+            if options.mode == "sync":
+                do_sync(client=client, directory=directory,
+                        action=options.action,
+                        dry_run=options.dry_run, quiet=options.quiet)
+            elif options.mode == "init":
+                do_init(client=client, share_spec=share_spec,
+                        directory=directory,
+                        quiet=options.quiet, subtree_path=options.subtree)
+            elif options.mode == "list-shares":
+                do_list_shares(client=client)
+            elif options.mode == "diff":
+                do_diff(client=client, share_spec=share_spec,
+                        directory=directory,
+                        quiet=options.quiet, subtree_path=options.subtree,
+                        ignore_symlinks=False)
+            elif options.mode == "authorize":
+                if not options.quiet:
+                    print "Authorized."
+        finally:
             client.disconnect()
+
+    def capture_exception(queue, func):
+        """Capture the exception from calling func."""
+        try:
+            func()
+        except Exception, e:
+            queue.put(sys.exc_info())
+        else:
+            queue.put(None)
         finally:
             reactor.callWhenRunning(reactor.stop)
-            reactor_thread.join(1.0)
+
+    queue = Queue()
+    reactor.callInThread(capture_exception, queue, run_client)
+    reactor.run(installSignalHandlers=False)
+    exc_info = queue.get(True, 0.1)
+    if exc_info:
+        raise exc_info[0], exc_info[1], exc_info[2]
 
 def main(*argv):
     """Top-level main function."""
@@ -446,10 +473,11 @@
         print "No matching share found."
     except ReadOnlyShareError:
         print "The selected action isn't possible on a read-only share."
-    except KeyboardInterrupt:
+    except (ForcedShutdown, KeyboardInterrupt):
         print "Interrupted!"
-    except TreesDiffer:
-        print "Trees differ."
+    except TreesDiffer, e:
+        if not e.quiet:
+            print "Trees differ."
     else:
         return 0
     return 1

